version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local diagnoses "ami alzh alzhdmta atrialfb cataract chrnkidn copd chf diabetes glaucoma hipfrac ischmcht depressn osteoprs ra_oa strketia cncrbrst cncrclrc cncrprst cncrlung cncrendm anemia asthma hyperl hyperp hypert hypoth"
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest *_samp mover age_5yr_bins ///
        `diagnoses' te_move) saving(../temp/data_loaded)
    foreach diag in `diagnoses' {
        merge m:1 hrr_orig hrr_dest using ../external/ranks/delta_`diag', ///
            assert(3) keep(3) keepusing(delta_hrrnum_`diag'_i) nogen
        drop delta_hrrnum_`diag'_i
    }
    save ../temp/data_loaded, replace
    foreach diag in `diagnoses' {
        use ../temp/data_loaded, clear
        run_event_study if ${`diag'_samp==1}, ///
            y_it(`diag') delta(../external/ranks/delta_`diag') absorb(bene_id) ///
            x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
            specification_name(`diag')
    }
end

* Execute
main


