version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main

    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU ${LnRBU_samp} mover age_5yr_bins ///
        te_move tm_move tl_move) keep_condition(${LnRBU_samp}==1) saving(../temp/data_loaded)
    run_event_study, ///
        y_it(LnRBU) delta(../external/ranks/delta_LnRBU) absorb(bene_id) ///
        x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
        specification_name(LnRBU)
    foreach panel in e m l {
        use ../temp/data_loaded, clear
        run_event_study if t`panel'_move==1, ///
            y_it(LnRBU) delta(../external/ranks/delta_LnRBU_t`panel'_move) absorb(bene_id) ///
            x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
            specification_name(LnRBU_`panel')
    }

    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
		nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU ${LnRBU_samp} mover age_5yr_bins) ///
		keep_condition(${LnRBU_samp}==1) saving(../temp/nonmover_data_loaded)
	use ../temp/nonmover_data_loaded.dta, clear
    run_event_study, ///
        y_it(LnRBU) delta(../external/ranks/delta_LnRBU) absorb(bene_id) ///
        x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
        specification_name(LnRBU_all)
end

* Execute
main


