version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local outcomes1 "anypcp Spec any_Ip anyErRBU Lndiag Lnimag Lnnum_doc Lnprv_num LnIp_RBU LnOp_RBU LnEr_RBU LnOt_RBU"
	local outcomes2 "RBU_perc"
	local outcomes "`outcomes1' `outcomes2'"
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest *_samp mover age_5yr_bins ///
        `outcomes') keep_condition(baseline_samp==1) saving(../temp/data_loaded)
    foreach outcome in `outcomes' {
        use ../temp/data_loaded, clear
        run_event_study if ${`outcome'_samp}==1, ///
            y_it(`outcome') delta(../external/ranks/delta_`outcome') absorb(bene_id) ///
            x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
            specification_name(`outcome')
    }

end

* Execute
main

