version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest RBU ${RBU_samp} mover age_5yr_bins ///
        te_move tm_move tl_move) keep_condition(${RBU_samp}==1) saving(../temp/data_loaded)
    forv i=1/50 {
        create_bootstrap_delta using ../external/ranks/RBU_hrr_mean, ///
            mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
            gamma_mean(RBU_total) gamma_standard_error(RBU_total_se) ///
            saving(../temp/bootstrap_delta)
        use ../temp/data_loaded, clear
        bsample, cluster(bene_id)
        run_event_study, ///
            y_it(RBU) delta(../temp/bootstrap_delta) absorb(bene_id) ///
            x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
            specification_name(RBU_`i')
        foreach panel in e m l {
            create_bootstrap_delta using ../external/ranks/RBU_hrr_mean_t`panel'_move, ///
                mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
                gamma_mean(RBU_total) gamma_standard_error(RBU_total_se) ///
                saving(../temp/bootstrap_delta)
            use ../temp/data_loaded if t`panel'_move==1, clear
            bsample, cluster(bene_id)
            run_event_study, ///
                y_it(RBU) delta(../temp/bootstrap_delta) absorb(bene_id) ///
                x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
                specification_name(RBU_`panel'_`i')
        }
    }
end

* Execute
main


