version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local subsamples1 "age_q1_a age_q2_a age_q3_a age_q4_a nondead nondh nonhmo nonatr xs xcr nf nfac"
	local subsamples2 "first_third second_third third_third"
	local subsamples "`subsamples1' `subsamples2'"
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU ${LnRBU_samp} mover age_5yr_bins ///
        `subsamples') keep_condition(${LnRBU_samp}==1) saving(../temp/data_loaded)
    forv i=1/50 {
        foreach subsample in `subsamples' {
            create_bootstrap_delta using ../external/ranks/LnRBU_hrr_mean_`subsample', ///
                mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
                gamma_mean(LnRBU_total) gamma_standard_error(LnRBU_total_se) ///
                saving(../temp/bootstrap_delta)
            use ../temp/data_loaded if `subsample'==1, clear
            bsample, cluster(bene_id)
            run_event_study, ///
                y_it(LnRBU) delta(../temp/bootstrap_delta) absorb(bene_id) ///
                x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
                specification_name(LnRBU_`subsample'_`i')
        }
    }
end

* Execute
main


