version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local subsamples "first_third second_third third_third age_q1_a age_q2_a age_q3_a age_q4_a nondead nondh nonhmo nonatr xs xcr nf nfac"
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU ${LnRBU_samp} mover age_5yr_bins ///
        `subsamples') keep_condition(${LnRBU_samp}==1) saving(../temp/data_loaded)
    foreach subsample in `subsamples' {
        use ../temp/data_loaded, clear
        run_event_study if `subsample'==1, ///
            y_it(LnRBU) delta(../external/ranks/delta_LnRBU_`subsample') absorb(bene_id) ///
            x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
            specification_name(LnRBU_`subsample')
    }
end

* Execute
main


