version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    load_data_event_study, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU ${LnRBU_samp} mover age_5yr_bins ///
        te_move tm_move tl_move) keep_condition(${LnRBU_samp}==1) saving(../temp/data_loaded)
    merge m:1 hrr_orig hrr_dest using ../external/ranks/delta_LnRBU, ///
        assert(3) keep(3) keepusing(delta_hrrnum_LnRBU_i) nogen
    gen up=delta_hrrnum_LnRBU_i>0
    gen down=delta_hrrnum_LnRBU_i<0
    drop delta_hrrnum_LnRBU_i
    save ../temp/data_loaded, replace
	forv i=1/50 {
		foreach dir in up down {
            create_bootstrap_delta using ../external/ranks/LnRBU_hrr_mean, ///
                mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
                gamma_mean(LnRBU_total) gamma_standard_error(LnRBU_total_se) ///
                saving(../temp/bootstrap_delta)			
			use ../temp/data_loaded if `dir'==1, clear
			bsample, cluster(bene_id)
			run_event_study, ///
				y_it(LnRBU) delta(../temp/bootstrap_delta) absorb(bene_id) ///
				x_it(i.year o${omit}.rel_yr_group o${omit}.rel_yr_group#o.delta i.age_5yr_bins) ///
				specification_name(LnRBU_`dir'_`i')
		}
	}

end

* Execute
main


