version 13
set more off
adopath + ../external/lib/stata/gslab_misc/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)
	
program main
    use LnRBU bene_id year rel_yr_rit ///
        using "../external_links/compiled/CompiledPatYrDataMovers", clear
    rename bene_id bene_id_mover
    rename LnRBU LnRBU_mover
    foreach loc in orig dest {
        merge 1:1 bene_id_mover year using ../external/matched/MatchedPatientSample, ///
                assert(1 2 3) keep(match) keepusing(bene_id_nonmover_`loc') nogen
        rename bene_id_nonmover_`loc' bene_id
        merge m:1 bene_id year using "../external_links/compiled/CompiledPatYrDataNonMovers", ///
            assert (1 2 3 ) keep(1 3) keepusing(LnRBU) nogen
        rename LnRBU LnRBU_nonmover_`loc'
        rename bene_id bene_id_nonmover_`loc'
    }
    collapse LnRBU*, by(rel_yr_rit)
    egen LnRBU_nonmover=rowmean(LnRBU_nonmover_orig LnRBU_nonmover_dest)
    label variable rel_yr_rit "Relative Year"
    label variable LnRBU_mover "Mean Log Utilization of Movers"
    label variable LnRBU_nonmover "Mean Log Utilization of Matched Non-Movers"
    label variable LnRBU_nonmover_orig "Mean Log Utilization of Matched Non-Movers (Origin)"
    label variable LnRBU_nonmover_dest "Mean Log Utilization of Matched Non-Movers (Destination)"
    save_data ../output/mean_utilization_over_relative_years, replace key(rel_yr_rit)
end

* EXECUTE
main
