version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local subsamples "bs bs_l bs_h bs_o bs_o_nsb"
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMoversAlt) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMoversAlt) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU mover `subsamples') ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj_alt.dta) saving(../temp/data_loaded)
    foreach subsample in `subsamples' {
        use ../temp/data_loaded, clear
        run_main_model if `subsample'==1&rel_yr_rit!=0, ///
            y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_`subsample') ///
            absorb(gbene_id)
    }
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMoversAlt) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMoversAlt) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU mover bs_o) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_adj_alt.dta) saving(../temp/data_loaded) ///
        lambda(lambda_r) lambda_filename(../external/loc_share/orig_dest_rit_mover)
    use ../temp/data_loaded, clear
    run_main_model if bs_o==1&rel_yr_rit!=0, ///
        y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_bs_o_adj) ///
        absorb(gbene_id) lambda(lambda_r)
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMoversAlt) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMoversAlt) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU mover bs) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_adj.dta) saving(../temp/data_loaded) ///
        lambda(lambda_r) lambda_filename(../external/loc_share/orig_dest_rit_mover)
    use ../temp/data_loaded, clear
    run_main_model if bs==1&rel_yr_rit!=0, ///
        y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_bs_adj) ///
        absorb(gbene_id) lambda(lambda_r)
end

* Execute
main
