version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hsa* state* LnRBU baseline_samp mover) ///
        keep_condition(baseline_samp==1 & rel_yr_rit!=0) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
	drop _I*
	rename hsanum hsa
	rename state_de state
	save ../temp/data_loaded, replace
	foreach var of varlist state hsa {
		cap mkdir ../output/`var'/
		use ../temp/data_loaded, clear
        areg LnRBU i.`var' _Y* _RY* _A*, a(gbene_id)
        gen gammatilde_j=.
        levelsof `var', local(units)
        foreach unit in `units' {
            cap replace gammatilde_j = _b[`unit'.`var'] if `var'==`unit'
        }
		keep bene_id year LnRBU mover gammatilde_j `var'
		gen fwgt = ${mover_weight}
		replace fwgt = ${nonmover_weight} if mover==0
		gen N=1
		collapse (mean) LnRBU_bar_jt=LnRBU gammatilde_j (rawsum) N [fw=fwgt], by(`var' year)
		collapse (mean) LnRBU_bar_j=LnRBU_bar_jt gammatilde_j (sum) N, by(`var')
		gen ctildebar_j = LnRBU_bar_j - gammatilde_j
		save_data ../output/`var'/`var'_fe, replace key(`var')
	}
end

* Execute
main
