version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local health_measures "Lnhcccom Lnchr Lnnumcon Lniez"
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest `health_measures' *_samp mover) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
    foreach hm in `health_measures' {
        use ../temp/data_loaded, clear
        run_main_model if ${`hm'_samp}==1&rel_yr_rit!=0, ///
            y_it(`hm') fixed_effects(_I* _Y* _RY* _A*) ///
            specification_name(`hm') absorb(gbene_id)
    }
end

* Execute
main
