version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local outcomes "LnOp_RBU"
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest `outcomes' *_samp mover) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
    forv i=1/50 {
        foreach outcome in `outcomes' {
            use ../temp/data_loaded, clear
            bsample, cluster(bene_id)
            run_main_model if ${`outcome'_samp}==1&rel_yr_rit!=0, ///
                y_it(`outcome') fixed_effects(_I* _Y* _RY* _A*) ///
                specification_name(`outcome'_`i') absorb(gbene_id)
        }
    }
end

* Execute
main
