version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main

    use bene_id year LnRBU mover rel_yr_rit age_5yr_bins hrrnum  non_mult_mover ///
        using ../external_links/compiled/CompiledPatYrDataMoversAll if rel_yr_rit!=0, clear
    append using ../external_links/compiled/CompiledPatYrDataNonMoversAll, ///
        keep(bene_id year LnRBU mover age_5yr_bins hrrnum non_mult_mover)
    replace rel_yr_rit=. if non_mult_mover==0
    merge 1:1 bene_id year using ../external_links/multiple_movers/MultipleMovers_RelativeYears, ///
        assert(1 2 3) keep(1 3) keepusing(*) nogen

    forv i=1/9{
        drop if rel_yr_rit_`i'==0
    }

    xi i.hrrnum, noomit
    xi i.age_5yr_bins, noomit prefix(_A)
    xi i.year, noomit prefix(_Y)
    xi i.rel_yr_rit, noomit prefix(_RY)

    forv i=1/8 {
        xi i.rel_yr_rit_`i', noomit prefix(_RY`i')
    }

    foreach var of varlist _RY* {
        replace `var'=0 if `var'==.
    }

    egen gbene_id = group(bene_id)

    run_main_model, y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) ///
        specification_name(MultipleMovers) absorb(gbene_id)

end

* Execute
main
