version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main

	local subsamples "rd5 rd3 rd1 first_third second_third third_third nondead nonhmo nonatr xs xcr"
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU baseline_samp ///
        mover `subsamples' age_q*_a) keep_condition(baseline_samp==1 & rel_yr_rit!=0) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
/*
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU baseline_samp mover) ///
        keep_condition(baseline_samp==1) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_adj_fd.dta) saving(../temp/data_loaded_fdfe)

    foreach subsample in `subsamples' {
        use ../temp/data_loaded, clear
        run_main_model if `subsample'==1, ///
            y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_`subsample') ///
			absorb(gbene_id)
    }

	use ../temp/data_loaded_fdfe, clear
	foreach var of varlist LnRBU _I* _Y* _RY* _A* {
		sort bene_id year
        gen `var'_diff=`var'[_n]-`var'[_n-1] ///
			if bene_id[_n]==bene_id[_n-1] & rel_yr_rit[_n]==rel_yr_rit[_n-1]+1
	}
	run_main_model, ///
		y_it(LnRBU_diff) fixed_effects(_I* _Y*_diff _RY*_diff _A*_diff) ///
		specification_name(LnRBU_fdfe) absorb(gbene_id)
    
    use ../temp/data_loaded_fdfe, clear
    estimates use ../output/LnRBU_fdfe/estimates
    gen gammatilde1_j = .
    gen gammatilde2_j = .
    replace gammatilde2_j = 0 if mover==0
    levelsof hrrnum, local(hrrnum_levels)
    foreach H of local hrrnum_levels {
        replace gammatilde1_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==0 & hrrnum == `H'
        replace gammatilde1_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_orig==`H' & rel_yr_rit<0
        replace gammatilde1_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_dest==`H' & rel_yr_rit>0 & rel_yr_rit<.
        replace gammatilde2_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_orig==`H' & rel_yr_rit>0 & rel_yr_rit<.
        replace gammatilde2_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_dest==`H' & rel_yr_rit<0
        replace gammatilde1_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_orig==`H' & rel_yr_rit==0
        replace gammatilde1_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_dest==`H' & rel_yr_rit==0
        replace gammatilde2_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_orig==`H' & rel_yr_rit==0
        replace gammatilde2_j = _b[_Ihrrnum_`H'_diff] + _b[_Ihrrnum_`H'] ///
            if mover==1 & hrr_dest==`H' & rel_yr_rit==0
    }
    gen lambda_r=1
    replace lambda_r=0.5 if rel_yr_rit==0
    gen gammatilde_j = lambda_r*gammatilde1_j + lambda_r*gammatilde2_j
    gen fwgt = ${mover_weight}
    replace fwgt = ${nonmover_weight} if mover==0
    gen N=1
    collapse (mean) LnRBU_bar_jt=LnRBU gammatilde_j (rawsum) N [fw=fwgt], by(hrrnum year)
    collapse (mean) LnRBU_bar_j=LnRBU_bar_jt gammatilde_j (sum) N, by(hrrnum)
    gen ctildebar_j = LnRBU_bar_j - gammatilde_j
    save_data ../output/LnRBU_fdfe/hrr_fe, replace key(hrrnum)
*/
	use ../temp/data_loaded, clear	
	foreach hrr of varlist _I* {
		forv q=1/4 {
			gen `hrr'_aq`q' = `hrr' * age_q`q'_a
        }
    }
	run_main_model, ///
		y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_ageq) absorb(gbene_id)

end

* Execute
main
