version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU baseline_samp mover) ///
        keep_condition(baseline_samp==1 & rel_yr_rit!=0) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
    gen patient_hrr = bene_id + string(hrrnum)
    save ../temp/data_loaded, replace
    run_main_model, ///
        y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) ///
        specification_name(SaturatedModel) absorb(patient_hrr)
    use ../temp/data_loaded, clear
    run_main_model if mover==1, ///
        y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) ///
        specification_name(SaturatedModelMoversOnly) absorb(patient_hrr)
end

* Execute
main
