version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    local subsamples "age_q1_a age_q2_a age_q3_a age_q4_a"
    load_data_main_model, ///
        mover_dataset(../external_links/compiled/CompiledPatYrDataMovers) ///
        nonmover_dataset(../external_links/compiled/CompiledPatYrDataNonMovers) ///
        variables(bene_id year hrrnum hrr_orig hrr_dest LnRBU baseline_samp mover `subsamples') ///
        keep_condition(baseline_samp==1 & rel_yr_rit!=0) ///
        rhs(../external_links/rhs_matrix/rhs_matrix_noadj.dta) saving(../temp/data_loaded)
    foreach subsample in `subsamples' {
        use ../temp/data_loaded, clear
        run_main_model if `subsample'==1, ///
            y_it(LnRBU) fixed_effects(_I* _Y* _RY* _A*) specification_name(LnRBU_`subsample') absorb(gbene_id)
    }
end

* Execute
main
