#! /usr/bin/env python
#****************************************************
# GET LIBRARY - Do not modify this section
#****************************************************
import subprocess, shutil, os
gslab_make_path = os.getenv('gslab_make_path')
subprocess.call('svn export --force -r 33345 ' + gslab_make_path + ' gslab_make', shell = True)
from gslab_make.py.get_externals import *
from gslab_make.py.make_log import *
from gslab_make.py.make_links import *
from gslab_make.py.make_link_logs import *
from gslab_make.py.run_program import *
from gslab_make.py.dir_mod import *

#****************************************************
# make.py starts: 
#****************************************************
set_option(link_logs_dir = '../output/')
clear_dirs('../output/figures/','../output/tables/','../temp/','../external/','../external_links/')
start_make_logging()

# GET_EXTERNALS
get_externals('externals.txt')

# MAKE_LINKS
make_links('./links.txt')
make_link_logs('./links.txt')

# INSTALL R PACKAGE
run_rinstall(package = '../external/lib/r/glmnet_2.0-2.tar.gz', lib = '../external/lib/r')

# ANALYSIS
run_stata(program = 'analysis_main.do')
run_rbatch(program = 'analysis_lasso.R')
run_stata(program = 'analysis_post_lasso.do')

end_make_logging()

shutil.rmtree('gslab_make')
input('\n Press <Enter> to exit.')
