#! /usr/bin/env python
#****************************************************
# GET LIBRARY
#****************************************************
import subprocess, shutil, os
gslab_make_path = os.getenv('gslab_make_path')
subprocess.call('svn export --force -r 33345 ' + gslab_make_path + ' gslab_make', shell = True)
from gslab_make.py.get_externals import *
from gslab_make.py.make_log import *
from gslab_make.py.make_links import *
from gslab_make.py.make_link_logs import *
from gslab_make.py.run_program import *
from gslab_make.py.dir_mod import *

#****************************************************
# MAKE.PY STARTS
#****************************************************
set_option(makelog = '../output/make.log', output_dir = '../output/', temp_dir = '../temp/')
clear_dirs('../external/', '../output/tables', '../output/figures', '../temp/')
start_make_logging()

# GET_EXTERNALS
get_externals('externals.txt')

# MAKE_LINKS
make_links('./links.txt')
make_link_logs('./links.txt')

# ANALYSIS
run_stata(program = 'analysis.do')

end_make_logging()

shutil.rmtree('gslab_make')
raw_input('\n Press <Enter> to exit.')