version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
adopath + ../external/lib/third_party/charlson
preliminaries

program main
    forv year=1998/2008 {
        use ../external_links/diagnosis/diag`year', clear
        charlson diag, icd(9) idvar(bene_id)
        keep bene_id weightch* wcharlsum
        gen year=`year'
        save ../temp/charlson_`year', replace
    }
    clear
    forv year=1998/2008 {
        append using ../temp/charlson_`year'
    }
    save_data ../output/charlson, replace key(bene_id year)
end

**Execute
main
