/***************************************************************************************************
 *
 * BUILD.DO
 * This code will take in the CSV HCC score files and transfer them to STATA
 **************************************************************************************************/

version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
preliminaries

program main

    forval year = 1998/2008 {
        insheet using ../temp/hcc_score_20_`year'.csv, clear names
        renvars, lowcase

        *keep bene_id score_community score_institutional score_new_enrollee score_snp_new_enrollee
        gen year = `year'

        save_data ../temp/score_`year', replace key(bene_id year)
    }

    use ../temp/score_1998, clear
    forval year = 1999/2008 {
        append using ../temp/score_`year'
    }
    sort bene_id year

    save_data ../output/HCC.dta, replace key(bene_id year)
end

main
