version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
adopath + ../external/lib/stata/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)

program main
    use ../output/LnRBU_hrr_mean, clear
    ebayes LnRBU_total, fe_se(LnRBU_total_se) groupfe(LnRBU_total) ///
        generate(LnRBU_total_eb) generate_se(LnRBU_total_se_eb)
    keep hrrnum LnRBU_total_eb LnRBU_total_se_eb
    save_data ../output/LnRBU_hrr_mean_eb, replace key(hrrnum)
    use hrr_orig hrr_dest using "../external_links/compiled/CompiledPatYrDataMovers.dta", clear
    egen tag = tag(hrr_orig hrr_dest)
    keep if tag==1
    drop tag
    save ../temp/temp, replace
    levelsof hrr_orig, local(orig_groups)
    levelsof hrr_dest, local(dest_groups)
    use ../temp/temp, clear
    foreach loc in orig dest {
        rename hrr_`loc' hrrnum
        merge m:1 hrrnum using ../output/LnRBU_hrr_mean_eb, ///
                assert(1 3) keep(3) keepusing(LnRBU_total_eb) nogen
            rename LnRBU_total_eb LnRBU_total_eb_`loc'
            rename hrrnum hrr_`loc'
    }
    gen delta_hrrnum_eb = LnRBU_total_eb_dest - LnRBU_total_eb_orig
    rename delta_hrrnum_eb delta_hrrnum_LnRBU_i_eb
    keep hrr_orig hrr_dest delta_hrrnum_LnRBU_i_eb
    save_data ../output/delta_LnRBU_eb, replace key(hrr_orig hrr_dest)
end

* EXECUTE
main

