version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)
global obs_no = "L"

program main
    use bene_id year mover using ../external/Sample/subsamples if mover==1, clear
    merge 1:1 bene_id year using ../external/ClaimShare/claim_share_data_mover, ///
        assert(1 2 3) keep(1 3) keepusing(*)
    foreach loc in orig dest other {
        replace ClaimCnt0_frac_`loc'=0 if _merge==1
    }
    collapse (mean) *orig* *dest*, by(rel_yr_rit)
    keep if rel_yr_rit!=.
    gen lambda_r = .
    replace lambda_r = ClaimCnt0_frac_orig / (ClaimCnt0_frac_orig + ClaimCnt0_frac_dest) ///
        if rel_yr_rit<0
    replace lambda_r = ClaimCnt0_frac_dest / (ClaimCnt0_frac_orig + ClaimCnt0_frac_dest) ///
        if rel_yr_rit>0 & rel_yr_rit!=.
    save_data ../output/orig_dest_rit_mover, replace key(rel_yr_rit)
    keep rel_yr_rit lambda_r
    replace lambda_r=1
    replace lambda_r=0.5 if rel_yr_rit==0
    save_data ../output/orig_dest_rit_mover_fd, replace key(rel_yr_rit)
end

* EXECUTE
main
