%macro LoadPhysCrosswalks();

    data pos.posmaster (RENAME=(year=fileyear));
        set pos.posmaster;
    run;

    data ziphrrxwalk;
	infile "../external/geo/ziphrrxwalk.csv" delimiter="," firstobs=2;
	informat zipcode $7.;
	informat hsanum 5.;
	informat hsacity $20.;
	informat hsastate $4.;
	informat hrrnum 3.;
	informat hrrcity $20.;
	informat hrrstate $4.;

	format zipcode $7.;
	format hsanum 5.;
	format hsacity $20.;
	format hsastate $4.;
	format hrrnum 3.;
	format hrrcity $20.;
	format hrrstate $4.;

	input zipcode $ hsanum hsacity $ hsastate $ hrrnum hrrcity $ hrrstate $;
        zipcode = substr(zipcode, 2, &zipcode_length.);
    run;

    data ziphrrxwalk;
        length zipcode $&zipcode_length..;
	set ziphrrxwalk;
	hsacity = dequote(hsacity);
	hsastate = dequote(hsastate);
	hrrcity = dequote(hsacity);
	hrrstate = dequote(hsastate);
    run;

    data physid_upinnpi;
        infile "../external/xwalk/PhysId_UpinNpi.csv" delimiter="," firstobs=2;
        informat phys_id $19.;
        informat upin $8.;
        informat npi $12.;
        format phys_id $19.;
        format upin $8.;
        format npi $12.;
        input  upin $ npi $ phys_id $;
    run;

    data physid_upinnpi;
        set physid_upinnpi;
        phys_id = dequote(phys_id);
        upin = dequote(upin);
        npi = dequote(npi);
        phys_id = trim(phys_id);
        upin = trim(upin);
        npi = trim(npi);
    run;

%mend LoadPhysCrosswalks;

