%macro CarrierVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %global c1998_from; %let c1998_from = from_dt;
    %global c1998_thru; %let c1998_thru = thru_dt;
    %global c1999_from; %let c1999_from = from_dt;
    %global c1999_thru; %let c1999_thru = thru_dt;
    %global c2000_from; %let c2000_from = from_dt;
    %global c2000_thru; %let c2000_thru = thru_dt;
    %global c2001_from; %let c2001_from = from_dt;
    %global c2001_thru; %let c2001_thru = thru_dt;
    %global c2002_from; %let c2002_from = sfromdt;
    %global c2002_thru; %let c2002_thru = sthrudt;
    %global c2003_from; %let c2003_from = sfromdt;
    %global c2003_thru; %let c2003_thru = sthrudt;
    %global c2004_from; %let c2004_from = sfromdt;
    %global c2004_thru; %let c2004_thru = sthrudt;
    %global c2005_from; %let c2005_from = sfromdt;
    %global c2005_thru; %let c2005_thru = sthrudt;
    %global c2006_from; %let c2006_from = from_dt;
    %global c2006_thru; %let c2006_thru = thru_dt;
    %global c2007_from; %let c2007_from = from_dt;
    %global c2007_thru; %let c2007_thru = thru_dt;
    %global c2008_from; %let c2008_from = from_dt;
    %global c2008_thru; %let c2008_thru = thru_dt;
    %global c2009_from; %let c2009_from = from_dt;
    %global c2009_thru; %let c2009_thru = thru_dt;

    %global upin1998; %let upin1998 = prf_upin;
    %global upin1999; %let upin1999 = prf_upin;
    %global upin2000; %let upin2000 = prf_upin;
    %global upin2001; %let upin2001 = prf_upin;
    %global upin2002; %let upin2002 = prf_upin;
    %global upin2003; %let upin2003 = prf_upin;
    %global upin2004; %let upin2004 = prf_upin;
    %global upin2005; %let upin2005 = prf_upin;
    %global upin2006; %let upin2006 = prf_upin;
    %global upin2007; %let upin2007 = prf_upin;
    %global upin2008; %let upin2008 = prf_upin;
    %global upin2009; %let upin2009 = prf_upin;

    %global npi1998; %let npi1998 = prfnpi;
    %global npi1999; %let npi1999 = prfnpi;
    %global npi2000; %let npi2000 = prfnpi;
    %global npi2001; %let npi2001 = prfnpi;
    %global npi2002; %let npi2002 = prfnpi;
    %global npi2003; %let npi2003 = prfnpi;
    %global npi2004; %let npi2004 = prfnpi;
    %global npi2005; %let npi2005 = prfnpi;
    %global npi2006; %let npi2006 = prf_npi;
    %global npi2007; %let npi2007 = prf_npi;
    %global npi2008; %let npi2008 = prf_npi;
    %global npi2009; %let npi2009 = prf_npi;

    %global keep1998;
    %let keep1998 = KEEP= year fileYear &upin1998. &npi1998. provzip prvstate &c1998_from. &c1998_thru.;
    %global rename1998;
    %let rename1998 = RENAME= (&c1998_from.=from_dt &c1998_thru.=thru_dt prvstate=state
        &upin1998.=upin &npi1998.=npi);
    %global keep1999;
    %let keep1999 = KEEP= year fileYear &upin1999. &npi1999. provzip prvstate &c1999_from. &c1999_thru.;
    %global rename1999;
    %let rename1999 = RENAME= (&c1999_from.=from_dt &c1999_thru.=thru_dt prvstate=state
        &upin1999.=upin &npi1999.=npi);
    %do yr=2000 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= year fileYear &&upin&yr.. &&npi&yr.. provzip prvstate
            &&c&yr._from. &&c&yr._thru.;
        %global rename&yr.;
        %let rename&yr. = RENAME= (&&c&yr._from.=from_dt &&c&yr._thru.=thru_dt
             &&upin&yr..=upin &&npi&yr..=npi prvstate=state);
        %end;

%mend;


%macro OpClmsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= fileYear at_upin at_npi from_dt thru_dt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= fileYear at_upin at_npi from_dt thru_dt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;

%mend;

%macro IpClmsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= fileYear at_upin at_npi from_dt thru_dt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= fileYear at_upin at_npi from_dt thru_dt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;

%mend;
