version 12
set more off
adopath + ../external/lib/stata/gslab_misc/ado
preliminaries, loadglob(../external/lib/input_parameters/input_param.txt)
global obsno = "L"

program main
    clean_bsfcc_data
    compile_bsfcc_data
end

program clean_bsfcc_data
    forval year = 1999 (1) 2008 {
        use in 1/${obsno} using ../external/bsfcc/`year'/bsfcc`year', clear
        duplicates drop bene_id, force
        gen year=`year'
        save ../temp/bsfcc`year', replace
    }
end


program compile_bsfcc_data
    use in 1/${obsno} using ../temp/bsfcc1999, clear
    forval year = 2000 (1) 2008 {
    append using  ../temp/bsfcc`year'
    }
    save ../temp/bsfcc.dta, replace

    use ../external_links/sample/samp_list, clear
    save ../temp/used_data, replace

    merge 1:m bene_id using ../temp/bsfcc.dta, assert(1 2 3) keepusing(*) keep(3)
    save_data ../output_local/ChronicCondition.dta, ///
    replace key(bene_id year) log("../output/data_file_manifest.log")
end

* EXECUTE
main

