*#########################################################;
* Merges in drg weight and base payment amounts in order to generate a cost ;
* utilization --amount reimbursed without geographic or other costs;
**
** Note generates a fiscal year marker, drops claims not from the the 48 ;
** contiguos states.
*#########################################################;
%macro IP_RBU (data=);
    
    %HASHMERGE(data=&data., data_a=&data., data_b=drg.DRGlong, vars_b= fyear drg_cd labor capital nonlabor DRGwght,
        by=drg_cd fyear, if=a);

    %MergeMSACBSA;

    data &data.;
        set &data.;
        *DRG codes of 0 are "ungroupable" and thus should have a weight of zero.;
        if drg_cd="000" then DRGwght=0;
        if drg_cd="000" then labor=0;
        if drg_cd="000" then capital=0;
        if drg_cd="000" then nonlabor=0;

        ** Replace additional Maryland state code with standard state code;
        if prstate=80 then prstate=21;
    run;

    %MergeCMSIndices(data_in=&data.);

    data &data._missingWI;
       set &data.;
       where wage_index=.;
       if fyear<2005 then msa = prstate;
       if fyear>=2005 then cbsa= prstate;
    run;

   %MergeCMSIndices(data_in=&data._missingWI);

   data &data. ;
      set &data.(WHERE=(wage_index~=.)) &data._missingWI;
      inpatient_Q=(labor+nonlabor)*DRGwght;
      inpatient_RBU = (labor+nonlabor)*DRGwght;
      if outlrpmt~=0 then inpatient_RBU = (labor+nonlabor)*DRGwght + outlrpmt/(0.25 + 0.75*wage_index);
       LABEL
          inpatient_Q= "Cost utilization measure: base payment times specific drg wgt"
          inpatient_RBU = "Cost utilization measure: base payment times specific drg wgt plus outlier amount scaled by wage index"
          fyear= "Fiscal year";
   run;

%mend IP_RBU;


