%macro OP_RBU_Prep (data=);

   %MergeMSACBSA;

   data &data.;
        set &data.;
        ** Replace additional Maryland state code with standard state code;
        if prstate=80 then prstate=21;
       ** Northern Marianas & American Samoa takes HI value https://www.google.com/url?
             sa=t&rct=j&q=&esrc=s&source=web&cd=3&cad=rja&ved=0CDUQFjAC&url=https%3A%2F%  
             2Fmed.noridianmedicare.com%2Fweb%2Fjea%2Faudit-reimbursement%2Fwage&ei=_IuqUpynB86jkQfJz4CIAQ&usg=AFQjCNHfJtfz_CqNcQqJy43CziR61YG1BQ;
        if prstate="66" or prstate="64" then prstate="12";
    run;

   %MergeCMSIndices(data_in=&data.);

   data &data._missingWI;
      set &data.;
      where wage_index=.;
      if fyear<2005 then msa = prstate;
      if fyear>=2005 then cbsa= prstate;    
   run;

   %MergeCMSIndices(data_in=&data._missingWI);

   data &data._missingWI;
       set &data._missingWI;
       ** Guam http://www.cms.gov/Medicare/Medicare-Fee-for-Service-Payment/InpatientRehabFacPPS/Downloads/cms1433n-wage-index.pdf.; 
       if prstate="65" then wage_index=0.9611;
       ** Virgin Islands set to 1: https://www.google.com/url?sa=t&rct=j&q=&esrc=s&source=web&cd=3&cad=rja&ved=0CDUQFjAC&url=https%3A%2F%  
             2Fmed.noridianmedicare.com%2Fweb%2Fjea%2Faudit-reimbursement%2Fwage&ei=_IuqUpynB86jkQfJz4CIAQ&usg=AFQjCNHfJtfz_CqNcQqJy43CziR61YG1BQ;
       if prstate="48" then wage_index=1;
       ** No info on West Indies - per document above, set wage index to 1.; 
       if prstate="57" then wage_index=1;
    run;
       
%mend OP_RBU_Prep;
