%macro Process_PRCDR(code=);
    /* I generate a numerical version of code, which is 5 digits long;
     * I have to add lagging zeros first, because there are up to 2 digits after a decimal place
     * but the Medicare data does not add them. */

    prcdr_length= length(&code.);
    prcdr_conform = &code.;
    if prcdr_length = 3 then prcdr_conform = CATT(prcdr_conform,"0");   
    prcdr_num = input(prcdr_conform, ??4.);

%mend Process_PRCDR;

%macro Count_IpDischarges();

    if drg_cd_num >= 1 and drg_cd_num <= 3 then IpDischarges = 1;
    if drg_cd_num >= 6 and drg_cd_num <= 111 then IpDischarges = 1;
    if drg_cd_num >= 113 and drg_cd_num <= 213 then IpDischarges = 1;
    if drg_cd_num >= 216 and drg_cd_num <= 220 then IpDischarges = 1;
    if drg_cd_num >= 223 and drg_cd_num <= 230 then IpDischarges = 1;
    if drg_cd_num >= 232 and drg_cd_num <= 399 then IpDischarges = 1;
    if drg_cd_num >= 401 and drg_cd_num <= 433 then IpDischarges = 1;
    if drg_cd_num >= 439 and drg_cd_num <= 455 then IpDischarges = 1;
    if drg_cd_num >= 461 and drg_cd_num <= 467 then IpDischarges = 1;
    if drg_cd_num >= 475 and drg_cd_num <= 482 then IpDischarges = 1;
    if drg_cd_num >= 484 and drg_cd_num <= 513 then IpDischarges = 1;
    if drg_cd_num >= 515 and drg_cd_num <= 543 then IpDischarges = 1;

%mend Count_IpDischarges;

%macro Calculate_IpDays();
    IpDays = thru_dt - from_dt + 1;
%mend Calculate_IpDays;

%macro Count_SurgicalDischarges();

    if drg_cd_num >= 1 and drg_cd_num <=3 then SurgicalDischarge = 1;
    if drg_cd_num >= 6 and drg_cd_num <=8 then SurgicalDischarge = 1;
    if drg_cd_num >= 36 and drg_cd_num <=42 then SurgicalDischarge = 1;
    if drg_cd_num >= 49 and drg_cd_num <=63 then SurgicalDischarge = 1;
    if drg_cd_num >= 75 and drg_cd_num <=77 then SurgicalDischarge = 1;
    if drg_cd_num >= 103 and drg_cd_num <=111 then SurgicalDischarge = 1;
    if drg_cd_num >= 113 and drg_cd_num <=120 then SurgicalDischarge = 1;
    if drg_cd_num >= 146 and drg_cd_num <=171 then SurgicalDischarge = 1;
    if drg_cd_num >= 191 and drg_cd_num <=201 then SurgicalDischarge = 1;
    if drg_cd_num >= 209 and drg_cd_num <=213 then SurgicalDischarge = 1;
    if drg_cd_num >= 216 and drg_cd_num <=220 then SurgicalDischarge = 1;
    if drg_cd_num >= 223 and drg_cd_num <=230 then SurgicalDischarge = 1;
    if drg_cd_num >= 232 and drg_cd_num <=234 then SurgicalDischarge = 1;
    if drg_cd_num >= 257 and drg_cd_num <=270 then SurgicalDischarge = 1;
    if drg_cd_num >= 285 and drg_cd_num <=293 then SurgicalDischarge = 1;
    if drg_cd_num >= 302 and drg_cd_num <=315 then SurgicalDischarge = 1;
    if drg_cd_num >= 334 and drg_cd_num <=345 then SurgicalDischarge = 1;
    if drg_cd_num >= 353 and drg_cd_num <=365 then SurgicalDischarge = 1;
    if drg_cd_num >= 370 and drg_cd_num <=371 then SurgicalDischarge = 1;
    if drg_cd_num >= 374 and drg_cd_num <=375 then SurgicalDischarge = 1;
    if drg_cd_num >= 392 and drg_cd_num <=394 then SurgicalDischarge = 1;
    if drg_cd_num >= 401 and drg_cd_num <=402 then SurgicalDischarge = 1;
    if drg_cd_num >= 406 and drg_cd_num <=408 then SurgicalDischarge = 1;
    if drg_cd_num >= 439 and drg_cd_num <=443 then SurgicalDischarge = 1;
    if drg_cd_num >= 476 and drg_cd_num <=482 then SurgicalDischarge = 1;
    if drg_cd_num >= 484 and drg_cd_num <=486 then SurgicalDischarge = 1;
    if drg_cd_num >= 493 and drg_cd_num <=504 then SurgicalDischarge = 1;
    if drg_cd_num >= 506 and drg_cd_num <=507 then SurgicalDischarge = 1;
    if drg_cd_num >= 512 and drg_cd_num <=513 then SurgicalDischarge = 1;
    if drg_cd_num >= 515 and drg_cd_num <=520 then SurgicalDischarge = 1;
    if drg_cd_num >= 525 and drg_cd_num <=543 then SurgicalDischarge = 1;
    if drg_cd_num = 377 then SurgicalDischarge = 1;
    if drg_cd_num = 381 then SurgicalDischarge = 1;
    if drg_cd_num = 488 then SurgicalDischarge = 1;
    if drg_cd_num = 491 then SurgicalDischarge = 1;
    if drg_cd_num = 461 then SurgicalDischarge = 1;
    if drg_cd_num = 471 then SurgicalDischarge = 1;
    if drg_cd_num = 415 then SurgicalDischarge = 1;
    if drg_cd_num = 424 then SurgicalDischarge = 1;
%mend Count_SurgicalDischarges;

%macro Diagnose_HipFracture(code=, codetype=);

    %if &codetype. = icd9 %then %do;
        if code_num >= 82000 and code_num <= 82099 then HipFracture = 1;
    %end;
%mend Diagnose_HipFracture;

%macro Diagnose_AAA(code=, codetype=);

    %if &codetype. = icd9 %then %do;
        if code_num >= 44130 and code_num <= 44190 then AAA_dgns = 1;
    %end;

    %if &codetype. = prcdr %then %do;
        if &code. = "3844" then AAA_prcdr = 1;
        if &code. = "3925" then AAA_prcdr = 1; 
        if &code. = "3971" then AAA_prcdr = 1;
    %end;

    if AAA_dgns = 1 and AAA_prcdr = 1 then AAA = 1;
%mend Diagnose_AAA;


%macro Diagnose_HipReplace(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
        if code_num >= 82000 and code_num<=82139 then Hip_dgns = -1;
        if code_num >= 99640 and code_num<=99649 then Hip_dgns = -1;
    %end;

    %if &codetype. = prcdr %then %do;
        if &code. = "8151" then Hip_prcdr = 1;
    %end;

    if Hip_prcdr = 1 and Hip_dgns ~= -1 then HipReplace = 1;
%mend Diagnose_HipReplace;

%macro Diagnose_LowerBypass(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
        if &code. = "44421" then LB_dgns = -1;
    %end;

    %if &codetype. = prcdr %then %do;
        if &code. = "3929" then LB_prcdr = 1;
    %end;

    if LB_prcdr = 1 and LB_dgns ~= -1 then LowerBypass = 1;
%mend Diagnose_LowerBypass;

%macro Diagnose_Mastectomy(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
        if code_conform = "23300" then Mast_dgns = -1;
        if (code_num >= 17400 and code_num <= 17499 and Mast_dgns ~= -1) then Mast_dgns = 1;
    %end;

    %if &codetype. = prcdr %then %do;
        if &code. = "8541" then Mast_prcdr = 1;
        if &code. = "8543" then Mast_prcdr = 1;
        if &code. = "8545" then Mast_prcdr = 1;
        if &code. = "8547" then Mast_prcdr = 1;
    %end;

    if Mast_prcdr = 1 and Mast_dgns = 1 then Mastectomy = 1;
%mend Diagnose_Mastectomy;

%macro Diagnose_Colectomy(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
        if code_num >= 15300 and code_num <= 15399 then Cole_dgns = 1;
    %end;

    %if &codetype. = prcdr %then %do;
	if prcdr_num >= 4570 and prcdr_num <= 4580 then Cole_prcdr = 1;
    %end;

    if Cole_prcdr = 1 and Cole_dgns = 1 then Colectomy = 1;
%mend Diagnose_Colectomy;

%macro Diagnose_TURP(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
        if code_num >= 60000 and code_num <= 60140  then TURP_dgns = 1;
        if code_num >= 60180 and code_num <= 60210  then TURP_dgns = 1;
        if code_num >= 78820 and code_num <= 78829  then TURP_dgns = 1;
        if code_num >= 78840 and code_num <= 78849  then TURP_dgns = 1;
    %end;

    %if &codetype. = prcdr %then %do;
        if prcdr_num = 6020 then TURP_prcdr = 1;
        if prcdr_num = 6021 then TURP_prcdr = 1;
        if prcdr_num = 6029 then TURP_prcdr = 1;
    %end;

    if TURP_prcdr = 1 and TURP_dgns = 1 then TURP = 1;
%mend Diagnose_TURP;

%macro Diagnose_ValveReplace(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if prcdr_num = 3520 then ValveReplace = 1;
        if &code. = "3521" then ValveReplace = 1;
        if &code. = "3522" then ValveReplace = 1;
        if &code. = "3523" then ValveReplace = 1;
        if &code. = "3524" then ValveReplace = 1;
    %end;
%mend Diagnose_ValveReplace;

%macro Diagnose_CarotidEnd(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "3812" then CarotidEnd = 1;
    %end;
%mend Diagnose_CarotidEnd;

%macro Diagnose_CoronaryAng(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "3722" then CoronaryAng = 1;
        if &code. = "3723" then CoronaryAng = 1;
        if &code. = "8855" then CoronaryAng = 1;
        if &code. = "8856" then CoronaryAng = 1;
        if &code. = "8857" then CoronaryAng = 1;
    %end;
%mend Diagnose_CoronaryAng;

%macro Diagnose_CABG(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if prcdr_num >= 3610 and prcdr_num <= 3619 then CABG = 1;
    %end;
%mend Diagnose_CABG;

%macro Diagnose_KneeReplace(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "8154" then KneeReplace = 1;
    %end;
%mend Diagnose_KneeReplace;

%macro Diagnose_PCI(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "0066" then PCI = 1;
        if &code. = "3601" then PCI = 1;
        if &code. = "3602" then PCI = 1;
        if &code. = "3605" then PCI = 1;
        if &code. = "3606" then PCI = 1;
        if &code. = "3607" then PCI = 1;
        if &code. = "3609" then PCI = 1;
    %end;
%mend Diagnose_PCI;

%macro Diagnose_Prostatectomy(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
	if prcdr_num >= 6050 and prcdr_num <= 6059 then Prostatectomy = 1;
    %end;
%mend Diagnose_Prostatectomy;

%macro Diagnose_Cholecystectomy(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "5121" then Cholecystectomy = 1;
        if &code. = "5122" then Cholecystectomy = 1;
        if &code. = "5123" then Cholecystectomy = 1;
        if &code. = "5124" then Cholecystectomy = 1;
    %end;
%mend Diagnose_Cholecystectomy;

%macro Diagnose_CardiacCath(code=, codetype=);
    
    %if &codetype. = icd9 %then %do;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "3722" then CardiacCath = 1;
        if &code. = "3723" then CardiacCath = 1;
        if &code. = "8855" then CardiacCath = 1;
        if &code. = "8856" then CardiacCath = 1;
        if &code. = "8857" then CardiacCath = 1;
        if &code. = "3601" then CardiacCath = 1;
        if &code. = "3602" then CardiacCath = 1;
        if &code. = "3605" then CardiacCath = 1;
        if prcdr_num = 3600 then CardiacCath = 1;
        if &code. = "3606" then CardiacCath = 1;
        if &code. = "3607" then CardiacCath = 1;
        if prcdr_num >= 3610 and prcdr_num <= 3619 then CardiacCath = 1;
    %end;
%mend Diagnose_CardiacCath;

%macro Diagnose_BackSurgery(code=, codetype=);

    %if &codetype. = icd9 %then %do;
        dgnscd_1 = substr(&code., 1, 1);    
        dgnscd_2_4 = substr(&code., 2,3);
        dgnscd_2_4_num = input(dgnscd_2_4, ??3.);

        if code_num >= 14000 and code_num <= 23999 then Back_ex = 1;
        if code_num >= 63000 and code_num <= 67699 then Back_ex = 1;
        if code_num >= 83900 and code_num <= 83959 then Back_ex = 1;
        if code_num >= 72000 and code_num <= 72099 then Back_ex = 1;
        if code_num >= 73000 and code_num <= 73099 then Back_ex = 1;
        if code_num >= 80500 and code_num <= 80599 then Back_ex = 1;
        if code_num >= 80600 and code_num <= 80699 then Back_ex = 1;
        if &code. = "3241"  then Back_ex = 1;
        if &code. = "7331"  then Back_ex = 1;
        if &code. = "73310" then Back_ex = 1;
        if &code. = "73313" then Back_ex = 1;
        if &code. = "7338"  then Back_ex = 1;
        if &code. = "73395" then Back_ex = 1;
        if &code. = "73381" then Back_ex = 1;
        if &code. = "73382" then Back_ex = 1;

        ** Back Surgery:E800-E849;
        if dgnscd_1 = "E" or dgnscd_1 = "e" and (dgnscd_2_4_num >=800 and dgnscd_2_4_num <=849) then Back_ex = 1;
  
        if &code. = "3539" then Back_dgns = 1;
        if &code. = "3550" then Back_dgns = 1;
        if &code. = "3559" then Back_dgns = 1;
        if &code. = "7210" then Back_dgns = 1;
        if &code. = "7211" then Back_dgns = 1;
        if &code. = "7212" then Back_dgns = 1;
        if &code. = "7213" then Back_dgns = 1;
        if &code. = "7214" then Back_dgns = 1;
        if &code. = "72142" then Back_dgns = 1;
        if &code. = "7217" then Back_dgns = 1;
        if &code. = "7218" then Back_dgns = 1;
        if &code. = "7219" then Back_dgns = 1;
        if &code. = "72190" then Back_dgns = 1;
        if &code. = "72191" then Back_dgns = 1;
        if &code. = "7220" then Back_dgns = 1;
        if &code. = "72210" then Back_dgns = 1;
        if &code. = "72211" then Back_dgns = 1;
        if &code. = "7222" then Back_dgns = 1;
        if &code. = "7224" then Back_dgns = 1;
        if &code. = "7225" then Back_dgns = 1;
        if &code. = "72251" then Back_dgns = 1;
        if &code. = "72252" then Back_dgns = 1;
        if &code. = "7226" then Back_dgns = 1;
        if &code. = "72270" then Back_dgns = 1;
        if &code. = "72271" then Back_dgns = 1;
        if &code. = "72272" then Back_dgns = 1;
        if &code. = "72273" then Back_dgns = 1;
        if &code. = "72280" then Back_dgns = 1;
        if &code. = "72281" then Back_dgns = 1;
        if &code. = "72283" then Back_dgns = 1;
        if &code. = "72290" then Back_dgns = 1;
        if &code. = "72291" then Back_dgns = 1;
        if &code. = "72292" then Back_dgns = 1;
        if &code. = "72293" then Back_dgns = 1;
        if &code. = "7230" then Back_dgns = 1;
        if &code. = "7231" then Back_dgns = 1;
        if &code. = "7238" then Back_dgns = 1;
        if &code. = "72400" then Back_dgns = 1;
        if &code. = "72401" then Back_dgns = 1;
        if &code. = "72402" then Back_dgns = 1;
        if &code. = "72409" then Back_dgns = 1;
        if &code. = "7242" then Back_dgns = 1;
        if &code. = "7243" then Back_dgns = 1;
        if &code. = "7244" then Back_dgns = 1;
        if &code. = "7245" then Back_dgns = 1;
        if &code. = "7246" then Back_dgns = 1;
        if &code. = "72470" then Back_dgns = 1;
        if &code. = "72471" then Back_dgns = 1;
        if &code. = "72479" then Back_dgns = 1;
        if &code. = "7248" then Back_dgns = 1;
        if &code. = "7249" then Back_dgns = 1;
        if &code. = "7370" then Back_dgns = 1;
        if &code. = "7371" then Back_dgns = 1;
        if &code. = "73710" then Back_dgns = 1;
        if &code. = "73719" then Back_dgns = 1;
        if &code. = "73720" then Back_dgns = 1;
        if &code. = "7373" then Back_dgns = 1;
        if &code. = "73730" then Back_dgns = 1;
        if &code. = "73732" then Back_dgns = 1;
        if &code. = "73734" then Back_dgns = 1;
        if &code. = "73739" then Back_dgns = 1;
        if &code. = "73743" then Back_dgns = 1;
        if &code. = "7378" then Back_dgns = 1;
        if &code. = "7379" then Back_dgns = 1;
        if &code. = "7384" then Back_dgns = 1;
        if &code. = "75611" then Back_dgns = 1;
        if &code. = "75612" then Back_dgns = 1;
        if &code. = "8460" then Back_dgns = 1;
        if &code. = "8461" then Back_dgns = 1;
        if &code. = "8462" then Back_dgns = 1;
        if &code. = "8463" then Back_dgns = 1;
        if &code. = "8468" then Back_dgns = 1;
        if &code. = "8469" then Back_dgns = 1;
        if &code. = "8470" then Back_dgns = 1;
        if &code. = "8472" then Back_dgns = 1;
        if &code. = "8479" then Back_dgns = 1;
    %end;
    %if &codetype. = prcdr %then %do;
        if &code. = "030"  then Back_prcdr = 1;
        if &code. = "0302" then Back_prcdr = 1;
        if &code. = "0309" then Back_prcdr = 1;
        if &code. = "036"  then Back_prcdr = 1;
        if &code. = "8059" then Back_prcdr = 1;
        if prcdr_num >= 8100 and prcdr_num >= 8109 then Back_prcdr = 1;
        if prcdr_num >= 8130 and prcdr_num >= 8139 then Back_prcdr = 1;
        if prcdr_num >= 8460 and prcdr_num >= 8469 then Back_prcdr = 1;
        if prcdr_num >= 8050 and prcdr_num <= 8054 then Back_prcdr = 1;
        if prcdr_num >= 8161 and prcdr_num <= 8164 then Back_prcdr = 1;

        if prcdr_num >= 320 and prcdr_num <= 329 then Back_ex=1;

        if &code. = "0393" then Back_prcdr2 = 1;
        if &code. = "0394" then Back_prcdr2 = 1;
        if prcdr_num = 7850 then Back_prcdr2 = 1;
        if &code. = "7859" then Back_prcdr2 = 1;
        if prcdr_num = 7860 then Back_prcdr2 = 1;
        if &code. = "7869" then Back_prcdr2 = 1;
        if prcdr_num = 7890 then Back_prcdr2 = 1;
        if &code. = "7899" then Back_prcdr2 = 1;
        if &code. = "8451" then Back_prcdr2 = 1;
        if &code. = "8452" then Back_prcdr2 = 1;
        if &code. = "8458" then Back_prcdr2 = 1;
        if &code. = "8459" then Back_prcdr2 = 1;
        if prcdr_num = 8480 then Back_prcdr2 = 1;
        if &code. = "8481" then Back_prcdr2 = 1;
        if &code. = "8482" then Back_prcdr2 = 1;
        if &code. = "8483" then Back_prcdr2 = 1;
        if &code. = "8484" then Back_prcdr2 = 1;
        if &code. = "8485" then Back_prcdr2 = 1;
    %end;

    if (Back_prcdr = 1 or (Back_prcdr2=1 and Back_dgns=1)) then BackSurgery=1;
    if Back_ex=1 then BackSurgery=0;    
%mend Diagnose_BackSurgery;
