%macro CarrierVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %global c1998_from; %let c1998_from = from_dt;
    %global c1998_thru; %let c1998_thru = thru_dt;
    %global c1999_from; %let c1999_from = from_dt;
    %global c1999_thru; %let c1999_thru = thru_dt;
    %global c2000_from; %let c2000_from = from_dt;
    %global c2000_thru; %let c2000_thru = thru_dt;
    %global c2001_from; %let c2001_from = from_dt;
    %global c2001_thru; %let c2001_thru = thru_dt;
    %global c2002_from; %let c2002_from = sfromdt;
    %global c2002_thru; %let c2002_thru = sthrudt;
    %global c2003_from; %let c2003_from = sfromdt;
    %global c2003_thru; %let c2003_thru = sthrudt;
    %global c2004_from; %let c2004_from = sfromdt;
    %global c2004_thru; %let c2004_thru = sthrudt;
    %global c2005_from; %let c2005_from = sfromdt;
    %global c2005_thru; %let c2005_thru = sthrudt;
    %global c2006_from; %let c2006_from = from_dt;
    %global c2006_thru; %let c2006_thru = thru_dt;
    %global c2007_from; %let c2007_from = from_dt;
    %global c2007_thru; %let c2007_thru = thru_dt;
    %global c2008_from; %let c2008_from = from_dt;
    %global c2008_thru; %let c2008_thru = thru_dt;
    %global c2009_from; %let c2009_from = from_dt;
    %global c2009_thru; %let c2009_thru = thru_dt;

    %global upin1998; %let upin1998 = rfr_upin;
    %global upin1999; %let upin1999 = rfr_upin;
    %global upin2000; %let upin2000 = rfr_upin;
    %global upin2001; %let upin2001 = rfr_upin;
    %global upin2002; %let upin2002 = rfr_upin;
    %global upin2003; %let upin2003 = rfr_upin;
    %global upin2004; %let upin2004 = rfr_upin;
    %global upin2005; %let upin2005 = rfr_upin;
    %global upin2006; %let upin2006 = rfr_upin;
    %global upin2007; %let upin2007 = rfr_upin;
    %global upin2008; %let upin2008 = rfr_upin;
    %global upin2009; %let upin2009 = rfr_upin;

    %global npi1998; %let npi1998 = rfr_npi;
    %global npi1999; %let npi1999 = rfr_npi;
    %global npi1999; %let npi1999 = rfr_npi;
    %global npi2000; %let npi2000 = rfr_npi;
    %global npi2001; %let npi2001 = rfr_npi;
    %global npi2002; %let npi2002 = rfr_npi;
    %global npi2003; %let npi2003 = rfr_npi;
    %global npi2004; %let npi2004 = rfr_npi;
    %global npi2005; %let npi2005 = rfr_npi;
    %global npi2006; %let npi2006 = rfr_npi;
    %global npi2007; %let npi2007 = rfr_npi;
    %global npi2008; %let npi2008 = rfr_npi;
    %global npi2009; %let npi2009 = rfr_npi;

    %global claimid1998; %let claimid1998 = carrcntl;
    %global claimid1999; %let claimid1999 = carrcntl;
    %global claimid2000; %let claimid2000 = carrcntl;
    %global claimid2001; %let claimid2001 = claim;
    %global claimid2002; %let claimid2002 = claimindex;
    %global claimid2003; %let claimid2003 = claimindex;
    %global claimid2004; %let claimid2004 = claimindex;
    %global claimid2005; %let claimid2005 = claimindex;
    %global claimid2006; %let claimid2006 = clm_id;
    %global claimid2007; %let claimid2007 = clm_id;
    %global claimid2008; %let claimid2008 = clm_id;
    %global claimid2009; %let claimid2009 = clm_id;


    %global keep1998;
    %let keep1998 = KEEP= clm_id_new year fileYear ehic &upin1998. &npi1998. provzip hcpcs_cd
            &c1998_from. &c1998_thru. alowchrg lalowchg clmstatus plcsrvc betos mdfr_cd1;
    %global rename1998;
    %let rename1998 = RENAME= (clm_id_new=clm_id &c1998_from.=from_dt &c1998_thru.=thru_dt &upin1998.=upin &npi1998.=npi);
    %global keep1999;
    %let keep1999 = KEEP= clm_id_new year fileYear ehic &upin1999. &npi1999. provzip hcpcs_cd
            &c1999_from. &c1999_thru. alowchrg lalowchg clmstatus plcsrvc betos mdfr_cd1;
    %global rename1999;
    %let rename1999 = RENAME= (clm_id_new=clm_id &c1999_from.=from_dt &c1999_thru.=thru_dt &upin1999.=upin &npi1999.=npi);

    %do yr=2000 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id_new year fileYear bene_id ehic &&upin&yr.. &&npi&yr.. provzip hcpcs_cd
            &&c&yr._from. &&c&yr._thru. alowchrg lalowchg clmstatus mdfr_cd1 plcsrvc betos;
        %global rename&yr.;
        %let rename&yr. = RENAME= (clm_id_new=clm_id &&c&yr._from.=from_dt &&c&yr._thru.=thru_dt
             &&upin&yr..=upin &&npi&yr..=npi);
        %end;

%mend;


%macro OpClmsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id fileYear ehic at_upin at_npi
            prstate from_dt thru_dt pmt_amt ptb_coin ptb_ded blddedam prpayamt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id fileYear bene_id at_upin at_npi
            prstate from_dt thru_dt pmt_amt ptb_coin ptb_ded blddedam prpayamt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;

%mend;

%macro OpRevCntrsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id ehic fileYear rev_cntr hcpcs_cd;
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id bene_id fileYear rev_cntr hcpcs_cd;
        %end;

%mend;

%macro IpClmsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id fileYear ehic at_upin at_npi drg_cd outlrpmt
             prstate from_dt thru_dt passthru util_day pmt_amt ded_amt coin_amt blddedam prpayamt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id fileYear bene_id at_upin at_npi drg_cd outlrpmt
            prstate from_dt thru_dt passthru util_day pmt_amt ded_amt coin_amt blddedam prpayamt provider;
        %global rename&yr.;
        %let rename&yr. = RENAME= (at_upin=upin at_npi=npi);
        %end;

%mend;

%macro IpRevCntrsVarNames(year=);

    %global var_mismatch; %let var_mismatch = sgmt_num sgmtline hcpcs_yr;
    %do yr=1998 %to 2005;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id ehic fileYear rev_cntr hcpcs_cd;
        %end;
    %do yr=2006 %to 2009;
        %global keep&yr.;
        %let keep&yr. = KEEP= clm_id bene_id fileYear rev_cntr hcpcs_cd;
        %end;

%mend;
