cap program drop calc_delta_die
program calc_delta_die
    syntax using, mover_dataset(str) yvar(str) fe_var(str) saving(str)

    use hrr_orig hrr_dest using `mover_dataset', clear
    egen tag = tag(hrr_orig hrr_dest)
    keep if tag==1
    drop tag
    levelsof hrr_orig, local(orig_groups)
    levelsof hrr_dest, local(dest_groups)
    foreach loc in orig dest {
        rename hrr_`loc' hrrnum
        merge m:1 hrrnum `using', assert(1 3) keep(3) keepusing(`yvar'_total) nogen
        rename `yvar'_total `yvar'_`loc'
        rename hrrnum hrr_`loc'
    }
    gen delta_`fe_var'= `yvar'_dest - `yvar'_orig
    rename delta_`fe_var' delta_`fe_var'_`yvar'_i

    label variable delta_`fe_var'_`yvar'_i ///
        "diff in `fe_var' fixed effect of nonmovers from origin to destination, `yvar'"
    keep hrr_orig hrr_dest delta_*_*_i
    save_data `saving', replace key(hrr_orig hrr_dest) log("../output/data_file_manifest.log")
end
