cap program drop create_bootstrap_delta
program create_bootstrap_delta
    syntax using, mover_dataset(str) gamma_mean(str) gamma_standard_error(str) saving(str)

    use hrrnum `gamma_mean' `gamma_standard_error' `using', clear
    egen tag=tag(hrrnum)
    gen gamma_temp=rnormal(`gamma_mean', `gamma_standard_error') if tag==1
    by hrrnum, sort: egen gamma=max(gamma_temp)
    save ../temp/hrr_gamma, replace

    use hrr_orig hrr_dest using `mover_dataset', clear
    bys hrr_orig hrr_dest: keep if _n==1
    foreach loc in orig dest {
        rename hrr_`loc' hrrnum
        merge m:1 hrrnum using ../temp/hrr_gamma, assert(3) keep(3) keepusing(*) nogen
        rename gamma gamma_`loc'
        rename hrrnum hrr_`loc'
    }
    gen delta=gamma_dest-gamma_orig
    keep hrr_orig hrr_dest delta
    save `saving', replace

end
