** This program plots the c-f graphs
program gen_binned_plot
    syntax, outcome(str) snowbird(str) panel(str) adj(str) type(str) stratification(str) [p]

    merge_matched_nonmovers, nonmover_data("../temp/nonmover_temp.dta") ///
            loc(orig) samp(${`outcome'_samp}) outcomes(`outcome')

    if "`type'"=="slc" {
        gen diff_`outcome'_mover=`outcome'_mover -`outcome'_nonmover_orig
        gen diff_`outcome'_nonmover_orig=`outcome'_nonmover_orig -`outcome'_nonmover_orig
    }

    reshape long diff_`outcome' `outcome', i(bene_id year) j(status) string
    replace mover = 0 if status!="_mover"
    drop status
    replace delta_i = 0 if mover==0
    replace bene_id = bene_id_nonmover_orig if mover==0

    if "`p'"=="p" {

        if "`type'"=="std" {
            bys bene_id: egen `outcome'_before = mean(`outcome') if rel_yr_rit>=-5 & rel_yr_rit<=-2
            bys bene_id: egen `outcome'_after = mean(`outcome') if rel_yr_rit>=2 & rel_yr_rit<=5
        }

        if "`type'"=="ptrd" | "`type'"=="ptrd2" {
            bys bene_id: gen `outcome'_before2 = `outcome' if rel_yr_rit==-5
            bys bene_id: gen `outcome'_after2 = `outcome' if rel_yr_rit==-2
        }


        if "`type'"=="slc" {
            bys bene_id: egen `outcome'_before_orig = mean(diff_`outcome') ///
                if rel_yr_rit>=-5 & rel_yr_rit<=-2
        }
        collapse (mean) mover*  delta* `outcome'* diff*, by(bene_id)

        gen delta_check = delta_i
        xtile delta_groupT = delta_check if delta_check!=0, nquantiles(20)
        bys bene_id: egen delta_group = min(delta_groupT)
        replace delta_group = 0 if mover==0

        collapse (mean) delta_i_`stratification'=delta_i `outcome'*, by(delta_group)

    }

    else {

        gen delta_check = delta_i
        xtile delta_groupT = delta_check if delta_check!=0, nquantiles(20)
        bys bene_id: egen delta_group = min(delta_groupT)
        replace delta_group = 0 if mover==0

        if "`type'"=="std" {
            bys delta_group: egen `outcome'_before = mean(`outcome') ///
                if rel_yr_rit>=-5 & rel_yr_rit<=-2
            bys delta_group: egen `outcome'_after = mean(`outcome') ///
                if rel_yr_rit>=2 & rel_yr_rit<=5
        }

        if "`type'"=="ptrd" | "`type'"=="ptrd2" {
            bys delta_group: gen `outcome'_before2 = `outcome' if rel_yr_rit==-5
            bys delta_group: gen `outcome'_after2 = `outcome' if rel_yr_rit==-2
        }


        if "`type'"=="slc" {
           bys delta_group: egen `outcome'_before_orig = mean(diff_`outcome') ///
                if rel_yr_rit>=-5 & rel_yr_rit<=-2
        }

        collapse (mean) delta_i_`stratification'=delta_i `outcome'*, by(delta_group)

    }
    
    
    if "`type'"=="std" {
        gen `outcome'_`stratification' = `outcome'_after - `outcome'_before


    }

    if "`type'"=="ptrd" | "`type'"=="ptrd2" {
        gen `outcome'_`stratification'=`outcome'_after2 - `outcome'_before2


    }


    if "`type'"=="slc" {

       gen `outcome'_`stratification'=`outcome'_before_orig
    }



    reg `outcome'_`stratification' delta_i_`stratification'
    global slope_`stratification' = string(round(_b[delta_i], 0.001), "%5.3f")
    
    gen order = _n

end

cap program drop merge_matched_nonmovers
    program merge_matched_nonmovers
        syntax, nonmover_data(str) loc(str) outcomes(str) samp(str)

        rename bene_id bene_id_mover
        foreach outcome in `outcomes' {
            cap rename `outcome' `outcome'_mover
        }
        if "`outcomes'"!="HMO" {
            merge 1:1 bene_id_mover year using ../external/matched/MatchedPatientSample.dta, ///
                assert(1 2 3) keep(match) keepusing(bene_id_nonmover_`loc') nogen
        }
        if "`outcomes'"=="HMO" {
            merge 1:1 bene_id_mover year using ../external/matched/MatchedPatientSampleFull.dta, ///
                assert(1 2 3) keep(match) keepusing(bene_id_nonmover_`loc') nogen
        }      
        rename bene_id_nonmover_`loc' bene_id
        merge m:1 bene_id year using `nonmover_data', ///
            assert (1 2 3 ) keep(1 3) keepusing(`outcome') nogen
        foreach outcome in `outcomes' {
            rename `outcome' `outcome'_nonmover_`loc'
        }
        rename bene_id bene_id_nonmover_`loc'
        rename bene_id_mover bene_id

    end
