** This program plots the c-f graph
program graph_binned_plot
    syntax, outcome(str) snowbird(str) panel(str) adj(str) type(str) ///
        stratification_grp(str) [nohmodeath(str) xstate(str) p]

if "`outcome'"=="LnRBU" {
    global outcome_title "Log Utilization"
}
if "`outcome'"=="LnTotExpn" {
    global outcome_title "Log Spending"
}
if "`outcome'"=="RBU" {
    global outcome_title "Utilization"
}
if "`outcome'"!="RBU" & "`outcome'"!="LnRBU"   {
    global outcome_title "`outcome'"
}

if "`type'"=="std" {
    global ytitle "Change in Average ${outcome_title} on Move"
}

if "`type'"=="slc"  {
    global ytitle "Movers-Non-Movers Difference in Average ${outcome_title} Before Move"
}

if "`type'"=="ptrd"  {
    global ytitle "Change in ${outcome_title} in Years Before Move"
}

if ("`outcome'"=="LnRBU" | "`outcome'"=="LnTotExpn")  & "`type'"=="std" {
    global yrange "0 [0.25] 1"   
}
if ("`outcome'"=="LnRBU" | "`outcome'"=="LnTotExpn") & "`type'"=="slc" {   
    global yrange "-0.5 [0.25] 0.5"
}
if ("`outcome'"=="LnRBU" | "`outcome'"=="LnTotExpn") & "`type'"=="ptrd" {   
    global yrange "-.25 [0.25] .75"
    global xlabel "-0.75 [0.25] 0.75"
}

if "`outcome'"=="RBU" & "`type'"=="std" {    
    global yrange "0 [1000] 6000"
    global xlabel "-2000 [500] 2000"
}
if "`outcome'"=="RBU" & "`type'"=="slc" {    
    global yrange "-3000 [1000] 1000"
    global  xlabel "-2000 [500] 2000"
}
if "`outcome'"=="RBU" & "`type'"=="ptrd"  {   
    global yrange "0 [1000] 3000"
    global xlabel "-2000 [500] 2000"
}

if ("`outcome'"=="Lnnumcon" | "`outcome'"=="Lnhcccom")  & "`type'"=="std" {
    global yrange "-0.2 [0.1] 0.8"   
}

if "`outcome'"=="HMO"  & "`type'"=="std" {
    global yrange "-0.2 [0.05] 0.2"   
}


if "`stratification_grp'"=="none" & "`type'"!="slc" {
    tw (scatter `outcome'_none delta_i_none if delta_group!=0) ///
       (lfit `outcome'_none delta_i_none if delta_group!=0) ///
       (scatter `outcome'_none delta_i_none if delta_group==0, msymbol(X) msize(large) mcolor(red)), ///
        legend(on order(2 3) label(2 "Movers") label(3 "Matched Non-Movers") pos(5) ring(0) ///
        r(1) symx(*.3)) ///
        ylabel("${yrange}") ///
        xtitle("Destination-Origin Difference in Average ${outcome_title}") ///
        ytitle("${ytitle}", size(small)) ///
        title("Slope=${slope_none}", size(medium) pos(12) ring(0)) ///
        scheme(s1mono)
    graph export ../output/figures/`outcome'/`type'_`snowbird'_`panel'_`adj'`nohmodeath'`xstate'.eps, replace
}

if "`stratification_grp'"=="none" & "`type'"=="slc" {
    tw (scatter `outcome'_none delta_i_none if delta_group!=0) ///
       (lfit `outcome'_none delta_i_none if delta_group!=0),  ///
        legend(off) ///
        ylabel("${yrange}") ///
        xtitle("Destination-Origin Difference in Average ${outcome_title}") ///
        ytitle("${ytitle}", size(small)) ///
        title("Slope=${slope_none}", size(medium) pos(12) ring(0)) ///
        scheme(s1mono)
    graph export ../output/figures/`outcome'/`type'_`snowbird'_`panel'_`adj'`nohmodeath'`xstate'.eps, replace
}


if "`stratification_grp'"!="none" {
    local n : word count ${`stratification_grp'}
    forvalues i = 1/`n' {
        local stratification_`i': word `i' of ${`stratification_grp'}
    }
    use  ../temp/pat_data_`stratification_1'_collapse.dta, clear
    forvalues i = 2/`n' {
        merge 1:1 order using ../temp/pat_data_`stratification_`i''_collapse.dta, assert(1 2 3) ///
            keep(1 2 3) nogen
    }
   if "`stratification_grp'"!="age_group" {
       tw (scatter `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group!=0) ///
           (lfit `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group!=0) ///
           (scatter `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group==0) ///
           (scatter `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group!=0) ///
           (lfit `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group!=0) ///
           (scatter `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group==0), ///
           legend(order(2 5) label(2 "`stratification_1'. Slope=${slope_`stratification_1'}" ) ///
           label( 5 "`stratification_2'. Slope=${slope_`stratification_2'}") ///
           r(2)) xtitle("Mean delta") ///
           ytitle("Difference in `outcome',`adj',`type'")
           graph export ///
                ../output/figures/`outcome'/`type'_`snowbird'_`panel'_`adj'_`stratification_grp'`nohmodeath'`xstate'.eps, ///
                replace
    }

   if "`stratification_grp'"=="age_group" {

    tw (scatter `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group!=0) ///
       (lfit `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group!=0) ///
       (scatter `outcome'_`stratification_1' delta_i_`stratification_1' if delta_group==0) ///
       (scatter `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group!=0) ///
       (lfit `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group!=0) ///
       (scatter `outcome'_`stratification_2' delta_i_`stratification_2' if delta_group==0) ///
       (scatter `outcome'_`stratification_3' delta_i_`stratification_3' if delta_group!=0) ///
       (lfit `outcome'_`stratification_3' delta_i_`stratification_3' if delta_group!=0) ///
       (scatter `outcome'_`stratification_3' delta_i_`stratification_3' if delta_group==0) ///
       (scatter `outcome'_`stratification_4' delta_i_`stratification_4' if delta_group!=0) ///
       (lfit `outcome'_`stratification_4' delta_i_`stratification_4' if delta_group!=0) ///
       (scatter `outcome'_`stratification_4' delta_i_`stratification_4' if delta_group==0), ///
        legend(order(2 5 8 11) label(2 "`stratification_1'. Slope=${slope_`stratification_1'}" ) ///
        label( 5 "`stratification_2'. Slope=${slope_`stratification_2'}") ///
        label( 8 "`stratification_3'. Slope=${slope_`stratification_3'}") ///
        label( 11 "`stratification_4'. Slope=${slope_`stratification_4'}") r(2) span) ///
        xtitle("Mean delta") ytitle("Mean change in `outcome',`adj', `type'")
        graph export ///
            ../output/figures/`outcome'/`type'_`snowbird'_`panel'_`adj'_`stratification_grp'`nohmodeath'`xstate'.eps, ///
            replace
    }
}
end

