cap program drop load_data_event_study
program load_data_event_study
    syntax, variables(str) mover_dataset(str) [nonmover_dataset(str)] [keep_condition(str)] ///
    [drop_condition(str)] [lambda(str)] [lambda_filename(str)] [saving(str)]

    use rel_yr_rit `variables' using `mover_dataset', clear
    if "`nonmover_dataset'"!="" {
        append using `nonmover_dataset', keep(`variables')
		replace rel_yr_rit=0 if rel_yr_rit==. 
    }
    if "`keep_condition'"!="" {
        keep if `keep_condition'
    }
    if "`drop_condition'"!="" {
        drop if `drop_condition'
    }
    if "`lambda'"!="" {
        merge m:1 rel_yr_rit using `lambda_filename',assert(1 3) keep(1 3) keepusing(`lambda') nogen
        replace `lambda'=1 if mover==0
        assert `lambda'!=. if rel_yr_rit!=0, fast
    }
    egen rel_yr_group = group(rel_yr_rit), label
    sum rel_yr_group if rel_yr_rit==-1, meanonly
    global omit=`r(mean)'
    if "`saving'"!="" {
        save `saving', replace
    }

end
