cap program drop load_data_event_study_doc
program load_data_event_study_doc
    syntax, variables(str) mover_dataset(str) [nonmover_dataset(str)] [keep_condition(str)] ///
    [drop_condition(str)] [saving(str)]

    use relyr `variables' using `mover_dataset', clear
    if "`nonmover_dataset'"!="" {
        append using `nonmover_dataset', keep(`variables')
		replace relyr=0 if relyr==. 
    }
    if "`keep_condition'"!="" {
        keep if `keep_condition'
    }
    if "`drop_condition'"!="" {
        drop if `drop_condition'
    }
    egen rel_yr_group = group(relyr), label
    sum rel_yr_group if relyr==-1, meanonly
    global omit=`r(mean)'
    if "`saving'"!="" {
        save `saving', replace
    }

end
