cap program drop load_data_main_model
program load_data_main_model
    syntax, variables(str) [mover_dataset(str)] [nonmover_dataset(str)] [keep_condition(str)] ///
    [drop_condition(str)] [lambda(str)] [lambda_filename(str)] [rhs(str)] [saving(str)]

    use rel_yr_rit `variables' using `mover_dataset', clear
    append using `nonmover_dataset', keep(`variables') 

    if "`keep_condition'"!="" {
        keep if `keep_condition'
    }
    if "`drop_condition'"!="" {
        drop if `drop_condition'
    }

    merge 1:1 bene_id year using `rhs', assert(1 3) keep(1 3) keepusing(*) nogen
    egen gbene_id = group(bene_id)
    xi i.year, noomit prefix(_Y)
    if "`lambda'"!="" {
        merge m:1 rel_yr_rit using `lambda_filename', ///
            assert(1 3) keep(1 3) keepusing(`lambda') nogen
        replace `lambda'=1 if mover==0
    }

    save `saving', replace

end
