cap program drop load_data_main_model_doc
program load_data_main_model_doc
    syntax, variables(str) [mover_dataset(str)] [nonmover_dataset(str)] [keep_condition(str)] ///
    [drop_condition(str)] [rhs(str)] [saving(str)]

    use relyr `variables' using `mover_dataset', clear
    append using `nonmover_dataset', keep(`variables') 

    if "`keep_condition'"!="" {
        keep if `keep_condition'
    }
    if "`drop_condition'"!="" {
        drop if `drop_condition'
    }

    merge 1:1 researchid year using `rhs', assert(1 3) keep(3) keepusing(*) nogen
    egen gresearchid = group(researchid)
    xi i.year, noomit prefix(_Y)

    save `saving', replace

end
