cap program drop output_hrr_mean_die
program output_hrr_mean_die
    syntax using, yvar(str) saving(str) [keep_condition(str)]
    use `using' if rel_yr_rit != 0, clear
    assert rel_yr_rit == . if mover == 0
    if "`keep_condition'" != "" {
        keep if `keep_condition'
    }
    gen `yvar'_mover = `yvar' if mover == 1
    gen `yvar'_nonmover = `yvar' if mover == 0
    collapse (mean) `yvar'_total=`yvar' `yvar'_mover `yvar'_nonmover (semean) ///
        `yvar'_total_se=`yvar' [aw=awgt], by(hrrnum year) 
    collapse (mean) `yvar'*, by(hrrnum)
    save_data `saving', key(hrrnum) replace log("../output/data_file_manifest.log")
end
