cap program drop run_event_study
program run_event_study
    syntax [if] [in], y_it(str) x_it(str) delta(str) [absorb(str)] ///
        specification_name(str) [lambda(str)]  

    marksample touse
    keep if `touse'

    merge m:1 hrr_orig hrr_dest using `delta', assert(1 2 3) keep(1 3) keepusing(*) nogen
	replace delta=0 if mover==0
	
    cap mkdir ../output/`specification_name'/
    datasignature set, saving(../output/`specification_name'/datasignature, replace)

    areg `y_it' `x_it', a(`absorb')

    estimates save ../output/`specification_name'/estimates, replace
    estimates store estimates

    gen coefficient = .
    levelsof rel_yr_group, local(RYs)
    foreach RY of local RYs {
        replace coefficient = _b[`RY'.rel_yr_group#c.delta] if rel_yr_group==`RY'
     }

    if "`lambda'" != "" {
        collapse (mean) coefficient lambda_r rel_yr_group, by(rel_yr_rit)
        lambda_adjust, lambda(`lambda')
    }
    else {
        collapse (mean) coefficient rel_yr_group, by(rel_yr_rit)
    }


    keep rel_yr_rit coefficient
    save_data ../output/`specification_name'/estimates, replace key(rel_yr_rit)

end

    program lambda_adjust
        syntax, lambda(str)

            egen coefficient_pre=mean(coefficient) if rel_yr_rit<0
            egen coefficient_post=mean(coefficient) if rel_yr_rit>0
            egen lambda_pre=mean(`lambda') if rel_yr_rit<0
            egen lambda_post=mean(`lambda') if rel_yr_rit>0
            foreach var of varlist coefficient_pre - lambda_post {
                egen `var'_min=min(`var')
                drop `var'
                rename `var'_min `var'
            }
            gen share = 1 - ((coefficient_post-coefficient_pre)/(lambda_post+lambda_pre-1))
            replace coefficient = (coefficient - (1-lambda)*(1-share)) if rel_yr_rit<0
            replace coefficient = (coefficient + (1-lambda)*(1-share)) if rel_yr_rit>=0
            gen adjust_coefficient_temp = coefficient if rel_yr_rit==-1
            egen adjust_coefficient=min(adjust_coefficient_temp)
            replace coefficient=coefficient-adjust_coefficient

    end
