cap program drop run_event_study_doc
program run_event_study_doc
    syntax [if] [in], y_it(str) x_it(str) delta(str) [absorb(str)] ///
        specification_name(str) [aweight(str)]

    marksample touse
    keep if `touse'

    merge m:1 hrr_orig hrr_dest using `delta', assert(1 2 3) keep(1 3) keepusing(*) nogen
	replace delta=0 if mover==0
	
    cap mkdir ../output/`specification_name'/
    datasignature set, saving(../output/`specification_name'/datasignature, replace)
    
	if "`aweight'"!="" {
        areg `y_it' `x_it' [aw=`aweight'], a(`absorb')
	}
	else {
	    areg `y_it' `x_it', a(`absorb')
	}

    estimates save ../output/`specification_name'/estimates, replace
    estimates store estimates

    gen coefficient = .
    levelsof rel_yr_group, local(RYs)
    foreach RY of local RYs {
        replace coefficient = _b[`RY'.rel_yr_group#c.delta] if rel_yr_group==`RY'
    }
	
    gen N=_N
	egen doctor_tag=tag(researchid)
	egen N_doc=total(doctor_tag)
    collapse (mean) coefficient rel_yr_group N N_doc, by(relyr)

    keep relyr coefficient N N_doc
    save_data ../output/`specification_name'/estimates, replace key(relyr)

end
