cap program drop run_main_model_doc
program run_main_model_doc
    syntax [if] [in], [y_it(str)] [x_it(str)] [fixed_effects(str)] ///
        [specification_name(str)]  [absorb(str)] [keep_fe_estimates]

    marksample touse
    keep if `touse'

    cap mkdir ../output/`specification_name'/

    datasignature set, saving(../output/`specification_name'/datasignature, replace) reset

    areg `y_it' `x_it' `fixed_effects', a(`absorb')

    estimates save ../output/`specification_name'/estimates, replace
    estimates store estimates

    compute_hrr_fixed_effects
	
	if "`keep_fe_estimates'"=="keep_fe_estimates" {
		predict chat, d
		predict resid, residuals
        predict_list _RY* _A*, gen(xhat_it)
        replace chat = chat+xhat_it
		predict_list _Yyear*, gen(tau)
        gen cons=_b[_cons]
		keep researchid year `y_it' mover gammatilde_j gammatilde_j_se hrrnum ///
			chat xhat_it tau cons resid
	}
    else {
		keep researchid year `y_it' mover gammatilde_j gammatilde_j_se hrrnum
    }
    
	save ../temp/estimation_data_uncollapsed, replace
    
    estimates restore estimates
    gen N=1
    collapse (mean) `y_it'_bar_jt=`y_it' gammatilde_j gammatilde_j_se ///
		(semean) `y_it'_se=`y_it' (rawsum) N, by(hrrnum year)
    collapse (mean) `y_it'_bar_j=`y_it'_bar_jt `y_it'_se gammatilde_j gammatilde_j_se ///
		(sum) N, by(hrrnum)
    gen ctildebar_j = `y_it'_bar_j - gammatilde_j

    save_data ../output/`specification_name'/hrr_fe, replace key(hrrnum)


end

    program compute_hrr_fixed_effects
    *This function computes HRR fixed effects from the regression above. If the option lambda 
    *is specified then it adjusts for fuzzy timing of move.
    
        gen gammatilde_j = .
        gen gammatilde_j_se = .
        levelsof hrrnum, local(hrrnum_levels)
        foreach H of local hrrnum_levels {
            replace gammatilde_j = _b[_Ihrrnum_`H'] if hrrnum==`H'
            replace gammatilde_j_se = _se[_Ihrrnum_`H'] if hrrnum==`H'
        }
        

    end
