cap program drop run_mortality_event_study
program run_mortality_event_study
	syntax [if], outcomes(str) x_it(str) specification_name(str)

	marksample touse
	keep if `touse'
	
	foreach outcome in `outcomes' {
		merge m:1 hrr_orig hrr_dest using ../external/ranks/delta_`outcome', ///
			assert(1 2 3) keep(1 3) keepusing(*) nogen
		rename delta_hrrnum_`outcome'_i delta_`outcome'
		
		reg `outcome' delta_`outcome' `x_it'
		gen beta_`outcome'=_b[delta_`outcome']
	}
	
	keep beta_*
	keep if _n==1
	xpose, clear
	rename v1 coefficient
	gen rel_yr_rit=_n
		 
    twoway (connected coefficient rel_yr_rit), ///
        xlabel(-10(1)8) ytitle("Died By Relative Year (Coefficient)") legend(off) ///
        scheme(s1mono) xline(0,lwidth(7) lcolor(gs11)) ///
		yline(-.25 (.25) 1, lwidth(vthin) lcolor(gray)) xtitle("Year Relative to Move") ///
		ylabel(-.25 (.25) 1)

     graph export ../output/figures/`specification_name'.eps, replace    

end
