cap program drop run_mortality_model
	program run_mortality_model
		syntax [if], [y_it(str)] [fixed_effects(str)] [specification_name(str)]

		marksample touse
		keep if `touse'

		cap mkdir ../temp/`specification_name'/

		datasignature set, saving(../temp/`specification_name'/datasignature, replace) reset

		reg `y_it' `fixed_effects'

		predict_list _Ihrrnum*, gen(gammatilde_j)	
		keep bene_id `y_it' gammatilde_j hrrnum
		save ../temp/estimation_data_uncollapsed, replace

		gen N=1
		collapse (mean) `y_it'_bar_j=`y_it' gammatilde_j (rawsum) N, by(hrrnum)
		gen ctildebar_j = `y_it'_bar_j - gammatilde_j

		save_data ../temp/`specification_name'/hrr_fe, replace key(hrrnum)

	end
