cap program drop run_xsection_event_study
program run_xsection_event_study
	syntax [if] [in], y_it(str) x_it(str) delta(str) specification_name(str)

	marksample touse
	keep if `touse'

	merge m:1 hrr_orig hrr_dest using `delta', assert(1 2 3) keep(1 3) keepusing(*) nogen
	replace delta=0 if mover==0
		
	cap mkdir ../output/`specification_name'/
	datasignature set, saving(../output/`specification_name'/datasignature, replace)
		
	gen coefficient = .
	levelsof rel_yr_group, local(RYs)
	foreach RY of local RYs {
		reg `y_it' `x_it' if rel_yr_group==`RY'
		replace coefficient = _b[delta] if rel_yr_group==`RY'
	}
		 
	collapse (mean) coefficient, by(rel_yr_rit)
	gen rel_yr_standard_temp=coefficient if rel_yr_rit==-1
	egen rel_yr_standard=min(rel_yr_standard_temp)
	replace coefficient=coefficient - rel_yr_standard

	keep rel_yr_rit coefficient
	save_data ../output/`specification_name'/estimates, replace key(rel_yr_rit)

end
