** This program generates a histogram of delta for a given dataset and sample.
cap drop summarize_delta_doc
program summarize_delta_doc
	syntax using, [keep_condition(str)] [drop_condition(str)] [delta_dataset(str)] ///
        [delta_variable(str)] [xtitle(str)] [xlabel(str)] [saving(str)]

    use researchid year hrr_orig hrr_dest baseline_samp `using', clear

    if "`keep_condition'"!="" {
        keep if `keep_condition'
    }
    if "`drop_condition'"!="" {
        drop if `drop_condition'
    }

	merge m:1 hrr_orig hrr_dest using `delta_dataset', ///
        assert(match using) keep(match) keepusing(`delta_variable')

    rename `delta_variable' delta_i
	
    collapse (mean) delta_i, by(researchid)
    insert_tag summ_delta_LnRBU, open
        summ delta_i, d
        insert_tag summ_delta_LnRBU, close
    local mean: display %8.3fc `r(mean)'
    local sd: display %8.3fc `r(sd)'

    hist delta_i, xlabel(`xlabel') ///
        fraction ytitle("Share of Movers") xtitle(`xtitle') ///
        legend(on order(- "Mean = `mean'" "SD = `sd'") pos(2) ring(0) region(lp(solid))) ///
        scheme(s1mono)
    graph export `saving', replace

end
