** Script for importing the xport file created in stata- stat-transfer is currently not working;
** for the job;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";


**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";

libname here "."    ;
libname inHRR "&HRRext."    ;
OPTIONS NOFMTERR;
libname in XPORT "./mashrrxw.xpt";

%let datedownload=10_20_2010;

data inHRR.masterhrrcross;
    set in.MasHRRxw;
    label
        hrrnum="Dartmth HRR Num, &datedownload."
        hrrcity=  "Dartmth HRR city, &datedownload."
        hrrstate=  "Dartmth HRR state, &datedownload."
        hsanum=  "Dartmth HSA Num, &datedownload."
        hsacity=  "Dartmth HSA city, &datedownload."
        hsastate=  "Dartmth HSA state, &datedownload."
        year=  "year to be used for merging -1995 used for 1984 to 1994"
        rawyear=  "HRR data used in current year -- 1995 is used before 1995";

run;

proc sort data=inHRR.masterhrrcross;
    by year zipcode;
run;

proc contents data=inHRR.masterhrrcross;run;
x "rm mashrrxw.xpt -f";

