**Creates a population level denomin enrollment file;
* DOES NOT ACCOUNT FOR THE SMALL AMOUNT OF CASE WHERE AN EHIC SWITCHER HAS DIFFERENT;
* INFORMATION FOR THE SAME BENE_ID;
* WRAPPER MACRO FOUND AT THE END ---%RunPrgram;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";


**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";
* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./DetermineMax.sas";
*Put final variable labels in this file;
%include "&SASmac./Labels.sas";
*Program which mergers in the crosswalk;
%include "&SASmac./ConformDenom.sas";
%include "&SASmac./archiveoldLogfiles.sas";
%include "&SASmac./decompressDenom.sas";
%include "&SASmac./decompressEnroll.sas";


*define libraries that allow access to the various directories specified above;
* define libraries.Defines local directories depending on which server currently running;
    libname spmed "&spmed.";
    libname spden "&spden.";
    libname spxw "&spxw";
    libname denerz "&denerz.";
    libname inDen "&inden.";
    libname here ".";
    libname denex "&denext.";
    libname inHRR  "&inHRRzipxw.";


%macro ExtractDenomInfo(pct=,yr=,start=,end=,identifier=,dflag=0,);
    %if &yr.>=2006 %then %do;
        %let rawid=bene_id;
        %end;
    %if &yr.<=2005 %then %do;
        %let rawid=ehic;
        %end;

*DATA STEP 6;
    proc contents data=denerz.denom&pct._&yr._all;run;

    data spden.denompop_&yr.;
        set denerz.denom&pct._&yr._all (in=inDenom);
       * Record the year from which this record comes;
        fileyear = &yr.;

        * Convert the file format for this year into a standard form;
        %if &pct.=05 %then %let NewVar= fivepctN efivepctN ;
        %if &pct.=0001 or &pct.=100 or &pct.=20  %then %let NewVar= ;

        ** Include information on the enhanced versus strict 5% samples. Create variable;
        ** in earlier years Recode into a binary numeric;
        %if &yr.>=2006 and &pct.=05 %then %do;
            %if &yr. =2009 %then %let strictflag=STRCTFLG;
            %if &yr. < 2009 or &yr>=2010 %then %let strictflag=fivepct;
            fivepctN=.;
            efivepctN=.;

            if &strictflag.="Y" then fivepctN=1;
            if efivepct="Y" then efivepctN=1;

            if &strictflag.="" then fivepctN=0;
            if efivepct="" then efivepctN=0;
            %end;

        ** All pre 2006 data comes from a strict 5% sample. Create this variable for consistency.;
        %if &yr.<=2005 and &pct.=05 %then %do;
         fivepctN=1;
         efivepctN=0;
         %end;

     %if &pct.=05 %then %do;
        ** Makes sure that all enhanced sample (non-five percent;
        ** sample are dropped from the dataset >=2006;
        if fivepctN=0 and &yr.>=2006 then delete;
        %end;

    ** Begin harmonizing variables;
    %ConformDenom(year=&yr.,adVar=fileyear &rawid. );
    run;



    ** Delete the Raw Denom record once we reach last cohort and after we have changed the medpar year;
        %if &dflag.=1 %then %do;
            x "rm &denerz./denom&pct._&yr._all.* -f " ;
            %end;
    %mend;

%macro ProcessDenomInfo(start=,end=,pct=,identifier=);
** This macro transforms the denominator file extract from long form (as generated;
** in the macro ExtractDenomInfo) into wide form;
** DATASTEP 7;

    proc print data=spden.denompop_2010 (obs=10 keep=bene_id buyin: hmo: fileyear);
    run;

    data denerz.pop_dataset_denom2005;
        length sdod 5 zipcode_de $9 ;
        set %RepeatN(spden.denompop_,&start.,2005);
    run;

    data denerz.pop_dataset_denom2006;
        set %RepeatN(spden.denompop_,2006,&end.);

    run;


    %if &dflag.=1 %then %do;
        x "rm &spden./denompop_* -f ";
        %end;

    proc sql;
    create table denerz.pop_denom2005bene as
        select *
        from denerz.pop_dataset_denom2005  S LEFT JOIN spxw.ehicbenex_unique&pct.  M
        ON  (S.ehic = M.ehic);
    quit;


    data denerz.pop_denombene ;
        set denerz.pop_denom2005bene denerz.pop_dataset_denom2006;
        bene_idinbene=0;
        if bene_id="" then bene_idinbene=1;
        if bene_id="" then bene_id=ehic;

    run;

    proc freq data=denerz.pop_denombene;
        table bene_idinbene;
    run;

    ** Sorting data as appropriate for the ensuing data step;
    proc sort data=denerz.pop_denombene;
        by bene_id fileyear;
    run;


*********************************************************************;
** TAKE DEMO VARIABLES AND SAVE THEM IN A WIDE AND LONG FORMAT     **;
*** this keeps the entire history of variables for those interested *;
*********************************************************************;

    data denex.pop&pct._demovars_wide (drop=sex race sdob sdod zipcode_de fileyear bene_zipnob benezip5 benezip5_num state_de benezip_num y);
        set denerz.pop_denombene (keep=bene_id ehic sex race sdob sdod county_de zipcode_de state_de fileyear bene_idinbene v_dod_sw);
        by bene_id;

        retain sex1992-sex&end. race1992-race&end.  sdob1992-sdob&end. sdod1992-sdod&end. county1992-county&end. benezip1992-benezip&end. benestate1992-benestate&end.;
        array a_sex{1992:&end.} $1 sex1992-sex&end.;
        array a_county{1992:&end.} $3 county1992-county&end.;
        array a_race{1992:&end.} $1 race1992-race&end.;
        array a_sdob{1992:&end.} 8  sdob1992-sdob&end.;
        array a_sdod{1992:&end.} 8  sdod1992-sdod&end.;
        array a_state{1992:&end.} $2  benestate1992-benestate&end.;
        array a_benezip{1992:&end.} $9 benezip1992-benezip&end.;
        bene_zipnob=compress(zipcode_de,,'s');
        benezip_num=input(bene_zipnob,8.);

        if length(bene_zipnob) >5 then benezip5=substr(bene_zipnob,1,5);
        if length(bene_zipnob) <=5 then benezip5=bene_zipnob;
        benezip5_num=input(benezip5,8.);

        do y=1992 to &end;
            if first.bene_id then do;
                a_state(y) = "";
                a_sex(y) = "";
                a_race(y) = "";
                a_sdod(y) = .;
                a_sdob(y) = .;
                a_benezip(y) = "";
                a_county(y) = "";
                end;
            if fileyear=y then do;
                a_county(y) = county_de;
                a_state(y) = state_de;
                a_sex(y) = sex;
                a_race(y) = race;
                a_sdod(y) = sdod;
                a_sdob(y) = sdob;
                a_benezip(y) = benezip_num;
            end;
        end;
        if last.bene_id then output;
    run;


***********************;
** GENERATE A LONG DEMO VAR;
***********************;
    data denex.pop&pct._demovars_long ;
        set denerz.pop_denombene (keep=bene_id ehic sex race sdob sdod zipcode_de  county_de fileyear bene_idinbene state_de v_dod_sw);
        bene_zipnob=compress(zipcode_de,,'s');
        benezip_num=input(bene_zipnob,8.);
        if length(bene_zipnob) >5 then benezip5=substr(bene_zipnob,1,5);
        if length(bene_zipnob) <=5 then benezip5=bene_zipnob;
        benezip5_num=input(benezip5,8.);
    run;

    ** **2006 through 2008 have duplicates, in the 100% data a handful of bene_ids have duplicates between 1992-1999;
    proc sort data=denex.pop&pct._demovars_long NODUPKEY;
        by bene_id ehic fileyear;
    run;
/*
                                                               The SAS System                        07:26 Tuesday, January 29, 2013   1

                                                         The FREQ Procedure

                                      year to be used for merging -1995 used for 1984 to 1994

                                                                        Cumulative    Cumulative
                                   fileyear    Frequency     Percent     Frequency      Percent
                                   -------------------------------------------------------------
                                       1992          18        0.33            18         0.33
                                       1993          17        0.31            35         0.64
                                       1994          12        0.22            47         0.86
                                       1995          10        0.18            57         1.04
                                       1996           9        0.16            66         1.20
                                       1997           1        0.02            67         1.22
                                       1998           1        0.02            68         1.24
                                       1999           1        0.02            69         1.26
                                       2006        2640       48.14          2709        49.40
                                       2007        1945       35.47          4654        84.87
                                       2008         830       15.13          5484       100.00
*/



***********************;
** BRING HRR/HSA INFO
***********************;
    proc sort data=inHRR.masterhrrcross;
        by year zipcode;
    run;

    proc sort data=denex.pop&pct._demovars_long;
        by fileyear benezip5_num;
    run;

    data denex.pop&pct._hsahrr_long ;
        merge denex.pop&pct._demovars_long (in=inindx)
              inHRR.masterhrrcross (in=xw rename=(year=fileyear zipcode=benezip5_num) );
        by fileyear benezip5_num;

        rename HRRCITY=bene_hrrcity
               HRRNUM=bene_hrrnum
               HRRSTATE=bene_hrrstate
               HSACITY=bene_hsacity
               HSASTATE=bene_hsastate
               HSANUM=bene_hsanum;

        LABEL
            ehic= "NBER Encrypted health insurance claim number (individual unique identifier)"
            bene_id= "Encrypted beneficiary identifier "
            sdob= "Date of birth"
            sdod= "Date of death"
            race= "Race code"
            sex= "Sex"
            v_dod_sw="valid date of death"
            benezip5_num = "Zipcode number, first five digits"
            bene_zipnob = "Zipcode number for beneficiary in the denominator files(character)"
            hrrnum = "Dartmouth HRR Num, matched on bene zip code"
            hrrcity = "Dartmouth HRR city, matched on bene zip code"
            hrrstate = "Dartmouth HRR state, matched on bene zip code"
            hsanum = "Dartmouth HSA Num, matched on bene zip code"
            hsacity = "Dartmouth HSA city, matched on bene zip code"
            hsastate = "Dartmouth HSA state, matched on bene zip code"
            fileyear = "Year raw file"
        if inindx;
    run;

    proc sort data=denex.pop&pct._hsahrr_long  dupout=denex.pop&pct._hsahrr_long_dupes NODUPKEY;
        by bene_id fileyear;
    run;

    proc sort data=denex.pop&pct._demovars_long;
        by bene_id fileyear;
    run;

********************************************************************************;
*** CONVERT TOO WIDE;
********************************************************************************;
    proc sort data=denerz.pop_denombene;
        by bene_id fileyear;
    run;

    data denerz.pop_dataset_widedenom;
        set denerz.pop_denombene;
        by bene_id fileyear;

        keep bene_id  sex race sdob sdod
            %GenYM(buyin,&start.,&end)
            %GenYM(hmoind,&start.,&end.)
            count fileyear;

        retain %GenYM(buyin,&start.,&end.)
            %GenYM(hmoind,&start.,&end.) ;

        ** arrays for input (long form) enrollment and hmo variables;
        array ai_entitl{1:12} buyin1-buyin12;
        array ai_hmo{1:12} hmoind1-hmoind12;

        * arrays for output (wide form) enrollment and hmo variables;
        array ao_entitl{&start.:&end.,1:12} $ 1 %GenYM(buyin,&start.,&end.);
        array ao_hmo{&start.:&end.,1:12} $ 1 %GenYM(hmoind,&start.,&end.);

        ** initialize output arrays on the first observation for each individual;
        if first.bene_id then do;
            do y=&start. to &end.;
                do m=1 to 12;
          * Add a missing code below so we can differentiate missing values from lost;
          ** values in the current process;
                    ao_entitl(y,m) = "M";
                    ao_hmo(y,m) = "M";
                    end;
                end;
            end;

        ** slot the values for this observation into their positions in the output array;
        do m=1 to 12;
            ao_entitl(fileyear,m) = ai_entitl(m);
            ao_hmo(fileyear,m) = ai_hmo(m);
            end;

        ** When all years of enrollment data for this individual have been processed, output the record;
        ** Note that this approach accepts the race/sex/DOB information on the last year record. For a ;
        ** very small number of individuals, these fields do change from one denominator file to the next.;
        ** Generally, these changes look like typos being corrected over time.  Thus, simply accepting;
        ** the most recent values of these fields is likely the correct approach;
        * ;
        ** This approach also means that, the field year contains the last year that the individual;
        ** appears in the denominator file;
        if last.bene_id then output denerz.pop_dataset_widedenom;
    run;

    proc print data=denerz.pop_dataset_widedenom (obs=10 keep=bene_id buyin: hmo: fileyear);
        WHERE fileyear=2010;
    run;

    proc print data=denerz.pop_denombene ( obs=10 keep=bene_id buyin: hmo: fileyear);
        where bene_id="mmmmmmDDWDmsXDD";
    run;

    %do y=1992 %to &end;
    data denerz.pop_dataset_demvar&y.   ;
        set denerz.pop_denombene (keep=bene_id  sex race sdob sdod fileyear count v_dod_sw);
        WHERE fileyear<=&y.;
        by bene_id fileyear;

        **Outputs the annual demographic variable using the last reported year;
        if last.bene_id and last.fileyear then do;
            output denerz.pop_dataset_demvar&y.;
            end;
        run;
        %end;


    ** Drop datasets no longer needed;
    proc datasets lib=spxw nolist;
        DELETE pop_dataset_denom;
    run;

    %mend;

%macro ExtractNRol(start=,pct=,identifier=);
** extracts enrollment records for all individuals having an diag at any point during the period;
    %if &pct.=01 or &pct.=0001 %then %let enpct=05;
    %else %let enpct=&pct.;
** DATA STEP 9;
    ** Extract records from the enrollment file for all those who have an diag during the study period;
    ** Extract with respect to bene_id because pre 1985.;
    **(where=(ehic=094221045A));
    proc sql;
    create table denerz.enrolbeneid as
        select *
        from spden.nrol&enpct._1984_2001_all
        S LEFT JOIN spxw.ehicbenex_unique&pct.  M
        ON  (S.ehic = M.ehic)
        ORDER by S.ehic;
    quit;


    data denerz.enrolehicinbene ;
        set denerz.enrolbeneid;
        ehicInbene=0;
        if bene_id="" then do;
            ehicInbene=1;
            bene_id=ehic;
            end;
    run;

    x "rm &denerz./enrolbeneid.sas* -f";

    proc sort data=denerz.enrolehicinbene;
        by bene_id;
    run;

    ** THERE IS AN ISSUE HERE FOR INDIVIDUALS WHO ARE EHIC SWITCHERS WHICH SHOW DIFFERENT ;
    ** ENROLLMENT PATTERNS ACROSS INDIVIDUALS. FOR EXAMPLE SUPPOSE BENE_ID 1 HAD ORIGINAL ;
    ** EHIC A AND THEN SWITCHED TO EHIC B. THE CODE BELOW WILL COMBINE THE ENROLLMENT ;
    ** PATTERNS FOR EHIC A AND B WHEN THEY EITHER HAVE THE SAME VALUES OR ONLY ONE IS POPULATED. ;
    ** HOWEVER WHEN THE EHIC ARE POPULATED WITH DIFFERING ENROLLMENT INFORMATION ONLY THE LATTER IS KEPT;
    data denerz.pop_dataset_nrolBene;
        LENGTH ehic $15;
        set denerz.enrolehicinbene ;
        by bene_id;

        retain buyin: hmoind: ;
        ** Translate the enrollment status variables to match the form available from the;
        ** denominator file.;
        array i_entit{&start.:1991,1:12} %do y=&start. %to 1991; en&y._01-en&y._12 %end; ;
        array o_entit{&start.:1991,1:12} $ 1 %GenYM(buyin,&start.,1991);
        array o_hmo{&start.:1991,1:12} $ 1 %GenYM(hmoind,&start.,1991);

            do y=&start. to 1991;
                do m=1 to 12;
                    if first.bene_id  then do;
                        o_entit(y,m) = "";
                        o_hmo(y,m) = "";
                        end;

                    if i_entit(y,m) in ("a","A") then do;
                        o_entit(y,m) = "1";
                        o_hmo(y,m) = "0";
                        end;
                    else if i_entit(y,m) in ("b","B") then do;
                        o_entit(y,m) = "2";
                        o_hmo(y,m) = "0";
                        end;
                    else if i_entit(y,m) in ("c","C") then do;
                        o_entit(y,m) = "3";
                        o_hmo(y,m) = "0";
                        end;
                    else if i_entit(y,m) in ("d","D") then do;
                        o_entit(y,m) = "";
                        o_hmo(y,m) = "";
                        end;
                    else if i_entit(y,m) in ("h","H") then do;
                        o_entit(y,m) = "3";
                        o_hmo(y,m) = "H";
                        end;
                    end;
                end;
            if last.bene_id then output;
            keep bene_id ehic hbdate hddate hrace hsex buyin: hmoind: count;
    run;

    **THIS IS A CASE WHERE BENE_ID IS EHIC SWITCHER AND THE ENROLLMENT VARIABLE DIFFER;
    /*proc print data=denerz.pop_dataset_nrolBene;
        WHERE bene_id="mmmmmmmWGmDmUmm";
    run;
*/
** Drop datasets we no longer need;
    x "rm &denerz./enrolehicinbene.sas* -f";


    %mend;

%macro CombineDenomNrol(pct=,start=,end=,identifier=);
** This macro merges the wide form denominator file with the enrollment file;
    proc sort data=denerz.pop_dataset_widedenom;
        by bene_id ;
    run;


    %if &start.<1992 %then %do;
        proc sort data=denerz.pop_dataset_nrolBene;
            by bene_id ;
        run;

        %do y=1992 %to &end;
            data denex.pop&pct._demo_bene_idcharvar&y. ;
                merge denerz.pop_dataset_demvar&y. (in=inWD keep=bene_id sex race sdod sdob fileyear v_dod_sw)
                    denerz.pop_dataset_nrolBene (in=inNrol keep=bene_id hddate hbdate  hrace hsex );
                by bene_id;
                ** As above, give more recent data on dates of birth/death, race, and sex, etc. precedence over earlier;
                ** From above, the year indicator on the widedenom file indicates the latest denom file that;
                ** a particular record in the widedenom file includes --SHOULD THIS BE 2001. I think we use 2001 assuming that the enrollment file is correct;
                if (inNrol and not inWD) or (inNrol and inWD and fileyear < 1992) then do;
                    sdob = hbdate;
                    sdod = hddate;
                    race = hrace;
                    sex = hsex;
                        end;
               ** Took year out here;
                    drop hbdate hddate hrace hsex fileyear;
               ** Label variablesr for stata;
                    %LabelLonExt_demo;
                    if last.bene_id then output;
            run;


            %end;

** DATA STEP 10;
        data denex.pop&pct._demo_bene_id;
            merge denerz.pop_dataset_widedenom(in=inWD) denerz.pop_dataset_nrolBene(in=inNrol);
            by bene_id;
            if last.bene_id then output;
            drop count;
        run;

        ** Drop datasets we no longer need;
        %if &dflag.=1 %then %do;
            x "rm &denerz./pop_dataset_widedenom.sas* -f";
            x "rm &denerz./pop_dataset_nrolBene.sas* -f";
            %end;
        %end;
    %else %do;
        %do y=1992 %to &end;
            data denex.pop&pct._demo_bene_idcharvar&y.;
                set denerz.pop_dataset_demvar&y. ;
                by bene_id;
                %LabelLonExt_demo;
                drop fileyear;
                if last.bene_id then output;
            run;

            /*proc contents data=denex.pop&pct._demo_bene_idcharvar&y.;run;*/
            %end;

        data denex.pop&pct._demo_bene_id;
            set denerz.pop_dataset_widedenom(in=inWD);
            by bene_id;

       ** Label variables for stata;
            %LabelLonExt_demo;
            if last.bene_id then output;
        run;

        ** Drop datasets we no longer need;
        %if &dflag.=1 %then %do;
            x "rm &denerz./pop_dataset_widedenom.sas* -f";
            %end;

        %end;

    proc sort data=denex.pop&pct._demo_bene_id;
        by bene_id;
    run;
/*
    proc print data=denex.pop&pct._demo_bene_id (keep=bene_id sdob );
        WHERE bene_id='mmmmmmmWGmDmUmm';
    run;
*/
        /* DO NOT CREATE INDEX SO PEOPLE CAN WORK WITH THE POP FILE EASILY??
         * INDX are fast for looking up about 10 to 20% of the sample*/

    data  %do yr=&start. %to &end.;
        denex.pop&pct._demo_bene_id&yr.
            (keep=bene_id  %GenYM(buyin,&yr.,&yr.) %GenYM(hmoind,&yr.,&yr.))
            %end;;
        set denex.pop&pct._demo_bene_id;
        %do yr=&start. %to &end.;
            output denex.pop&pct._demo_bene_id&yr.;
            %end;
    run;

    proc print data=denex.pop&pct._demo_bene_id ( obs=10 keep=bene_id buyin2010: hmoind2010:);
        where bene_id="mmmmmmDDWDmsXDD";
    run;

    proc freq data=denex.pop&pct._demo_bene_id ;
        table buyin2010m1 buyin2009m1 buyin2000m9 ;
    run;

    /*DONT SAVE AS INDX FILE;
    %do yr=&start. %to &end.;
        proc sql;
            create  index bene_id on denex.pop&pct._demo_bene_id&yr. (bene_id)  ;
            quit;
            %end;
*/

        x "rm &denerz./* -f";
                %mend;



**#############################################################################;
*** BEGIN  WRAPPER MACRO HERE**************************************************;
**#############################################################################;
%macro CreatePopEnrollFile(yearin=,yearout=,pct=,id=,dflag=,clmDTA=);

***STEP 1: PRELIMINARY MACRO WRAPPER PARAMETER DEFINITIONS---;

    *Make Sure we are starting with an empty dataset;
    x "rm &denerz./* -f";
    x "rm &denext./pop&pct._* -f";
**#############################################################################;
*****---------TIMER CODE ----------;
**#############################################################################;
%global tBeforeRun;
%let tBeforeRun=%sysfunc(datetime());

x "rm &spxw./* -f ";
x "cp &inbenexw./ehicbenex_unique_bene_indx&pct..* &spxw./ -f ";
x "cp &inbenexw./ehicbenex_unique&pct..* &spxw./ -f ";
x "bunzip2 &spxw./*.*bz2  ";


**#############################################################################;
***STEP 3: BRING IN ENROLLMENT INFORMATION FROM DENOM AND ENROLLMENT FILES;
**#############################################################################;

    ** Set Denominator start year;
%if &yearin.>=1992 %then %do;
    %let denomst=&yearin.;
    %end;
%else %do;
    %let denomst=1992;
    %end;

    *************************************************************************;
    ** *STEP3A: DECOMPRESS AND EXTRACT DENOMINATOR FILE (1992-2005);
    *************************************************************************;
x "rm &denerz./* -f " ;
  %do y=&denomst. %to &yearout. ;
    ** Only run the denom files if the yearin is equal to or after 1992--since thats when;
    ** they start;

      %if &y.>=1992 %then %do;
          %decompressDenom(yr=&y.,pct=&pct.,outdir=&denerz.,outlib=denerz,dflag=&dflag.);
          %ExtractDenomInfo(pct=&pct.,yr=&y.,start=&denomst.,
              end=&yearout.,identifier=&id.,dflag=&dflag.);
          %end;
      %end;

    *************************************************************************;
    *STEP3B: EXTRACT ENROLL (1984-1991);
    *************************************************************************;
    ** DO OUTSIDE OF THE LOOP BECAUSE ONLY NEED TO DO ONCE ;
  %if &yearin. < 1992 %then %do;
      %decompressEnroll(pct=&pct.,outdir=&spden.,dflag=&dflag.);
      %ExtractNRol(start=1984,pct=&pct.,identifier=&id.);
      %end;

    %ProcessDenomInfo(start=&denomst.,end=&yearout.,
        pct=&pct.,identifier=&id.);

    %CombineDenomNrol(pct=&pct.,start=&yearin.,end=&yearout.,
        identifier=&id.);

        **#############################################################################;
        *****---------TIMER CODE ----------;
        **#############################################################################;
    %let tAftercohrt=%sysfunc(datetime());
    %let elapsedcohrt=%sysevalf(%sysevalf((&tAftercohrt.-&tBeforeRun.)/60));
    %put <TIMER> FINAL  took &elapsedcohrt. minutes  ;

    **#############################################################################;
    *Delete all temp files;
    **#############################################################################;
    %if &dflag.=1 %then %do;
        proc datasets lib=denerz nolist kill ; run;
        proc datasets lib=spden nolist kill ; run;
            %end;

        %let tAfterRun=%sysfunc(datetime());
        %let elapsedrun=%sysevalf(%sysevalf((&tAfterRun.-&tBeforeRun.)/60));
        %put <TIMER> FINAL  took &elapsedrun. minutes  ;
    **#############################################################################;
    *Copy log and lst files to folder with same name and attach date being run;
    **#############################################################################;
        %archiveoldLogfiles(pct=&pct.,yearin=&yearin.,yearout=&yearout.)  ;

        x "rm &spxw./* -f ";
        /*x "bzip2 --best &denext./* -f";*/

        x "rm &spden./* -f ";

            %mend;



***********************Call Wrapper Program Below-***********************;
*WRAPPER MACRO DOCUMENTATION --SAME AS DOC FOUND AT BEGINNING OF SCRIPT ---;
*** It has the following options;
*** yearin=    -- Start year for the run;
*** yearout=   -- End year for the run;
*** pct=05     -- Define the percent extract you are interested in. Use .01% for debugging where possible;
*** win=1      -- Define the  window around the index event for the program to extract.;
***            -- In years. Note when changing this you may also be interested in changing the window;
***               which determines which consecutive index events get dropped. For example currently;
***               the program drops AMIs from the index events which occur within the past year. Search;
***               variable name last_dgn_date for more info  ;
*** identifier -- Choose to either use the old bene_id or the new bene_id ;
*** dflag      -- Set equal to one if you want to delete raw files as you run the program;

*** clmDTA     -- Set equal to one if you want to convert the all files into a stata format (DTA)*;
***;
******NOTE ABOUT LOG******;
*     At the end of each run the program copies the log and lst file to a folder and appends the date to it.;
* ;
************************************************************************************************************;


*%CreatePopEnrollFile(yearin=1984,yearout=2012,pct=05,id=bene_id,dflag=1,clmDTA=0);
*%CreatePopEnrollFile(yearin=1992,yearout=2012,pct=100,id=bene_id,dflag=1,clmDTA=0);
*%CreatePopEnrollFile(yearin=1984,yearout=2012,pct=0001,id=bene_id,dflag=1,clmDTA=0);
%CreatePopEnrollFile(yearin=1984,yearout=2012,pct=01,id=bene_id,dflag=1,clmDTA=0);
%CreatePopEnrollFile(yearin=1984,yearout=2011,pct=20,id=bene_id,dflag=1,clmDTA=0);

