**ORIGINAL CODE THAT GENERATED THE ENROLLMENT FILES;
*libname library '/home/roghmann/formats';
filename formats '/dir3/convert/Nrolment_files/faq_denrol.txt';

libname t '/dir68/Nrol_Output';

*********** 4 minutes to run the 001 ********;
***assume 40 for 01******;

%let d45=/dir45;
%let d40=/dir40;
libname s100 "&d45./Tape100";
libname d100 "&d40./Tape100";

%let A=1984;
%let B=2001;
%let nmo=
filename HCFA_DAT '/dir3/convert/Nrollment_files/hcfa.sas';

*libname s '/dir59';
options ps=50 ls=160 nocenter  compress=yes noovp sasautos=('/home/roghmann/macros');
%let obs=max;


proc format ;
value $enrol
'0' = 'not entitled'
'A' = 'ffs, a only'
'B' = 'ffs, b only'
'C' = 'ffs, a and b'
'H' = 'hmo'
'D' = 'dead'
'U' = 'underage, <65'
'a' = 'disabled,ffs, a only'
'b' = 'disabled,ffs, b only'
'c' = 'disabled,ffs, a and b'
'h' = 'disabled,HMO';

%macro rename(year);
%do i=1 %to 9; dpyri0&i.=den&year._0&i. dhmoi0&i.=dhm&year._0&i. %end;
%do i=10 %to 12; dpyri&i.=den&year._&i. dhmoi&i. =dhm&year._&i.  %end;
%mend;

%macro DEF_ARR;
array jul{&A.:&B.} _temporary_ (%do year=&A. %to &B.; "01jul&year."d %end;);
array aenr{204} $1 %do year=&A. %to &B.;  ae&year._01-ae&year._12 %end;;  *covers &A. through &B.;
array benr{204} $1 %do year=&A. %to &B.;  be&year._01-be&year._12 %end;;  *covers &A. through &B.;
array  enr{204} $1 %do year=&A. %to &B.;  en&year._01-en&year._12 %end;;  *covers &A. through &B.;
array  hmo{204} $1 %do year=&A. %to &B.;  hmo&year._01-hmo&year._12 %end;;  *covers &A. through &B.;
array denr{145:204} $1  %do year=1996 %to &B.; den&year._01-den&year._12 %end;;  *covers 1996 through &B.;
array dhm{145:204} $1  %do year=1996 %to &B.; dhm&year._01-dhm&year._12 %end;;  *covers 1996 through &B.;
array dnr{12} $1  den84_01-den84_12 ;  *covers 84;
array dhr{12} $1  dhm84_01-dhm84_12 ;  *covers 84;

array mon{205} 4  _temporary_  (%do year=&A. %to &B.;
                               "01jan&year."d "01feb&year."d "01mar&year."d "01apr&year."d "01may&year."d "01jun&year."d
                               "01jul&year."d "01aug&year."d "01sep&year."d "01oct&year."d "01nov&year."d "01dec&year."d %end; "01jan2001"d);
 %mend;

%let enr= en&A._01--en&B._12;
%let hmo= hmo&A._01--hmo&B._12;

%MACRO LABELS;
label
%do year = &A. %to &B.;
%do i=1 %to 9;
hmo&year._0&i.="HMO ind for &year. month &i. (1/0)"
en&year._0&i.="C=A+B,H=HMO,0=not,U=<65,D=dead"
%end;
%do i=10 %to 12;
hmo&year._&i.="HMO ind for &year. month &i. (1/0)"
en&year._&i.="C=A+B,H=HMO,0=not,U=<65,D=dead"
%end;
%END;
%MEND;

%let strt=A B C H U D 0 Z;
%t_array;

%let stru=a b c h;
%u_array;

**********************************************;
%MACRO NROL(t,u,code1,code2,rule);

*proc print data= s&t..nrol&t. (obs=100);
*var hicbic hsex hrace hbdate hddate;;

%include hcfa_dat;

*proc contents data=s&t..denom&t._96;
*proc contents data=s&t..denom&t._97;
*proc contents data=s&t..enrol&t._8595;
*proc contents data=s&t..denom&t._98;
*proc contents data=s&t..d&t._98;
*proc contents data=s&t..d&t._&B.;


data s&t..nrol&t._&A._&B. (index=(hicbic) keep=hicbic hsex hrace hbdate hddate &enr.);
length dcrec&A. hcrec1985-hcrec1995 dcrec1996-dcrec&B. $1;
merge
      d&t..dn&t._84 (obs=&obs. in=f keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12 dcrec
                          rename=(dddate=hddate dbdate=hbdate dsex=hsex drace=hrace dcrec=dcrec&A. %rename(&A.)))
      d&t..enrol&t._8595 (obs=&obs. in=h rename=(%do yr=85 %to 95; hcrec&yr.=hcrec19&yr. %end;) )
      d&t..dn&t._96 (obs=&obs. in=b keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12 dcrec
                          rename=(dddate=hddate dbdate=hbdate dsex=hsex drace=hrace dcrec=dcrec1996 %rename(1996)))
      d&t..dn&t._97 (obs=&obs. in=c keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12  dcrec
                          rename=(dddate=hddate dbdate=hbdate  dsex=hsex drace=hrace dcrec=dcrec1997 %rename(1997)))
      d&t..dn&t._98 (obs=&obs. in=d keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12  dcrec
                          rename=(dddate=hddate dbdate=hbdate dsex=hsex drace=hrace  dcrec=dcrec1998 %rename(1998)))
      d&t..dn&t._99 (obs=&obs. in=e keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12  dcrec
                          rename=(dddate=hddate dbdate=hbdate  dsex=hsex drace=hrace  dcrec=dcrec1999 %rename(1999)))
      d&t..dn&t._00 (obs=&obs. in=e keep=hicbic dddate dbdate dsex drace dpyri01-dpyri12 dhmoi01-dhmoi12  dcrec
                          rename=(dddate=hddate dbdate=hbdate  dsex=hsex drace=hrace  dcrec=dcrec&B. %rename(&B.)))
      d&t..ghp&t. (obs=&obs. in=g keep=hicbic gsex gbdate gddate bdnrdt1--adnrdt6 rename=(gbdate=hbdate gddate=hddate gsex=hsex))
;

; by hicbic;

format hbdate date9.;

array live{&A.:&B.} 3 live&A.-live&B.;
array age{&A.:&B.} 3 age&A.-age&B.;

***GHP arrays**;
array benrdt{6} 4 benrdt1-benrdt6;
array bdnrdt{6} 4 bdnrdt1-bdnrdt6;
array enrol{6} 4 aenrdt1-aenrdt6;
array disen{6} 4 adnrdt1-adnrdt6;

***Hiskew arrays***;
array hcaed{*} 4 hcaed1-hcaed4;
array hcatd{*} 4 hcatd1-hcatd4;
array hcbed{*} 4 hcbed1-hcbed4;
array hcbtd{*} 4 hcbtd1-hcbtd4;
format hcaed1-hcaed3 hcbed1-hcbed4
       hcatd1-hcatd3 hcbtd1-hcbtd4 hddate
date7. hbdate date9.;

%DEF_ARR;
array crec{&A.:&B.} $1 dcrec&A. hcrec1985-hcrec1995 dcrec1996-dcrec1999 dcrec&B.;

*DROP PEOPLE DEAD BEFORE JAN1 84;
if hddate=. or hddate>"01jan&A."d;

do t= 1 to 204;
 enr{t}='0';  hmo{t}='0';
end;


*ENTITLEMENT INITIALIZED TO 0 FOR ALL THOSE ALIVE AT T;
do t= 1 to 144;
if (mon{t}<hddate or hddate=.) then do;
aenr{t}='0';
benr{t}='0';
end;
end;

***PROCESS HISKEW-BASED ENTITLEMENT ARRAYS INTO MONTHLY VARS*******;
do i=1 to 4;
do t= 1 to 144;
if (mon{t} >= hcaed{i} and hcaed{i}^=.) and
   ((mon{t} < hcatd{i} and hcatd{i}^=.) or (hcatd{i}=. and hddate=.) or (hcatd{i}=. and hddate^=. and hddate > mon{t})) then aenr{t}='1';
if (mon{t} >= hcbed{i} and hcbed{i}^=.) and
   ((mon{t} < hcbtd{i} and hcbtd{i}^=.) or (hcbtd{i}=. and hddate=.) or (hcbtd{i}=. and hddate^=. and hddate > mon{t})) then benr{t}='1';
end;
end;


do t=1 to 144;
if aenr{t}='1' and benr{t}='1' then enr{t}='C';
else if aenr{t}='1' then enr{t}='A';
else if benr{t}='1' then enr{t}='B';
if aenr{t}='0' and benr{t}='0' then enr{t}='0';
end;

*84 DENOM VARIABLES;
do t=1 to 12;
if dnr{t} in ('C','3') then enr{t}='C';
else if dnr{t} in ('1','A') then enr{t}='A';
else if dnr{t} in ('2','B') then enr{t}='B';
else if dnr{t} in ('0') then enr{t}='0';

if dhr{t} in ('0') then hmo{t}='0';
else if dhr{t} in ('1','2','A','B','C') then hmo{t}='1';
end;


*4 years of DENOM VARIABLES;
do t=145 to 204;
if denr{t} in ('C','3') then enr{t}='C';
else if denr{t} in ('1','A') then enr{t}='A';
else if denr{t} in ('2','B') then enr{t}='B';
else if denr{t} in ('0') then enr{t}='0';

if dhm{t} in ('0') then hmo{t}='0';
else if dhm{t} in ('1','2','A','B','C') then hmo{t}='1';
end;



***PROCESS GHP ARRAYS INTO MONTHLY VARS*******;

do t= 1 to 204;
do i=1 to 6;
   if (enrol{i} ^=.) and ( enrol{i} <= mon{t} < disen{i}) then hmo{t}='1';
   if (enrol{i} ^=.) and ( enrol{i} <= mon{t} )  and (disen{i}=.) then hmo{t}='1';
end;
end;

do t= 1 to 204;
year=year(mon{t});
if (hddate<mon{t} and hddate^=.) then do;  enr{t}='D';end;
else do;
    if ((mon{t}-hbdate)/365.25)<65   then do;                         *<65;
        *in 84, too many elderly vs disabled;

	if crec{year} ='' then enr{t}='U';  *lt 65 and no flag;
        else if crec{year} in ('1','2','3') and enr{t}='A' then  enr{t}='a';
        else if crec{year} in ('1','2','3') and enr{t}='B' then  enr{t}='b';
        else if crec{year} in ('1','2','3') and enr{t}='C' then  enr{t}='c';

	if hmo{t}='1' and crec{year} in ('0')  then enr{t}='H';
	else if hmo{t}='1' and crec{year} in ('1','2','3')  then enr{t}='h';
   end;

   else do;                                                           *>=65;

	*if crec{year} ='' and enr{t}^='0' then enr{t}='Z';
        if crec{year} in ('1','2','3') and enr{t}='A' then  enr{t}='a';
        if crec{year} in ('1','2','3') and enr{t}='B' then  enr{t}='b';
        if crec{year} in ('1','2','3') and enr{t}='C' then  enr{t}='c';

	if hmo{t}='1' and crec{year}=''  then enr{t}='H';
	if hmo{t}='1' and crec{year} in ('0')  then enr{t}='H';
	if hmo{t}='1' and crec{year} in ('1','2','3')  then enr{t}='h';

   end;

*if hmo{t}='1' and enr{t}^='H' then put 'BEFORE ' hmo{t}= enr{t}=;
*if hmo{t}='1' and enr{t}='Z' then enr{t}='H';
*if hmo{t}='1' and enr{t}^='H' then put 'AFTER ' hmo{t}= enr{t}=;
end;


end;

%LABELS;

run;


proc print data= s&t..nrol&t._&A._&B. (obs=5); *where en1991_12='Z';
proc contents data= s&t..nrol&t._&A._&B. ;

*PART 2*****************COUNT EM UP***************************************;
**************************************************************************;

%let dataset= s&t..nrol&t._&A._&B.;
   %LET DSID = %SYSFUNC(OPEN(&dataset.));
   %LET NOBS = %SYSFUNC(ATTRN(&DSID,NOBS));
   %LET RC = %SYSFUNC(CLOSE(&DSID));

%PUT &NOBS;

*proc freq data=s&t..nrol&t._&A._&B. (obs=10000); *tables en84_01 en96_12;

data t.enr&t. (keep= year month  %do i=1 %to &nt.;  ne_&&t&i.. %end;   %do i=1 %to &nu.;  nd_&&u&i.. %end; );
set s&t..nrol&t._&A._&B. end=eof; by hicbic;

%DEF_ARR;

%do i=1 %to &nt.; array  e_&&t&i..{204}  %do year=&A. %to &B.;  e_&&t&i..&year._01-e_&&t&i..&year._12 %end;; %end;
%do i=1 %to &nu.; array  d_&&u&i..{204}  %do year=&A. %to &B.;  d_&&u&i..&year._01-d_&&u&i..&year._12 %end;; %end;
array n_hmo{204};
if _n_=1 then do;
    %do i=1 %to &nt.; %init(e_&&t&i..,1,204,0);  %end;
    %do i=1 %to &nu.; %init(d_&&u&i..,1,204,0);  %end;
end;

do t=1 to 204;
%do i=1 %to &nt.; if enr{t} in ("&&t&i..") then e_&&t&i..{t}+1;  %end;
%do i=1 %to &nu.; if enr{t} in ("&&u&i..") then d_&&u&i..{t}+1;  %end;
end;

if (eof) then do t= 1 to 204;
month=month(mon{t});
year=year(mon{t});
%do i=1 %to &nt.; ne_&&t&i..=&u*e_&&t&i..{t};  %end;
%do i=1 %to &nu.; nd_&&u&i..=&u*d_&&u&i..{t};  %end;

output t.enr&t.;
end;


***********PART 3****PRINT OUT RESULTS********************;
*********************************************************;

**********ENR*************;
data t.el&t.;
set t.enr&t.; if month=7;

********hmo*************;
data t.hmo&t.(keep=year NR_eld_HMO NR_dis_HMO NR_tot_HMO);
set  t.enr&t.; if month=12;
NR_eld_HMO=ne_h;
NR_dis_HMO=nd_h;
NR_tot_HMO=ne_h + nd_h;
;

***********merge hmo, enr, and HCFA *******;
data t.bo&t.;
merge t.el&t. t.hcfa t.hmo&t. t.nchs_death_counts (keep=year nchs); by year;
NR_eld_AB=ne_c + ne_h;
NR_dis_AB=nd_c + nd_h;
NR_tot_AB=NR_eld_AB + NR_dis_AB ;
NR_eld_FFS=ne_c;
NR_tot_FFS=ne_c + nd_c;



format NR_eld_AB NR_tot_AB NR_dis_AB  NR_eld_HMO NR_tot_HMO NR_dis_HMO  comma12.;

diff_eld_ab=(NR_eld_AB-HC_eld_AB);
diff_tot_ab=(NR_tot_AB-HC_tot_AB);
diff_dis_ab=(NR_dis_AB-HC_dis_AB);
diff_HMO=(NR_tot_HMO-HC_tot_HMO);

p_eld_ab&t.=(NR_eld_AB-HC_eld_AB)/HC_eld_AB;
p_tot_ab&t.=(NR_tot_AB-HC_tot_AB)/HC_tot_AB;
p_dis_ab&t.=(NR_dis_AB-HC_dis_AB)/HC_dis_AB;
p_HMO&t.=(NR_tot_HMO-HC_tot_HMO)/HC_tot_HMO;

total= %do i=1 %to &nt.; +ne_&&t&i.. %end;  %do i=1 %to &nu.; +nd_&&u&i.. %end; ;
label
NR_eld_AB='Nrol elderly A & B'
NR_dis_AB='Nrol disabled A & B'
NR_tot_AB='Nrol total A & B'

NR_eld_HMO='Nrol elderly HMO'
NR_dis_HMO='Nrol disabled HMO'
NR_tot_HMO='Nrol total HMO'

NR_eld_FFS='Nrol elderly FFS'
NR_tot_FFS='Nrol total FFS'

HC_eld_AB='HCFA elderly A & B'
HC_dis_AB='HCFA disabled A & B'
HC_tot_AB='HCFA total A & B'


HC_tot_HMO='HCFA total HMO'

HC_eld_FFS='HCFA elderly FFS'
HC_tot_FFS='HCFA total FFS';
run;



***************printing*********;



proc print noobs data=t.bo&t.;
var year diff_eld_ab diff_dis_ab diff_tot_ab ne_z diff_hmo  p_tot_ab&t. p_eld_ab&t. p_dis_ab&t.
 ;
format year 4. diff_eld_ab diff_dis_ab diff_tot_ab diff_hmo comma12.0 p_tot_ab&t. p_eld_ab&t. p_dis_ab&t. percent8.2;
title &t. TOTAL;


proc print noobs data=t.bo&t.;
var year ne_a  hc_eld_a ne_b  hc_eld_b nr_eld_ab hc_eld_ab p_eld_ab&t.;
format year 4. ne_a  hc_eld_a ne_b  hc_eld_b ne_c hc_eld_ab nr_eld_AB comma12.0 p_eld_ab&t. percent8.2;
title &t. ELDERLY;


proc print noobs data=t.bo&t.;
var year ne_a  hc_dis_a ne_b  hc_dis_b nr_dis_ab hc_dis_ab p_dis_ab&t.;
format year 4. ne_a  hc_dis_a ne_b  hc_dis_b ne_c hc_dis_ab nr_dis_AB comma12.0 p_dis_ab&t. percent8.2;
title &t. DISABLED;


proc print noobs data=t.bo&t.;
var year  hc_tot_hmo nr_tot_hmo hc_risk p_hmo&t.;
format year 4. hc_tot_hmo nr_tot_hmo comma12.0 p_hmo&t. percent8.2;
title &t. HMO;


proc print noobs data=t.bo&t.;
/*var year %do i=1 %to &nt.; ne_&&t&i.. %end; HC_tot_HMO NR_tot_HMO   total;
format year 4. total Nr_eld_ffs nr_tot_ffs %do i=1 %to &nt.; ne_&&t&i.. %end;  %do i=1 %to &nu.; nd_&&u&i.. %end; total comma12.0;
title &t.  enrerly;
*/



%MEND;


*%NROL(0001,10000);
*%NROL(001,1000);
*%NROL(01,100);
*%NROL(05,20);
*%NROL(20,5);

%NROL(100,1);


goptions interpol=join;
legend1 label=none shape=symbol(4,2)  frame        position=(bottom center) mode=reserve;
title '0.1%';
*proc gplot data=t.bo&t.;
*plot nr_eld_ab*year hc_eld_ab*year /overlay legend=legend1;
*plot nr_tot_hmo*year hc_tot_hmo*year /overlay legend=legend1;
*plot nr_dis_ab*year hc_dis_ab*year /overlay legend=legend1;

run;


/*
%MACRO LOOKIE(Z);

%let strv=0001 001 01 05 20 100;
%v_array;

data lk&z.;
merge  %do i=1 %to &nv.; ts&&v&i...bo&&v&i.. (keep=year &z.&&v&i..) %end;;
label   %do i=1 %to &nv.;
 &z.&&v&i..="% Diff Nrol and HCFA, Part A & B"
 %end;;
proc print noobs data=lk&z.;
 var year  %do i=1 %to &nv.;  &z.&&v&i.. %end;;
 format %do i=1 %to &nv.;  &z.&&v&i.. %end; percent6.4;

%MEND;

*%LOOKIE(p_ab);









