
 **Program runs all programs needed before moving onto the main extracts.
** simply adjust the pct to match the pct file you are running.
***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

***********************************************************************
* DEFINE DIRECTORIES****;
***********************************************************************;
%include "../../dirInit.sas";

***********************************************************************;
* DEFINE LIBRARIES ;
***********************************************************************;
* Defines local directories depending on which server currently running;
    libname xwfile "&xwext.";
    libname beneIn "&inbenexw.";
    libname here ".";
    libname benroot  "&beniroot.";
***********************************************************************;
* READ IN SAS MACRO FOUND IN OTHER FILES  ;
***********************************************************************;

%macro CW_create(pct=);
      *Count number of duplicate ehics and drop cases where there are multiple bene_id to a single ehic.;
    %if &pct.=0001 %then %do;
        proc sql;
            create table beneIn.ehicbenex_unique&pct. as
                SELECT *, COUNT(J.bene_id) as count
                FROM benroot.ehicbenex_unique J
                WHERE substr(ehic,6,4) in ("1545")
                group by J.bene_id;
             quit;
             %end;
   %if &pct.=01 %then %do;
        proc sql;
            create table beneIn.ehicbenex_unique&pct. as
                SELECT *, COUNT(J.bene_id) as count
                FROM benroot.ehicbenex_unique J
                WHERE substr(ehic,8,2) in ("45")
                group by J.bene_id;
             quit;
             %end;
    %if &pct.=05 %then %do;
        proc sql;
            create table beneIn.ehicbenex_unique&pct. as
                SELECT *, COUNT(J.bene_id) as count
                FROM benroot.ehicbenex_unique J
                WHERE substr(ehic,8,2) in ("05","20","45","70","95")
                group by J.bene_id;
             quit;
             %end;
    %if &pct.=20 %then %do;
        proc sql;
            create table beneIn.ehicbenex_unique&pct. as
                SELECT *, COUNT(J.bene_id) as count
                FROM benroot.ehicbenex_unique J
                WHERE substr(ehic,9,1) in ("0","5")
                group by J.bene_id;
             quit;
             %end;
    %if &pct.=100 %then %do;
        proc sql;
            create table beneIn.ehicbenex_unique&pct. as
                SELECT *, COUNT(J.bene_id) as count
                FROM benroot.ehicbenex_unique J
                group by J.bene_id;
             quit;
             %end;

    proc sort data=beneIn.ehicbenex_unique&pct. ;
           by ehic;
    run;

    proc sort data=benroot.ehicbenex_two_to_n;
        by  ehic;
    run;

       *Merge here so that we can drop ehics which  match many time to a bene_id. About 4000 observations.;
        data beneIn.ehicbenex_unique&pct.;
            merge beneIn.ehicbenex_unique&pct.(in=inehic)  benroot.ehicbenex_two_to_n(in=inbene keep=ehic);
            by ehic;
            if inehic;
            **missing count if bene_id in post 2005 data;
            if count=. then count=1;
            *Identifies mismatched beneid whicha re dropped at a later point in time currently drop these individuals;
            *if inbene=1 then count=-1;
        run;


    proc freq data=beneIn.ehicbenex_unique&pct.;
        WHERE bene_id ne "";
        table count;
    run;

    proc sort data=beneIn.ehicbenex_unique&pct. ;
        by ehic;
    run;

    *Assign indexes. Speeds processing by a factor of 10 or so for 5% claims files.;
    proc sql;
        create unique index ehic on beneIn.ehicbenex_unique&pct. (ehic)  ;
        quit;

    *Assign indexes. Speeds processing by a factor of 10 or so for 5% files.Create different files.;
    *Assigning two indexes to a single file slows processing.So we create seperate files.;

    proc sort data=beneIn.ehicbenex_unique&pct. out=beneIn.ehicbenex_unique_bene_indx&pct.;
             by bene_id ;
    run;

    proc sql;
        create  index bene_id on beneIn.ehicbenex_unique_bene_indx&pct. (bene_id)  ;
        quit;

%mend;

%CW_create(pct=0001);
%CW_create(pct=01);
%CW_create(pct=05);
%CW_create(pct=100);
%CW_create(pct=20);



