# Import system modules
import arcpy
from arcpy import env
import csv

# Set local variables:
env.workspace = "<FILE_LOCATIOIN_DIR>"
addrfile = "POSAddresses100_12082012.csv"

address_locator = "F:/ArcGIS 10 Data & Maps/streetmap_na/data/Street_Addresses_US.loc"
geocode_result = "geocode_result"

## Run the geocoding command
str_varname = "address"
zip_varname = "zipcode"

print "Geocoding " + addrfile + "..."
arcpy.GeocodeAddresses_geocoding(addrfile, address_locator, \
                                     "Street " + str_varname +
                                     " VISIBLE NONE;City city VISIBLE NONE;State state VISIBLE NONE;Zip " + zip_varname + " VISIBLE None", \
                                     geocode_result, "STATIC")
    

## Export the results to a CSV file (which is surprisingly complex to do) and delete the output table

# select the fields to output
fieldsToExport = ["Status", "Score", "Match_addr", "X", "Y", "addrid_pos" ]

# intialize the out file
outfile = open(env.workspace + "/" + addrfile.replace(".csv", "-Matched.csv"), "wb")
myWriter = csv.writer(outfile)
myWriter.writerow(fieldsToExport)

# iterate over the rows of the attribute table
output = []
rows = arcpy.SearchCursor(geocode_result+".shp")
for row in iter(rows.next, None):
    outputrow = []

    for fieldname in fieldsToExport:
        outputrow.append(row.getValue(fieldname))

    myWriter.writerow(outputrow)

# close the CSV file
outfile.close()

# delete the SHP file
arcpy.Delete_management(geocode_result+".shp")



