/*
%include "&SASmac./ImportVariableXW.sas";
%readinmedparxw;
%include "&SASmac./CreateXWmacro.sas";
%include "&SASmac./ConformMedPar.sas";
*/
%macro GenrateRawMedPARfiles(yr=, diag=, pct=,dgnPos=,start=,end=,identifier=);
    ***********************************************************************************;
    ** RETRIEVE VARAIBLE INFORMATINO FROM MEDPAR CSV XW FILE;
    ***********************************************************************************;
        %rawVarXw(harVar=prvnumgrp,yr=&yr.,outputvar=provider,filename=medparxw,pct=&pct.);
        %rawVarXw(harVar=spclunit,yr=&yr. ,outputvar=ftypeVar,filename=medparxw,pct=&pct.);
        %rawVarXw(harVar=sslssnf,yr=&yr.,outputvar=snfvar,filename=medparxw,pct=&pct.);
        %rawVarXw(harVar=admsndt,yr=&yr.,outputvar=admdtVar,filename=medparxw,pct=&pct.);
        %rawVarXw(harVar=dgnscd1,yr=&yr.,outputvar=diagcd,filename=medparxw,pct=&pct.);
    * The scan fxn breaks up string into chuncks using the list of delimeters;
    * note that the ussage of the scan function is the following:;
    ** SCAN(char_var,n,listofdelimiters). In the case below it returns everything
    ** before the 1;
    %let dgnsPfx=%scan(&diagcd.,1,'1') ;

    %if &yr<= 1991 and &dgnPos.>5 %then %do;
        %let  dgnPos = 5;
        %end;

    ***********************************************************************************;
    * TAG CANIDATE INDEX EVENTS  ADDITIONAL RESTRICTIONS TAKEN LATER;
    ***********************************************************************************;
    data rawmedpar&yr. ;
        set spmed.medpar&pct._&yr._all (keep=&provider. &ftypeVar.  &snfvar. &admdtVar. &diagcd.    );
        %ConformMedPAR(y=&yr.,pct=&pct.,file=indx);
        *Loops through the diagnosis variables of interest;

        ****************************************************************;
        * DEFINES AMI ICD9CM CODE SEQUENCE;
        ****************************************************************;
        %if "&diag." = "ami"  %then %do;
            flagami=0;
            if substr(&diagcd.,1,3) = "410" and
                ( (length(&diagcd.) = 5 and
                substr(&diagcd.,5,1) ne "2") or (length(&diagcd.) < 5) )
                then flagami=1;
            %end;

        ** VARIABLE HARMONIZATION;
        diag_year=year(&admdtVar.);
        fileyear=&yr.;

        rename &provider. = prvnumgrp
               &ftypeVar. = spclunit
               &admdtVar. = admsdndt
               &diagcd.   = dgnscd1   ;

        swing_bed = &ftypeVar. in ("U","W","Y","Z");

    run;

    x "rm &spmed./medpar&pct._&yr._all.sas7bdat -f " ;
    %mend;

