***********************************************************************;
** Import provider of service files                                    ;
***********************************************************************;
**  The file imports a subset of variables from teh raw pos text files;
**  should be easy to add variables to this once you figure out the  ;
**  correct collumns from the data dictionaries;
** first thng we need to do scp inti your home directory
***********************************************************************;

***********************************************************************;
* READ IN SAS OPTIONS - NOT NECESSARY****;
***********************************************************************;
*Use these options for debugging;
options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";*/

***********************************************************************;
* DEFINE DIRECTORIES****;
**- NOT NECESSARY IF YOU DEFINE THE DIRECTORIES BELOW
***********************************************************************;
%include "../../dirInit.sas";*/


*define libraries that allow access to the various directories specified above;
* Raw provder files live here;
%let providerDir= /homes/data/pos;
X "mkdir -p &POSext. ";


libname provDir "&providerDir.";
libname provOut "&posext.";


*Make sure we are starting with a clean slate- no old files;

x "rm &posext./pos* -fr ";

*1984 to 1990 ;
%macro RunPOS1984to1990;
    %do y=84 %to 90;
        filename dd&y. "&providerDir./POS1984_90/wm.provider.cy&y..us100";
        data provOut.pos19&y.;
            length state $2 statusofrecord $2 bedtotal_certified 5 bedtotal 5;
            infile dd&y. lrecl=700 missover pad;
            input
                ownerType $203-204
                termCode $61-61
                FMSsurveyDate $25-30
                parentProvider $286-291
                parentType $334-334
                priorownChDate $335-340
                faciltySubType $201-202
                provider $2-7
                oldprov $292-297
                partDate  $13-18
                ownChDate $19-24
                termDate $37-42
                category $55-56
                name $86-123
                address $124-161
                citystate $162-194
                ssastate $205-206
                zipcode $195-199
                prv_ssacounty 207-209;
                statusofrecord="";
                owncount=.;
                state="";
                bedtotal=.;
                bedtotal_certified=.;

            * first, detect a small number of hospitals that have county names at the end;
            * and strip this information off;
            citystate = prxchange("s/\([A-Z]+\s(CO|CO\.|COUNTY)\)\s*$//",1,citystate);

            * next, look for a handful of records that have a state name rather than;
            * a state code at the end;
            citystate = prxchange("s/\sALABAMA\s*$/ AL/", 1, citystate);
            citystate = prxchange("s/\sCALIFORNIA\s*$/ CA/", 1, citystate);
            citystate = prxchange("s/\sMINNESOTA\s*$/ MN/", 1, citystate);
            citystate = prxchange("s/\sOREGON\s*$/ OR/", 1, citystate);
            citystate = prxchange("s/\sTEXAS\s*$/ TX/", 1, citystate);
            citystate = prxchange("s/\sKENTUCKY\s*$/ KY/", 1, citystate);
            citystate = prxchange("s/\sWEST\ VIRGINIA\s*$/ WV/", 1, citystate);
            citystate = prxchange("s/\sGUAM\s*$/ GU/", 1, citystate);
        run;

        proc contents data=provOut.pos19&y.;
        run;

        proc print data=provOut.pos19&y.(obs=10);
        run;

        %end;
    %mend;

%RunPOS1984to1990;
*1991 to the rest;

*Survey date for the FMS also one for the health or life sfety code survey;
filename dd1 "&providerDir./1991/POS1991Data.txt";
data provOut.pos1991;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 5 bedtotal 5
           termDate $8  address $50  priorownChDate $8 statusofrecord $1;

    input
        ownerType $219-220
        termCode $211-211
        FMSsurveyDate $59-64
        parentProvider $1460-1469
        faciltySubType $1-2
        priorownChDate $133-138
        category $3-4
        ownChDate $7-12
        owncount 5-6
        partDate $127-132
        termDate $212-217
        provider $144-153
        oldprov $49-58
        prv_ssacounty 46-48
        name $72-109
        citystate $13-43
        address $163-200
        zipcode $221-225
        ssastate $158-159
        statusofrecord $154-154
        bedtotal 265-269
        bedtotal_certified 270-274 ;

     * first, detect a small number of hospitals that have county names at the end;
     * and strip this information off;
     citystate = prxchange("s/\([A-Z]+\s(CO|CO\.|COUNTY)\)\s*$//",1,citystate);

     * next, look for a handful of records that have a state name rather than;
     * a state code at the end;
     citystate = prxchange("s/\sALABAMA\s*$/ AL/", 1, citystate);
     citystate = prxchange("s/\sCALIFORNIA\s*$/ CA/", 1, citystate);
     citystate = prxchange("s/\sMINNESOTA\s*$/ MN/", 1, citystate);
     citystate = prxchange("s/\sOREGON\s*$/ OR/", 1, citystate);
     citystate = prxchange("s/\sTEXAS\s*$/ TX/", 1, citystate);
     citystate = prxchange("s/\sKENTUCKY\s*$/ KY/", 1, citystate);
     citystate = prxchange("s/\sWEST\ VIRGINIA\s*$/ WV/", 1, citystate);
     citystate = prxchange("s/\sGUAM\s*$/ GU/", 1, citystate);
run;
proc freq data=provOut.pos1991 ; table statusofrecord;run;

filename dd1 "&providerDir./1992/POS1992Data.txt";
data provOut.pos1992;
    infile dd1 lrecl=700 missover pad;
        length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal 5
           termDate $8  address $50  priorownChDate $8 bedtotal_certified 5;

    input
        ownerType $625-626
        termCode $543-543
        FMSsurveyDate $109-114
        parentProvider $1978-1987
        priorownChDate $304-309
        faciltySubType $1-2
        owncount 5-6
        category $3-4
        ownChDate $7-12
        partDate $298-303
        termDate $544-549
        provider $357-366
        oldprov $49-58
        name $187-224
        city  $13-40
        state $470-471
        prv_ssacounty 46-48
        prv_fipscounty 646-648
        address $477-514
        zipcode $627-631
        ssastate $472-473
        statusofrecord $367-367
        bedtotal 683-687
        bedtotal_certified 688-692;
    citystate="";

run;




filename dd1 "&providerDir./1993/POS1993Data.txt";
data provOut.pos1993;
    infile dd1 lrecl=700 missover pad;
        length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal 5
           termDate $8  address $50  priorownChDate $8 bedtotal_certified 5;
    input
        faciltySubType $1-2
        ownerType $218-219
        termCode $543-543
        FMSsurveyDate $109-114
        parentProvider $1978-1987
        priorownChDate $304-309
        owncount 5-6
        prv_ssacounty 43-45
        prv_fipscounty 227-229
        category $3-4
        ownChDate $7-12
        provider $141-150
        termDate $211-216
        partDate $124-129
        oldprov $46-55
        name $ 69-106
        city  $13-40
        state $155-156
        address $162-199
        zipcode $220-224
        ssastate $157-158
        statusofrecord $151
        bedtotal 264-268
        bedtotal_certified 269-273;

    citystate="";

run;


filename dd1 "&providerDir./1994/pos94data.txt";
data provOut.pos1994;
    infile dd1 lrecl=700 missover pad;
        length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 5 bedtotal 5
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $207-208
        termCode $198-199
        FMSsurveyDate $56-61
        parentProvider $1555-1564
        priorownChDate $118-123
        owncount 5-6
        prv_ssacounty 43-45
        prv_fipscounty 216-218
        category $3-4
        provider $129-138
        ownChDate $7-12
        partDate $112-117
        termDate $200-205
        oldprov $46-55
        name $69-106
        city  $13-40
        state $143-144
        address $150-187
        zipcode $209-213
        ssastate $145-146
        statusofrecord $139-139
        bedtotal 253-257
        bedtotal_certified 258-262;

    citystate="";

run;


filename dd1 "&providerDir./1995/pos95data.txt";
data provOut.pos1995;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 5 bedtotal 5
        termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $207-208
        termCode $198-199
        FMSsurveyDate $56-61
        parentProvider $1555-1564
        priorownChDate $118-123
        prv_ssacounty 43-45
        prv_fipscounty 216-218
        owncount 5-6
        category $3-4
        ownChDate $7-12
        provider $129-138
        partDate $112-117
        termDate $200-205
        oldprov $46-55
        name $69-106
        city  $13-40
        state $143-144
        address $150-187
        zipcode $209-213
        ssastate $145-146
        statusofrecord $139
        bedtotal 253-257
        bedtotal_certified 258-262;

        citystate="";


run;


filename dd1 "&providerDir./1996/POS96DATA.TXT";
data provOut.pos1996;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $219-220
        termCode $208-209
        FMSsurveyDate $58-65
        parentProvider $1576-1585
        priorownChDate $126-133
        prv_ssacounty 45-47
        prv_fipscounty 228-230
        owncount 5-6
        category $3-4
        ownChDate $7-12
        partDate $118-125
        termDate $210-217
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-197
        zipcode $221-225
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 273-276
        bedtotal_certified 277-280;

            citystate="";
run;


* NOTE:CLIA Laboratories added: effective 1997. In the CLIA txt file. We do not import these.;
filename dd1 "&providerDir./1997/POS97OTHER.TXT";
data provOut.pos1997;
    infile dd1 lrecl=700 missover pad;
        length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $219-220
        termCode $208-209
        FMSsurveyDate $58-65
        parentProvider $1576-1585
        priorownChDate $126-133
        prv_ssacounty 45-47
        prv_fipscounty 228-230
        owncount 5-6
        category $3-4
        ownChDate $7-12
        partDate $118-125
        termDate $210-217
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-197
        zipcode $221-225
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 273-276
        bedtotal_certified 277-280;

    citystate="";
run;

filename dd1 "&providerDir./1998/POS98OTHER.TXT";
data provOut.pos1998;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $219-220
        termCode $208-209
        FMSsurveyDate $58-65
        parentProvider $1577-1586
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 228-230
        category $3-4
        ownChDate $7-12
        partDate $118-125
        termDate $210-217
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-197
        zipcode $221-225
        ssastate $155-156
    statusofrecord $149-149
        bedtotal 273-276
        bedtotal_certified 277-280;

        citystate="";
run;

x "rm &posext./POS99OTHER.txt -f";
x "unzip -o -d &posext. &providerDir./1999/POS99OTHER.txt.zip ";
filename dd1 "&posext./POS99OTHER.txt";


data provOut.pos1999;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
        termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $ 58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;

        citystate="";
run;


x "rm &posext./POS00OTHER.txt -f";
x "unzip -o -d &posext.  &providerDir./2000/POS00OTHER.txt.zip";
filename dd1 "&posext./POS00OTHER.txt";

data provOut.pos2000;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;

    citystate="";
run;


x "rm &posext./DEC01other -f";
x "unzip -o -d &posext. &providerDir./2001/DEC01other.zip ";
filename dd1 "&posext./DEC01other";

data provOut.pos2001;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;
        citystate="";
run;
x "rm &posext./DEC01other -f";


x "unzip -o -d &posext. &providerDir./2002/posotherdec02.txt.zip";
filename dd1 "&posext./posotherdec02.txt";

data provOut.pos2002;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;


        citystate="";
run;

x "rm &posext./posotherdec02.txt -f";



filename dd1 "&providerDir./2003/DEC03other";
data provOut.pos2003;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1606-1615
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 312-315
        bedtotal_certified 316-319;

        citystate="";
run;




x "rm &posext./DEC04other -f";
x "unzip -o -d &posext.  &providerDir./2004/DEC04other.zip ";
filename dd1 "&posext./DEC04other";


data provOut.pos2004;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1606-1615
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176
        bedtotal 312-315
        bedtotal_certified 316-319;

        citystate="";
run;
x "rm &posext./DEC04other -f ";


x "rm &posext./DEC05other -f";
x "unzip -o -d &posext.  &providerDir./2005/DEC05other.zip ";
filename dd1 "&posext./DEC05other";
data provOut.pos2005;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1631-1640
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        prv_ssacounty 45-47
        prv_fipscounty 267-269
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

        citystate="";
run;
x "rm &posext./DEC05other -fr";




x "rm &posext./DEC06other -f";
x "unzip -o -d &posext. &providerDir./2006/DEC06other.zip ";
filename dd1 "&posext./DEC06other";


data provOut.pos2006;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        category $3-4
        ownChDate $7-12
        termDate  $249-256
        partDate $145-152
        provider $ 166-175
        oldprov $ 48-57
        name $ 75-124
        city  $15-42
        state $180-181
        address $ 187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

        citystate="";
run;
x "rm &posext./DEC06other -fr";





x "unzip -o -d &posext. &providerDir./2007/other.dec07.zip";
filename dd1 "&posext./M1M1/@BFV2550/POSOTHER/DEC07";


data provOut.pos2007;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;


    citystate="";

run;
x "rm &posext./M1M1 -fr"


x "rm &posext./OtherDec08 -f";
x "unzip -o -d &posext. &providerDir./2008/OtherDec08.zip  ";
filename dd1 "&posext./W148.@AAASOO1.POSOTHER.DEC08";


data provOut.pos2008;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        owncount 5-6
        category $3-4
        ownChDate $7-14
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176
        bedtotal 291-294
        bedtotal_certified 295-298;

       citystate="";
run;
x "rm &posext./W148.@AAASOO1.POSOTHER.DEC08 -f";



x "unzip -o -d &posext. &providerDir./2009/POS.OTHER.Annual09.zip";
filename dd1 "&posext./EXTRACT.POSY.OTHER.YR09";

data provOut.pos2009;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-14
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

       citystate="";
run;
x "rm &posext./EXTRACT.POSY.OTHER.YR09 -fr";
x "rm &posext./POS.OTHER.Annual09.zip -fr";



x "cp &providerDir./2010/EXTRACT.POSY.OTHER.YR10  &posext./ -f";
filename dd1 "&posext./EXTRACT.POSY.OTHER.YR10";


data provOut.pos2010;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
            statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

    citystate="";
run;
x "rm &posext./EXTRACT.POSY.OTHER.YR10 -f";


x "cp &providerDir./2011/POSQ.OTHER.DATA.DEC11.txt  &posext./ -f";
filename dd1 "&posext./POSQ.OTHER.DATA.DEC11.txt";


data provOut.pos2011;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $250-251
        termCode $239-240
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $241-248
        partDate $137-144
        provider $158-167
        oldprov $1510-1519
        name  $67-116
        city  $15-42
        state $180-181
        address $179-228
        zipcode $252-256
        ssastate $174-175
        statusofrecord $168-168
        bedtotal 390-393
        bedtotal_certified 386-389;

    citystate="";
    FMSsurveyDate="";
run;
x "rm &posext./POSQ.OTHER.DATA.DEC11.txt -f";


x "rm &posext./*.txt -f";

%macro AssignYear;
    %do year=1984 %to 2011;
        proc contents data=provOut.pos&year.;
        run;

        proc print data=provOut.pos&year.(obs=10);
        run;

        data posyr_&year.;
            length provider $10 oldprov $10 parentProvider $10 name $50 bedtotal_certified 5 bedtotal 5
                   city $50 FMSsurveyDate  $8 termCode $2  partDate $8
                termDate $8  address $50  priorownChDate $8 citystate $50 state $2;
            set provOut.pos&year. ;
            year=&year.;
                        **10 digit providers exist in some years, break them up;
            if length(provider)>6 then do;
                provider4=substr(provider,1,4);
                provider6=substr(provider,5,6);
                end;
            else do;
                provider6=substr(provider,1,6);
                end;


    *The imputed date values change over time and convert them to numeric;
            %if &year<=1995 %then %do;
                if partDate ne "" then partYr="19" || substr(partDate,1,2);
                if ownChDate ne "" then ownCYr="19" || substr(ownChDate,1,2);
                if termDate ne "" then termYr="19" || substr(termDate,1,2);
                if FMSsurveyDate ne "" then FMSsurveyYr="19" || substr(FMSsurveyDate,1,2);
                if priorownChDate ne "" then priorownChYr="19" || substr(priorownChDate,1,2);
                %end;
            %if &year>=1996 %then %do;
                termYr=substr(termDate,1,4);
                partYr=substr(partDate,1,4);
                ownCYr=substr(ownChDate,1,4);
                FMSsurveyYr=substr(FMSsurveyDate,1,4);
                priorownChYr=substr(priorownChDate,1,4);
    *The inputed date values change over time;
                %end;
            *drop partDate ownChDate termDate;
             %if &year< 1992 %then %do;
                 if provider="" then delete;
                 number=countw(citystate);
                 state="";
                 city=scan(citystate,1," ");
                 %do i=2 %to 30;
                     if &i.< number then do;
                         temp=scan(citystate,&i.," ");
                         city=catx(" ",city,temp);
                         end;
                     %end;
                 state=reverse(scan(reverse(citystate),1," "));
                 city=compress(city,',');
                 drop temp ;
                 %end;
        run;
        x "rm &posext./pos&year..sas7bdat -f ";
        %end;



data provOut.posmaster;
    set %do y=1984%to 2011; posyr_&y. %end;;
run;


proc freq data=provOut.posmaster;
    table year*statusofrecord;
run;

proc freq data=provOut.posmaster;
    where bedtotal=.;
    table year;
run;


x "st &posext./posmaster.sas7bdat  &posext./posmaster.dta -Y";
%mend ;

**Run Macro defined above;
%AssignYear;




/*
  TERMINATION CODE                            1     211   211  C    PROV2805
     THE REASON A FACILITY HAS BEEN TERMINATED FROM THE
     MEDICARE AND/OR MEDICAID PROGRAMS
     COBOL NAME: TERM-CD
     VALUES:   0                   ACTIVE
               1                   VOL-MERG,CLOSE
               2                   VOL-REIMBURSE
               3                   VOL-RISK INVOL
               4                   VOL-OTHER
               5                   INVOL-FAIL REQ
               6                   INVOL-AGREEMNT
               7                   OTH-STATUS CHG


  ownerType
  TYPE OF CONTROL                             2     258   259  C    PROV2885
     INDICATES THE NATURE OF THE ORGANIZATION THAT OPERATES
     A PROVIDER OF SERVICES.
     COBOL NAME: TYPE-CONTROL
     VALUES:   01                  VOLUNTARY NON-PROFIT - CHURCH
               02                  VOLUNTARY NON-PROFIT - PRIVATE
               03                  VOLUNTARY NON-PROFIT - OTHER
               04                  PROPRIETARY
               05                  GOVERNMENT - FEDERAL
               06                  GOVERNMENT - STATE
               07                  GOVERNMENT - LOCAL
               08                  GOV. - HOSP. DIST. OR AUTH.


I believe that what is happening is that the diagnosed date and the POS file year do not exactly match
up. For example you may have some cases happening around the end of a year which may end up on a
different POS file or MEDICARE claim file.

POSSIBLE FIX IS TO USE THE participation date or some of these other dates-- Doesnt work because it is often
refers when they entered into the program.. LAST resort is to basically assume that the provider number does
not change across time. Not sure if this is the case the medicare manuals will provide and answer for this.
 Mergers maybe the case where this does work.

*/


