// program pulls together AHA, POS and HCRIS info;
//



clear
clear matrix
set more off

// REad in directories from this file
do ../../dirInit.do
set trace off

global ahadta ~/aha.work/20120413
global ahadta2 /homes/nber/daltonm/aha.work/20120420
global ahaex /homes/nber/daltonm/aha.out/20120420/
! mkdir -p $ahaex
** aha_extract2000.dta

*******************************************
//  PREP AHA DATA ///////////
*******************************************
  forvalues year=1997/2009 {
   use $ahadta2/aha_extract`year',clear
   tostring cntrl,replace
   tostring serv,replace
   tostring netwrk,replace
   tostring mapp8,replace

   save $ahaex/aha_extract`year',replace
   }

use $ahaex/aha_extract1997,clear
gen fileyear=1997
forvalues year=1998/2009 {
   append using $ahaex/aha_extract`year'
   replace fileyear=`year' if fileyear==.
   }

rename mcrnum provider
rename fy fyear
rename id aha_id
rename cntrl aha_controltype
rename serv aha_serviceCodes
gen AHA_HosOwnAg="gov" if substr(aha_controltype,1,1) =="1" | substr(aha_controltype,1,1) =="4"
replace AHA_HosOwnAg="profit" if substr(aha_controltype,1,1) =="3"
replace AHA_HosOwnAg="nonprofit" if substr(aha_controltype,1,1) =="2"

tab fyear,missing
replace fyear =fyear +2000 if fyear <20
replace fyear =fyear +1900 if fyear <100
tab fyear AHA_HosOwnAg
drop if fileyear<2002
gen missprov=provider==""

**THERE ARE SOME PROVIDER # WHICH ARE NOT UNIQUE TO AN AHA ID --DROP FOR NOW  COULD BE MERGES;
duplicates drop provider fileyear AHA_HosOwnAg netwrk netname netcity netstcd genbd pedbd mname mapp8 netstate netct netst netsc  ,force
duplicates tag provider fileyear ,gen(tagprov)
tab tagprov AHA_HosOwnAg


drop if tagprov>0
save $ahaex/aha_only,replace
exit
rename provider prvnumgrp
merge 1:1 prvnumgrp fileyear using $inpos/posmaster_clean ,keepusing(prvnumgrp fileyear swing_bed inmedpar is_snf totdis)
rename prvnumgrp provider
drop if _merge==2

drop fyear
 label variable provider "AHA reported Medicare Provider ID"
 label variable fileyear
 label variable AHA_HosOwnAg "Ownership type aggregated"
 label variable is_snf "SNF flag, from MedPAR file"
 label variable swing_bed "Swing bed flag, from MedPAR file"
 label variable inmedpar  "Flag for found in MedPAR file"
 label variable totdis "Total discharge by provider-year, from MedPAR file"

replace inmedpar=0 if _merge==1
drop tagprov _merge missprov
save $ahaex/aha_combined,replace
exit
/*
*******************************************
///LOOK AT HCRIS DATA::
*******************************************
use $exhcris/hcrisextract,clear
duplicates tag provider fileyear provOwnType,gen(ownerSwitchDateFlag)
/// In some years it appears where maybe ownership has changed
/// And the fiscal year reporting changes. This means that two
  /// fiscal years get reported. I decided to drop the first instance of these,
  /// taking the value of the new entity

sort provider fileyear fy_bgn_dt
bysort provider fileyear: gen flag=_n
tab flag

gen HCRIS_HosOwnAg="nonprofit" if inlist(provOwnType,1,2)==1
replace HCRIS_HosOwnAg="profit" if inlist(provOwnType,3,4,5,6)==1
replace HCRIS_HosOwnAg="gov" if inlist(provOwnType,7,8,9,10,11,12,13)==1

destring lastownCode,replace
gen HCRIS_HosOwnAg_last="nonprofit" if inlist(lastownCode,1,2)==1
replace HCRIS_HosOwnAg_last="profit" if inlist(lastownCode,3,4,5,6)==1
replace HCRIS_HosOwnAg_last="gov" if inlist(lastownCode,7,8,9,10,11,12,13)==1

collapse (last) fy_bgn_dt fy_end_dt provOwnType ownerSwitchDateFlag last* HCRIS_HosOwnAg_last (sum) tot1_bed tot5_bed tot12_bed, by(provider fileyear)



save $exhcris/deduped_hcrisextract,replace

*******************************************
// START THE MERGING
*******************************************
use $inpos/posmaster,clear
rename year fileyear
drop if fileyear<2002
des
drop if length(trim(provider)) > 6

** POS FILE IS CUMLATIVE FILE THAT KEEPS OLD PROVIDER IN THERE. THE IMPORTANT THING IS THAT WE ;
** DROP OBS WHICH HAVE TERMINATED
destring termYr,replace

** ALSO POS FILE CARRIES PROVIDER WITH LETTERS IN THEM WHICH ARE CONSIDERED SPECIAL CASES;
** SWING BED HOSPITALS -- AMOUNT OTHERS ARE INCLUDED HERE. DROP THEM FROM SAMPLE - NOT IN HCRIS DATA PULLED;
**DROP THEM;

/// 03--RELIGIOUS NONMEDICAL HEALTH CARE INSTITUTIONS--For the most part AHA does not have these



**DROP PROVIDER WITH 10 digits -- mostly labs i believe
duplicates drop provider fileyear,force
rename provider prvnumgrp
merge 1:1 prvnumgrp fileyear using $inpos/posmaster_clean ,keepusing(prvnumgrp fileyear swing_bed inmedpar is_snf totdis)
drop if _merge==2
drop _merge
rename prvnumgrp provider

merge 1:m provider fileyear using $exhcris/deduped_hcrisextract.dta



gen POS_HosOwnAg="nonprofit" if inlist(ownerType,"01","02","03")
replace POS_HosOwnAg="profit" if inlist(ownerType,"04")
replace POS_HosOwnAg="gov" if inlist(ownerType,"05","06","07","08")

rename _merge mflg_POS_HCRIS

merge 1:m provider fileyear using $ahaex/aha_combined

/// WE CAN EITEHR ONLY KEEP ALL OB IN THE AHA AND IN THE SURVEYS --MERGE==3
/// OR WE CAN ATTEMPT TO REFINE THE SAMPLE TO COVER THE SAME SUBSAMPLES AND TEHNE
/// COMPARE THE AVERAGES. THE SECOND GIVE A BETTER IDEA OF WHAT MAYBE HAPPENING BUT
/// ALSO INTRODUCES SOME ERROR IN THAT IT IS NOT EXACTLY CLEAR HOW SUSBSET THE DATA
/// WITHOUT MAKING IT TOO SMALL OFA SAMPLE

///DROP MISSING PROVIDER NUMBERS FROM THE AHA
///keep if _merge==3
drop if missprov==1

///REFINE SAMPLE FROM THE POS FILE;
**REFINE POS SAMPLE EVEN FURTHER
drop if termYr<fileyear
drop if regexm(provider,"[a-zA-Z]")
keep if category=="01"
drop if faciltySubType=="03"
destring ssastate,replace
drop if ssastate==40
drop if ssastate==55
drop if ssastate>=56 & ssastate<=66
drop if ssastate>=97
tab ssastate


rename _merge mflg2_AHA
tab mflg2_AHA
///SHORT TERM HOSPOITAL HAVE A PROVDER NUMNER < XX1000
gen shortermHosp=substr(provider,3,1)=="0"
drop if fileyear <2002 | fileyear ==2009


tab AHA_HosOwnAg  HCRIS_HosOwnAg
tab AHA_HosOwnAg  POS_HosOwnAg
tab HCRIS_HosOwnAg  POS_HosOwnAg


/// THIS IS TOO RESTRICTAVE
///keep if shortermHosp==1


tab AHA_HosOwnAg  HCRIS_HosOwnAg
tab AHA_HosOwnAg  POS_HosOwnAg
tab HCRIS_HosOwnAg  POS_HosOwnAg

drop if AHA_HosOwnAg=="" &  HCRIS_HosOwnAg=="" &  POS_HosOwnAg==""
count
local keeporigcount=`r(N)'

preserve
keep provider fileyear
save $exhcris/temp,replace
restore



keep provider fileyear POS_HosOwnAg HCRIS_HosOwnAg AHA_HosOwnAg
gen newAHA=AHA_HosOwnAg
gen newHCRIS=HCRIS_HosOwnAg
tab AHA_HosOwnAg HCRIS_HosOwnAg
list if provider=="020004"
rename HCRIS_HosOwnAg_last HCRIS_HosOwnAg
reshape wide AHA_HosOwnAg HCRIS_HosOwnAg POS_HosOwnAg newHCRIS newAHA, i(provider) j(fileyear)



forvalues yr=2003/2007{
   gen flagAHAHCRIS`yr'=0
   gen flagPOSHCRIS`yr'=0
   gen str10 checkAHA`yr'=AHA_HosOwnAg`yr'
   gen str10 checkPOS`yr'=POS_HosOwnAg`yr'
   if "`yr'"=="2002"{
   local lastyr=`yr'
      local nextyr=`yr'
      }
   else {
   local lastyr=`yr'-1
   local nextyr=`yr'+1
      }

   ** FIX OWNERSHIP TYPE WHICH MAY DIFFER BASED ON THE YEAR THE SURVEY WAS PROCESSED;
   ** LOOK AROUND NON-MATCHING SAMPLES TO ASSIGN THE DATE CORRECTLY.
   replace flagAHAHCRIS`yr'=1 if AHA_HosOwnAg`yr'!=HCRIS_HosOwnAg`yr' & AHA_HosOwnAg`lastyr'==HCRIS_HosOwnAg`lastyr' & AHA_HosOwnAg`nextyr'==HCRIS_HosOwnAg`nextyr'
   replace checkAHA`yr'=HCRIS_HosOwnAg`yr'  if AHA_HosOwnAg`yr'!=HCRIS_HosOwnAg`yr' & AHA_HosOwnAg`lastyr'==HCRIS_HosOwnAg`lastyr' & AHA_HosOwnAg`nextyr'==HCRIS_HosOwnAg`nextyr'

   replace flagPOSHCRIS`yr'=1 if POS_HosOwnAg`yr'!=HCRIS_HosOwnAg`yr' & POS_HosOwnAg`lastyr'==HCRIS_HosOwnAg`lastyr' & POS_HosOwnAg`nextyr'==HCRIS_HosOwnAg`nextyr'
   replace checkPOS`yr'=HCRIS_HosOwnAg`yr'  if AHA_HosOwnAg`yr'!=HCRIS_HosOwnAg`yr' & AHA_HosOwnAg`lastyr'==HCRIS_HosOwnAg`lastyr' & AHA_HosOwnAg`nextyr'==HCRIS_HosOwnAg`nextyr'
}

gen checkAHA2002=AHA_HosOwnAg2002
gen checkAHA2008=AHA_HosOwnAg2008

gen checkPOS2002=POS_HosOwnAg2002
gen checkPOS2008=POS_HosOwnAg2008

forvalues yr=2002/2008{
    gen ownershipType`yr'=""
    gen str10 flag`yr'=""
    replace flag`yr'="ALL MATCH"                 if checkAHA`yr'==HCRIS_HosOwnAg`yr' & HCRIS_HosOwnAg`yr'==checkPOS`yr' & checkAHA`yr'==checkPOS`yr' & HCRIS_HosOwnAg`yr'!=""
    replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if checkAHA`yr'==HCRIS_HosOwnAg`yr' & HCRIS_HosOwnAg`yr'==checkPOS`yr' & checkAHA`yr'==checkPOS`yr' & HCRIS_HosOwnAg`yr'!=""

    replace flag`yr'="AHA-HCRIS MATCH" if checkAHA`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""
    replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if checkAHA`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""

    replace flag`yr'="POS-HCRIS MATCH" if checkPOS`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""
    replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if checkPOS`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""

    replace flag`yr'="POS-AHA MATCH" if checkPOS`yr'==checkAHA`yr' & ownershipType`yr'==""
    replace ownershipType`yr'=AHA_HosOwnAg`yr' if checkPOS`yr'==checkAHA`yr' & ownershipType`yr'==""
}

reshape long AHA_HosOwnAg HCRIS_HosOwnAg POS_HosOwnAg ownershipType flagAHAHCRIS flagPOSHCRIS flag checkAHA checkPOS newAHA newPOS newHCRIS, i(provider) j(fileyear)
drop if AHA_HosOwnAg=="" &  HCRIS_HosOwnAg=="" &  POS_HosOwnAg==""
list if provider=="020004"

tab AHA_HosOwnAg HCRIS_HosOwnAg
merge 1:1 provider fileyear  using $exhcris/temp

count
di "`keeporigcount'?`r(N)'"
assert `keeporigcount'==`r(N)'

tab flag ownershipType




////MERGE HCRIS AND POS CLEANED;
  /*
  use $inpos/posmaster_clean,clear
  rename prvnumgrp provider
  drop if fileyear<2002
  des
  drop if length(provider) > 6

forvalues yr=2002/2008{
   gen str10  ownershipType`yr'=""
   gen flag`yr'=""
   if "`yr'"=="2002"{
   local lastyr=`yr'
      local nextyr=`yr'
      }
   else {
   local lastyr=`yr'-1
   local nextyr=`yr'+1
      }

   replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`yr' & HCRIS_HosOwnAg`yr'==POS_HosOwnAg`yr' & ownershipType`yr'=="" & HCRIS_HosOwnAg`yr'!=""
   replace flag`yr'="ALL MATCH" if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`yr' & HCRIS_HosOwnAg`yr'==POS_HosOwnAg`yr'   & flag`yr'==""


   replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""
   replace flag`yr'="AHA-HCRIS MATCH" if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`yr' & flag`yr'==""


   replace ownershipType`yr'=AHA_HosOwnAg`yr' if AHA_HosOwnAg`lastyr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""
   replace flag`yr'="AHA-HCRISlast MATCH" if AHA_HosOwnAg`lastyr'==HCRIS_HosOwnAg`yr'  & flag`yr'==""

   replace ownershipType`yr'=AHA_HosOwnAg`yr' if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`lastyr'  & ownershipType`yr'==""
   replace flag`yr'="AHA-HCRISlast MATCH" if AHA_HosOwnAg`yr'==HCRIS_HosOwnAg`lastyr'  & flag`yr'==""

   replace ownershipType`yr'=HCRIS_HosOwnAg`yr' if POS_HosOwnAg`yr'==HCRIS_HosOwnAg`yr'  & ownershipType`yr'==""
   replace flag`yr'="POS-HCRIS MATCH" if POS_HosOwnAg`yr'==HCRIS_HosOwnAg`yr' & flag`yr'==""

   replace ownershipType`yr'=AHA_HosOwnAg`yr' if POS_HosOwnAg`yr'==AHA_HosOwnAg`yr' & ownershipType`yr'==""
   replace flag`yr'="POS-AHA MATCH" if POS_HosOwnAg`yr'==AHA_HosOwnAg`yr' & flag`yr'==""
   }
reshape long AHA_HosOwnAg HCRIS_HosOwnAg POS_HosOwnAg ownershipType flag, i(provider) j(fileyear)
count
assert `keeporigcount'==`r(N)'


**USING THE HOT FIXES
. tab flagall

    flagall |      Freq.     Percent        Cum.
------------+-----------------------------------
          0 |      5,135       21.68       21.68
          1 |     18,547       78.32      100.00
------------+-----------------------------------
      Total |     23,682      100.00

. tab AHA_HosOwnAg POS_HosOwnAg

AHA_HosOwn |           POS_HosOwnAg
        Ag |       gov  nonprofit     profit |     Total
-----------+---------------------------------+----------
       gov |     3,619        350         91 |     4,060
 nonprofit |       691     12,341        387 |    13,419
    profit |       196        804      3,628 |     4,628
-----------+---------------------------------+----------
     Total |     4,506     13,495      4,106 |    22,107


. tab AHA_HosOwnAg HCRIS_HosOwnAg

AHA_HosOwn |          HCRIS_HosOwnAg
        Ag |       gov  nonprofit     profit |     Total
-----------+---------------------------------+----------
       gov |     3,519        267        137 |     3,923
 nonprofit |       391     12,534        428 |    13,353
    profit |        28        126      4,450 |     4,604
-----------+---------------------------------+----------
     Total |     3,938     12,927      5,015 |    21,880

