/*
Program imports CCS files
*/

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

*****PRELIMINARIES************;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* define libraries;
* define libraries;
libname medEx  "&medparExt.";
libname indxex "&indxExt.";
libname spcar "&spcar.";
libname carEx   "&carExt.";
libname OpEx   "&OpExt.";
libname procs   "&proc.";
libname ccsext   "&ccsext.";
libname here ".";

%macro readinCCSxw;
* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";

x "dos2unix -437   ./ccs/single/$prref 2014.csv";
data here.singleCCScw_proc;
        infile "./ccs/single/$prref 2014.csv" MISSOVER DSD delimiter=","  LRECL=32767 FIRSTOBS=2  ;

        informat  icd9cm $4.
                  ccs  $3.
                  ccsdes  $50.
                  icd9des  $1.;

              input
                  icd9cm $
                  ccs  $
                  ccsdes  $
                  icd9des  $;
              drop icd9des;
    run;
    proc print data=here.singleCCScw_proc (obs=10);run;

    x  "dos2unix  -437 ./ccs/multi/ccs_multi_pr_tool_2014.csv ";
data here.multiCCScw_proc;
        infile "./ccs/multi/ccs_multi_pr_tool_2014.csv"  MISSOVER DSD delimiter=","  LRECL=32767 FIRSTOBS=2  ;

        informat  icd9cm $4.
                  ccs1  $5.
                  ccs1des  $50.
                  ccs2  $5.
                  ccs2des  $50.
                  ccs3  $5.
                  ccs3des  $50.;

              input
                  icd9cm $
                  ccs1  $
                  ccs1des  $
                  ccs2  $
                  ccs2des  $
                  ccs3  $
                  ccs3des  $;
    run;

    proc print data=here.multiCCScw_proc (obs=10);run;

x "dos2unix -437   ./ccs/single/$dxref 2013.csv";
data here.singleCCScw_dxn;
        infile "./ccs/single/$dxref 2013.csv" MISSOVER DSD delimiter=","  LRECL=32767 FIRSTOBS=2  ;

        informat  icd9cm $5.
                  ccs  $3.
                  ccsdes  $50.
                  icd9des  $1.;

              input
                  icd9cm $
                  ccs  $
                  ccsdes  $
                  icd9des  $;
              drop icd9des;
    run;
    proc print data=here.singleCCScw_dxn (obs=10);run;

    x  "dos2unix  -437 ./ccs/multi/ccs_multi_dx_tool_2013.csv ";
data here.multiCCScw_dxn;
        infile "./ccs/multi/ccs_multi_dx_tool_2013.csv"  MISSOVER DSD delimiter=","  LRECL=32767 FIRSTOBS=2  ;

        informat  icd9cm $5.
                  ccs1  $5.
                  ccs1des  $50.
                  ccs2  $5.
                  ccs2des  $50.
                  ccs3  $5.
                  ccs3des  $50.;

              input
                  icd9cm $
                  ccs1  $
                  ccs1des  $
                  ccs2  $
                  ccs2des  $
                  ccs3  $
                  ccs3des  $;
    run;

    proc print data=here.multiCCScw_dxn (obs=10);run;

%mend;


%readinCCSxw;
