/*
bringinBetos.sas;
Program to read in betos codes to SAS.
Maurice Dalton , October 22, 2012
    */

options pagesize=200;
options nocenter;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;
options NOQUOTELENMAX;
**THROWS ERROR IF CANT FIND A VARIABLE;
options DKRICOND=ERROR;
options DKROCOND=ERROR;
** TURNS ON MULTI CORE PROCESSING;
OPTIONS THREADS = YES CPUCOUNT = 2;


libname betoxw "/homes/nber/daltonm/betos/";


%macro readinbetosxw;
    %do year=1992 %to 1998;
        data betoxw.betos&year.XW;
            infile "/homes/nber/daltonm/betos/1998/BETPUF98.TXT" delimiter='09'x MISSOVER DSD
                DSD lrecl=32767 firstobs=1 ;
            informat  hcpcs_cd $5.
                betos $3.
                ;
            input
                hcpcs_cd $
                betos  $
                ;
            year=&year.;
            rawyear=1998;
        run;
        %end;

    data betoxw.betos1999XW;
        infile "/homes/nber/daltonm/betos/1999/betpuf99.txt" MISSOVER
            lrecl=32767 firstobs=1 ;
        informat  hcpcs_cd $5.
            betos $3.
            codetermdate yymmdd8.
            ;
        input
            hcpcs_cd $
            betos  $
            codetermdate
            ;
        year=1999;
        rawyear=1999;
    run;
    proc print data=betoxw.betos1999XW (obs=10);run;


        %do yr=0 %to 9;
        data betoxw.betos200&yr.XW;
            infile "/homes/nber/daltonm/betos/200&yr./betpuf0&yr..txt"  MISSOVER
                lrecl=32767 firstobs=1 ;
            informat  hcpcs_cd $5.
                betos $3.
                codetermdate yymmdd8.
                ;
            input
                hcpcs_cd $
                betos  $
                codetermdate
                ;
            year=200&yr.;
            rawyear=200&yr.;
        run;
        proc print data=betoxw.betos200&yr.XW (obs=10);run;
            %end;

        %do yr=10 %to 12;
        data betoxw.betos20&yr.XW;
            infile "/homes/nber/daltonm/betos/20&yr./betpuf&yr..txt" MISSOVER
                lrecl=32767 firstobs=1 ;

            informat  hcpcs_cd $5.
                betos $3.
                codetermdate yymmdd8.
                ;

            input
                hcpcs_cd $
                betos  $
                codetermdate
                ;

            year=20&yr.;
            rawyear=20&yr.;
        run;
        proc print data=betoxw.betos20&yr.XW (obs=10);run;
            %end;



    data betoxw.betoxw;
        set %do year=1992 %to 2012; betoxw.betos&year.XW %end;;
        rename betos=betosxw;
    run;
    %mend;

%readinbetosxw;


