


//Program combines the seperate files which have been created at
// the index level to aid in comparing across cohorts



clear
clear matrix
set mem 4G
set more off
pause off
// REad in directories from this file
do ../../dirInit.do

local cohrt ami
local pct   05

//number of index events coded in by hand
local  indx1993 12647
local  indx1994 12517
local  indx1995 12688
local  indx1996 12805
local  indx1997 12592
local  indx1998 12598
local  indx1999 12884
local  indx2000 12893
local  indx2001 13092
local  indx2002 13142
local  indx2003 13351
local  indx2004 12726
local  indx2005 11938
local  indx2006 11055
local  indx2007 10343
local  indx2008 10047
local  indx2009  9209
local  indx2010  8323


forvalues yr=1994/2010 {
    use $ccsext/`cohrt'`pct'_betoagg,clear
    collapse (first)countyear costyear (sum)countbeto betocost , by(clm_yr betosxw)
    replace  betosxw="MIS" if  betosxw==""
    keep if clm_yr==`yr'
    ///drop lalow* rawyear*  inca* inxw* betosgroup betodes codete* clm_yr
    di "`indx`yr''"
    gen pcount=countbeto/`indx`yr''
    gen pcost=betocost/`indx`yr''
    renvars *,postfix(`yr')
    rename betosxw`yr' betosxw
    drop clm_yr*
    save /tmp/clm`yr',replace
}


use $ccsext/`cohrt'`pct'_betoagg,clear
    collapse (first)countyear costyear betosgroup betodes (sum)countbeto betocost , by(clm_yr betosxw)
///drop lalow* rawyear*  inca* inxw* codete*
replace  betosxw="MIS" if  betosxw==""
gen pcount=countbeto/`indx1993'
gen pcost=betocost/`indx1993'
keep if clm_yr==1993
renvars *,postfix(1993)
rename betosxw1993 betosxw
rename betodes1993 betodes
rename betosgroup1993 betosgroup
rename clm_yr1993 clm_yr
drop clm_yr*

forvalues yr=1994/2010 {
merge 1:1 betosxw using /tmp/clm`yr'
drop _merge
! /tmp/clm`yr'* -f
}

save compareyearALL,replace
export excel using betoscount93to10ALL.xls, firstrow(variables) replace


foreach type in d30 after before{
forvalues yr=1994/2010 {
    use $ccsext/`cohrt'`pct'_betoagg`type',clear
    collapse (first)countyear costyear (sum)countbeto betocost , by(clm_yr betosxw)
    replace  betosxw="MIS" if  betosxw==""
    di "indxyr3::`indx`yr''"
    keep if clm_yr==`yr'
    ///drop lalow* rawyear*  inca* inxw* betosgroup betodes codete* clm_yr
    gen pcount=countbeto/`indx`yr''
    gen pcost=betocost/`indx`yr''
    renvars *,postfix(`yr')
    rename betosxw`yr' betosxw
    drop clm_yr*
    save /tmp/clm`yr',replace
}


use $ccsext/`cohrt'`pct'_betoagg`type',clear
collapse (first) countyear costyear betosgroup betodes (sum) countbeto betocost , by(clm_yr betosxw)
///drop lalow* rawyear*  inca* inxw* codete*
di "indxyr3::`indx1993' "
replace  betosxw="MIS" if  betosxw==""

gen pcount=countbeto/`indx1993'
gen pcost=betocost/`indx1993'

keep if clm_yr==1993
renvars *,postfix(1993)
rename betosxw1993 betosxw
rename betodes1993 betodes
rename betosgroup1993 betosgroup
rename clm_yr1993 clm_yr
drop clm_yr*

forvalues yr=1994/2010 {
merge 1:1 betosxw using /tmp/clm`yr'
drop _merge
! /tmp/clm`yr'* -f
}
aorder *
save compareyear`type',replace
export excel using betoscount93to10`type'.xls, firstrow(variables) replace

gen countdif09_93=pcount2009-pcount1993
gen costdif09_93=pcost2009-pcost1993

gsort -countdif09_93


}



