****************************************************************************************************************;
** The ICD9 to CC crosswalk is not exact. I previsoly padded it with 0 because I found that, as a hypethetical  ;
** example, in some cases 410 was reported but only 4100 was found in the crosswalk. I believed such an assumptio;
** about the structure of ICD9 code was innocuous but it came to my attention that 0 may not always be implied ;
** in order to test this i wrote this code to compare the padding to the CCS codes ;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";

* define libraries;
libname medex  "&medparExt.";
libname indxex "&indxExt.";
libname comorb   "&comorb.";
libname CCdir   "&CC.";
libname CCSdir   "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/Medicode/2SecondaryManipPrgms/CCScode";
libname here ".";
* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";

data CC2010;
        infile "&CC./2010_ICD_9_Crosswalk.txt" dlm="," FIRSTOBS=4 DSD;
        length dgnscd $6 ;
        length CC 3;
        input dgnscd $  dgnsLabel $  CC ;
       *Removes single white space;
        dgnscd=compress(dgnscd," ");
        *Removes multiple blanks;
        dgnscd=compbl(dgnscd);
       keep  dgnscd CC dgnsLabel;
run;

proc sort data  = CCSdir.multiccscw_dxn (keep=icd9cm ccs3)
            out = ccs (rename=(icd9cm=dgnscd)) NODUPKEY;
    by icd9cm;
run;

data cc2ccs;
    merge CC2010 (in=fcc) ccs (in=fccs);
    by dgnscd;
    inCC=fcc;
    inCCS=fccs;
    rename ccs3=ccs3nopad;
run;

data CC2010padded;
        infile "&CC./2010_ICD_9_Crosswalk.txt" dlm="," FIRSTOBS=4 DSD;
        length dgnscd $6 ;
        length CC 3;

        input dgnscd $  dgnsLabelnopad $  CC CClabel $;

        *Removes single white space;
        dgnscd=compress(dgnscd," ");
        *Removes multiple blanks;
        dgnscd=compbl(dgnscd);
        dgnscdold=dgnscd;
        keep dgnscdold dgnscd CC dgnsLabelnopad ;
        zero="0";
        **NEED to create any instance where the variable has trailing blanks, need to ;
        ** create all instance since some claims have trailing blancks while other do not.;

        output;
        if length(dgnscd) <5 then do;
            if length(dgnscd) =3 then do;
                dgnscd=trim(dgnscd) || zero;
                output;
                dgnscd=trim(dgnscd) || zero;
                output;
                end;
            if length(dgnscd) =4 then do;
                dgnscd=trim(dgnscd) || zero;
                output;
                end;
            end;
        if substr(dgnscd,length(dgnscd),1) = "0" then do;
            dgnscd=substr(dgnscd,1,length(dgnscd)-1);
            output;
            if substr(dgnscd,length(dgnscd),1) = "0" then do;
                dgnscd=substr(dgnscd,1,length(dgnscd)-1);
                output;

                if substr(dgnscd,length(dgnscd),1) = "0" then do;
                    dgnscd=substr(dgnscd,1,length(dgnscd)-1);
                    output;

                    if substr(dgnscd,length(dgnscd),1) = "0" then do;
                        dgnscd=substr(dgnscd,1,length(dgnscd)-1);
                        output;
                        end;
                    end;
                end;
            end;
    run;

proc sort data=CC2010padded;
    by dgnscd;
run;

data cc2ccs_padded;
    merge CC2010padded (in=fcc) ccs (in=fccs);
    by dgnscd;
    inCC=fcc;
    inCCS=fccs;
run;


data here.combine_pad_cc;
    merge cc2ccs_padded (drop=inCC inCCS in=fad rename=(cc=cc_padded))
          cc2ccs (drop=inCC inCCS in=fnopad);
    by dgnscd;
    inpad=fad;
    innopad=fnopad;
    dgnsLabelnopad=upcase(dgnsLabelnopad);
    dgnsLabel=upcase(dgnsLabel);
run;

TITLE "LIST OF DIAGNOSTIC CODES WHICH WHEN PADDED DO NOT BECOME UNIQUE -BASED ON ICD9 TO CC XW - THESE DIAGNOSTIC CODES ARE EXCLUDED FROM PADDING";
proc print data=combine_pad_cc (drop=ccs3 ccs3nopad);
    where dgnsLabelnopad ne dgnsLabel AND dgnsLabel ne "";
run;

TITLE "LIST CCS level 3 descriptions which differ the most";
proc print data=combine_pad_cc;
    where ccs3nopad ne ccs3 AND ccs3nopad ne "";
run;




