clear
clear matrix
set mem 3G
set more off

// REad in directories from this file
do ../../dirInit.do


local pct 05

foreach cohrt in ami  {
    ! st $costs/`cohrt'`pct'_alldcost.sas7bdat $costs/`cohrt'`pct'_alldcost.dta -Y
use $costs/`cohrt'`pct'_alldcost.dta
des
gen diag_year=year(dgn_date)
foreach file in op medpar car snf hosp  {
  foreach day in 1 30 90 365 {

    statsmat stayCost_`file'_d`day' ,by(diag_year)  s(mean) mat(cost`file'`day')  f(%4.0f)
    if `day'== 1 {
      local days "1 day or less"
    }
    if `day'== 3 {
      local days "less than 3 days"
    }
    if `day'== 7 {
      local days "less than 7 days"
    }
    if `day'== 9 {
      local days "less than 9 days"
    }
    if `day'== 15 {
      local days "less than 15 days"
    }
    if `day'== 30 {
      local days "less than 30 days"
    }
    if `day'== 60 {
      local days "less than 60 days"
    }
    if `day'== 90 {
      local days "less than 90 days"
    }
    if `day'== 180 {
      local days "less than 180 days"
    }
    if `day'== 365 {
      local days "less than 365 days"
    }

    mat colnames cost`file'`day'  = "`days'"



  }

  mat Cost`file'=(cost`file'1, cost`file'30, cost`file'90, cost`file'365)

}

 mat rownames Costmedpar = MedPar:
 mat rownames Costop = OutPatient:
 mat rownames Costcar = Carrier:
 mat costAgg=(Costmedpar \ Costop \ Costcar)

 mat rownames Costhosp = Hospital:
 mat rownames Costsnf = SNF:
 mat costMedPar=(Costhosp \ Costsnf )


 xml_tab costAgg using "$outCost/Mean`cohrt'Cost`pct'.xls",  sheet(Aggregate,nogridlines)  format((S3110) (S3230 N3120))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)   cblanks(10 20) tblanks(3) font("Garamond" 11)  title("`pct' Cost statistics-$S_DATE  ")   note("These statistics are computed from the output of the SAS program.") replace

 xml_tab costMedPar using "$outCost/Mean`cohrt'Cost`pct'.xls",  sheet(MedPAR,nogridlines)  format((S3110) (S3230 N3120))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)   cblanks(10 20) tblanks(3) font("Garamond" 11)  title("`pct' Cost statistics-$S_DATE ")   note("These statistics are computed from the output of the SAS program.") append


}
