******************************************************************************;
**Create Cost UTILIZATION  Measure across claims files. **********************;
******************************************************************************;
*** This programs is a type of wrapper programs which allows users to call the macros  ;
*** in the correct swquence. It is somewhat different from the other files.            ;
***                                                                                    ;
*** Most of what these programs due are segement the correct claims, mergen in the PPS ;
*** weights and conversion factors then estimate the amounts.                          ;
***                                                                                    ;
*** In order to use this program fill out the macro below with appropriate information,;
*** parameters are the same as those found in the main programs                       ;
*Maurice Dalton,daltonm.at.nber.org,;

***********************************************************************;
* DEFINE SAS OPTIONS ****;
***********************************************************************;
**READ IN SAS OPTIONS;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

****************************************************************;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
****************************************************************;
%include "../../dirInit.sas";


*define libraries that allow access to the various directories specified above;
*define libraries that allow access to the various directories specified above;
* define libraries.Defines local directories depending on which server currently running;
libname here ".";
libname spcost "&spcost.";
libname medEx  "&medparExt.";
libname opex "&opExt.";
libname carex "&carExt.";
libname indxex "&indxExt.";
libname costutil "&costutil.";
libname carRVU "&carRVU.";
libname APCS  "&APCdir";
libname DRGs "&DRGdir.";



** load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./DetermineMax.sas";
%include "&SASmac./archiveoldLogfiles.sas";
%include "&SASmac./read_sysparm.sas";

    *NEED TO DEFINE IF YOUR RUNNING FROM THIS PROGRAM (not from runAll.sh;
/*
    %let yearin=1992;
    %let yearout=2012;
    %let pct=05;
    %let cohrt=ami;
*/
*#########################################################################################;
**  RUN CARRIER RVU ALGORYTHM --NEED TO RUN ON SERVER WITH STAT TRANSFER;
*#########################################################################################;

%include "carrierRVU/generateCarrierCostUtil.sas";
   ** Need to run on a server with stat transfer;
    ** NEED TO BE SURE TO RUN ON SERVER WITH STAT TRANSFER THE PROGRAM -AGESAS1 --;
    ** OR RUN SEPERATLY AND COMMENT OUT;
    ** Stata file imports RVUs.;
    x "cd carrierRVU/";
    x "pwd";

    x "statamp -b do importRVU.do ";


data carRVU.rvu_weights (ENCODING=WLATIN1);
        set carRVU.rvu_weights (ENCODING = ANY);
run;


    ** ONLY DEFINED BACK TO 2000;
    %generateCarrierCostUtil(pct=&pct.,cohrt=&cohrt.,id=bene_id,yearin=&yearin.,yearout=&yearout.,los=365);
    x "cd .. ";
    x "rm spcost/* -f ";

*#########################################################################################;
**  RUN OPPS COST UTILIZATION ALGORYTHM     ** ONLY DEFINED BACK TO 2001;
*#########################################################################################;

    x "rm &spcost./* -f ";
    x "cd outpatient ";
    **********************************************************;
    **  IMPORTS APC DATA -- MACRO CALLED                   ***;
    **********************************************************;

    %include "calledMacroLib/OPPSimport_addenB.sas";
   %importOPPS(yearin=2001,yearout=2012);

   ** *******************************************************;
   ** COMBINE CLMS AND REV CNTRS - ;
   **********************************************************;
   **ONLY NEED TO RUN ONCE -merge Addendum B with revenue center and clm files.;
   %include "calledMacroLib/CombineOPclms_revcenter.sas";
   %include "OPPScostUtil.sas";
   *# RUN 5% ;
   %CombineOPclms_revcenter(pct=&pct.,cohrt=&cohrt.,yearin=2000,yearout=&yearout.);
  ** CREATES THE COST UTILIZATION MEASURES;
  ** THE LOS IS ONLY IMPORTANT FOR THE FINAL PRINT STATEMENT;
  ** THE OPPS DID NOT START UNTILL LATE 2000 DUE TO Y2K- START ANALYSIS IN 2001;
   %OPPScostUtil(pct=&pct.,cohrt=&cohrt.,yearin=2001,yearout=&yearout.,testlos=365);

    x "cd .. ";
    x "rm spcost/* -f ";

*#########################################################################################;
**  RUN ACUTE IPPS EXTRACTION --
*#########################################################################################;

    x "cd inpAcutePPS ";
    ** load file containing various simple macros that make programming easier;
    %include "ImportDRGinfo.sas";
    %ReshapDRGmatrix;
    ** load file containing various simple macros that make programming easier;
    %include "InpatientPPS_calc.sas";
    %AcuteIPPScostUtil(cohrt=&cohrt.,yearin=&yearin.,yearout=&yearout.,pct=&pct.);
    ** Get rid of all files writen to space directories.;
   x "rm spcost/* -f ";
   x "cd .."

* NOTE WORKING;
%archiveoldLogfiles(pct=&pct.,cohrt=&cohrt.,note=&note.)

