*###WRAPPER MACRO;
%macro generateCarrierCostUtil(pct=,cohrt=,id=,yearin=,yearout=,los=);

*** FROM CLAIMS PROCESSING IOM ;
** In addition to the major annual update, CMS also updates HCPCS codes quarterly to reflect ;
** additional changes or corrections that are emergency in nature.  Quarterly changes are ;
** issued by letter or memorandum for local implementation.;
** For this reason we use those reported in the last quarter;

*#########################################################################################;
**  IMPORT RVU DATA;
*#########################################################################################;

    ** Need to run on a server with stat transfer;
    *x statamp -b do importRVU.do ;

*#########################################################################################;
**  CODE IN CONVERSION FACTORS;
*#########################################################################################;
    data togetsample (drop=hcpcs_cd mdfr_cd1 rename=(hcpcs_cdsp=hcpcs_cd modifier=mdfr_cd1));
        length hcpcs_cd $7 modifier $4;
        set carex.&cohrt.&pct._carlnits ;
        WHERE (fileYear >= &yearin. and (expnsdt1>=dgn_date and trim(pmtdnlcd) ne "0"));
        difcount=expnsdt2-dgn_date;
        modifier=trim(mdfr_cd1);
        hcpcs_cdsp=trim(hcpcs_cd);

        FORMAT expnsdt2 DATE9;
        ** Trying to ignore all other hcpcs modifiers because only these three are found in the ;
        ** RVU crosswalk files;
        convfact=.          ;
        cf_surg=.                            ;
        cf_primcare=.                            ;
        cf_other=.                            ;
        cf_anesth=.                            ;
        * BASED ON OIM MANUALS - SEE ABOVE;
        if year(expnsdt2) = 1992 then do;
            convfact=31.001;
            end;
        * BASED ON OIM MANUALS - SEE ABOVE;
        if year(expnsdt2) = 1993 then do;
            cf_anesth=.                            ;
            cf_surg=31.926                          ;
            cf_primcare=.               ;
            cf_other=31.249                            ;
            **WE DO NOT HAVE THE UPDATE CODE IN THE 92-94 PFS. USE AVERAGE ;
            convfact=(31.249+31.926)/2;
            end;
        * BASED ON OIM MANUALS - SEE ABOVE;
        if year(expnsdt2) = 1994 then do;
            cf_anesth=.                            ;
            cf_surg=39.447                            ;
            cf_primcare=33.718            ;
            cf_other=32.905                            ;
            **WE DO NOT HAVE THE UPDATE CODE IN THE 92-94 PFS. USE AVERAGE ;
            convfact=(32.905+33.718+39.447)/3;
            end;
        if year(expnsdt2) = 1995 then do;
            cf_anesth=.                            ;
            cf_surg=39.447                            ;
            cf_primcare=36.382                            ;
            cf_other=34.616                          ;
            **Average of the surg,primcare and other cf;
            convfact=36.9484;
            end;
        if year(expnsdt2) = 1996 then do;
            cf_surg=40.7986                            ;
            cf_primcare=35.4173                            ;
            cf_other=34.6293                            ;
            **Average of the surg,primcare and other cf;
            convfact=36.9484;
            end;
        if year(expnsdt2) = 1997 then do;
            cf_surg=40.9603                            ;
            cf_primcare=35.7671                            ;
            cf_other=33.8454                            ;
            **Average of the surg,primcare and other cf;
            convfact=36.8576;
            end;
        if year(expnsdt2) = 1998 then convfact=36.6873  ;
        ** seems low;
        if year(expnsdt2) = 1999 then convfact=34.7315  ;
        if year(expnsdt2) = 2000 then convfact=36.6137   ;
        if year(expnsdt2) = 2001 then convfact=38.2581   ;
        if year(expnsdt2) = 2002 then convfact=36.1992   ;
        if year(expnsdt2) = 2003 then convfact=36.7856   ;
        if year(expnsdt2) = 2004 then convfact=37.3374   ;
        if year(expnsdt2) = 2005 then convfact=37.8975   ;
        if year(expnsdt2) = 2006 then convfact=37.8975   ;
        ***according to AMA it is 37.895 , not 35.9848 ;
        if year(expnsdt2) = 2007 then convfact=37.8975   ;
        * ** The 2009 PFS proposed rule noted 2 conversion factors, although this did not end up happening.
        **** based on review of data and the AMA ;
        if year(expnsdt2) = 2008 then convfact=38.0870       ;
        if year(expnsdt2) = 2009 then convfact=36.0666 ;
        jan2may2010=0;
        jun2dec2010=0;
        if year(expnsdt2) = 2010 and month(expnsdt2) <=5 then do;
            convfact=36.0791       ;
            jan2may2010=1;
            end;
        * http://www.gpo.gov/fdsys/pkg/PLAW-111publ192/pdf/PLAW-111publ192.pdf;
        if year(expnsdt2) = 2010 and month(expnsdt2) >=6 then do ;
            convfact=36.8729       ;
            jun2dec2010=1;
            end;
         end_yr=year(expnsdt2);
        if year(expnsdt2) = 2011 then convfact=33.9764       ;
        if year(expnsdt2) = 2012 and month(expnsdt2) <=2 then do ;
          convfact=34.0376       ;
          jan2feb2012=1;
          end;
        if year(expnsdt2) = 2012 and month(expnsdt2) >=3 then do ;
          convfact=34.0376       ;
          mar2dec2012=1;
          end;

        flagcontiguous48=1;
        ** drop providers with out of state codes -iincluding hawaii, alaska and wash dc;
        if prvstate =54 or prvstate = 2 or prvstate = 9 or prvstate = 12 or (prvstate>=56 and prvstate<=66) or prvstate>=80 then flagcontiguous48=0;

    run;

    TITLE "RAW DATA COUNTS";
    proc freq data=togetsample;
    table end_yr;
    run;
    TITLE "";

*#########################################################################################;
**  TAG OBERVATIONS WITH modifiers - PREP FOR MERGE WITH PFS;
*#########################################################################################;
    ** These are the only 3 modifiers found in the RVU payment systems.;
    data addVar;
        set togetsample;
        flag=0;
        if mdfr_cd1 = "26" then flag=1;
        if mdfr_cd1 = "53" then flag=1;
        if mdfr_cd1 = "TC" then flag=1;
        modifier=mdfr_cd1;
        **drop obervations without modifiers of interest;
        if flag=1;
        drop flag;
        flag2002=0;
        **BASED ON NOTE FROM FINAL RULE;
        if year(expnsdt2) = 2003 and month(expnsdt2) <= 3 then do ;
            end_yr=2002;
            flag2002=1;
            end;
    run;

    data addVarNonMod;
        set togetsample;
        flag=0;
        if mdfr_cd1 = "26" then flag=1;
        if mdfr_cd1 = "53" then flag=1;
        if mdfr_cd1 = "TC" then flag=1;
        modifier=mdfr_cd1;
        **drop obervations without modifiers of interest;
        if flag=0;
        drop flag;
        **BASED ON NOTE FROM FINAL RULE;
        flag2002=0;
        if year(expnsdt2) = 2003 and month(expnsdt2) <= 3 then do ;
            end_yr=2002;
            flag2002=1;
            end;
    run;

    proc sort data=addVarNonMod;
        by hcpcs_cd end_yr;
    run;

    proc sort data=carRVU.rvu_weights;
        by hcpcs_cd year modifier;
    run;

    proc sort data=addVar;
        by hcpcs_cd end_yr modifier;
    run;


    *#########################################################################################;
    ** MERGE BASED ON HCPCS_CD AND END_YR IN CASE WHERE MODIFIER IS NOT ONE OF THREE IDENTIFIED;
    *#########################################################################################;
    data mergeInRVUsNonMod;
        merge addVarNonMod(in=nonmod) carRVU.rvu_weights (in=inphyf drop=mdfr_cd1 modifier betos rename=(year=end_yr)) ;
        by hcpcs_cd end_yr ;
        innonMod=nonmod;
        inPhy=inphyf;
        if innonMod ;
    run;
    *#########################################################################################;
    ** MERGE BASED ON HCPCS_CD AND END_YR AND MODIFIER ;
    *#########################################################################################;
    data mergeInRVUsMod;
        merge addVar(in=nonmod) carRVU.rvu_weights (in=inphyf drop=mdfr_cd1 betos rename=(year=end_yr)) ;
        by hcpcs_cd end_yr modifier;
        inMod=nonmod;
        inPhy=inphyf;
        if inMod ;
    run;


  proc contents data=mergeInRVUsMod;
    run;
    *#########################################################################################;
    *## BUILD STATS;
    *#########################################################################################;
    TITLE "COUNT MERGE 3 MOD OF INTERESt -miss wgt";
    proc freq data=mergeInRVUsMod;
        WHERE end_yr=2002;
        table plcsrvc;
    run;

    TITLE "COUNT MERGE MISSING MOD -miss wgt ";
    proc freq data=mergeInRVUsNonMod;
        WHERE end_yr=2002;
        table plcsrvc;
    run;
    TITLE "COUNT MERGE 3 MOD OF INTERESt ";
    proc freq data=mergeInRVUsMod;
        table end_yr;
    run;

    TITLE "COUNT MERGE MISSING MOD ";
    proc freq data=mergeInRVUsNonMod;
        table end_yr;
    run;

    *#########################################################################################;
    *## COMBINE CARRIER WITH PFS MERGE (NO MODIFIER MATCH - MODIFIER MATCH;
    *#########################################################################################;
    data RVUcalcs missRVU;
        set mergeInRVUsNonMod (WHERE=(innonMod and inPhy)) mergeInRVUsMod (WHERE=(inMod and inPhy));
        *FACILITY/NON-FACILITY CODES FOUND HERE::;
        ** https://www.cms.gov/manuals/downloads/clm104c26.pdf;
        * FAcility;
        fac="O";
        if plcsrvc in("21","22","23","24","26","31","33","41","42","51",
                       "52","53","56","61") then fac="F";
            * Non-facility ;
        if plcsrvc in("01","03","04","09","11","12","13","14","15","16",
                      "17","20","25","32","33","49","50","54","57","60",
                      "62","65","71","72","81","91") then fac="N";

        **Facilty/non-facilty RVUwghts are handled in the import STata script;
        RVUwght=0;
        if fac="F" then RVUwght=fac_total_rvu;
        if fac="N" or fac="O" then RVUwght=nonfac_total_rvu;

        cyear=end_yr;
        year=end_yr;
        if modifier="" then modifier="MI";
        **anesthesia is reimbursed trhoug a different system;
         if RVUwght=0 or RVUwght= . or betos="P0" then do;
            missingrvu_anest=1;
            output missRVU;
            end;
        if RVUwght ne 0 then do;
            missingrvu_anest=0;
            output RVUcalcs;
            end;
        **could speed up by dropping observations;
    run;

    *#########################################################################################;
    *## GENERATE MEDIAN FOR CLMS WITH RVU == 0  ;
    *#########################################################################################;
    *#Note: Of those that merge, 26.41% of the claims (18.34% of costs) are associated with total RVU of 0. ;
    *#      These are largely associated with Status Codes indicating statutory exclusions, excluded ;
    *#      from physician fee schedule by regulation, or that the carriers themselves are supposed;
    *#      to price the code.            ;
    *#;
    *#Note: For this 26.41% of claims, we assign the RVU to be the median Carrier Payment by HCPCS code ;
    *#      modifier and year, divided by the Conversion Factor for that year                           ;

    proc means data=missRVU (keep=hcpcs_cd modifier end_yr lalowchg )  MEDIAN NWAY NOPRINT;
        class hcpcs_cd modifier end_yr;
        var lalowchg;
        output out=missRVUmedian MEDIAN=medianHCPCScost;
    run;

    proc univariate data=missRVUmedian;
        var medianHCPCScost;
    run;

    proc sort data=missRVU;
        by hcpcs_cd modifier end_yr;
    run;

    proc sort data=missRVUmedian;
        by hcpcs_cd modifier end_yr;
    run;

    data medianHCPCScostMissRVU;
        merge missRVU (in=inRVU) missRVUmedian (in=inMed keep=hcpcs_cd modifier end_yr medianHCPCScost);
        by hcpcs_cd modifier end_yr;
        if inRVU and inMed;
    run;

    *#########################################################################################;
    *## ASSIGN MEDIAN TO RVU WGT FOR CLMS WITH RVU == 0, RVU==. or ANESTHESIA SERVICES  ;
    *#########################################################################################;
    data &cohrt.&pct._carlnitsQ;
        set medianHCPCScostMissRVU RVUcalcs;
        if missingrvu_anest=1 then do;
            RVUwght=medianHCPCScost/convfact;
            end;
        RVUbase&los.=convfact*(RVUwght);
    run;

    TITLE "BROUGHT MISSING RVU CODES BACK INTO SAMPLE";
    proc freq data=&cohrt.&pct._carlnitsQ;
        table end_yr end_yr*missingrvu_anest / nocol norow nocel;
    run;
    TITLE "";

    proc sort data=&cohrt.&pct._carlnitsQ;
        by end_yr;
    run;

    *#########################################################################################;
    *## CREATE ANNAUAL STATS USED IN THE RAW CAR   ;
    *#########################################################################################;
    data ANNUAL_CALCS (keep=end_yr totalRVU totalPay ratio totalConv );
        set &cohrt.&pct._carlnitsQ;
        by end_yr;
        retain totalPay totalRVU totalConv countyr 0;
        if first.end_yr then totalPay=0;
        if first.end_yr then  totalRVU=0;
        if first.end_yr then countyr=0;
        if first.end_yr then totalConv=0 ;

        totalPay=totalPay+lalowchg;
        totalConv=totalConv+convfact;

        totalRVU = RVUwght + totalRVU ;
        if last.end_yr then ratio=totalPay/totalRVU;
        if last.end_yr then output;
    run;

    proc print data=ANNUAL_CALCS ;
    run;


    *#########################################################################################;
    *## MERGE IN WGHTS AND GENERATE COST UTILIZATION MEASURE    ;
    *#########################################################################################;
    data costutil.&cohrt.&pct._RVUratio;
        merge ANNUAL_CALCS (in=yeardta) &cohrt.&pct._carlnitsQ (in=clms);
        by end_yr;
        yeardtafl=yeardta;
        clmsfl=clms;

        if end_yr >= 1998 then do;
            physician_Q=RVUwght*convfact;
            end;
        else if end_yr = 1995 or end_yr = 1996 or end_yr = 1997 then do;
            if update ="P" then physician_Q=cf_primcare*(RVUwght);
            if update ="N" then physician_Q=cf_other*(RVUwght);
            if update ="S" then physician_Q=cf_surg*(RVUwght);
            end;
        else if end_yr <= 1994 then do;
            physician_Q=RVUwght*convfact;
            end;
         **status_code value definitions;
         /* PFS=A
            CARRIERPRICED
            excluded -reasonanble charge or other=E
            carrier priced=C, restricted covereage, if ocvered carrier priced R

            UNCOVERED
            deleted codes=D
            no valid=G
            deleted modifier=H
            service not covered=N
            excluded=X

            BUNDLED SERVICES
            bundled=B
            bundled services-some times bundled into other PFS or not (do not use)=P
            injections. ussually bundled. only paid if no other rvu billed by the same date and provider
         */

        **FOUND IN THE PFS SCHEDULE;
        if in(status_code,"A") then inpfs=1;
        **BUNDLED SERVICED ;
        if in(status_code,"B","P") then inpfs=2;
        **CARRIER PRICED ;
        if in(status_code,"E","R") then inpfs=3;
        **NOT COVERED BY PFS ;
        if in(status_code,"D","G","H","X") then inpfs=4;
        **PFS PAYS ANNESTHESIA DIFFERENTLY ;
        if in(betos,"P0") then inpfs=5;

        physician_Q&los.=RVUwght*ratio;
        if flag2002=1 then end_yr=2003;
        keep bene_id dgn_date hcpcs_cd mdfr_cd1 end_yr physician_Q physician_Q&los. cf_: carrawindx flag2002
             year totalRVU RVUwght totalRVU lalowchg convfact RVUbase&los. plcsrvc modifier status_code
            missingrvu_anest update inpfs;

        LABEL
            physician_Q&los.= "Alternate Cost utilization measure : conversion factor estimated from data"
            physician_Q= "Recommended cost utilization measure: conversion factor from Final Rule"
            end_yr= "Year of the claim end date, year(sexpendt2)"
            mdfr_cd1= "First HCPCS modifier code-RAW"
            modifier="Modifier code used to merge in PFS, assigned MI code"
            plcsrvc = "Place of service code"
            RVUwght ="total RVU weight associated with HCPCS code"
            convfact ="Carrier conversion factor, $/RVU wght"
            flag2002="Half of fiscal year 2003 uses 2002 rates according to the final rule - flags these cases"
            missingrvu_anest="RVU which are not in the PFS and median cost/conversion factor assigned as weight"
            inpfs="in pfs 1 : bundled 2 : carrier priced 3 : no pfs 4 : anesthesia 5";

    run;

    TITLE "FINAL COST UTILIZATION COUNT";
    proc freq data=costutil.&cohrt.&pct._RVUratio;
        table end_yr ;
    run;

    TITLE "MISSING PHYSICIAN Q";
    proc freq data=costutil.&cohrt.&pct._RVUratio;
        WHERE physician_Q =.;
        table end_yr end_yr*update/ nocol norow nocel;
    run;
    TITLE "";

    proc sort data=costutil.&cohrt.&pct._RVUratio;
        by year;
    run;

    *#########################################################################################;
    *## GENERATE CROSSWALK FOR THIS SPECIFIC COHORT PCT WHICH CAN BE APPLIED TO THE RAW DATA  ;
    *#########################################################################################;
    proc sort data=costutil.&cohrt.&pct._RVUratio
              out=costutil.&cohrt.&pct._HCPCS2costutil
                  (keep=end_yr hcpcs_cd modifier plcsrvc RVUwght physician_Q  convfact physician_Q&los. status_code update
                   rename=modifier=mdfr_cd1)
               nodupkey;
        by end_yr hcpcs_cd modifier plcsrvc  ;
    run;

    proc corr data=costutil.&cohrt.&pct._RVUratio;
        by year;
        var physician_Q&los. lalowchg;
    run;

    ***RATIO CORRLEATION;
    proc corr data=costutil.&cohrt.&pct._RVUratio;
        by year;
        var physician_Q lalowchg;
    run;

    **Clear Space directory;
    x "rm &spcost./* -f";

    %mend;




**;
**########################################################################3;
** updateThe national conversion factors are - from the CARRIER IOM ;
**########################################################################3;
**SOURCE FOR OlD CONVERSION FACTORS;
** Medicare Claims Processing Manual;
** Chapter 12 - Physicians/Nonphysician Practitioners;
**     http://www.cms.gov/Regulations-and-Guidance/Guidance/Manuals/downloads/clm104c12.pdf
**
** 2002 - $36.1992 ;
** 2001 - $38.2581 ;
** 2000 - $36.6137 ;
** 1999 - $34.7315 ;
** 1998 - $36.6873 ;
** 1997 - $40.9603 (Surgical) $33.8454 (Nonsurgical) $35.7671 (Primary Care);
** 1996 - $40.7986 (Surgical) $34.6296 (Nonsurgical) $35.4173 (Primary Care);
** 1995 - $39.447 (Surgical) $34.616 (Nonsurgical) $36.382 (Primary Care)   ;
** 1994 - $35.158 (Surgical) $32.905 (Nonsurgical) $33.718 (Primary Care)   ;
** 1993 - $31.926 (Surgical) $31,249 (Nonsurgical)                          ;
** 1992 - $31.001;
** For the years 1999 through 2002, payments attributable to practice expenses transitioned ;
** from charge-based amounts to resource-based practice expense RVUs.  The CMS used ;
** the following transition formula to calculate the practice expense RVUs.;
** 1999 -75 percent of charged-based RVUs and 25 percent of the resource-based ;
** RVUs.;
** 2000 - 50 percent of the charge-based RVUs and 50 percent of the resource-based ;
** RVUs.2001 - 25 percent of the charge-based RVUs and 75 percent of the resource-based ;
** RVUs.;
** 2002 - 100 percent of the resource-based RVUs;
**########################################################################3;
/*AMA HAS THE COMPLETE HISTORY WIHT AN EXPLANATION BELOW
**########################################################################3;
///http://www.ama-assn.org/resources/doc/rbrvs/cf-history.pdf
History of Medicare Conversion Factors
Change
1992 $31.0010 N/A N/A N/A
1993 N/A $31.9620 $31.2490
1994 N/A $33.7180 $35.1580 10.0 $32.9050 5.3
1995 N/A $36.3820 7.9 $39.4470 12.2 $34.6160 5.2
1996 N/A $35.4173 -2.7 $40.7986 3.4 $34.6293 0.0
1997 N/A $35.7671 1.0 $40.9603 0.4 $33.8454 -2.3
1998 $36.6873
1999 $34.7315 -5.3
2000 $36.6137 5.4
2001 $38.2581 4.5
2002 $36.1992 -5.4
2003 $36.7856 1.6
2004 $37.3374 1.5
2005 $37.8975 1.5
2006 $37.8975 0.0
2007 $37.8975 0.0
2008 $38.0870 0.5
2009 $36.0666 -5.3
1/1/10-
5/31/10 $36.0791 0.03
6/1/10-
12/31/10 $36.8729 2.2
2011 $33.9764 -7.9
2012 $34.0376 0.18
Initially, the Medicare Physician Payment Schedule included distinct
conversion factors for various categories of services. In 1998, a single
conversion factor was offset by elimination of the work adjustor and increases
in the practice expense and PLI RVUs. The reduction in the 2009 conversion
factor was offset by elimination of the work adjustor from the third Five-Year
Review. The reduction in the 2011 conversion factor was offset by increases
to the practice expense and PLI RVUs resulting from the rescaling of those
RVU pools to match the revised MEI weights
*/
