*#########################################################;
*Format DRG MATRIX -- in wide format change to long format;
*#########################################################;
%macro ReshapDRGmatrix;

/*
x "cd ";
x wget http://www.nber.org/drg/drg2014.sas7bdat";
x wget http://www.nber.org/drg/drg2013.sas7bdat";
x wget http://www.nber.org/drg/drg2012.sas7bdat";
x wget http://www.nber.org/drg/drg2011.sas7bdat";
*/
libname drgex "&DRGdir.";

    proc import datafile= "&DRGdir./DRGhistory.csv"
        out=DRGhistory
        dbms=dlm
        replace;
        delimiter=","  ;
        getnames=yes;

    run;

    %do y=1983 %to 2010;
        data DRG&y.;
            set DRGhistory   (keep=DRG FY&y.) ;
            fyear=&y.+1;
            drg_cd1=put(DRG,3.0);

            %do i=1 %to 9;
                if drg_cd1="  &i." then drg_cd1="00&i.";
                %end;
            %do i=10 %to 99;
                if drg_cd1=" &i." then drg_cd1="0&i.";
                %end;
            rename drg_cd1=drg_cd;
            DRGwght=FY&y./10000;
            drop FY&y.;
        run;
        %end;
    %do y=2011 %to 2014;
        data DRG&y.;
            set drgex.drg&y.;
            fyear=&y.+1;
            rename drg=drg_cd
                   drgweight=drgwght;
            keep fyear drg drgweight;
        run;
%end;

    **assumed that large labor areas index >1;
    data costutil.DRGlong;
        set %RepeatN(DRG,1983,2014) ;
        if fyear=1992 then do;
        **FULLUPDATE;
        *** HEIN LIBRARY FEDERAL REGISESTER - 1991 - Aug 30 1991 - pg 43249;
        * labor     large urban :: 2526.80   otherurban :: 2486.60   rural :: 2434.26;
        * non-labor large urban :: 1041.01   otherurban :: 1024.54   rural ::  816.50;

        *** HEIN LIBRARY FEDERAL REGISESTER - 1991 - Aug 30 1991 - pg 43249 - no cap reported;
            capital=.;
            labor=(2526.80+2486.60+2434.26)/3;
            nonlabor=(1041.01+1024.54+816.50)/3;
            end;
        if fyear=1993 then do;
        **FULLUPDATE;
        *** HEIN LIBRARY FEDERAL REGISESTER - 1992 - Sep 1,1992 - pg39845
        * labor     large urban :: 2588.38   otherurban :: 2547.40   rural :: 2623.30;
        * non-labor large urban :: 1066.39   otherurban :: 1049.51   rural ::  844.54;

        *** HEIN LIBRARY FEDERAL REGISESTER - 1992 - Sep 1,1992 - pg39845;
            capital=417.29;
            labor=(2855.38+2547.40+2623.30)/3;
            nonlabor=(1066.39+1049.51+844.54)/3;
            end;
        if fyear=1994 then do;
       **FULLUPDATE;
        *** HEIN LIBRARY FEDERAL REGISESTER - 1992 - Sep 1,1993 - pg46362;
        * labor     large urban :: 2646.19   otherurban :: 2604.30   rural :: 2698.19;
        * non-labor large urban :: 1090.21   otherurban :: 1072.95   rural ::  869.31;

        *** HEIN LIBRARY FEDERAL REGISESTER - 1992 - Sep 1,1993 - pg46362;
            capital=378.34;
            labor=(2646.19+2604.30+2698.19)/3;
            nonlabor=(1090.21+1072.95+869.31)/3;
            end;
        if fyear=1995 then do;
        **FULLUPDATE;
        ** 9/1/1994: text (270KB);
        * labor     <1 :: 2666.52        labor >=1 :: 2709.42  ;
        * non-labor <1 :: 1068.10   non-labor >=1 :: 1085.29 ;
            capital=376.83;
            labor=(2709.42+2666.52)/2;
            nonlabor=(1068.10+1085.29)/2;
            end;
        if fyear=1996 then do;
        **FULLUPDATE;
        ** 9/1/1995: text (270KB);
        * labor     <1 :: 2697.99        labor >=1 :: 2741.39  ;
        * non-labor <1 :: 1080.71   non-labor >=1 ::  1098.09 ;

        ** :: change to the way capital is updated - see final rule;
            capital=461.96;
            labor=(2697.99+2741.39)/2;
            nonlabor=(1080.71+1098.09)/2;
            end;
        if fyear=1997 then do;
        **FULLUPDATE;
        ** 8/30/1996: text (270KB);
        * labor     <1 :: 2738.79        labor >=1 :: 2782.84  ;
        * non-labor <1 :: 1107.83    non-labor >=1 :: 1125.64 ;

        ** :: change to the way capital is updated - see final rule;
            capital=438.92;
            labor=(2738.79+2782.84)/2;
            nonlabor=(1107.83+1125.64)/2;
            end;
        if fyear=1998 then do;
            labor=(2776.21+2732.26)/2;
            nonlabor=(1128.44+1110.58)/2;
            capital=371.51;
            end;
        if fyear=1999 then do;
            labor=(2783.42+2739.36)/2;
            nonlabor=(1313.41+1113.47)/2;
            capital= 378.05;
            end;
        if fyear=2000 then do;
            labor=(2809.18+2764.7)/2;
            nonlabor=(1141.85+1123.76)/2;
            capital= 377.03;
            end;
        if fyear=2001 then do;
            capital=382.03;
            labor=(2864.19+2818.85)/2;
            nonlabor=(1164.21+1145.78)/2;
            end;
        if fyear=2002 then do;
            capital=390.74;
            labor=(2955.44+2908.65)/2;
            nonlabor=(1201.30+1182.27)/2;
            end;
        if fyear=2003 then do;
        **FULLUPDATE;
        ** CMS-1470-CN: PDF Version (270KB);
        * labor     <1 :: 2974.75        labor >=1 :: 3022.6  ;
        * non-labor <1 :: 1209.15   non-labor >=1 :: 1228.6 ;

            capital=407.01;
            labor=(3022.6+2974.75)/2;
            nonlabor=(1209.15+1228.6)/2;
            end;

        if fyear=2004 then do;
                 **FULLUPDATE;
        ** CMS-1470-CN: PDF Version (270KB);
        * labor     <1 :: 3089.73        labor >=1 :: 3136.39  ;
        * non-labor <1 :: 1254.67   non-labor >=1 :: 1274.85 ;
            capital=414.18;
            labor=(3089.73+3136.39)/2;
            nonlabor=(1254.67+1274.85)/2;
            end;
        if fyear=2005 then do;
         **FULLUPDATE;
        ** CMS-1428-F2: PDF Version (1.9MB)
        ** http://www.gpo.gov/fdsys/pkg/FR-2005-05-04/pdf/05-8507.pdf -- pg 23483;
        * labor     <1 :: 2823.64        labor >=1 :: 3238.07  ;
        * non-labor <1 :: 1730.62   non-labor >=1 :: 1316.18 ;
            capital=416.53;
            labor=(3238.07+2823.64)/2;
            nonlabor=(1316.18+1730.62)/2;
            end;
        if fyear=2006 then do;
        **FULLUPDATE;
        ** http://www.gpo.gov/fdsys/pkg/FR-2005-05-04/pdf/05-8507.pdf -- pg 23483
        * labor     <1 :: 1428.55       labor >=1 :: 1791.58  ;
        * non-labor <1 :: 2923.11   non-labor >=1 :: 3286.14 ;
            labor=(3286.14+2923.11)/2;
            nonlabor=(1428.55+1791.58)/2;
            capital=419.90;
            end;
        if fyear=2007 then do;
        **FULLUPDATE;
        ** careful, CMS update the base payments several time. ;
        ** CMS-1488-N: PDF Version (989KB);
        * non-labor     <1 :: 1852.31        non-labor >=1 :: 1476.97   ;
        * labor         <1 :: 3022.18        labor     >=1 :: 3397.52 ;
            labor=(3397.52+3022.18)/2;
            nonlabor=(1852.31+1476.97)/2;
            capital=427.03;
            end;
        if fyear=2008 then do;
        **FULLUPDATE;
        ** careful, CMS update the base payments several time. ;
        ** CMS-1533-CN2: PDF Version (727KB)  ;
        * non-labor     <1 :: 1885.04        non-labor >=1 :: 1503.07   ;
        * labor <1 :: 3075.60   labor >=1 :: 3457.57 ;
            labor=(3457.57+3075.6)/2;
            nonlabor=(1885.04+1503.07)/2;
            capital=423.34;
            end;
        if fyear=2009 then do;
        **FULLUPDATE;
        * labor     <1 :: 1544.98       labor >=1 :: 3553.98 ;
        * non-labor <1 :: 1934.60   non-labor >=1 :: 3161.36 ;
            labor=(3553.98+3161.36)/2;
            nonlabor=(1544.98+1934.6)/2;
            capital=421.29;
            end;
        if fyear=2010 then do;
        **FULLUPDATE
        * labor     <1 :: 3179.71       labor >=1 :: 3441.26 ;
        * non-labor <1 :: 1948.85   non-labor >=1 :: 1687.30 ;
            labor=(3179.71+3441.26)/2;
            nonlabor=(1948.85+1687.30)/2;
            capital=420.67;
            end;
        if fyear=2011 then do;
        **FULLUPDATE
        * labor     <1 :: 3179.71       labor >=1 :: 3441.26 ;
        * non-labor <1 :: 1948.85   non-labor >=1 :: 1687.30 ;
            labor=(3545.96+3195.49)/2;
            nonlabor=(1608.05+1970.09)/2;
            capital=422.18;
            end;
        if fyear=2012 then do;
        **FULLUPDATE
        * labor     <1 :: 3179.71       labor >=1 :: 3441.26 ;
        * non-labor <1 :: 1948.85   non-labor >=1 :: 1687.30 ;
            labor=(3584.30+3230.04)/2;
            nonlabor=(1625.44+1979.70)/2;
            capital=421.42;
            end;
        if fyear=2013 then do;
        **FULLUPDATE
        * labor     <1 :: 3179.71       labor >=1 :: 3441.26 ;
        * non-labor <1 :: 1948.85   non-labor >=1 :: 1687.30 ;
            labor=(3679.95+3316.23)/2;
            nonlabor=(1668.81+2032.53)/2;
            capital=425.49;
            end;

    run;
    %mend;

