**NO LONGER UPDATE ALTHOUGH THE CODE MAYBE USEFULL DOWN THE LINE;

*********NOTE THAT THIS IS NOT BEEN FINALIZED. INCLUDED IN CASE ANYONE IS INTERESTED;
options pagesize=200;
options nocenter;
** These options create large log files ;
options mprint mlogic;
options msglevel=i;
options notes stimer fullstimer;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;

** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;

%include "../../dirInit.sas";

** load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "../setupdir.sas";
%let APCdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput;
%let AFSdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput/AmbulanceFeeSchedule;
%let ASCdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput/AmbulatoryServiceCenters;

*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname out "&longExt.";
libname carout "&carExt.";
libname opout "&opExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";
libname reimOut "/disk/agero5/medicare.work/wise-DUA16702/daltonm/reimb/OP";
libname APCS  "&APCdir";
libname AFS  "&AFSdir";
libname ASC  "&ASCdir";

%include "importAFS.sas";

*###WRAPPER MACRO;
%macro AFS_ratioCalc(pct=,cohrt=,dgnPos=,id=,yearin=,yearout=,los=);
   ** ################################;
    ** #######  IMPORTS APC DATA;
    ** ################################;
    %do yr=&yearin. %to &yearout.;
        %importAFSdata(year=&yr.);
        %end;

    data AFS.AFS_fee&yearin._&yearout.;
        set %RepeatN(AFS.AFS_fee,&yearin.,&yearout.);
        where rvu ne .;
    run;


    proc sort data=AFS.AFS_fee&yearin._&yearout.;
        by cyear hcpcs_cd;
    run;

    **Refine the sample to the right LOS;
    proc sort data=reimOut.merge_revclms out=reimOut.merge_revclms&los.;
        where (rev_dt-dgn_date<=&los. and rev_dt-dgn_date >=0) ;
        by cyear hcpcs_cd;
    run;


    data AFS.AFS_fee&yearin._&yearout.;
        length hcpcs_cd $5;
        set AFS.AFS_fee&yearin._&yearout.;
    run;

    data reimOut.revlcmsAFS  ;
        merge reimOut.merge_revclms&los. (in=clms )
              AFS.AFS_fee&yearin._&yearout. (in=AFSfl );
        by cyear hcpcs_cd;
        inclm=clms;
        inAFS=AFSfl;
        if inclm ;
        if rev_dt=. then rev_dt=thru_dt;
    run;

    proc sort data=reimOut.revlcmsAFS ;
        by clm_id  bene_id dgn_date ;
    run;

    data reimout.claimLevel_AFS&los.;
        set reimOut.revlcmsAFS (keep=clm_id  bene_id dgn_date revallpay inAFS cyear rvu);
        by clm_id  bene_id dgn_date ;
        retain rvuwght AFSpay_rev
               AFSpay_clm pay_rev
               nonAFSpay_rev 0;
        if  first.clm_id  and first.bene_id and first.dgn_date then do;
            rvuwght=0;
            AFSpay_rev=0;
            nonAFSpay_rev=0;
            pay_rev=0;
            end;

        pay_rev=revallpay+pay_rev;
        if inAFS=1 and revallpay ne . then AFSpay_rev=revallpay+AFSpay_rev;
        if inAFS=0 and revallpay ne . then nonAFSpay_rev=revallpay+nonAFSpay_rev;
        if inAFS=1 and rvu  ne . then rvuwght=rvu+rvuwght;

        keep cyear clm_id diag_id inAFS AFSpay_rev nonAFSpay_rev rvuwght pay_rev;
        if last.clm_id and last.bene_id and last.dgn_date then do;
            output;
            end;
    run;

    proc sort data= reimout.claimLevel_AFS&los. ;
        by  cyear;
    run;

    data reimOut.AverageProvAFS&los. (keep=cyear totalRVU  tot_rev totAFS_rev totnonAFS_rev ratio) ;
        set reimout.claimLevel_AFS&los.    ;
        by cyear;
        retain  totalRVU  tot_rev totAFS_rev totnonAFS_rev  0;
        ratio=.;
        if first.cyear then do;
            totalRVU=0;
            tot_rev=0;
            totAFS_rev=0;
            totnonAFS_rev=0;
            end;

        *ONLY ADD UP PAYNENTS WHICH ARE PAYED THROUGH OPPS;
        if pay_rev ne .                  then tot_rev=tot_rev+pay_rev;
        if AFSpay_rev  ne .    then totAFS_rev=totAFS_rev+AFSpay_rev ;
        if nonAFSpay_rev  ne . then totnonAFS_rev=totnonAFS_rev+nonAFSpay_rev ;
        if rvuwght ne .                 then totalRVU=totalRVU+rvuwght;
        if last.cyear                   then do;
            if totalRVU ne 0 then ratio=totAFS_rev/totalRVU;
            output;
            end;
    run;

    TITLE "NUMBERS for &los.";
    proc print data=reimOut.AverageProvAFS&los.;
    run;
    TITLE "";

    proc sort data=reimOut.AverageProvAFS&los.;
        by cyear;
    run;

    proc sort data=reimOut.revlcmsAFS;
        by cyear;
    run;

    data reimOut.&cohrt.&pct._&dgnPos._AFS_Q_&los.;
        merge reimOut.AverageProvAFS&los.(in=afsin)  reimOut.revlcmsAFS (in=clmsin );
        by cyear;
        afs=afsin;
        clmsf=clmsin;
        AFSratio_Q=ratio*rvu;
        if inAFS;
    run;


    proc corr data=reimOut.ami05_1_AFS_Q_&los.;
        by cyear;
        var AFSratio_Q revallpay;
    run;

    proc sort data=reimOut.&cohrt.&pct._&dgnPos._AFS_Q_&los.(keep=cyear hcpcs_cd inAFS ratio rvu) out=reimOut.&cohrt.&pct._&dgnPos._AFS&los._cw nodupkey;
        by cyear hcpcs_cd;
    run;


%mend;


%AFS_ratioCalc(pct=05,cohrt=ami,dgnPos=1,id =bene_id,yearin=2003,yearout=2008,los=15);
%AFS_ratioCalc(pct=05,cohrt=ami,dgnPos=1,id =bene_id,yearin=2003,yearout=2008,los=30);
%AFS_ratioCalc(pct=05,cohrt=ami,dgnPos=1,id =bene_id,yearin=2003,yearout=2008,los=90);
%AFS_ratioCalc(pct=05,cohrt=ami,dgnPos=1,id =bene_id,yearin=2003,yearout=2008,los=180);
%AFS_ratioCalc(pct=05,cohrt=ami,dgnPos=1,id =bene_id,yearin=2003,yearout=2008,los=365);


