** ASC payment system before 2008 was simply a standard amount - no adjuster.;
** Beginning in 2008 a systems similar to the OPPS was introduced.;
** This program is used to identifty ASCs;
*********NOTE THAT THIS IS NOT BEEN FINALIZED. INCLUDED IN CASE ANYONE IS INTERESTED;
options pagesize=200;
options nocenter;
** These options create large log files ;
options mprint mlogic;
options msglevel=i;
options notes stimer fullstimer;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;

** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;

%include "../../dirInit.sas";

** load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "setupdir.sas";
%let APCdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput;
%let AFSdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput/AmbulanceFeeSchedule;
%let ASCdir=/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/OP_paymentSys/rawinput/AmbulatoryServiceCenters;

*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname out "&longExt.";
libname carout "&carExt.";
libname opout "&opExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";
libname DRGs "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/";
libname reimOut "/disk/agero5/medicare.work/wise-DUA16702/daltonm/reimb/OP";
libname APCS  "&APCdir";
libname AFS  "&AFSdir";
libname ASC  "&ASCdir";


%include "importAFS.sas";



%macro ASCextractionPRgm(pct=,cohrt=,dgnPos=,id=,yearin=,yearout=,los=);
   ** ################################;
    ** #######  IMPORTS APC DATA;
    ** ################################;

    %do yr=&yearin. %to &yearout.;
        %importASCdata(year=&yr.);
        %end;

    data ASC.ASC_fee&yearin._&yearout.;
        set %RepeatN(ASC.ASC_fee,&yearin.,&yearout.);
    run;


    proc sort data=ASC.ASC_fee&yearin._&yearout.;
        by cyear hcpcs_cd;
    run;

    proc sort data=reimOut.merge_revclms out=reimOut.merge_revclms&los.;
        where (rev_dt-dgn_date<=&los. and rev_dt-dgn_date >=0) ;
        by cyear hcpcs_cd;
    run;


    data ASC.ASC_fee&yearin._&yearout.;
        length hcpcs_cd $5;
        set ASC.ASC_fee&yearin._&yearout.;
    run;


    data reimOut.revlcmsASC  ;
        merge reimOut.merge_revclms&los. (in=clms )
              ASC.ASC_fee&yearin._&yearout. (in=ASCfl );
        by cyear hcpcs_cd;
        inclm=clms;
        inASC=ASCfl;
        if inclm ;
        if rev_dt=. then rev_dt=thru_dt;
    run;
/*
    proc freq data=reimOut.revlcmsASC;
        tables inclm*inASC;
    run;
*/
    data temp (keep=cyear totalREVPAY totalREVPAY_NONASC totalREVPAY_ASC)  ;
        set reimOut.revlcmsASC;
        by cyear ;
        retain totalREVPAY totalREVPAY_NONASC totalREVPAY_ASC 0;
        if first.cyear then do;
            totalREVPAY=0;
            totalREVPAY_NONASC=0;
            totalREVPAY_ASC=0;
            end;

        totalREVPAY=revallpay+totalREVPAY;
        if inASC=0 & revallpay ne . then totalREVPAY_NONASC=totalREVPAY_NONASC+revallpay;
        if inASC=1 & revallpay ne . then totalREVPAY_ASC=totalREVPAY_ASC+revallpay;
        if last.cyear then output;
    run;

    TITLE "LOS &los.";
    proc print data=temp;
    run;
    TITLE "";

    %mend;



%ASCextractionPRgm(pct=05,cohrt=ami,dgnPos=1,id=bene_id,yearin=2003,yearout=2007,los=30);
