>** IMPORT THE AMBULATORY FEE SCHEDULE;

/* NOTE THAT THE csv file have WINDOWS LINE FEED AND SAS IS TRYING TO READ UNIX LINE FEEDS. RESULTS IN AN ERROR. SAVED THEM XLS FILES BY HAND IN UNIX.
    RVUPUF08 (in Word (.doc) format ) contains the file’s record layout and file documentation;
(2) The RVUs and policy indicators associated with the physician fee schedule in ASCII text(.txt), EXCEL (.xls) and comma delimited format (.csv);
(3) GPCI08(in Excel (.xls),  ASCII text (.prn) and comma delimited (.csv)  formats) provides each Geographic Practice Cost Index (GPCI) component for each carrier/locality for 2007; and
    (4) 08LOCCO (in Excel (.xls), ASCII text (.prn) and comma delimited (.csv) formats) contains the  locality/county crosswalk.
    (5) ANES2008 (in Excel (.xls), ASCII text (.TXT) and comma delimited (.csv) formats) contains the 2008 Anesthesia conversion factors.
    6) OPPSCAP (in Excel (.xls), and comma delimited (.csv) formats) contains the payment amounts after the application of the OPPS based payment caps, except for carrier priced codes. For carrier priced codes, the field only contains the OPPS based payment caps. Carrier prices cannot exceed the OPPS based payment caps.
    */

%macro importAFSdata(year=);
%if &year.=2008 %then %do ;
    %let yearstub=08;
    %let line=2;
    %let lineB=2;
    %end;
%if &year.=2007 %then %do ;
    %let yearstub=07;
    %let line=2;
    %let lineB=2;
    %end;
%if &year.=2006 %then %do ;
    %let yearstub=06;
    %let line=2;
    %let lineB=2;
    %end;
%if &year.=2005 %then %do ;
    %let yearstub=05;
    %let line=2;
    %let lineB=2;
    %end;
%if &year.=2004 %then %do ;
    %let yearstub=04;
    %let line=2;
    %let lineB=3;
    %end;
%if &year.=2003 %then %do ;
    %let yearstub=03;
    %let lineB=2;
    %end;
%if &year.=2002 %then %do ;
    %let yearstub=02;
    %let lineB=2;
    %end;
%if &year.=2001 %then %do ;
    %let yearstub=01;
    %let lineB=2;
    %end;
%if &year.=2000 %then %do ;
    %let yearstub=00;
    %let lineB=2;
    %end;

/*
Before 2003 teh AFS was adminstered on a reasonable cost basis which is taken as the lowest of the
customary, prevailing, actual or inflation adjusted charged amounts. This means that providers charges
are compared against some reasonable amount ( a ceiling on the payment amount) and then are reimbursed on the
min of thw two. Between 2003 to 2005 the transtion from a reasonable charge amoutn to a FFS occured in which
the new fee schedule was slowly phased in (see Centers fo rMedicare And Medicaid Services,HHS (section of the
law) 414.615
*/
%if &year.= 2003 %then %let filename=&AFSdir./&year./2003_Ambulance_Fee_Schedule_PUF.formatted.csv;
%if &year.= 2004 %then %let filename=&AFSdir./&year./July_2004_AFS_-_rev_20040723.csv;
%if &year.= 2005 %then %let filename=&AFSdir./&year./Jan20052-17-05.csv;
%if &year.= 2006 %then %let filename=&AFSdir./&year./2006_afs.csv;
%if &year.= 2007 %then %let filename=&AFSdir./&year./2007_Ambulance_Fee_Schedule_PUF_final3.csv;
%if &year.= 2008 %then %let filename=&AFSdir./&year./2008_Ambulance_Fee_Schedule_PUF_MIPPA_Update.csv;


           data AFS.AFS_fee&year.                                  ;
            infile "&filename." delimiter = ',' MISSOVER DSD lrecl=32767 firstobs=&lineB. ;
            input
                carrier $
                locality $
                hcpcs_cd $
                convfac1 $
                rvu1 $
                gpci1 $
                base_urban_1 $
                base_rural_1 $
                base_rural_low_1 $
                rural_m1_17_1 $
                urban_m51_1 $
                rural_m51_1 $
                ;



            if convfac1="0" then convfac1="";
            convfac=input(convfac1,10.5);

            ** READIN IN 1 incorrectly;
            ** MISSING IN SOME YEARS AND EQUAL TO 1 IN OTHER - SET TO 1;
            rvu2=compress(rvu1,',');
            rvu=rvu2*1;
            if rvu=. then rvu=1;

            if gpci1="-" then gpci1="";
            gpci=input(gpci1,10.5);

            base_urban_2=compress(base_urban_1,'$,');
            if base_urban_2="-" then base_urban_2="";
            if base_urban_2="n/a" then base_urban_2="";
            base_urban=input(base_urban_2,10.5);

            base_rural_2=compress(base_rural_1,'$,');
            if base_rural_2="-" then base_rural_2="";
            if base_rural_2="n/a" then base_rural_2="";
            base_rural=input(base_rural_2,10.5);

            base_rural_low_2=compress(base_rural_low_1,'$,');
            if base_rural_low_2="-" then base_rural_low_2="";
            if base_rural_low_2="n/a" then base_rural_low_2="";
            base_rural_low=input(base_rural_low_2,10.5);

            rural_m1_17_1=compress(rural_m1_17_1,'$,');
            if rural_m1_17_2="-" then rural_m1_17_2="";
            if rural_m1_17_2="n/a" then rural_m1_17_2="";
            rural_m1_17=input(rural_m1_17_2,10.5);

            urban_m51_1=compress(urban_m51_1,'$,');
            if urban_m51_2="-" then urban_m51_2="";
            if urban_m51_2="n/a" then urban_m51_2="";
            urban_m51=input(urban_m51_2,10.5);

            rural_m51_1=compress(rural_m51_1,'$,');
            if rural_m51_2="-" then rural_m51_2="";
            if rural_m51_2="n/a" then rural_m51_2="";
            rural_m51=input(rural_m51_2,10.5);


            cyear=&year.;
          keep  carrier locality cyear hcpcs_cd convfac rvu gpci base_urban_1 base_rural_1
                base_rural_low_1 rural_m1_17_1 urban_m51_1 rural_m51_1     ;

    run;

    proc sort data=AFS.AFS_fee&year. (keep = cyear hcpcs_cd rvu) nodupkey;
        by hcpcs_cd rvu;
    run;

    %mend;
