
/* NOTE THAT THE csv file have WINDOWS LINE FEED AND SAS IS TRYING TO READ UNIX LINE FEEDS. RESULTS IN AN ERROR. SAVED THEM XLS FILES BY HAND IN UNIX.
    RVUPUF08 (in Word (.doc) format ) contains the file’s record layout and file documentation;
(2) The RVUs and policy indicators associated with the physician fee schedule in ASCII text(.txt), EXCEL (.xls) and comma delimited format (.csv);
(3) GPCI08(in Excel (.xls),  ASCII text (.prn) and comma delimited (.csv)  formats) provides each Geographic Practice Cost Index (GPCI) component for each carrier/locality for 2007; and
    (4) 08LOCCO (in Excel (.xls), ASCII text (.prn) and comma delimited (.csv) formats) contains the  locality/county crosswalk.
    (5) ANES2008 (in Excel (.xls), ASCII text (.TXT) and comma delimited (.csv) formats) contains the 2008 Anesthesia conversion factors.
    6) OPPSCAP (in Excel (.xls), and comma delimited (.csv) formats) contains the payment amounts after the application of the OPPS based payment caps, except for carrier priced codes. For carrier priced codes, the field only contains the OPPS based payment caps. Carrier prices cannot exceed the OPPS based payment caps.
    */

%macro OPPSimport_addenB(year=,yearin=,yearout=);
%if &yearin. < 2001  or &yearout. < &yearin. %then %do;
    %PUT "USER ERROR :: OPPS cost utilization is not defined before 2001- see docs. Change yearin parameter.";
        ENDSAS ;
        %end;
    %if &year.=2012 %then %do ;
        %let yearstub=12;
        %let line=3;
        %let lineB=2;
        %end;
    %if &year.=2011 %then %do ;
        %let yearstub=11;
        %let line=3;
        %let lineB=2;
        %end;
    %if &year.=2010 %then %do ;
        %let yearstub=10;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2009 %then %do ;
        %let yearstub=09;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2008 %then %do ;
        %let yearstub=08;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2007 %then %do ;
        %let yearstub=07;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2006 %then %do ;
        %let yearstub=06;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2005 %then %do ;
        %let yearstub=05;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2004 %then %do ;
        %let yearstub=04;
        %let line=2;
        %let lineB=3;
        %end;
    %if &year.=2003 %then %do ;
        %let yearstub=03;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2002 %then %do ;
        %let yearstub=02;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2001 or &year.=20012 %then %do ;
        %let yearstub=01;
        %let line=2;
        %let lineB=2;
        %end;
    %if &year.=2000 %then %do ;
        %let yearstub=00;
        %let line=2;
        %let lineB=2;
        %end;
* 20012  filenameB=&APCdir./cy&yearstub./CY01_111301_AddendumB_formated.csv;
    %if &year.= 2012 %then %let filenameB=&APCdir./cy&yearstub./April-2012-Add-B.txt;
    %if &year.= 2011 %then %let filenameB=&APCdir./cy&yearstub./addb2011Janweb.txt;
    %if &year.= 2010 %then %let filenameB=&APCdir./cy&yearstub./2010October_AddB.txt;
    %if &year.= 2009 %then %let filenameB=&APCdir./cy&yearstub./508_Compliant_Version_of_2009JulyAddB.txt;
    %if &year.= 2008 %then %let filenameB=&APCdir./cy&yearstub./CMS1392FC_Addendum_B.csv;
    %if &year.= 2007 %then %let filenameB=&APCdir./cy&yearstub./CMS1506FC_Addendum_B.csv;
    %if &year.= 2006 %then %let filenameB=&APCdir./cy&yearstub./AddenB_1501fc.csv;
    %if &year.= 2005 %then %let filenameB=&APCdir./cy&yearstub./addenb_1427fc.csv;
    %if &year.= 2004 %then %let filenameB=&APCdir./cy&yearstub./AddB.MPDIMA.csv;
    %if &year.= 2003 %then %let filenameB=&APCdir./cy&yearstub./AddbWeb_2.csv;
    %if &year.= 2002 %then %let filenameB=&APCdir./cy&yearstub./addBf402.csv;
    %if &year.= 2001 %then %let filenameB=&APCdir./cy&yearstub./InterimFinalRule_11132001_AddB.csv;
    %if &year.= 2000 %then %let filenameB=&APCdir./cy&yearstub./addB.csv;

    %if &year. = 2009  or &year. = 2010 or &year. = 2011 or &year. = 2012  %then %do;
        %let variable=
            hcpcs_cd $
            Description $
            Status_Indicator $
            APC $
            APCwgt
            payrate
            Nat_unadj_copay
            Min_unadj_copay
            ;
        %end;
    %if &year. = 2007 or  &year. = 2008 %then %do;
        %let variable=
            hcpcs_cd $
            Description $
            CI $
            Status_Indicator $
            APC $
            APCwgt
            payrate
            Nat_unadj_copay
            Min_unadj_copay
            PDIMAflag
            ;
        %end;
    %if &year. = 2006 %then %do;
        %let variable=
            hcpcs_cd $
            Description $
            CI $
            Status_Indicator $
            APC $
            APCwgt
            payrate
            Nat_unadj_copay
            Min_unadj_copay
            PDIMAflag
            ;
        %end;
    %if &year. <= 2005  %then %do;
        %let variable=
            hcpcs_cd $
            Status_Indicator $
            CI $
            Description $
            APC $
            APCwgt
            payrate
            Nat_unadj_copay
            Min_unadj_copay
            PDIMAflag
            ;
        %end;
    %if &year. = 20012  %then %do;
        %let variable=
            hcpcs_cd $
            Status_Indicator $
            CI $
            Description $
            APC $
            APCwgt
            payrate
            Nat_unadj_copay
            Min_unadj_copay
            PDIMAflag
            ;
        %end;

    %if &year.<= 2008 %then %do;
    data spcost.APC_B&year. ;
        infile "&filenameB." delimiter = ',' MISSOVER DSD lrecl=32767 firstobs=&lineB. ;
        informat hcpcs_cd $5. ;
        informat Status_Indicator $2. ;
        informat CI $3. ;
        informat Description $96. ;

        informat APC $4. ;
        informat APCwgt 8. ;
        informat payrate 8. ;
        informat Nat_unadj_copay  8. ;
        informat Min_unadj_copay  8. ;
        informat PDIMAflag  $10. ;



        format hcpcs_cd $5. ;
        format Status_Indicator $2. ;
        format Description $96. ;
        format CI $3. ;

        format APC $4. ;
        format APCwgt 8.2 ;
        format payrate 8.2 ;
        format Nat_unadj_copay 8.2 ;
        format Min_unadj_copay 8.2 ;
        format PDIMAflag $10. ;
        input
            &variable.  ;
        cyear=&year.;
        keep cyear APC Description Status_Indicator APCwgt payrate
            Min_unadj_copay Nat_unadj_copay PDIMAflag  hcpcs_cd CI            ;

    run;
    %end;
%else %do;
    x "dos2unix -437   &filenameB.";
    data spcost.APC_B&year. ;
        infile "&filenameB." delimiter='09'x MISSOVER DSD DSD lrecl=32767 firstobs=2 ;
        informat hcpcs_cd $5. ;
        informat Status_Indicator $2. ;
        informat Description $96. ;

        informat APC $4. ;
        informat APCwgt 8. ;
        informat payrate Comma8.0 ;
        informat Nat_unadj_copay  Comma8.0 ;
        informat Min_unadj_copay  Comma8.0 ;

        format hcpcs_cd $5. ;
        format Status_Indicator $2. ;
        format Description $96. ;
        format APC $4. ;
        format APCwgt 8.2 ;
        format payrate 8.2 ;
        format Nat_unadj_copay 8.2 ;
        format Min_unadj_copay 8.2 ;
        input
            &variable.  ;
        cyear=&year.;
        keep cyear APC Description Status_Indicator APCwgt payrate
            Min_unadj_copay Nat_unadj_copay   hcpcs_cd             ;

    run;
    %end;

    proc contents data=spcost.APC_B&year. ;
    run;

    proc sort data=spcost.APC_B&year. nodupkey;
        by hcpcs_cd  Status_Indicator APC APCwgt payrate;
    run;

    proc print data=spcost.APC_B&year. ;
        WHERE hcpcs_cd ="77418";
    run;

    %mend;

/*spcost.APC_B20012*/
%macro importOPPS(yearin=,yearout=);
    %do yr=&yearin. %to &yearout.;
        %OPPSimport_addenB(year=&yr.,yearin=&yearin.,yearout=&yearout.);
       %end;

            data costutil.addendumb_apcwghts;
                set %RepeatN(spcost.APC_B,&yearin.,&yearout.) ;
                confact=.;
/*                flag2001April=0;
                if cyear=20012 then flag2001April=1;
                if cyear=20012 then cyear=2001;
*/
        **CONVERSION FACTORS TRANSLATE THE WEIGHTS INTO $;
        **April 7,2000 OPPS Final Rule;
                if cyear=2000 then confact=47.583;
        **Nov 13, 2000 Interim Final Rule ;
                if cyear=2001 then confact=49.596;
        **Nov 30,2001 final rule;
                if cyear=2002 then confact=50.904;
                if cyear=2003 then confact=52.151;
                if cyear=2004 then confact=54.561;
                if cyear=2005 then confact=56.983;
                if cyear=2006 then confact=59.511;
                if cyear=2007 then confact=61.468;
                if cyear=2008 then confact=63.694;
                **Full conversion factor-66.059, ;
                ** reduced conversion factor 64.784 - is set forth in 2010 for hospital failing to meet ;
                ** Hospital Outpatinet Quality Data Reporting Program requirements. I use the 66.086 amount here;
                ** because the upright is meant to compensate hospitals for these reports as well as providing a incentives ;
                if cyear=2009 then confact=64.784;
                **Full conversion factor-67.406, ;
                ** reduced conversion factor 66.086 - is set forth in 2010 for hospital failing to meet ;
                ** Hospital Outpatinet Quality Data Reporting Program requirements. I use the 66.086 amount here;
                ** because the uprate is meant to compensate hospitals for these reports as well as providing a incentives ;
                if cyear=2010 then confact=66.086;
                *pg 71876 right colummn- ocnversion factor reference Nov 24 2010;
                if cyear=2011 then confact=68.876;
        *###########CREATE PAYMENT VARIABLES;
         *###########ADD INFO FROM THE FINAL RULES;
                si=Status_Indicator;
                OPPSratio=0;
                passthru=0;
                inOPPS=0;
                OPPSnewtech=0;
                packagePay=0;
                NewTechAPC=0;
                nogeo=0;
                discountPossible=0;
        ** Status indicator is the key variable which indicates whether or not a hcpcs;
        ** code is covered by the OPPS. However even within OPPS there are several different ;
        ** issues which need to be considered when dealing with the OPPS.;
                if si in("G","H","K","S","P","Q","T","V","X","N") then inOPPS=1;

        * These are SI which are in the OPPS and also have some passthru in them;
        ** Medical devices passtrhoughs are based on actual charges and are geographically adjusted.;
        ** Do not included these in the final ratio calc.;
                if si in("H") then passthru=1;

        ** Note that drug and biologiicual are not assigned a geographic component;
        ** My understanding of this reasoning is that a seperate HCPCS code documents;
        ** the charge for adminstering the drugs - and qualifies for passthru costs.;
        ** There is no rural adjustment either -- maybe some other adjustment;
                if si in("G","K") then nogeo=1;

        ** The OPPS allows for discounting of potential claims when multiplce HCPCS codes appear;
        ** on a single line;
                if si in("T") then discountPossible=1;

        ** Payment for HCPCS code has been packaged into another payment. No payment ;
        ** should appear for this hcpcs code and the entry is blank in the AddendumB.;
                if si in("N") then packagePay=1;

        ** New technology payments. Providers can recieve payments for new tech either through transitional;
        ** pass-through payments or through being placed in a new technology APC. When in a NEW tech APC;
        ** no realtive weight can be assigned since no claims data are available during this time period.;
        ** During the transitnoal period CMS assigns HCPCS codes to the new APC category with a flat ;
        ** rate -- there is no relative weight assigned in AddedumB, only a payment rate. I have not found;
        ** any direct indication that it is geographically adjusted (or not adjusted), based on my review;
        ** of several claims it appears to be geographically adjusted. Note that as time goes on and CMS;
        ** gather better information these HCPCS codes are placed into the proper APC with a weight;
        ** New tech is assigned based on aPC category;
                if cyear<=2003 and apc in("0970"
                    %do num=971 %to 997;
                    ,"&num."
                    %end;
                )  then NewTechAPC=1;
                if cyear>=2004 and cyear<=2005 and apc in("1501"
                    %do num=1502 %to 1574;
                    ,"&num."
                    %end;
                )  then NewTechAPC=1;
                if cyear>=2006 and apc in("1491"
                    %do num=1492 %to 1574;
                    ,"&num."
                    %end;
                )  then NewTechAPC=1;

        ** Not all hcpcs codes in the AddB have a relative weight. This occurs for drugs (K) who reach some;
        ** cost threshold and also for some pass through payment and for new tech APCs;

                costutiltype=0;
        ** RELATIVE WEIGHTS EXITS -- NOTE TAHT SI=P IS A SPECIAL CASE..;
                if inOPPS=1 and
                    nogeo = 0 and
                    passthru = 0 and
                    packagePay = 0 and
                    NewTechAPC =0 then costutiltype=1;
        ** NO RELATIVE WEIGHT ONLY PAYRATES -- STILL ADJUSTED;
                if inOPPS=1   and
                    (NewTechAPC =1 ) then costutiltype=2;
        ** NO POLICY ADJUSTMENT-- JUST USE COSTS FOR THESE VARIABLES;
                if inOPPS=1   and
                    ( nogeo =1 or passthru=1 ) then costutiltype=3;

            run;


        x "rm &spcost./APC* -f ";
    %mend;



