//Writes several different reports and figures and exports them for tex consumption. See
//accompanying Lyx file.
clear
set more off

local count 0
local pct `1'



/// REad in directories from this file
do ../../dirInit.do
do prgms/onestat4category.do
do prgms/tex_cat_year_1stat.do
do prgms/tex_year_1stat.do
do prgms/tex_manyvars_yearcolumns.do

global     mortal    mort_30 mort_90    mort_365
global total_cost totalR_d30 totalR_d90  totalR_d365
global partA_cost partA_d30  partA_d90  partA_d365
global partB_cost partB_d30  partB_d90  partB_d365
global total_cost totalR_d30 totalR_d90  totalR_d365
global partA_cost partA_d30  totalR_d90  partA_d365
global partB_cost partB_d30  totalR_d90  partB_d365

local cohort ami
local startyr 1992
global tex $texroot/`pct'/`cohort'/`startyr'
! mkdir -p $tex

global reportex /disk/agebulk3/medicare.work/wise-DUA16702/daltonm/medicode/benchmark/v4.65/work/3reports
use $reportex/ALL`pct'_indexDemoCosts.dta, clear

///keep if cohort=="ami"
gen dgn_year=year(dgn_date)
keep if dgn_year>=`startyr'

exit
///drop if notlower48states==1

foreach d in 30 90 365 {
    if "`pct'"!="100"{
    gen totalR_d`d' = car_d`d' + op_d`d' + medpar_d`d'
    gen totalR_shosp_d`d' = car_d`d' + op_d`d' + shosp_d`d'
    gen partA_d`d' = medpar_d`d'
    gen partB_d`d' = car_d`d' + op_d`d'
    gen totalR_shosp_cu_d`d' = car_cu_d`d' + op_cu_d`d' + shosp_cu_d`d'
    gen partB_cu_d`d' = car_cu_d`d' + op_cu_d`d'
}
    else {
    gen car_d`d'=0
    gen car_cu_d`d'=0
    gen totalR_d`d' = 0
    gen totalR_shosp_d`d' =0
    gen partA_d`d' = medpar_d`d'
    gen partB_d`d' = 0

    gen totalR_shosp_cu_d`d' = 0
    gen partB_cu_d`d' = 0
}

//    gen totalR_cu_d`d' = car_cu_d`d' + op_cu_d`d' + shosp_cu_d`d'
//    gen totalR_shosp_cu_d`d' = car_cu_d`d' + op_cu_d`d' + shosp_cu_d`d'
//    gen partB_cu_d`d' = car_cu_d`d' + op_cu_d`d'


}



///drop *_flag stayCost* costutil_*
gen mort_30  = 1 - surv_30
gen mort_90  = 1 - surv_90
gen mort_365 = 1 - surv_365



///Cost Models
gen pat_white=race=="1"
gen pat_black=race=="2"
gen pat_other=inlist(race,"3","0","4","5","6")==1

drop race
/*
esttab using $texout/dist_stats.tex, cells("min(fmt(0)) p5(fmt(0)) p25(fmt(0)) p50(fmt(0)) p75(fmt(0)) max(fmt(0)) count(fmt(0))")  noobs compress title("Dependent variable summary stats") replace
*/


///#####################################################################################
///########  WRITE OUT SUMMARY TABLES OF RAW STATS ;
///#####################################################################################

des *
estpost tabulate dgn_year
esttab  using $tex/demo_indx_year.tex, cell("b(label(freq))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, number of index events ")


foreach var in $total_cost $partA_cost $partB_cost car_d30  op_d30  medpar_d30  car_d365  op_d365  medpar_d365 $mortal  pat_white pat_black pat_other totalR_shosp_cu_d365 totalR_shosp_cu_d30 totalR_shosp_d365 totalR_shosp_d30 op_cu_d30  op_cu_d365 car_cu_d30  car_cu_d365 shosp_cu_d30  shosp_cu_d365 shosp_d30  shosp_d365     {
    di "var::`var'"
    tex_year_1stat empty, statvar(`var') yearvar(dgn_year) stat(mean)
}


esttab  shosp_cu_d30 shosp_d30 op_cu_d30  op_d30 car_cu_d30  car_d30 totalR_shosp_cu_d30  totalR_shosp_d30   using $tex/cost_d30_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers     varlabels($label) mtitle("total:cu" "total:raw" "hosp:cu" "hosp:raw" "op:cu" "op:raw" "car:cu" "car:raw")

    esttab   shosp_cu_d365 shosp_d365 op_cu_d365  op_d365 car_cu_d365  car_d365 totalR_shosp_cu_d365  totalR_shosp_d365  using $tex/cost_d365_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers     varlabels($label) mtitle("total:cu" "total:raw" "hosp:cu" "hosp:raw" "op:cu" "op:raw" "car:cu" "car:raw")

esttab  car_d30  car_d365 using $tex/cost_car_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, carrier costs")   varlabels($label)

esttab  op_d30  op_d365 using $tex/cost_op_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, outpatient costs")   varlabels($label)

esttab  medpar_d30  medpar_d365 using $tex/cost_mpar_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, medpar costs")   varlabels($label)

esttab  partA_d30  partA_d365 using $tex/cost_partA_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, PartA reimbursements")   varlabels($label)


esttab  totalR_shosp_cu_d30  totalR_shosp_d30  totalR_shosp_cu_d365  totalR_shosp_d365 using $tex/cost_total_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers     varlabels($label)


esttab  shosp_cu_d30  shosp_d30 shosp_cu_d365  shosp_d365 using $tex/cost_shosp_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers   varlabels($label)

esttab  op_cu_d30  op_d30 op_cu_d365  op_d365 using $tex/cost_op_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers    varlabels($label)


esttab  car_cu_d30  car_d30 car_cu_d365  car_d365 using $tex/cost_car_cu_compare_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers     varlabels($label)

esttab  partA_d30  partA_d365 using $tex/cost_partA_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, PartA reimbursements")   varlabels($label)


esttab  partB_d30  partB_d365 using $tex/cost_partB_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, PartB reimbursements")   varlabels($label)

esttab  totalR_d30  totalR_d365 using $tex/cost_totalR_year.tex, cell("cmean(fmt(%9.0f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, total reimbursements ")   varlabels($label)

esttab  mort_30 mort_90 mort_365 using $tex/mortal_year.tex, cell("cmean(fmt(%9.3f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, total reimbursements ")   varlabels($label)

esttab  pat_white pat_black pat_other using $tex/demo_race_year.tex, cell("cmean(fmt(%9.3f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, percent of index event with given race ")   varlabels($label)


estpost summarize $mortal $total_cost $partA_cost $partB_cost $total_costutil $partA_costutil $partB_costutil,detail
esttab using $tex/dist_stats.tex, cells("min(fmt(0)) p5(fmt(0)) p25(fmt(0)) p50(fmt(0)) p75(fmt(0)) max(fmt(0)) count(fmt(0))")  noobs compress title("Dependent variable summary stats") replace


esttab using $tex/demo_index.tex, cells("min(fmt(0)) p5(fmt(0)) p25(fmt(0)) p50(fmt(0)) p75(fmt(0)) max(fmt(0)) count(fmt(0))")  noobs compress title("Dependent variable summary stats") replace


/// AGE

histogram ageAtdiag,  fraction
graph2tex , epsfile( "$tex/demo_age")

histogram ageAtdiag,  by(dgn_year) fraction
graph2tex , epsfile( "$tex/demo_age_yr")
/// RACE



/// DUAL ELIGIBLES - MIGHT BE A BIT DIFFICULT TO GET AT BUT MAYBE NOT
/// KIDNEY FAILTURE - EDI AND IN SAMPLE
tab dgn_year

ds como* card*
tex_manyvars_yearcolumns `r(varlist)' ,listyr( 1992 1996 2000 2005 2010 ) yearvar(dgn_year) stat(mean)
esttab y1992 y1996 y2000 y2005 y2010 using $tex/como_year.tex, cell("cmean(fmt(%9.3f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, percent of index event with given comorbiditiy ")   varlabels($label)

/*
tex_manyvars_yearcolumns `r(varlist)' ,listyr(1992 1996 2000 2005 2010) yearvar(dgn_year) stat(mean)
esttab  y1992 y1996 y2000 y2005 y2010 using $tex/como_year.tex, cell("cmean(fmt(%9.3f))") noobs  compress  replace  nodepvars nonumbers  title("`cohort' cohort, percent of index event with given comorbiditiy ")   varlabels($label)
*/

