**Extract index events and corresponding claims from the inpatients and SNF claims (MEDPAR);
**Maurice Dalton, daltonm.at.nber.org,  based on code initially written by Jean Roth;
** and further refined by Matt Fiedler.  All errors are my own.;
**;
** PROGRAM STRUCTURE;
** The program consists of several sas macros which are combined in a macro which sequences the;
** macros correctly.This wrapper macro is found at the end of the program and has several ;
** different parameters defined at the end of the program;
**;
*!!!!WRAPPER MACRO FOUND AT THE END ---%RunDefineIndexEvents!!!!!;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../sasoptions.sas";

***********************************************************************
* DEFINE DIRECTORIES****;
***********************************************************************;
%include "../dirInit.sas";

***********************************************************************;
* READ IN SAS MACRO FOUND IN OTHER FILES  ;
***********************************************************************;
* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./errorCheckparameters.sas";
***********************************************************************;
* DEFINE LIBRARIES ;
***********************************************************************;
* Defines local directories depending on which server currently running;
libname carex "&carext.";
libname opex "&opext.";
libname mpex "&medparExt.";
libname here ".";
libname indxex "&indxExt.";

%let rootoutputDir=/disk/agebulk3/medicare.work/wise-DUA16702/daltonm;
***OPCLMS;
***OPCLMS;


***LONG CLMS;
%macro compareDatasets(cohrt=,pct=,ftype=, baseV=,compareVID=,branch=work,folder=,baselib=,id=,renamestatement=,wherestatement=,fnew="", keepvar= );


    libname base "&rootoutputDir./&projectName./&baseV./&branch./1PrimaryExtract/&folder.";
    libname comp "&rootoutputDir./&projectName./&compareVID./&branch./1PrimaryExtract/&folder.";
    libname here ".";

    %put "&rootoutputDir./&projectName./&compareVID./&branch./1PrimaryExtract/&folder.";
    %if &fnew.="" %then %let fnew=&ftype.;
    x "bunzip2 &rootoutputDir./&projectName./&compareVID./&branch./1PrimaryExtract/&folder./&cohrt.&pct._&ftype.*.bz2";
    x "bunzip2 &rootoutputDir./&projectName./&baseV./&branch./1PrimaryExtract/&folder./&cohrt.&pct._&ftype.*.bz2";

    proc datasets lib=comp ;run;
    proc datasets lib=base ;run;

    proc contents data=comp.&cohrt.&pct._&ftype. ;run;
    proc contents data=base.&cohrt.&pct._&fnew ;run;


    proc sort data=base.&cohrt.&pct._&fnew (keep = &keepvar. ) out=base;
        WHERE &wherestatement.;
        by &id.;
    run;

    proc sort data=comp.&cohrt.&pct._&ftype.  (keep = &keepvar. ) out=comp;
        WHERE &wherestatement.;
        by &id.
            ;run;

    TITLE "COMPARE THE &FTYPE. FILES";
    proc compare base    = base (keep = &keepvar. )
                 compare = comp (&renamestatement. keep=&keepvar.  fileyear) LISTALL;
        id &id.  ;

    run;
    x "bzip2 &rootoutputDir./&projectName./&compareVID./&branch./1PrimaryExtract/&folder./&cohrt.&pct._&ftype.*.bz2 &";
    %mend;


** Back in V3.51 medpar clms with los ? 365 were dropped from being an index event - changed that in v4.0 figured reseachers could just make this restriction themselves. That is why I drop one observation below. ;
/*AND bene_id ne "mmmmmmmUGJDfsUJ" AND dgn_date ne 15208;
%compareDatasets(cohrt=ami,pct=05,ftype=indx, baseV=v4.65, compareVID=v4.50,
                 folder=indx,branch=work, id=bene_id dgn_date  ,
                 keepvar= bene_id dgn_date fileyear,
                 wherestatement=fileyear>1984 & fileyear<2010 ) ;
*/

%compareDatasets( cohrt = ami, pct = 05, ftype= medparclms,
                  fnew = medparclms, baseV=v4.65, compareVID = v4.50, folder = medpar,
                  branch=work,
                  id      = bene_id  dgn_date  medrawindx fileyear ,
                  keepvar = bene_id  dgn_date  loscnt admsndt dschrgdt prvnumgrp
                            acrtndt outlrday loscnt  outlrday_new coin_amt ded_amt blddedam
                            prpayamt outlramt disp_shr ime_amt pps_cptl passthru mperdiem
                            pmt_amt drgprice pps_ind dgnscnt ad_dgns dgnscd1 dgnscd2 dgnscd3
                            dgnscd4 dgnscd5 dgnscd6 dgnscd7 dgnscd8 fileyear medrawindx,
                   wherestatement= fileyear>2000 & fileyear<2009 ) ;













%compareDatasets(cohrt=ami,pct=05,ftype=carlnits,compareVID=v4.50, baseV=v4.65,
                 folder=car, branch=work,
                 id=bene_id dgn_date clm_id part fileyear carrawindx,
                 keepvar=bene_id dgn_date fileyear   hcpcs_cd tax_num prf_upin clm_id
                         lalowchg part fileyear carrawindx,
                 wherestatement= fileyear>2000 & fileyear<2009);


%compareDatasets(cohrt=ami,pct=05,ftype=opclms, compareVID=v4.50,
                 baseV=v4.65,folder=op, branch=work,
                 id=bene_id dgn_date fileyear clm_id oprevrawindx opclmrawindx ,
    keepvar=bene_id dgn_date fileyear clm_id pmt_amt oprevrawindx opclmrawindx ,
                 wherestatement= fileyear>2000 & fileyear<2009 ) ;
