;; MoMo Colour Theme for Emacs.
;;
;; Defines a colour scheme resembling that of the original TextMate MoMo colour theme.
;; To use add the following to your .emacs file (requires the color-theme package):
;;
;; (require 'color-theme)
;; (color-theme-initialize)
;; (load-file "/homes/nber/daltonm/.emacs.d/color-theme-6.6.0/color-theme-MoMo.el")
;;
;; And then (color-theme-MoMo) to activate it.
;;
;; Several areas still require improvement such as recognition of code that ruby-mode doesn't
;; yet pick up (eg. parent classes), Rails/Merb keywords, or non Ruby code related areas
;; (eg. dired, HTML, etc). Please feel free to customize further and send in any improvements,
;; patches most welcome.
;;
;; MIT License Copyright (c) 2008 Marcus Crafter <crafterm@redartisan.com>
;; Credits due to the excellent TextMate MoMo theme
 
(require 'color-theme)
 
;;;###autoload
(defun color-theme-MoMo ()
  "Color theme by Marcus Crafter, based off the TextMate MoMo theme, created 2008-04-18"
  (interactive)
  (color-theme-install
   '(color-theme-MoMo
     ((background-color . "black")
      (background-mode . dark)
      (border-color . "black")
      (cursor-color . "#A7A7A7")
      (foreground-color . "green3")ERROR
	  ;;#F8F8F8")
      (mouse-color . "sienna1"))
    ;;(default ((t (:stipple nil :background "black" :foreground "green3" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 98 :width normal :family "outline-courier new"))))
	;;(Info-title-1-face ((t (:bold t :weight normal :family "helv" :height 1.728))))
    ;; (Info-title-2-face ((t (:bold t :family "helv" :weight normal:height 1.44))))
    ;; (Info-title-3-face ((t (:bold t :weight normal :family "helv" :height 1.2))))
    ;; (Info-title-4-face ((t (:bold t :family "helv" :weight bold))))    
	(blue ((t (:foreground "blue"))))
     ;;(bold ((t (:bold t))))
     ;;(bold-italic ((t (:bold t))))
     (border-glyph ((t (nil))))
     (buffers-tab ((t (:background "black" :foreground "green3"))))
     (font-lock-builtin-face ((t (:foreground "green3"))))
     (font-lock-comment-face ((t (:foreground "#5F5A60"))))
     (font-lock-constant-face ((t (:foreground "#CF6A4C"))))
     (font-lock-doc-string-face ((t (:foreground "DarkOrange"))))
     (font-lock-function-name-face ((t (:foreground "#9B703F"))))
     (font-lock-keyword-face ((t (:foreground "#CDA869"))))
     (font-lock-preprocessor-face ((t (:foreground "Aquamarine"))))
     (font-lock-reference-face ((t (:foreground "SlateBlue"))))
 
     (font-lock-regexp-grouping-backslash ((t (:foreground "#E9C062"))))
     (font-lock-regexp-grouping-construct ((t (:foreground "red"))))
	
     (font-lock-string-face ((t (:foreground "#8F9D6A"))))
     (font-lock-type-face ((t (:foreground "#9B703F"))))
     (font-lock-variable-name-face ((t (:foreground "#7587A6"))))
     (font-lock-warning-face ((t (:bold t :foreground "Pink"))))
     (gui-element ((t (:background "#303030" :foreground "black"))))
     (region ((t (:background "#444444"))))
     (mode-line ((t (:background "#303030" :foreground "black"))))
     (highlight ((t (:background "yellow"))))
     (highline-face ((t (:background "SeaGreen"))))
     (italic ((t (nil))))
     (left-margin ((t (nil))))
     (text-cursor ((t (:background "yellow" :foreground "black"))))
     (toolbar ((t (nil))))
     (underline ((nil (:underline nil))))
     (zmacs-region ((t (:background "snow" :foreground "ble")))))))