#!/usr/bin/perl
## COALLATE SAS LOG TIME INFORMATION
## by MauriceDalton, daltonm@nber.org ;

use strict ;
use warnings;
use diagnostics -verbose;

# Declare the subroutines;
sub trim($);

my $fname;
## READ IN SUBPROGRAMS WHICH READS STATA DO FILE FOR DIRECTORIES

my $indir="../../ExtractCohort";


##Indicators
my ($i , $j, $cbname);
my ($lastline, $quest_text, $response, $label, $varname, $shrtdes , $section, $level,$type, $ref);
my ( $line,  $instru, $condition,  $hold, $freq);
my $firstval = 0;
my $condTag;
my $time;

open (SASLOG, ">LOGSAS_TIMER.txt");

my @CodeBooks = ("LongitudinalExtract","CarrierExtract","OpExtract");
foreach $cbname (@CodeBooks) {
  my $readdir="$indir"."/"."$cbname";
  if (-d $readdir) {
    system ("gunzip $readdir/*") ;          
    opendir DIRH,  $readdir or die "couldn't open: $!"; 
    foreach (sort readdir DIRH) {
      if ($_=~/.log/) {
        print "$_ \n";
        $fname = "$readdir"."/"."$_"; 
        open (READIN,$fname) || die("Could not open file!");
        print "$fname \n";
        my @BIGFILE =<READIN>;  ##Read the file into an array;
  
  
   
        my $file="$_";
        $lastline="lastline";
  
  
        print SASLOG "FILE;sasfxn;00;line\n";
        for $i (@BIGFILE) {
          next if $i =~ /^(\s+$)/; ## skip blank lines  
          chomp($i);   
          #print "$lastline-$i \n";
          if ($i=~/DATA statement used/) { 
            $lastline="data step";     
          } elsif ($i=~/PROCEDURE SORT/) { 
            $lastline="proc sort";     
          } elsif ($i=~/PROCEDURE DATASETS/) { 
            $lastline="proc datasets";     
          } elsif ($i=~/PROCEDURE SQL/) { 
            $lastline="proc SQL";     
          } elsif ($i=~/PROCEDURE APPEND/) { 
            $lastline="proc append";     
          } elsif ($i=~/PROCEDURE PRINT/) { 
            $lastline="proc print";     
          }   
          if ($i=~/(real time)(\s*)([0-9]*)(\.)([0-9]*)(\s*)(seconds)/) { 
            $time=($3+$5/100)/60;
            #print "$time-- $3 --$5  --$i  \n";
            print SASLOG "$file;$lastline;$time;$i\n";
          } elsif ($i=~/(real time)(\s*)([0-9]*)(\:)([0-9]*)(\.)([0-9]*)/) { 
            $time=$3+$5/60;
            #print "min $3 - sec $5  milisec $7 \n $i \n";
            print SASLOG "$cbname;$lastline;$time;$i \n";
          } elsif ($i=~/(Decompressing file)(\s*[A-Za-z0-9\_]*\s*took\s*)([0-9]*\.[0-9]*)(\s* minutes\.)/) { 
            # print "$i \n";
            $lastline="DECOMPRESSION";     
            $time="$3";
            print SASLOG "$file;$lastline;$time;$i\n";
          }
    
        }
      }
    }
    system ("gzip --best $readdir/*") ;          
  }   
}

close (SASLOG);
system ("statamp < compileStats.do ") ;          
if ( $? == -1 ) {
  print "command failed: $!\n";
} else {
  print "command exited successfully with value %d", $? >> 8;
}         


