options pagesize=200;
options nocenter;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;


**** PRELIMINARIES ****;




* directory where denominantor and enrollment files can be decompressed and manipulated;
%let spdirDenom=/disk/agero5/medicare.work/wise-DUA16702/daltonm/denom05.NOBACKUP;

* directory where the NBER keeps compressed raw claims data;
%let dataRoot = /disk/agedisk1/medicare/data.NOBACKUP/u/c;

* directory where the NBER keeps compressed raw claims data;
%let SASmac =/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/SASmacros;


* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";




* define libraries that allow access to the various directories specified above;
libname spDenom "&spdirDenom.";



%macro DenomExtracts(ftype=denom,start=1995,end=2002);

    %do y=&start. %to &end.;

        %if "&ftype." = "denom" %then %do;
            %if &y. > 1995 %then %do;
                %let numDenoms = 1;
                %end;
            %else %if &y. = 1994 or &y. = 1995 %then %do;
                %let numDenoms = 8;
                %end;
            %else %if &y. = 1992 or &y. = 1993 %then %do;
                %let numDenoms = 6;
                %end;

            %let pct = 100;
            %end;
        %else %if "&ftype." = "hsk" %then %do;
            %let numDenoms = 1;
            %let pct = 20;
            %end;

        %if &y. = 1985 %then %do;
            x "cp /disk/agedisk1/medicare/data.NOBACKUP/u/c/20pct/hsk/1985/hsk20_1985_1.sas7bdat &spdirDenom.";
            %end;
        %else %do;
            %decompress(spaceDir=&spdirDenom.,dataRoot=&dataRoot.,ftype=&ftype.,pct=&pct.,year=&y.,min=1,max=&numDenoms.);
            %end;

        data spDenom.&ftype.05_&y._1;
            set %RepeatN(spDenom.&ftype.&pct._&y._,1,&numDenoms.);

            ehicDigits = substr(ehic,8,2);
            if ehicDigits in ("05","20","45","70","95");

            drop ehicDigits;
        run;

        x "rm -f &spdirDenom./&ftype.&pct._&y._*.sas7bdat";

        %end;

    %mend;

%macro SortExtracts(ftype=denom,start=1992,end=2005);
    %do y=&start. %to &end.;
        proc sort data=spDenom.&ftype.05_&y._1 out=spDenom.&ftype.05_&y._1;
            by ehic;
        run;
        %end;
    %mend;


*** GENERATE EXTRACTS FOR DENOMINATOR YEARS ***;
*%DenomExtracts(ftype=denom,start=1995,end=2002);
*%SortExtracts(type=denom,start=1992,end=2005);


*** GENERATE EXTRACTS FOR HSK YEARS ***;
%DenomExtracts(ftype=hsk,start=1985,end=1991);
%SortExtracts(ftype=hsk,start=1985,end=1991);


