****Extract index events and corresposnfing claims from the inpatients and SNF claims (MEDPAR);
****Maurice Dalton June 20, 2010,  based on code initially written by Matt Fiedler with help from Jean Roth.  ;
****;
****WRAPPER MACRO FOUND AT THE END ---%RunPrgram;
**** It has the following options;
************** cohrt1=    --These reference the ICD-9-CM codes in teh code and define what these files will be called.;
************** cohrt2=    -- You can add as many of these as you would like, hwoever if you start running several;
*************             -- (4 plus)the efficiecnty of tyhe program maybe impacted. ;
************** .....;
************** cohrtN=2   -- Define the total number of cohorts you are creating;

************** noflags=no -- Tell the program whether you want to create claims files for an unrestricted sample;
**************            -- Will almost always be no, but maybe of intrest for better understanding whats happening;
**************               in the data;

************** dgnPos=1   -- Determine how many diagnosis you want to use to create the index event. Most of the time;
**************            -- this will be equal to 1 (the principle diagnosis). However this is usefull for better;
**************            -- understanding the data. For example investigating what princple diagnosis are recorded;
**************            -- for individuals with who report an AMI or hip fracture as a comorbitiy (second diagnosis;
**************            -- Diagnosis variables range from 1 to 5 in the early years and was increased from 1 to 10;
**************            -- later on. ;

************** yearin=1984-- Start year for the run;
************** yearout=2005- End year for the run;
************** pctm=05    -- Define the percent extract you are intrested in. Use .01% for debugging where possible;
************** win=1)     -- Define the look back,forward window around the index event for the program to extract.;
**************            -- In years.;

*NOTE ABOUT LOG***> The log file has been split into several different pieces in order to preserve the entire log;
******************> file in the case where only a few years need to be rerun.;

options pagesize=200;
options nocenter;
options  SYMBOLGEN  ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;

**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../dirInit.sas";

* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";

* load files with macros that conform the files of various years into a common format;
%include "&SASmac./ConformDenom.sas";
%include "&SASmac./ConformMedPAR.sas";
%include "&SASmac./CreateReports.sas";



*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname exlib "&longExt.";
libname spDenom "&spden.";
libname spMedpar "&spmed.";
libname tempEr "&medErz.";

%macro proctest(diag=,sampleRule=,dgnPos=,pctm=);
   data tempProc;
       set exlib.&diag.&pctm._&dgnPos._claims_&sampleRule.;
       diag_year=year(dgn_date);
run;

    ODS HTML FILE="/homes/nber/daltonm/Medicare/Output/LongExt/&diag._procCodes.xls" STYLE=statistical;
    %do s=1 %to 6;
        TITLE "Diagnosis code frequency  by year for &diag.&s.=1";
        proc freq data=tempProc;
            table  prcdr_cd&s.*diag_year /norow nocol nopercent ;
        run;
        %end;
    ODS HTML  CLOSE;
%mend;


%proctest(diag=hip,sampleRule=mn,dgnPos=1,pctm=05);
%proctest(diag=ami,sampleRule=mn,dgnPos=1,pctm=05);
%proctest(diag=acs,sampleRule=mn,dgnPos=1,pctm=05);
