/*******Create Cost Measure across claims files. *****************************;
******************************************************************************
*** This program aggregates the costs variables and into the correct cases. It
*** then looks to create a summary at different day measures and then finally it
*** aggregates it to the index- claim levels;*/
*Maurice Dalton,daltonm.at.nber.org,  based on code originally written by Matt Fiedler;


OPTIONS SPOOL;
options pagesize=200;
options nocenter;
options mlogic;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;

*****PRELIMINARIES************
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";

* define libraries;
libname med "&spmed.";
libname spcar "&spcar.";
libname longEx  "&longExt.";
libname carEx   "&carExt.";
libname OpEx   "&OpExt.";
libname cost   "&costs.";


* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";

/*Start the add var*/



%macro AddVarFromClaims(cohrt1=ami,cohrt2=,cohrt3=,cohrt4=,cohrt5=,cohrt6=,cohrt7=,cohrt8=,cohrtN=1,dgnPos=1,pctm=05,sampleRule=mn);

    %do j=1 %to &cohrtN.;
        proc means data=longEx.&&cohrt&j..&pctm._&dgnPos._indx_&sampleRule.;
            var diag_id;
        run;

        data ClaimsVar;
            set  longEx.&&cohrt&j..&pctm._&dgnPos._claims_&sampleRule. ;
            keep  dgns_cd1 dgns_cd2  diag_id ehic dgn_date sadmsndt sdschrgdt prv: loscnt dstntncd dschrgcd  dstntncd prvstate zip_clm;
            if sdschrgdt = . then do;
                sdschrgdt = sadmsndt + loscnt - 1;
                end;

        run;

        data Indx;
            set  longEx.&&cohrt&j..&pctm._&dgnPos._indx_&sampleRule. ;
            if sdschrgdt = . then do;
                sdschrgdt = dgn_date + loscnt - 1;
                end;

        run;

        proc sql;
            create table longEx.TempDelete as
                select *
                from  ClaimsVar C, Indx I
                WHERE C.diag_id eq I.diag_id AND
                C.sadmsndt eq I.dgn_date AND
                C.sdschrgdt eq I.sdschrgdt AND
                C.dgns_cd1 eq I.dgns_cd1 AND
                C.dgns_cd2 eq I.dgns_cd2 AND
                C.prvdrsrl eq I.prvdrsrl ;
        quit;


        %put 'display';
        x "st &longExt./tempdelete.sas7bdat  &longExt./&&cohrt&j..&pctm._&dgnPos._indxdemo_mn.dta -y -od";

        %put 'display';

        x "rm &longExt./tempdelete -f";


        %end;
    %mend;


    %AddVarFromClaims(cohrt1=ami,cohrtN=1,dgnPos=1,pctm=100,sampleRule=mn);
/*
%AddVarFromClaims(cohrt1=hip,cohrtN=1,dgnPos=1,pctm=05,sampleRule=mn);


