
**Extract index events and corresponding claims from the inpatients and SNF claims (MEDPAR);
**Maurice Dalton, daltonm.at.nber.org,  based on code initially written by Jean Roth;
** and further refined by Matt Fiedler.  All errors are my own.;
**;
** PROGRAM STRUCTURE;
*** Extract IP claims files;

/*	$Id$	*/


options pagesize=200;
options nocenter;
options symbolgen mlogic mprint mfile ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
*options errorabend;

**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/Medicode/dirInit.sas";
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";

********************************************************************;
********************************************************************;


*define libraries that allow access to the various directories specified above;

libname spMedpar "&spmed.";

** This is a macro which is used at three different places in the wrapper files to decompress the ;
** ftype = medpar , ftype = denominator , and/or ftype = enrollment files;
%macro CallDecompress(yr=,pct=,ftype=,type=,subtype=);

    %DetermineMax(datadir=&dataroot.,pct=&pct,ftype=&ftype. ,year=&yr.,subtype=&subtype.,pctsuffix=);
     *autocount is a dataset the previous macro outputs which simply has one observation equal to the max number of files in the folder.;
    data _NULL_;
        set autocount;
        if _n_=1 then do;
            call symputx('denom_max',n);
            stop;
            end;
    run;
    x "rm spMedpar.&ftype.&pct._&subtype._&yr.* -f ";
    %do z=1 %to &denom_max.;
        x "rm &spmed./&ftype.&pct._&yr._&subtype.&z.* -f ";
        %decompress_i(spaceDir=&spmed.,dataRoot=&dataRoot.,ftype=&ftype.,subtype=&subtype.,pct=&pct.,year=&yr.,indx=&z.);

        proc append base=spMedpar.&ftype.&pct._&subtype._&yr.  data=spMedpar.&ftype.&pct._&yr._&subtype.&z. force;
        run;

        x "rm &spmed./&ftype.&pct._&yr._&subtype.&z.* -f ";
        %end;

    %mend;

%macro Extractdiag(yearin=,yearout=,pct=,ftype=,subtype=);
    %put MARK&yearin.---&yearout.;

    proc datasets lib=spMedpar;
        DELETE &ftype.&pct._&subtype._&yearin._&yearout.;
    run;

    data spMedpar.&ftype.&pct._&subtype._&yearin._&yearout.;
        set %RepeatN(spMedpar.&ftype.&pct._&subtype._,&yearin.,&yearout.);

****DEFINES AMI ICD9-CM CODE SEQUENCE;
/*         **Make sure that we are dropping  410.X2;
    if (substr(dgnscd1,5,1) = "2" and length(dgnscd1) = 5 ) then delete;
    if (substr(dgnscd2,5,1) = "2" and length(dgnscd2) = 5 ) then delete;

    if (substr(dgnscd1,1,3) = "410" and
        ( (length(dgnscd1) = 5 and substr(dgnscd1,5,1) ne "2") or (length(dgnscd1) < 5) )
        or
        substr(dgnscd2,1,3) = "410" and
        ( (length(dgnscd2) = 5 and substr(dgnscd2,5,1) ne "2") or (length(dgnscd2) < 5) ))                    then output;
    */
    run;

    proc datasets lib=spMedpar;
        DELETE %RepeatN(&ftype.&pct._&subtype._,&yearin.,&yearout.);
    run;


    %mend;

%macro runprgm(yearin=,yearout=,filetype=,subtype=,pct=);
    /*x " rm &spmed./&filetype.&pct._200*_clms*.sas7bdat -f";*/
    %do yr=&yearin. %to &yearout.;
        %CallDecompress(yr=&yr.,pct=&pct.,ftype=&filetype.,subtype=&subtype.);
        %end;

    %put &yearin.---&yearout.;
    %Extractdiag(yearin=&yearin.,yearout=&yearout.,pct=&pct.,ftype=&filetype.,subtype=&subtype.);


    %mend;



*%runprgm(yearin=2007,yearout=2008,filetype=ip,subtype=clms,pct=05);
*%runprgm(yearin=2007,yearout=2008,filetype=ip,subtype=revcntrs,pct=05);
%runprgm(yearin=2007,yearout=2008,filetype=med,subtype=,pct=05);

