

options mprint msglevel=i;
options mergenoby=error;
options errorabend;
options spool;


* root directory of the directory hierarchy containing the NBER claims data collection;
%let dataRoot = /disk/agedisk1/medicare/data.NOBACKUP/u/c;
%let dataRoot2= /disk/agero9/medicare/data;
* directory to which data should be decompressed;

%let  spopDir=/space/daltonm/op05.NOBACKUP;
*%let  spopDir=/age1space/daltonm/op05.NOBACKUP;

* directory where extracts should be saved;
%let exDir=/disk/agero5/medicare.work/wise-DUA16702/daltonm/op05.NOBACKUP/Extract;

* directory where temporary extracts can be stored;
%let tempEx=/disk/agero5/medicare.work/wise-DUA16702/daltonm/op05.NOBACKUP/Temp;

* directory where the output of LongitudinalExtract.sas (notably the &diag. sample) resides;
%let sampDir=/disk/agero5/medicare.work/wise-DUA16702/daltonm/medpar05.NOBACKUP;

%let bene=/disk/agero5/medicare.work/wise-DUA16702/daltonm/beneID_cw;

* directory where the NBER keeps compressed raw claims data;
%let SASmac =/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/SASmacros;

* directory where denominantor and enrollment files can be saved;
%let outDenom=/disk/agero5/medicare.work/wise-DUA16702/daltonm/denom05.NOBACKUP;


* configure needed libraries;
libname bE "&bene.";
libname spop "&spopDir.";
libname samp "&&sampDir.";
libname out "&exDir.";
libname tempEx "&tempEx.";
libname outDen "&outDenom.";


%macro runme(pct=,yearin=,yearout=);
    %if &yearout.<=2005 %then %do;
    %do year=&yearin. %to &yearout. ;
        proc sql;
            create table Raw&year. as
                select COUNT(*) as RawCountYear                 
                from samp.medpar&pct._&year._1
                PRINT;
            quit;
        run;

        data Raw&year.;
            set Raw&year.;
            year=&year.;
        run;
        
 proc sql;
            create table crossWalk&year. as
                select S.ehic, M.count, M.bene_id                
                from samp.medpar&pct._&year._1  S, bE.ehicbenex_unique  M
                where (S.ehic = M.ehic);
            quit;
        run;



        
        proc sql;
            create table Match&year. as
                select COUNT(*) as MatchCount                 
                from crossWalk&year.
                PRINT;
            quit;
        run;

        data Match&year.;
            set Match&year.;
            year=&year.;
        run;
        
        data Total&year.;
            merge   Raw&year. Match&year.;
            by   year;
        run;

              %end;  
        %end;
%if &yearout.>2005 %then %do;
    %do year=2006 %to &yearout. ;

        proc sql;
            create table Raw&year. as
                select COUNT(*) as RawCountYear                 
                from samp.medpar&pct._&year._1;
            quit;
        run;

        data Raw&year.;
            set Raw&year.;
            year=&year.;
        run;
      proc sql;
            create table crossWalk&year. as
                select M.ehic, M.count, S.bene_id                
                from samp.medpar&pct._&year._1  S, bE.ehicbenex_unique_bene_indx  M
                where (S.bene_id = M.bene_id);
            quit;
        run;

        
        proc sql;
            create table Match&year. as
                select COUNT(*) as MatchCount                 
                from crossWalk&year.;
            quit;
        run;

        data Match&year.;
            set Match&year.;
            year=&year.;
        run;
        
        data Total&year.;
            merge   Raw&year. Match&year.;
            by year;
        run;
        

        %end;
        %end;

    data samp.CrossWalkCount_pc&pct.;
        set %do year=&yearin. %to &yearout.;  Total&year.  %end; ;
    run;
    
    proc print data=samp.CrossWalkCount_pc&pct.;
    run;
    
    %mend;


%runme(pct=100,yearin=2004,yearout=2005);


