/* The purpose of this code is to document how well the crosswalk merged.
    Specifically I want to better understand the impact of using the bene_id

    (1) How many bene_id mathc to a single ehic
    (2) How does the cw code function. Is there any stange match


    */


*(1) How many bene_id match to a single ehic -- 1984 ,1990, 2005, 2006;

**** PRELIMINARIES ****;
* directory where extracts should be placed;
    %let extractdir=/disk/agero5/medicare.work/wise-DUA16702/daltonm/LongExtract;

* directory where denominantor and enrollment files can be decompressed and manipulated;
    %let spdirDenom=/space/daltonm/denom05.NOBACKUP;
*%let spdirDenom=/age1space/daltonm/denom05.NOBACKUP;

* directory where denominantor and enrollment files can be saved;
    %let outDenom=/disk/agero5/medicare.work/wise-DUA16702/daltonm/denom05.NOBACKUP;

* directory where the MedPAR files can be decompressed and manipulated;
    %let spdirMedpar=/disk/agero5/medicare.work/wise-DUA16702/daltonm/medpar05.NOBACKUP;
*%let spdirMedpar=/space/daltonm/medpar05.NOBACKUP;
*%let spdirMedpar=/age1space/daltonm/medpar05.NOBACKUP;

* directory where temporary files can be written;
    %let tempEx=/disk/agero5/medicare.work/wise-DUA16702/daltonm/medpar05.NOBACKUP/TempExtract;

* directory where the NBER keeps compressed raw claims data;
    %let dataRoot = /disk/agedisk1/medicare/data.NOBACKUP/u/c;

* directory where the SAS macros can be found ;
    %let SASmac =/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/SASmacros;

*Post 2005 data found here;
    %let dataroot2= /disk/agero9/medicare/data;

*ehic to ehic crosswalk found here; 
    %let benei= /disk/agero5/medicare.work/wise-DUA16702/daltonm/beneID_cw;

* load file containing various simple macros that make programming easier;
    %include "&SASmac./UtilityMacros.sas";
    %include "&SASmac./AutoFileCountPipe.sas";

*Put final variable labels in this file;
    %include "&SASmac./Labels.sas";
*Runs a program which flags the different transfer scenarios referenced in the documentation;
    %include "&SASmac./FlagTransfersv2.sas";

*Program which mergers in the crosswalk;
    %include "&SASmac./cw_bene_ehic_Extract.sas";

* load files with macros that conform the files of various years into a common format;
    %include "&SASmac./ConformDenom.sas";
    %include "&SASmac./ConformMedPAR.sas";
    %include "&SASmac./CreateReports.sas";


*define libraries that allow access to the various directories specified above;
    libname tempDir "&tempEx.";
    libname out "&extractdir.";
    libname spDenom "&spdirDenom.";
    libname outDen "&outDenom.";
    libname spMedpar "&spdirMedpar.";
    libname bene "&benei.";

/* The purpose of this code is to document how well the crosswalk merged.
    Specifically I want to better understand the impact of using the bene_id

    (1) How many bene_id mathc to a single ehic in ami extract for example
    (2) How does the cw code function. Is there any stange matchs
    (3) How many missing ehic/bene_id exist in the crosswalk

    */
*----------------RAw AMI COUNT ---------------------------------;
%macro ExtractNonStrict5pctEhics(yearin=,yearout=,pct=);
    %do yr=&yearin. %to &yearout.;
        %if &yr. >= 1984 and &yr. <= 2001 %then %do;
            %let dschgdtVar = mdisdte;
            %let pnum = mprovno;
            %let idcode = ehic;               
            %let losVar = mlos;
            %if &yr. >= 1987 and &yr <= 1997 %then %do;
                %let ftypeVar=mfaclty;
                %end;
            %else %if  &yr. >= 1998 and &yr. <= 2001 %then %do;
                %let ftypeVar=mstay;
                %end;

            
            %let dgnsPfx=mdiag;
            %let admdtVar=madmdte;

            %if &yr. = 1984 or &yr. = 1986 %then %do;
                %let nDiagFields = 5;
                %end;
            %else %do;
                %let nDiagFields = 10;
                %end;                    
            
            %end;
        %else %if &yr.>= 2002 and &yr.<= 2005 %then %do;
            %let idcode = ehic;           
            %let ftypeVar=sslssnf;

            
            %let dschgdtVar = sdschrgdt;
            %let losVar = loscnt;
            
            %let dgnsPfx=dgns_cd;
            %let admdtVar=sadmsndt;

            %let nDiagFields = 10;
            %end;
        %else %if &yr.>= 2006  %then %do;
            %let idcode = bene_id;           
            %let ftypeVar=sslssnf;
            %let pnum = PRVDRNUM;
            %let dschgdtVar = dschrgdt;
            %let losVar = loscnt;
            
            %let dgnsPfx=dgnscd;
            %let admdtVar=admsndt;

            %let nDiagFields = 10;
            %end;


       
        proc sort data=spMedpar.medpar&pct._&yr._1 (keep=ehic) out=test&yr. nodupkey;
            WHERE substr(&dgnsPfx.1,1,3)="410";
            by ehic;
        run;


**** Merge in bene_ids associated with EHIC in the AMI extract;        
        proc sql;
            create table temp as
                select S.ehic, M.bene_id, M.count 
                from work.test&yr.  S , bene.ehicbenex_unique  M
                WHERE  (S.ehic = M.ehic) and M.count>1;
            quit;


*** Take the associated bene_id from the ehics found in the AMI extract and get rid of duplicates;
        proc sort data=temp out=temp1(keep=bene_id) nodupkey;
            by bene_id;
        run;

*** Take all bene_id from the ehic found in the extract and remerge with the crosswalk in order to ;
*** capture all ehics (including the ehics not found in the extract) associated with a bene_id in teh cw;
        proc sql;
            create table spMedpar.xw&pct._&yr. as
                select S.bene_id, M.ehic, M.count,M.hic_mtch 
                from temp1  S , bene.ehicbenex_unique_bene_indx  M
                WHERE  (S.bene_id = M.bene_id) and M.count>1;
            quit;

            
        data spMedpar.xw&pct._&yr.;
            set spMedpar.xw&pct._&yr.;
            yearRaw=&yr.;
        run;

        proc datasets lib=work;
            delete test&yr temp temp1;
        %end;
    

    data spMedpar.xw&pct.List;    
        set %do yr=&yearin. %to &yearout.;
        spMedpar.xw&pct._&yr.  %end;;
        digit8 = substr(ehic,8,2);
        strict5=0;
        if digit8 in("05","20","45","70","95") then strict5=1; 
    run;

    proc freq data=spMedpar.xw&pct.List;
        tables digit8 strict5 yearRaw yearRaw*strict5 /nopercent nocol nocum norow;
run;

%mend;


**Run on the entire sample over nite;

%ExtractNonStrict5pctEhics(yearin=1984,yearout=2004, pct=05 );



