clear

set memory 5000m
// REad in directories from this file
do ../../dirInit.do
foreach diag in  "hip" "ami" "acs" "chf" {

fdause "$carExt/`diag'_carrier_mn.xpt"

// some variables get transformed into doubles in the transition, which is not desirable
recast long dgn_date diag_id sexpndt1 sexpndt2

//add labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable diag_id "Unique ID of AMI episode"
label variable dgn_date "Date of AMI that defines episode"


label variable st_clm "Patient state of residence at time of claim"
label variable cnty_clm "Patient county of residence at time of claim"
label variable zip_clm "Patient zipcode of residence at time of claim"


label variable tax_num "Provider tax identification number"
label variable prf_upin "Provider unique physician identification number"
label variable prf_prfl "Provider identification number"

label variable provzip "Provider zipcode"
label variable prvstate "Provider state"
label variable hcfaspcl "CMS specialty code"
label variable prv_type "Carrier provider type code"


label variable pdgns_cd "Principal diagnosis"
label variable dgns_cd1 "Diagnosis code #1"
label variable dgns_cd2 "Diagnosis code #2"
label variable dgns_cd3 "Diagnosis code #3"
label variable dgns_cd4 "Diagnosis code #4"

label variable linedgns "Line diagnosis code"


label variable hcpcs_cd "Service HCPCS code"
label variable mdfr_cd1 "Service HCPCS code modifier #1"
label variable mdfr_cd2 "Service HCPCS code modifier #2"
label variable hcpcs_yr "Year of HCPCS coding system used"

label variable betos "Service BETOS code"
label variable typsrvcb "CMS type of service code"
label variable plcsrvc "Place of service code"

label variable sexpndt1 "Service expenditure start date"
label variable sexpndt2 "Service expenditure end date"

label variable clm_type "Claim type code"

label variable lalowchg "Total all-payer payment amount"
label variable linepmt "Medicare payment amount"


label variable fileyear "Year of Carrier file containing claim"

//fix variable order
/*#delimit ;
order ehic diag_id dgn_date
st_clm cnty_clm zip_clm
tax_num prf_upin prf_prfl
provzip prvstate hcfaspcl prv_type
dgns_cd1 dgns_cd2 dgns_cd3 dgns_cd4 pdgns_cd linedgns
hcpcs_cd mdfr_cd1 mdfr_cd2 hcpcs_yr betos typsrvcb plcsrvc sexpndt1 sexpndt2 clm_type
lalowchg linepmt
fileyear;
#delimit cr
*/
save "/disk/agero5/medicare.work/wise-DUA16702/daltonm/cleanDTA/`diag'_carrier_mn.dta", replace
clear
}
