clear
set memory 1000m

// REad in directories from this file
do ../../dirInit.do

///DEfine a diagnoses name
foreach diag in "hip"  "chf" "ami" "acs"{


// *** MedPAR CLAIMS FILE ***
fdause "$longExt/`diag'_dataset_claims_mn.xpt"



rename st_clm state_clm
rename cnty_clm county_clm
rename sdschgdt sdschrgdt
rename out_new outlrday_new
renpfix dg_cd dgns_cd
renpfix pr_cd prcdr_cd
renpfix pr_dt prcdr_dt
rename drg_new drg_cd_new
rename prnumgrp prvnumgrp
rename epindxnt ep_indxNT
rename ambigord ambigOrder
rename amborddd ambigOrder_dd

// some variables get transformed into doubles in the transition, which is not desirable
recast long dgn_date diag_id sadmsndt sdschrgdt prcdr_dt*

//make sure the date fields are valid
assert sdschrgdt != . & sadmsndt != .

//add labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable diag_id "Unique ID of diag episode"
label variable dgn_date "Date of diag that defines episode"

label variable state_clm "Patient state of residence at admission"
label variable county_clm "Patient county of residence at admission"
label variable zip_clm "Patient zipcode of residence at admission"

label variable prvnumgrp "Institution provider number"
label variable prvstate "Institution state code"
label variable prvnum3 "Institution type code "
label variable spclunit "Institution type alpha-numeric code"
label variable prvdrsrl "Institution serial number"
label variable sslssnf "Short stay/long stay/SNF indicator"
label variable is_snf "Skilled nursing facility flag"

label variable sadmsndt "Admission date"
label variable sdschrgdt "Discharge date (or claim end date)"
label variable sacrtndt "Date claim added to CMS masterfile"

label variable src_adms "Source of admission"
label variable type_adm "Type of admission"
label variable dstntncd "Discharge destination code"
label variable dschrgcd "Discharge status code"

label variable loscnt "Length of stay in days"
label variable outlr_cd "Outlier status code"
label variable outlrday "Number of outlier days"
label variable outlrday_new "Number of outlier days (84-86 new method)"

label variable drg_cd "DRG code"
label variable drg_cd_new "DRG code (84-86 new method)"

label variable dgnscnt "Number of diagnosis codes on record"
label variable dgns_cd1 "Diagnosis code #1"
label variable dgns_cd2 "Diagnosis code #2"
label variable dgns_cd3 "Diagnosis code #3"
label variable dgns_cd4 "Diagnosis code #4"
label variable dgns_cd5 "Diagnosis code #5"
label variable dgns_cd6 "Diagnosis code #6"
label variable dgns_cd7 "Diagnosis code #7"
label variable dgns_cd8 "Diagnosis code #8"
label variable dgns_cd9 "Diagnosis code #9"
label variable dgns_cd10 "Diagnosis code #10"
label variable ad_dgns "Diagnosis at admission"

label variable prcdrcnt "Number of procedure codes on record"
label variable prcdr_cd1 "Procedure code #1"
label variable prcdr_cd2 "Procedure code #2"
label variable prcdr_cd3 "Procedure code #3"
label variable prcdr_cd4 "Procedure code #4"
label variable prcdr_cd5 "Procedure code #5"
label variable prcdr_cd6 "Procedure code #6"
label variable prcdr_dt1 "Procedure date #1"
label variable prcdr_dt2 "Procedure date #2"
label variable prcdr_dt3 "Procedure date #3"
label variable prcdr_dt4 "Procedure date #4"
label variable prcdr_dt5 "Procedure date #5"
label variable prcdr_dt6 "Procedure date #6"

label variable coin_amt "Patient coinsurance amount"
label variable ded_amt "Patient deductible amount"
label variable blddedam "Patient blood deductible amount"
label variable prpayamt "Non-Medicare primary payer payment amount"
label variable ime_amt "Indirect medical education payment amount"
label variable disp_shr "Disproportionate share payment"
label variable pps_cptl "PPS capital payment"
label variable drgprice "Total all-payer payment w/o outlier payments"
label variable outlramt "Outlier payment amount"
label variable pmt_amt "Total Medicare payment"
label variable passthru "Bill pass-through payment amount"
label variable mperdiem "Cost report pass-through/per diem"
label variable prpay_cd "Type of primary payer"
label variable pps_ind "Prospective payment status"

label variable ep_indx "Index of claim within diag episode"
label variable ambigOrder "Temporal order of claim is ambiguous"
label variable ambigOrder_dd "Temporal order is ambiguous based on dates and death indicators alone"
label variable ep_indxNT "Index of claim within diag episode (no ties)"

label variable fileyear "Year of MedPAR file containing claim"

// put the variables in a more desirable order
#delimit ;
order ehic diag_id dgn_date
state_clm county_clm zip_clm
prvnumgrp prvstate prvnum3 spclunit prvdrsrl sslssnf is_snf
sadmsndt sdschrgdt sacrtndt
src_adms type_adm dstntncd dschrgcd
loscnt outlr_cd outlrday outlrday_new
drg_cd drg_cd_new
dgnscnt dgns_cd1 dgns_cd2 dgns_cd3 dgns_cd4 dgns_cd5 dgns_cd6 dgns_cd7 dgns_cd8 dgns_cd9 dgns_cd10 ad_dgns
prcdrcnt prcdr_cd1 prcdr_cd2 prcdr_cd3 prcdr_cd4 prcdr_cd5 prcdr_cd6 prcdr_dt1 prcdr_dt2 prcdr_dt3 prcdr_dt4 prcdr_dt5 prcdr_dt6
coin_amt ded_amt blddedam prpayamt ime_amt disp_shr pps_cptl drgprice outlramt pmt_amt passthru mperdiem prpay_cd pps_ind
ep_indx ambigOrder ambigOrder_dd ep_indxNT
fileyear;
#delimit cr

save "$exDir/LongExt/`diag'_dataset_claims_mn.dta", replace


// *** SAMPLE FILE ***
fdause "$exDir/LongExt/`diag'_dataset_mn.xpt"

// some variables get transformed into doubles in the transition, which is not desirable
recast long dgn_date diag_id


//add labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable diag_id "Unique ID of diag episode"
label variable dgn_date "Date of diag that defines episode"

//fix variable order
order ehic diag_id dgn_date

save "$exDir/LongExt/`diag'_dataset_mn.dta", replace


// *** DEMO FILE ***
fdause "$exDir/LongExt/`diag'_dataset_demo.xpt"

//add labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable sdob "Date of birth"
label variable sdod "Date of death"
label variable race "Race code"
label variable sex "Sex"

local enrollList ""
local ppList ""
forvalues y=1984(1)2005 {
  forvalue m=1(1)12 {
    label variable e`y'm`m' "Medicare enrollment code for year `y', month `m'"
    label variable h`y'm`m' "Private plan enrollment code for year `y', month `m'"

    local enrollList "`enrollList' e`y'm`m'"
    local ppList "`ppList' h`y'm`m'"
  }
}

//fix variable order
order ehic sdob sdod race sex `enrollList' `ppList'

save "$exDir/LongExt/`diag'_dataset_demo.dta", replace

}
