clear

set memory 8000m
// REad in directories from this file
do ../../dirInit.do



foreach diag in "hip"  "chf" "ami" "acs"{

** CLAIMS FILE **

fdause "$opExt/`diag'_opclms_mn.xpt"

// some variables get transformed into doubles in the transition, which is not desirable
recast long dgn_date diag_id sfromdt sthrudt
forvalues i=1(1)10 {
  recast long pr_dt`i'
}

//switch back the variable names that I had to change
rename st_clm state_clm
rename cnty_clm county_clm
renpfix dg_cd dgns_cd
renpfix pr_cd prcdr_cd
renpfix pr_dt prcdr_dt
rename clmindx claimindex

//add variable labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable diag_id "Unique ID of `diag' episode"
label variable dgn_date "Date of AMI that defines episode"

label variable claimindex "Index number of claim within file year"
label variable linecnt "Number of revenue centers in claim"

label variable sfromdt "Claim start date"
label variable sthrudt "Claim end date"

label variable state_clm "Patient state of residence at time of claim"
label variable county_clm "Patient county of residence at time of claim"
label variable zip_clm "Patient zipcode of residence at time of claim"

label variable provider "Institution provider number"
label variable prstate "Institution state"

label variable dgns_cd1 "Diagnosis code #1"
label variable dgns_cd2 "Diagnosis code #2"
label variable dgns_cd3 "Diagnosis code #3"
label variable dgns_cd4 "Diagnosis code #4"
label variable dgns_cd5 "Diagnosis code #5"
label variable dgns_cd6 "Diagnosis code #6"
label variable dgns_cd7 "Diagnosis code #7"
label variable dgns_cd8 "Diagnosis code #8"
label variable dgns_cd9 "Diagnosis code #9"
label variable dgns_cd10 "Diagnosis code #10"

label variable prcdr_cd1 "Procedure code #1"
label variable prcdr_cd2 "Procedure code #2"
label variable prcdr_cd3 "Procedure code #3"
label variable prcdr_cd4 "Procedure code #4"
label variable prcdr_cd5 "Procedure code #5"
label variable prcdr_cd6 "Procedure code #6"
label variable prcdr_cd7 "Procedure code #7"
label variable prcdr_cd8 "Procedure code #8"
label variable prcdr_cd9 "Procedure code #9"
label variable prcdr_cd10 "Procedure code #10"
label variable prcdr_dt1 "Procedure date #1"
label variable prcdr_dt2 "Procedure date #2"
label variable prcdr_dt3 "Procedure date #3"
label variable prcdr_dt4 "Procedure date #4"
label variable prcdr_dt5 "Procedure date #5"
label variable prcdr_dt6 "Procedure date #6"
label variable prcdr_dt7 "Procedure date #7"
label variable prcdr_dt8 "Procedure date #8"
label variable prcdr_dt9 "Procedure date #9"
label variable prcdr_dt10 "Procedure date #10"

label variable ptb_ded "Patient deductible amount"
label variable ptb_coin "Patient coinsurance amount"
label variable blddedam "Patient blood deductible amount"
label variable prpayamt "Non-Medicare primary payer payment amount"
label variable benepmt "Beneficiary payment amount"
label variable prvdrpmt "Provider payment amount"
label variable pmt_amt "Total Medicare payment"

label variable tot_chrg "Claim total charges"

label variable fileyear "Year of Carrier file containing claim"

//set variable order
#delimit ;
order ehic diag_id dgn_date
claimindex linecnt sfromdt sthrudt
state_clm county_clm zip_clm
provider prstate
dgns_cd1 dgns_cd2 dgns_cd3 dgns_cd4 dgns_cd5 dgns_cd6 dgns_cd7 dgns_cd8 dgns_cd9 dgns_cd10
prcdr_cd1 prcdr_cd2 prcdr_cd3 prcdr_cd4 prcdr_cd5 prcdr_cd6 prcdr_cd7 prcdr_cd8 prcdr_cd9 prcdr_cd10
prcdr_dt1 prcdr_dt2 prcdr_dt3 prcdr_dt4 prcdr_dt5 prcdr_dt6 prcdr_dt7 prcdr_dt8 prcdr_dt9 prcdr_dt10
ptb_ded ptb_coin blddedam prpayamt benepmt prvdrpmt pmt_amt tot_chrg
fileyear;
#delimit cr

save "$exDir/`diag'_opclms_mn.dta", replace


** REVENUE CENTERS FILE **

fdause "$exDir/`diag'_oprevcntrs_mn.xpt"

rename clmindx claimindex
rename cntrindx cntrindex

recast long claimindex diag_id dgn_date srev_dt
recast int cntrindex fileyear

//add labels
label variable ehic "Encrypted health insurance claim number (individual unique identifier)"
label variable diag_id "Unique ID of `diag' episode"
label variable dgn_date "Date of AMI that defines episode"

label variable claimindex "Index number of claim within file year"
label variable cntrindex "Index number of revenue center within claim"

label variable hcpcs_cd "Service HCPCS code"
label variable mdfr_cd1 "Service HCPCS code modifier #1"
label variable mdfr_cd2 "Service HCPCS code modifier #2"
label variable mdfr_cd3 "Service HCPCS code modifier #3"
label variable mdfr_cd4 "Service HCPCS code modifier #4"
label variable mdfr_cd5 "Service HCPCS code modifier #5"

label variable rev_cntr "Service revenue center code"
label variable srev_dt "Service date"

label variable apchipps "Service ambulatory payment classification code"

label variable fileyear "Year of Carrier file containing claim"

//set order
#delimit ;
order ehic diag_id dgn_date
claimindex cntrindex
hcpcs_cd mdfr_cd1 mdfr_cd2 mdfr_cd3 mdfr_cd4 mdfr_cd5
rev_cntr srev_dt
apchipps fileyear;
#delimit cr

save "$exDir/`diag'_oprevcntrs_mn.dta", replace
clear
}
