set more off
clear
set memory 3000m

///NOTE
/* Uses output from Longitudinal Extract files"
///The program uses the following two user written programs statsmat AND xml_tab which need to be installed

*/



// REad in directories from this file
do ../../dirInit.do

local pct 05
local DGNMX 1

pause off

///

foreach i in "ami" {

///local i "hip" "hip" "ami" "acs"




local name1 Summary`i'
local name2 $S_DATE
local name3 .xls
local name `name1'`name2'`name3'

  /// CROSS WALK WHICH HAS EHIC, `i', `i' DATE --sample are unique instance of this info
  use "$longExt/`i'`pct'_`DGNMX'_indxdemo_mn_bene_id.dta"  , clear
  gen total =1
  ///  `i' Mortality (30 , 180,  and 360 days)

  ///Population Counts


  statsmat total if male ==1 ,by(diag_year)  s(sum) mat(male)  f(%4.0f)
  statsmat total if male ==0 ,by(diag_year)  s(sum) mat(female)  f(%4.0f)
  statsmat total            ,by(diag_year)  s(sum) mat(total)  f(%4.0f)

  mat rownames male  =Men:
  mat rownames female=Women:
  mat rownames total =Total:

  mat counts = ( male \ female \ total )
  xml_tab counts   using "$sumStatout/`name'",  sheet(Counts,nogridlines)  format((S3110) (S3230 N3200))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)  tblanks(3) font("Garamond" 11) title("Population Count")      note("Enter note here") replace


  ///Cumaltive mortality Age

  gen age65t74=1 if ag65t69==1 | ag70t74==1
  gen age75t84=1 if ag75t79==1 | ag80t84==1
  gen age85p=1 if ag85t89==1 | ag90t94==1 | ag95p==1

  foreach age in 65t74 75t84 85p {

  statsmat age`age' if male ==1 ,by(diag_year)  s(sum) mat(ag`age'_m)  f(%4.0f)
  statsmat age`age' if male ==0 ,by(diag_year)  s(sum) mat(ag`age'_f)  f(%4.0f)
  statsmat age`age'   ,by(diag_year)  s(sum) mat(ag`age')  f(%4.0f)

  mat colnames ag`age'_m=age`age'
  mat colnames ag`age'_f=age`age'
  mat colnames ag`age'=age`age'
}


  statsmat ageatdiag   if male ==1 ,by(diag_year)  s(mean) mat(AgeMea_m)  f(%4.0f)
  statsmat ageatdiag if male ==0 ,by(diag_year)  s(mean) mat(AgeMea_f)  f(%4.0f)
    statsmat ageatdiag  ,by(diag_year)  s(mean) mat(AgeMea)  f(%4.0f)

  mat colnames AgeMea_m=Mean
  mat colnames AgeMea_f=Mean
  mat colnames AgeMea=Mean

  mat age_men=(ag65t74_m, ag75t84_m, ag85p_m, AgeMea_m)
  mat rownames age_men= Men:

  mat age_wo=(ag65t74_f, ag75t84_f, ag85p_f, AgeMea_f)
  mat rownames age_wo= Women:

  mat age_to=(ag65t74, ag75t84, ag85p, AgeMea)
  mat rownames age_to = Total:

  mat age = ( age_men \ age_wo \ age_to)

  xml_tab age using "$sumStatout/Summary`i'.xml",  cblanks(4 8)  sheet(Age,nogridlines)   format((S3110) (S3230 N3200))   lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)  tblanks(3) font("Garamond" 11)  title("Age population count by sex with summary measure")    note("Enter note here")  append
  mat drop _all

///Survivorship
  foreach days in 3 7 30 180 365  {

  statsmat surv_`days' if male ==1 ,by(diag_year)  s(sum) mat(surv`days'_m)  f(%4.0f)
  statsmat surv_`days' if male ==0    ,by(diag_year)  s(sum) mat(surv`days'_f)  f(%4.0f)
  statsmat surv_`days'                ,by(diag_year)  s(sum) mat(surv`days')  f(%4.0f)

  mat colnames surv`days'_m = Men:Days`days'
  mat colnames surv`days'_f = Women:Days`days'
  mat colnames surv`days'   = Total:Days`days'


}


mat survm= (surv3_m, surv7_m, surv30_m, surv180_m, surv365_m)
mat survf= (surv3_f, surv7_f, surv30_f, surv180_f, surv365_f)
mat surv= (surv3, surv7, surv30, surv180, surv365)


  mat rownames survm = Men:
  mat rownames survf = Women:
  mat rownames surv  = Total:

  mat survall = (survm \ survf \ surv )

  xml_tab  survall  using "$sumStatout/`name'",  cblanks(5 10)  sheet(Survival,nogridlines)   format((S3110) (S3230 N3200))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)   tblanks(3) font("Garamond" 11) title("Survival over time")    note("Enter note here")  append





  keep dgn_date diag_id sex male sdod diag_year
  merge diag_id dgn_date using "$longExt/`i'`pct'_`DGNMX'_claims_mn_bene_id.dta", uniqmaster sort
  count


 /// This step retrieves the orignal cohorts. In some instance where there are repeat admission dates this may cause problems.
  drop if dgn_date!=sadmsndt

  ///INPERFECT AMTCH CREATES SOME DUPLICATES - WHICH WE GET RID OF HERE
  duplicates tag diag_id dgn_date , gen(dupes)
  bysort diag_id dupes: gen DROPTAG=_n

  drop if DROPTAG==2
 drop DROPTAG dupes

/// cap drop diag_year
/// gen  diag_year = yofd(dgn_date)

tab diag_year


  gen lengOfStay7= loscnt <=7
  gen lengOfStay15= loscnt <=15
  gen lengOfStay30= loscnt <=30
  gen lengOfStay60= loscnt <=60
  gen lengOfStay180= loscnt <=180
  gen lengOfStay360= loscnt <=360

  pause


///LOS
  foreach days in 7 15 30 60 180 360  {

  statsmat lengOfStay`days' if male ==1 ,by(diag_year)  s(sum) mat(los`days'_m)  f(%4.0f)
  statsmat lengOfStay`days' if male ==0 ,by(diag_year)  s(sum) mat(los`days'_f)  f(%4.0f)
  statsmat lengOfStay`days'             ,by(diag_year)  s(sum) mat(los`days')  f(%4.0f)

  mat colnames los`days'_m = LOS`days'
  mat colnames los`days'_f = LOS`days'
  mat colnames los`days'   = LOS`days'

}
   statsmat loscnt  if male ==1         ,by(diag_year)  s(median) mat(losMed_m)  f(%4.0f)
   statsmat loscnt  if male ==0         ,by(diag_year)  s(median) mat(losMed_f)  f(%4.0f)
   statsmat loscnt                      ,by(diag_year)  s(median) mat(losMed)  f(%4.0f)

  mat colnames losMed_m = Median
  mat colnames losMed_f = Median
  mat colnames losMed   = Median


  mat los_m=(los7_m , los15_m, los30_m, los60_m, los180_m, los360_m, losMed_m )
  mat rownames los_m= Men:

  mat los_f=(los7_f , los15_f, los30_f, los60_f, los180_f, los360_f, losMed_f )
  mat rownames los_f= Women:

  mat los_t=(los7 , los15, los30, los60, los180, los360, losMed )
  mat rownames los_t= Total:

  mat los= ( los_m \ los_f \ los_t)

  xml_tab los  using "$sumStatout/`name'",  cblanks(7 14)  sheet(LOS,nogridlines)  format((S3110) (S3230 N3100))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)   tblanks(3) font("Garamond" 11)  title("Length of Stay (LOS)")    note("Note: Defined as number of individuals who survived XX days or more")  append


/// DISCHARGE DESTINATION
///NOT WORKING///***

 ///  THESE MATCH THE PAPER MARCELO DID;
gen dischdestCD=.
//home
replace dischdestCD =1 if dstntncd==1 | dstntncd==8
//ICF
replace dischdestCD =2 if dstntncd==4
//Other including death
replace dischdestCD =3 if dstntncd==2 | dstntncd==6 |  dstntncd==7  | dstntncd==20 | dstntncd==30 | dstntncd==41 | dstntncd==42

//Outpatient
replace dischdestCD =4 if dstntncd==5 | dstntncd==9 |  dstntncd==62 |  dstntncd>=43
//SNF
replace dischdestCD =5 if dstntncd==3


tab dischdestCD
  di "MARK"
///DischargeDestn
  forvalues j=1/5  {

  statsmat dischdestCD if dischdestCD==`j' &  male ==1 ,by(diag_year)  s(count) mat(disc`j'_m)
  statsmat dischdestCD if dischdestCD==`j' & male ==0 ,by(diag_year)  s(count) mat(disc`j'_f)
  statsmat dischdestCD if dischdestCD==`j'  ,by(diag_year)  s(count) mat(disc`j'_t)

  if `j'==1 {
    local disName "home"
  }
  if `j'==2 {
    local disName "ICF"
  }
  if `j'==3 {
    local disName "Other"
  }
  if `j'==4 {
    local disName "Outpatient"
  }
  if `j'==5 {
    local disName "SNF"
  }


  mat colnames disc`j'_m = `disName'
  mat colnames disc`j'_f = `disName'
  mat colnames disc`j'_t = `disName'
  di "End of loop `j'"
}


  mat dis_m=( disc1_m, disc2_m, disc3_m, disc4_m , disc5_m)
 di "Done dis_m"
mat dis_f=( disc1_f, disc2_f, disc3_f, disc4_f , disc5_f)
 di "Done dis_m"
mat dis_t=( disc1_t, disc2_t, disc3_t, disc4_t , disc5_t)
di "Done dis_m"
  mat rownames dis_m= Men:
  mat rownames dis_f= Women:
  mat rownames dis_t= Total:

  mat dis = ( dis_m \ dis_f \ dis_t)
  xml_tab  dis  using "$sumStatout/`name'",  cblanks(5 10)  sheet(DisDes,nogridlines)   format((S3110) (S3230 N3200))  lines(COL_NAMES 4 LAST_ROW 13 SCOL_NAMES 2)   tblanks(3) font("Garamond" 11) title("Discharge Location--NOT CORRECT--SUMMING")    note("Enter note here")  append



}



