** This is some test code to figure out how sas views function ;
** and whether they are usefull to implement;


options pagesize=200;
options nocenter;
****************************************;
** These options create large log files ;
options mprint mlogic;
****************************************;
options  msglevel=i;
options notes stimer fullstimer;
options formdlim=" ";
options mergenoby=error;
options errorabend;
options NOQUOTELENMAX;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* define libraries;
libname tempDir "&medtmp.";
libname out "&longExt.";
libname carout "&carExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";
libname DRGs "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/";
libname reimOut "/disk/agero5/medicare.work/wise-DUA16702/daltonm/reimb/RVU";
libname CarRvu  "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/reimburse_calc/CarrierRVUs/RVUinputFiles";
libname forNIv  "/disk/agebulk1/medicare.work/chandra-DUA21441/daltonm";

libname root  "/disk/agedisk1/medicare/data.NOBACKUP/u/c/20pct/car/2005";


proc print data=root.CAR20I_2005_LNITS8 (obs=10); run;
endsas;

** load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";
%include "&SASmac./cw_bene_ehic_Extract.sas";
** load files with macros that conform the files of various years into a common format;

%include "&SASmac./ConformCarrier.sas";

%macro RunProgram(pct=,cohrt=,dgnPos=,id=,yearin=,yearout=,los=);
  ** Define macro variables for timiing the runs -- used at the end of the loop ;
    %let tBefore=%sysfunc(datetime());
    %put Begin run at time &SYSTIME.;

    data CarRvu.togetsample;
        length hcpcs_cd $7 hicpicm $4;
        set carout.&cohrt.&pct._&dgnPos._carlnits_mn_&id.;
        WHERE (fileYear>=2003 and (expnsdt2-dgn_date<=&los. and expnsdt2-dgn_date>=0));
        difcount=expnsdt2-dgn_date;
        hicpicm=mdfr_cd1;
        FORMAT expnsdt2 DATE9;
        ** Trying to ignore all other hcpcs modifiers because only these three are found in the ;
        ** RVU crosswalk files;
    run;

    data addVar1;
        set CarRvu.togetsample;
        end_yr=year(expnsdt2);
        if fileYear>=2003;
        flag=0;
        if mdfr_cd1 = "26" then flag=1;
        if mdfr_cd1 = "53" then flag=1;
        if mdfr_cd1 = "TC" then flag=1;
        **drop obervations without modifiers of interest;
        if flag=1;
        drop flag;
    run;


    proc sort data=addVar1;
        by hcpcs_cd end_yr hicpicm;
    run;
    data mergeInRVUsMod;
        merge addVar1(in=nonmod) CarRvu.RVU&yearin._&yearout.(in=inphyf) ;
        WHERE hicpicm ne "";
        by hcpcs_cd end_yr hicpicm;
        inMod=nonmod;
        inPhy=inphyf;
        *if inMod and inPhy;
    run;


      ** Define macro variables for timiing the runs -- used at the end of the loop ;
    %let tEND=%sysfunc(datetime());
    %let elapsed1=(%sysevalf((&tEND.-&tBefore/60)));
    %put Begin run at time &SYSTIME.;
    %put TIMER &elapsed1.;
    %mend;


%macro RunProgramViews(pct=,cohrt=,dgnPos=,id=,yearin=,yearout=,los=);
  ** Define macro variables for timiing the runs -- used at the end of the loop ;
    %let tBefore=%sysfunc(datetime());
    %put Begin run at time &SYSTIME.;


    data togetsample(keep=end_yr fileYear) / view=togetsample ;
        length hcpcs_cd $7 hicpicm $4;
        set carout.&cohrt.&pct._&dgnPos._carlnits_mn_&id.;
        WHERE (fileYear>=2003 and (expnsdt2-dgn_date<=&los. and expnsdt2-dgn_date>=0));
        difcount=expnsdt2-dgn_date;
        hicpicm=mdfr_cd1;
        FORMAT expnsdt2 DATE9;
        ** Trying to ignore all other hcpcs modifiers because only these three are found in the ;
        ** RVU crosswalk files;
    run;

    data addVar(keep=end_yr fileYear) / view=addVar ;
        set togetsample;
        end_yr=year(expnsdt2);
        if fileYear>=2003;
        flag=0;
        if mdfr_cd1 = "26" then flag=1;
        if mdfr_cd1 = "53" then flag=1;
        if mdfr_cd1 = "TC" then flag=1;
        **drop obervations without modifiers of interest;
        if flag=1;
        drop flag;
    run;

    proc print data=AddVar (obs=10);
    run;

    proc sql;
        create view test as
            select * FROM addVar
            order by hcpcs_cd, end_yr, hicpicm;
        quit;

    data mergeInRVUsMod;
        merge test(in=nonmod) CarRvu.RVU&yearin._&yearout.(in=inphyf) ;
        WHERE hicpicm ne "";
        by hcpcs_cd end_yr hicpicm;
        inMod=nonmod;
        inPhy=inphyf;
        *if inMod and inPhy;
    run;




    %let tEND=%sysfunc(datetime());
    %let elapsed1=(%sysevalf((&tEND.-&tBefore/60)));
    %put TIMER &elapsed1.;
    %mend;

%RunProgramViews(pct=05,cohrt=ami,dgnPos=1,id=bene_id,yearin=2003,yearout=2008,los=10);
*%RunProgram(pct=05,cohrt=ami,dgnPos=1,id=bene_id,yearin=2003,yearout=2008,los=10);


