

options pagesize=200;
options nocenter;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;

**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";
*Put final variable labels in this file;
%include "&SASmac./Labels.sas";
*Runs a program which flags the different transfer scenarios referenced in the documentation;
%include "&SASmac./FlagTransfersv2.sas";
*Program which mergers in the crosswalk;
%include "&SASmac./cw_bene_ehic_Extract.sas";

* load files with macros that conform the files of various years into a common format;
%include "&SASmac./ConformDenom.sas";
%include "&SASmac./ConformMedPAR.sas";
%include "&SASmac./CreateReports.sas";



*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname carout "&carExt.";
libname out "&longExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";
libname caroutoldrun "&carExt./20pctExtUsing100diagID";



proc means data=caroutoldrun.ami20_1_carlnits_mn_bene_id;run;
proc means data=carout.ami20_1_carlnits_mn_bene_id;run;


proc sort data=carout.ami20_1_carlnits_mn_bene_id(keep=bene_id fileyear) out=carnodup nodupkey;
    by bene_id;
run;

data mergte;
    merge carnodup (keep=bene_id fileyear  in=cari) out.ami20_1_demo_bene_id (keep=bene_id fileyear  in=p20);
    by bene_id;
    if fileyear>1998;
    carrier=cari;
    p20denom=p20;
run;


proc freq data=mergte;
    tables carrier*p20denom /missing;
run;


/*
20 pct  <---> 100 pct

    ehic only in 100 pct ok.
    ehic switcher 20% to 100% ehic or vice versa --
    will have more information from the 100% index creation
      -- 1) the index file will not incorrectly identify switchers as having a laps in coverage.
      -- 2) HOwever 20% file does not contain non-20 info on these indviduals so no problem.
      -- 3) it will create more individuals because they are more likely to qualify (about 1%);

   SHOULD BE ABLT TO USE 20% index extract to refine the carrier extract created from the 100% MEdPAR extract index
       with 20% car files.


       Sum of carrier version separatly for a year.

*/

