**Extract index events and corresponding claims from the inpatients and SNF claims (MEDPAR);
**Maurice Dalton, daltonm.at.nber.org,  based on code initially written by Jean Roth;
** and further refined by Matt Fiedler.  All errors are my own.;
**;
** PROGRAM STRUCTURE;
** The program consists of several sas macros which are combined in a macro which sequences the;
** macros correctly.This wrapper macro is found at the end of the program and has several ;
** different parameters defined at the end of the program;

** Also note that the macro CreateReports can be found within the SAS macro directory defined
** below and can simply be called at the end of this program.;

** Note that it is suggested that individuals create extracts using the bene_id if you
** are interested in the 2006-2008 data. As the code is structured now, extracting index;
** events based on ehic may create some duplicates.;

** IF INTERESTED IN RUNNING 100% or 20% FILE SPACE WILL LIKLY BE AN ISSUE. THE PROGRAM HAS
** BEEN STRUCTURED TO BE ABLE TO WORK WITH A FEW YEAR FILES AT A TIME AND DELETE THEM WHEN;
** THEY ARE DONE. USE THE DELETE FLAG ;

*WRAPPER MACRO FOUND AT THE END ---%RunPrgram;


options pagesize=200;
options nocenter;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;

**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";
*Put final variable labels in this file;
%include "&SASmac./Labels.sas";
*Runs a program which flags the different transfer scenarios referenced in the documentation;
%include "&SASmac./FlagTransfersv2.sas";
*Program which mergers in the crosswalk;
%include "&SASmac./cw_bene_ehic_Extract.sas";

* load files with macros that conform the files of various years into a common format;
%include "&SASmac./ConformDenom.sas";
%include "&SASmac./ConformMedPAR.sas";
%include "&SASmac./CreateReports.sas";



*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname out "&longExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";


FILENAME in PIPE "gzip -dc rawdata.sas";


    *"only works with text files...";
