** Extract a 1 year window from the Carrier files for the given index events extracted in the
** LongitudinalExtractScript.SAS. ;
**;
** PROGRAM STRUCTURE;
** The program consists of several SAS macros which are wrapped together using a macro which
** sequences them correctly.This wrapper macro is found at the end of the program and has
**  several different parameters defined at the end of the code.;

** Maurice Dalton, daltonm.at.nber.org based on code initially written by Jean Roth and refined;
** by Matt Fiedler. All errors are my own.;
**;


options pagesize=200;
options nocenter;
** These options create large log files ;
options mprint mlogic;
options  msglevel=i;
options notes stimer fullstimer;
options formdlim=" ";
options mergenoby=error;
options errorabend;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* define libraries;
libname spcar "&spcar.";
libname longEx  "&longExt.";
libname out   "&carExt.";
libname tempEx "&carErz.";
libname tempDir "&cartmp.";
libname bene "&benei.";

libname xwfile "/disk/agedisk1/medicare.work/wise-DUA16702/daltonm/Medicode/Auxiliary/codeTest";



data temp;
length lopnr $ 4;
input lopnr;
cards;
1234
0009
9999
;;
run;

data new(drop=x);
set temp(rename=(lopnr=x));
lopnr=input(x,best4.);
run;

proc print data=new;
run;
