
**Extract index events and corresponding claims from the inpatients and SNF claims (MEDPAR);
**Maurice Dalton, daltonm.at.nber.org,  based on code initially written by Jean Roth;
** and further refined by Matt Fiedler.  All errors are my own.;
**;
** PROGRAM STRUCTURE;
** The program consists of several sas macros which are combined in a macro which sequences the;
** macros correctly.This wrapper macro is found at the end of the program and has several ;
** different parameters defined at the end of the program;
**;
*!!!!WRAPPER MACRO FOUND AT THE END ---%RunDefineIndexEvents!!!!!;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

***********************************************************************
* DEFINE DIRECTORIES****;
***********************************************************************;
%include "../../dirInit.sas";

***********************************************************************;
* READ IN SAS MACRO FOUND IN OTHER FILES  ;
***********************************************************************;
* load file containing various simple macros that make programming easier;
%include "&SASmac./decompressMedPar.sas";
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./DetermineMax.sas";

***********************************************************************;
* DEFINE LIBRARIES ;
***********************************************************************;
* Defines local directories depending on which server currently running;
libname spmed "&spmed.";
libname spden "&spden";
libname spxw "&spxw";
libname mederz "&medtmp.";
libname inDen  "&inden.";
libname xwfile "&xwfile.";
libname beneIn "&inbenexw.";
libname here ".";
libname denext "&denExt.";
libname medex  "&medparExt";

%macro Extractdiag(yr=, pct=, );
    x "rm &spmed./* -f";

    %decompressMedPar(yr=&yr.,pct=&pct.,libout=spmed,
        dirout=&spmed.,dflag=1,dataroot=&dataroot.);

    data mederz.sasview&yr. / view=mederz.sasview&yr.;
        set spmed.medpar&pct._&yr._all ;
    run;

    data mederz.sasview2&yr. / view=mederz.sasview2&yr.;
        set mederz.sasview&yr. ;
        diagnew=mdiag1;
    run;


    /*proc contents data=mederz.sasview&yr.;run;*/


    data test;
        set mederz.sasview&yr.;
        where mdiag1="41071";
    run;

    data test2;
        set spmed.medpar&pct._&yr._all ;
        where mdiag1="41071";
    run;

    data test3;
        set spmed.medpar&pct._&yr._all (where=(mdiag1="41071"));
    run;

    data test4;
        set mederz.sasview&yr. (where=(mdiag1="41071"));
    run;

    data test5;
        set mederz.sasview&yr. ;
        if mdiag1="41071";
    run;
    data test6;
        set mederz.sasview2&yr. ;
        where diagnew="41071";
    run;



    x "rm &spmed./medpar&pct._&yr._all.* -f";
    x "rm &mederz./sasview&yr.* -f"
    %mend;

%Extractdiag(yr=2000,pct=100);


