** TESTING ;

options pagesize=200;
options nocenter;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
options errorabend;
options NOQUOTELENMAX;
**THROWS ERROR IF CANT FIND A VARIABLE;
options DKRICOND=ERROR;
options DKROCOND=ERROR;
**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";


* load file containing various simple macros that make programming easier;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./AutoFileCountPipe.sas";
*Put final variable labels in this file;
%include "&SASmac./Labels.sas";
*Runs a program which flags the different transfer scenarios referenced in the documentation;
%include "&SASmac./FlagTransfersv2.sas";
*Program which mergers in the crosswalk;
%include "&SASmac./cw_bene_ehic_Extract.sas";

* load files with macros that conform the files of various years into a common format;
%include "&SASmac./ImportVariableXW.sas";
%readinmedparxw;

%include "&SASmac./CreateXWmacro.sas";
%include "&SASmac./ConformDenom.sas";
%include "&SASmac./ConformMedPar.sas";
%include "&SASmac./CreateReports.sas";

%include "&SASmac./decompressDenom.sas";
%include "&SASmac./decompressMedPar.sas";
%include "&SASmac./decompressEnroll.sas";
%include "&SASmac./CreateReports.sas";


********************************************************************;
********************RUN THIS SAS SCRIPT ONCE - Corresponding to PCT of interest*******************;
**** ;
%include "&SASmac./CW_create.sas";
       *  %CW_create(pct=05);
       *  %CW_create(pct=0001);
**** ;
********************************************************************;
********************************************************************;


*define libraries that allow access to the various directories specified above;
libname tempDir "&medtmp.";
libname out "&longExt.";
libname spDenom "&spden.";
libname outDen "&denExt.";
libname spMedpar "&spmed.";
libname bene "&benei.";

libname xwfile "&xwfile.";


        %generateannualvariablelistfromxw(yr=2003,filename=medparxw,fileVarIn=indx,pct=05);
        %rawVarXw(harVar=prvnumgrp,yr=2003,outputvar=provider,filename=medparxw,pct=05);
        %rawVarXw(harVar=spclunit,yr=2003 ,outputvar=ftypeVar,filename=medparxw,pct=05);
        %rawVarXw(harVar=outlr_cd_ch,yr=2003,outputvar=outlyer,filename=medparxw,pct=05);
        %rawVarXw(harVar=dstntncd_ch,yr=2003,outputvar=dest_cd,filename=medparxw,pct=05);
        %rawVarXw(harVar=drg_cd_ch,yr=2003,outputvar=drg_code,filename=medparxw,pct=05);
        %rawVarXw(harVar=sslssnf,yr=2003,outputvar=snfvar,filename=medparxw,pct=05);
        %rawVarXw(harVar=admsndt,yr=2003,outputvar=admdtVar,filename=medparxw,pct=05);
        %rawVarXw(harVar=dgnscd1,yr=2003,outputvar=diagcd,filename=medparxw,pct=05);

proc contents data=spMedpar.medpar05_2003_all_bene (keep= &dest_cd.);
run;

data renameDropTest;
    set spMedpar.medpar05_2003_all_bene;

    testdest=put(&dest_cd.,2.0);
    *drop &dest_cd. &outlyer. &drg_code.;
    rename testdest=&dest_cd. ;
    RENAME &dest_cd.=dstntncd_ch;
run;

    proc contents data=renameDropTest (keep=dstntncd_ch);run;
