** their are currently several different ways to speed up sas IO we go through each one and attempt to benchmark each one;
***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
OPTIONS THREADS = YES CPUCOUNT = 2;
proc options;run;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";

***********************************************************************;
* DEFINE LIBRARIES ;
***********************************************************************;
* Defines local directories depending on which server currently running;
libname here ".";
libname opex "/tmp/daltonm";
libname optmp "&optmp.";
libname spxw "&inbenexw.";
x "mkdir -p &opext./view4extract/tmp";
libname opvw  "&opext./view4extract";
libname opvwtm  "&opext./view4extract/tmp";
libname indxex "&indxExt.";
libname root05 "&dataroot./05pct/op/2011";
libname root01 "&dataroot./0001pct/op/2011";

options source2;




**SAS VIEWS;

**SAS FILES ;

**SAS SPDE ;
*docs say to set SPDEMAXTHREADS (a system oiption to  max(2* number of drives,8*number of cores);
*on agero this means that SPDEMAXTHREADS==max(2*6,8*4) == 32;
*https://support.sas.com/rnd/scalability/spde/spde_setup.pdf;
*sas balh.sas -SPDEMAXTHREADS=16 --THREADNUM=16 ;

%PUT "SPDE";

libname testsp spde '/tmp'
               datapath=("/var/spde1"  "/var/spde2" "/var/spde3"
                         "/var/spde4" "/var/spde5" "/var/spde6" )
  ;
                                 run;

libname testsp2 spde '/tmp'
               datapath=("/var/spde1"  "/var/spde2" )
  ;
                                 run;

 libname testsp3 spde '/tmp'  ;
                                 run;


libname testop spde '/tmp'
               datapath=("/var/spde1"  "/var/spde2" "/var/spde3"
                         "/var/spde4" "/var/spde5" "/var/spde6" )
               bysort=yes
               compress=yes
  ;
                                 run;


libname temp "/tmp";

/*
proc datasets lib=testsp kill;
run;
quit;

proc datasets lib=testsp2 kill;
run;
quit;

proc datasets lib=testsp3 kill;
run;
quit;

proc datasets lib=testop kill;
run;
quit;
*/


***TEST IO;

%macro ioscale(maxth=,lib=);

    %let nrows=4.5E9 ;
    data &lib..test2;
        do i = 1 to &nrows;
            x = mod(i,33);
            output;
            end;
    run;

    data &lib..test;
        set &lib..test2 (threadnum=&maxth.);
    run;


    %put "SPDEMAXTHREADS = &maxth";

    %let tcnt = 1;
    %do %while(&tcnt le &maxth);
        %put "THREADNUM = &tcnt";

        data _null_;
            set &lib..test (threadnum=&tcnt);
            where x = 33;
        run;


        %let tcnt = %eval(&tcnt * 2);
        %end;

    %mend;

%ioscale(maxth=32, lib= testsp);
*%ioscale(maxth=16, lib= testsp2);
*%ioscale(maxth=16, lib= testsp3);
*%ioscale(maxth=16, lib= testop);
*%ioscale(%sysfunc(getoption(spdemaxthreads)));
*%ioscale(%sysfunc(getoption(spdemaxthreads)));

 %let nrows=4.5E9 ;
***test against mase;
    data test;
        do i = 1 to &nrows;
            x = mod(i,33);
            output;
            end;
    run;

*Run the following DATA step against the TESTBASE.TEST data set:;
    data _null_;
        set test;
        where x=33;
    run;


***test agains mase;
    data temp.test;
        do i = 1 to &nrows;
            x = mod(i,33);
            output;
            end;
    run;

*Run the following DATA step against the TESTBASE.TEST data set:;
    data _null_;
        set temp.test;
        where x=33;
    run;





proc datasets lib=testsp kill;
run;
quit;




/*
%macro dotest(maxthr);
%do nthr=1 %to &maxthr;

data _null_;
set spde cen.precs(threadnum= &nthr);
   where occup= '022'
   and state in('37','03','06','36');
run;
%mend dotest;



%macro doit;

do i=1 to &SYSPARM;
   x=i;
   output;
end;
run;

proc means;
run;
%mend;

%PUT "Plain";
data temp;
%doit;
proc delete data=temp;
run;

%PUT "VIEW";
data foo /view=foo;
%doit
proc means data=foo;
run;

%PUT "SASFILE";
data temp;
%doit;
sasfile temp open;
proc means;
run;
proc means;
run;
sasfile temp close;


data temp.spde;
%doit;
