**Extract a 1 year window from OP files for the final list of index events generated ;
**in the 1B program. The script reshape the revenue center codes in the earlier years;
*of the claims from a wide format into a long format. These are easier to work with ;
*and match the current format used by CMS;
**Maurice Dalton, daltonm.at.nber.org   based on code initially written by Jean Roth;
** and further refined by Matt Fiedler.;
**All errors are my own.;
**;
** PROGRAM STRUCTURE;
** The program consists of several SAS macros which are wrapped together using a macro which sequences them correctly.;
** This wrapper macro is found at the end of the program and has several different parameters defined below. The;
** wrapper mAcro program is found at the end. The parameters are defined at the end of the program. ;

***********************************************************************;
* READ IN SAS OPTIONS ****;
***********************************************************************;
*Use these options for debugging;
*options symbolgen mlogic mprint mfile ;
%include "../../sasoptions.sas";

** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "../../dirInit.sas";

***********************************************************************;
* DEFINE LIBRARIES ;
***********************************************************************;
* Defines local directories depending on which server currently running;
libname here ".";
libname opex "/tmp/daltonm";
libname optmp "&optmp.";
libname spxw "&inbenexw.";
x "mkdir -p &opext./view4extract/tmp";
libname opvw  "&opext./view4extract";
libname opvwtm  "&opext./view4extract/tmp";
libname indxex "&indxExt.";
libname root05 "&dataroot./05pct/op/2011";
libname root01 "&dataroot./0001pct/op/2011";


*import useful simple utility macros;
%include "&SASmac./UtilityMacros.sas";
%include "&SASmac./DetermineMax.sas";
%include "&SASmac./ConformOp.sas";
%include "&SASmac./ImportVariableXW.sas";
%readinopxw;
%include "&SASmac./CreateXWmacro.sas";
%include "&SASmac./archiveoldLogfiles.sas";

/*
proc sql _METHOD  MAGIC=103 BUFFERSIZE=1048576;
    CREATE TABLE test_bene as
    SELECT *
        FROM  root05.opr2011 B,
              root01.opc2011 S
        WHERE B.bene_id=S.bene_id;
    quit;


proc sql _METHOD  ;
    CREATE TABLE test_bene as
    SELECT *
        FROM  root05.opr2011 B,
              root01.opc2011 S
        WHERE B.bene_id=S.bene_id;
    quit;
*/

    proc contents data=spxw.ehicbenex_unique_bene_indx05;run;
    proc contents data=indxex.ami05_indx;run;
/*
proc sql _METHOD  _TREE MAGIC=103 BUFFERSIZE=1048576;
    CREATE TABLE test_clm_idbene as
SELECT S.diag_id, S.dgn_date, S.bene_id,  COALESCE(M.ehic,S.ehic) as ehicx
                           FROM  indxex.ami05_indx S
                          LEFT JOIN spxw.ehicbenex_unique_bene_indx05 (keep=ehic bene_id)  M
                              ON trim(S.bene_id)=trim(M.bene_id);
                          quit;

proc sql _METHOD  _TREE MAGIC=103 BUFFERSIZE=70048576;
    CREATE TABLE test_clm_idbene as
SELECT S.diag_id, S.dgn_date, M.bene_id,  COALESCE(M.ehic,S.ehic) as ehicx
                           FROM  indxex.ami05_indx S
                          LEFT JOIN spxw.ehicbenex_unique_bene_indx05 (keep=ehic bene_id)  M
                              ON trim(S.bene_id)=trim(M.bene_id);
                          quit;



proc sql _METHOD  _TREE MAGIC=103 BUFFERSIZE=70048576;
    CREATE TABLE test_clm_idbene as
    SELECT *
        FROM   root01.opc2011 (keep=bene_id)  C
        LEFT JOIN   spxw.ehicbenex_unique_bene_indx05    S
        ON       C.bene_id=S.bene_id;
    quit;





         %GenerateAnnualVariableListFromXw(yr=2001,filevarin=rev,pct=05,pctsuffix=,filename=opxw);

            data optmp.indxfile;
                set indxex.ami05_indx (keep=dgn_date bene_id diag_id ehic);
                WHERE (year(dgn_date) >= %sysevalf(2001. - 1)) and
                    (year(dgn_date) <= %sysevalf(2001. + 1)) ;
            run;

         libname spop "&dataRoot./05pct/op/2003/";
            proc sql _method  BUFFERSIZE=2097162;
                create table testrun as
                select C.diag_id, C.dgn_date, C.clm_id, C.bene_id, C.ehic, R.*
                from opvwtm.op05_2003_clms_1  C ,
                     (select *
                               from spop.op05_2003_revcntrs1  (keep=&rawvarlist_rev. )
                     )  R
                where C.ehic = R.ehic  and C.clm_id = R.claimindex ;
            quit;
        run;


            proc sql _method  BUFFERSIZE=2097162;
                create table testrun as
                select C.diag_id, C.dgn_date, C.clm_id, C.bene_id, C.ehic, R.*
                from opvwtm.op05_2003_clms_1  C ,
                     (select *
                               from spop.op05_2003_revcntrs1  (keep=&rawvarlist_rev. )
                     )  R
                where C.clm_id = R.claimindex ;
            quit;
        run;
        data test;
            set opvwtm.op05_2003_clms_1;
        run;

        proc contents data=test;run;

            proc sql _method  BUFFERSIZE=8048576;
                create table testrun as
                select C.diag_id, C.dgn_date, C.clm_id, C.bene_id, C.ehic, R.*
                from test  C ,
                     (select *
                               from spop.op05_2003_revcntrs1  (keep=&rawvarlist_rev. )
                     )  R
                where C.clm_id = R.claimindex ;
            quit;
        run;
*/


         %GenerateAnnualVariableListFromXw(yr=2011,filevarin=rev,pct=05,pctsuffix=,filename=opxw);
         libname spop "&dataRoot./100pct/op/2011/";


            data optmp.indxfile;
                set indxex.ami05_indx (keep=dgn_date bene_id diag_id ehic);
                WHERE (year(dgn_date) >= %sysevalf(2011 - 1)) and
                    (year(dgn_date) <= %sysevalf(2011 + 1)) ;
            run;

OPTIONS VBUFSIZE=500m;
            proc sql _METHOD BUFFERSIZE=2097162 ;
            create table test as
                select *
                from opvw.op100_2011_revcntrs_1  ;                            ;
            quit;

OPTIONS VBUFSIZE=64k;
            proc sql _METHOD BUFFERSIZE=2097162 ;
            create table test as
                select *
                from opvw.op100_2011_revcntrs_1  ;                            ;
            quit;


OPTIONS VBUFSIZE=10M;
            proc sql _METHOD BUFFERSIZE=2097162 ;
            create table test as
                select *
                from opvw.op100_2011_revcntrs_1  ;                            ;
            quit;





