
%macro ConformIp_ClmsChar2Numeric(year=);
    %if &year>=1997 and &year. <= 2005 %then %do;
         clm_id=put(trim(clmindx_temp),15.);
        %end;
    %mend;



%macro ConvertStr2Num_setrenameIp(y=,pct=,filevarin=);
    %if (&y. >= 1997 and &y. <= 2005 and &filevarin.=rev) %then %do;
        (rename=(&clmindx.=clmindx_temp ))
            %end;
    %if (&y. >= 1997 and &y. <= 2005 and &filevarin.=clm) %then %do;
        (rename=(&clmindx.=clmindx_temp ))
            %end;
    %mend;


* This macro loops over each of the revenue center fields for each year;
* and, where these fields are non-empty, writes a separate record containing;
* HCPCS code, APC code, reimbursement, etc);
%macro ConformIp_WriteRevcntrs(year=,cohrt=,dir=,part=);
    **********************************************************************;
    ***SETUP ARRAYS;
    **********************************************************************;
   %if &year. >= 1998 and &year. <= 2001 %then %do;
       array revcntra{1:%eval(&numFields.)} &rev_cntr.1-&rev_cntr.&numFields.;
       array hcpcsa{1:%eval(&numFields.)} &hcpcs_cd.1-&hcpcs_cd.&numFields.;
       array mdfr1a{1:%eval(&numFields.)} &mdfr_cd1.1-&mdfr_cd1.&numFields.;
       array mdfr2a{1:%eval(&numFields.)} &mdfr_cd2.1-&mdfr_cd2.&numFields.;
       array revdatea{1:%eval(&numFields.)} rev_dt1-rev_dt&numFields.;
       %end;
   %if &year. >= 2000 and &year. <= 2001 %then %do;
       array mdfr3a{1:%eval(&numFields.)} &mdfr_cd3.1-&mdfr_cd3.&numFields.;
       array mdfr4a{1:%eval(&numFields.)} &mdfr_cd4.1-&mdfr_cd4.&numFields.;
       array mdfr5a{1:%eval(&numFields.)} &mdfr_cd5.1-&mdfr_cd5.&numFields.;
       %end;

    **********************************************************************;
    ***START LOOPING THROUGH REV CENTER VARIABLES- OUTPUT TO LONG FORMAT;
    **********************************************************************;
    %if &year. >= 1998 and &year. <= 1999 %then %do;
       linecnt = &numFields.;
       do i=1 to &numFields.;
           if revcntra{i} = "" then do;
               linecnt = i - 1;
               leave;
               end;
           end;
        * As noted in ExtractOp.sas, claims for 1999-2000 can be split across;
        * records.  This code sets the maximum iteration index given this;
        * fact;
       iterLimit=linecnt;
       do  i=1 to iterLimit;
           &hcpcs_cd. = hcpcsa{i};
           &mdfr_cd1. = mdfr1a{i};
           &mdfr_cd2. = mdfr2a{i};
           &rev_cntr. = revcntra{i};
           &rev_dt. = revdatea{i};
           cntrindex = i;
               output ;
           end;
       %end;
   %else %if &year. >= 2000 and &year. <= 2001 %then %do;
         * As noted in ExtractOp.sas, claims for 1999-2000 can be split across;
         * records.  This code sets the maximum iteration index given this;
         * fact if not on the final segment of the record, then iterate to the last field;
         * if on the final segment, then calculate the number of items on this record;
       if sgmt_num < sgmt_cnt or sgmt_cnt=. then do;
           iterLimit = &numFields.;
           end;
       else do;
           iterLimit=linecnt-&numFields.*(sgmt_num-1);
           end;

       do  i=1 to iterLimit;
           &hcpcs_cd. = hcpcsa{i};
           &mdfr_cd1. = mdfr1a{i};
           &mdfr_cd2. = mdfr2a{i};
           &mdfr_cd3. = mdfr3a{i};
           &mdfr_cd4. = mdfr4a{i};
           &mdfr_cd5. = mdfr5a{i};
           &rev_cntr. = revcntra{i};
           &rev_dt. = revdatea{i};
           cntrindex = i;
               output ;
           end;
       %end;
   %if &year.>=2002 and &year<=2005 or &year=1997 %then %do;
       clm_id=put(trim(clmindx_temp),15.);
       %end;
    %mend;

