* These variabes in 2006 are characters, need to convert from numeric to characters.;
        *no longer including warning flags:: -wrngcd=wrngcd_temp;
%macro ConvertString2Num_setrename(y=,pct=);
    %if (&y. >= 2002 and &y. <= 2005) or
        (&y. >= 1992 and &y. <= 1995)
        %then %do;

        rename=(&dest_cd.=dstntncd_temp &outlyer.= outlr_cd_temp
            &drg_code.=drg_cd_temp )
            %end;
    %mend;

**no longer using warning flag if so add the following;
/*            %if (&y. >= 2002 and &y. <= 2005) or (&y. >= 1992 and &y. <= 1995) %then %do;
        * These variabes in 2006 are characters, need to convert from numeric to characters.;
                wrngcd=put(strip(wrngcd_temp),17.0);
                %end;
            %if &y. >= 2006 %then %do;
                wrngcd_ch=put(wrngcd,17.);
                %end;
*/
%macro ConformMedPAR(y=,pct=,file=);
    ** This macro conforms the MedPAR files of different years;
    ** into a slightly modified version of the 2005 format to;
    ** allow concatenation.  Called by macro ExtractClaims (see below).;
    ** year: the year of the MedPAR file being conformed.;
    ** See spreadsheet MedparFileLayouts.xlsx for the file layouts;
    /*
    NEED TO PLACE THESE MACRO CALLS OUT OF THE DATASTEP. GRABS THE CORRECT VAR;
    FROM THE CSV FILE WITH VAR CW.
    ** MAKE SURE YOU INCLUDE THE FOLLOWING BEFORE RUNNING THIS IN YOUR OWN FILE;
    %include "&SASmac./ImportVariableXW.sas";
    %include "&SASmac./CreateXWmacro.sas";
    %rawVarXw(harVar=prvnumgrp,yr=&y.,outputvar=provider,filename=medparxw);
    %rawVarXw(harVar=spclunit,yr=&y. ,outputvar=ftypeVar,filename=medparxw);
    %rawVarXw(harVar=outlr_cd,yr=&y. ,outputvar=outlyer,filename=medparxw);
    %rawVarXw(harVar=dstntncd,yr=&y. ,outputvar=dest_cd,filename=medparxw);
    %rawVarXw(harVar=drg_cd,yr=&y.   ,outputvar=drg_code,filename=medparxw);
    %rawVarXw(harVar=sslssnf,yr=&y.  ,outputvar=snfvar,filename=medparxw);
    */
    ** SET UP REGEXP TO FLAG DIFFERENT PROVIDER TYPES;
    ** prvdr number table in the inpatient resdac variable definitions;
        retain longterm_prvnum shrtterm_prvnum rehap_prvnum psych_prvnum cah_prvnum;
        if _N_=1 then do;
            longterm_prvnum =prxparse("/[0-9][0-9][2][012][0-9][0-9EF]/");
            shrtterm_prvnum =prxparse("/[0-9][0-9][0](([0-7][0-9][0-9EF])|(8[0-7][0-9EF]))/");
            cah_prvnum =prxparse("/[0-9][0-9][1][3][0-9][0-9EF]/");
            rehap_prvnum =prxparse("/[0-9][0-9][3][0](([2][5-9EF])|([3-9][0-9EF]))/");
            psych_prvnum =prxparse("/[0-9][0-9][4][0-4][0-9][0-9EF]/");
            end;

        is_longhosp=prxmatch(longterm_prvnum,&provider.);
        is_shorthosp=prxmatch(shrtterm_prvnum,&provider.);
        is_cah=prxmatch(cah_prvnum,&provider.);
        is_psychhosp=prxmatch(psych_prvnum,&provider.);
        is_rehabhosp=prxmatch(rehap_prvnum,&provider.);


        ** Note that some long term care hospitals can also be swing beds.;
        ** These are included as snfs.;
        if is_longhosp =1 and &ftypeVar. in ("W") then is_longhosp=0;
        if is_shorthosp =1 and &ftypeVar. in ("U","W","Y","Z") then is_shorthosp=0;

     *** DEAL WITH VARIABLE WHICH ARE CHANGING FROM NUMERIC TO CHARACTER;
            %if (&y. >= 2002 and &y. <= 2005) or
                (&y. >= 1992 and &y. <= 1995)
                %then %do;
        * These variabes in 2006 are characters, need to convert from numeric to characters.;
                &dest_cd.=put(strip(dstntncd_temp),2.0);
                %end;

        prvstate = input(substr(&provider.,1,2),2.0);
        prvnum3 = substr(&provider.,3,1);
        prvdrsrl = substr(&provider.,3,4);

    **Define SNFS;
        %if &y. >= 1984 and &y. <= 1986 %then %do;
                * The MedPAR documentation referenced above indicates that when the third digit of the;
                * provider number is a letter, it is shifted to the mpcode variable and replaced;
                * with a zero in the provider number.  This is why the third clause is required;
                * below.;
            is_snf = (prvnum3 = "5" or prvnum3 = "6" or (prvnum3 = "0" and &ftypeVar. in ("U","W","Y","Z") ) );
            %end;
        %else %if &y. >= 1987  %then %do;
                    ** SET SNF FLAG **;
            ** For years pre-2005, the MedPAR files contain an explicit flag that indicates whether;
            ** a visit is a SNF visit or a regular hospital visit.  This flag is variously called sslssnf,;
            ** mstay, and mfaclty, depending upon the file year.;
            ** ;
            ** For years 1984-1986, this flag does not exist, so I Examine the third digit of the provider;
            ** number to determine whether the discharge is from a regular hospital or a skilled nursing;
            ** facility.;
            ** Information on the meaning of different third digits is available from:;
            ** http://www.resdac.umn.edu/ddvh/Historical_Record_Layouts/Record_Layout_MedPAR_838.htm;
            ** ;
            ** This approach almost exactly reproduces the SNF/non-SNF indicator available for 1987-2005.;
            ** The only exceptions are 5 records in the 5 percent extracts for 1992 and 1993.  Here,;
            ** the records suggests that this is because CMS made a small error in data processing;
            ** That is, I think my indicator may be right and the CMS indicator wrong.  Nonetheless, I accept;
            ** the CMS indicator for these 5 records.;
            is_snf = (&snfvar. = "N");
            %end;
        **Redefine DRG CODES AND OTHERS;
        %if &file. ne indx  %then %do;
                *** DEAL WITH VARIABLE WHICH ARE CHANGING FROM NUMERIC TO CHARACTER;
            %if (&y. >= 2002 and &y. <= 2005) or
                (&y. >= 1992 and &y. <= 1995)
                %then %do;
        * These variabes in 2006 are characters, need to convert from numeric to characters.;
                &outlyer.=put(strip(outlr_cd_temp),1.0);
                &drg_code.=put(strip(drg_cd_temp),3.0);
                %end;
            %if &y. <= 2005 %then %do;
    *Corrects for digits with a 0 in front ;
                if length(&dest_cd.)=1 then &dest_cd.="0" || &dest_cd.;


                if length(&drg_code.)=1 then &drg_code.="00" || &drg_code.;
                if length(&drg_code.)=2 then &drg_code.="0" || &drg_code.;

                %end;
            %end;
    %mend;

