***********************************************************************;
** Import CrossWalk Files for the different files.;
***********************************************************************;
** NOTE THIS PROGRAM REQUIRES YOU READ IN THE FOLLOWING PROGRAMS;
**         1) %include ../dirInit.sas;
** Takes the raw text files with the variable name crosswalk and generates;
** a SAS dataset;
***********************************************************************;
** Maurice Dalton daltonm@nber.org, 11/30/2012 ;
***********************************************************************;

%macro readinopxw;
libname xwfile "&xwfile.";


**************************************************************************************;
******   CARRIER FILES;
**************************************************************************************;

** load files with macros that conform the files of various years into a common format;
data xwfile.opxw
                ;
                * MAKE SURE TO SAVE THE FILE IN TAB SEPERATED FORMAT WITH;
                infile "&xwfile./opxw.txt" delimiter='09'x MISSOVER DSD
        DSD lrecl=32767 firstobs=2 ;
            LENGTH
                        finalvar $20
                        key $20
                        labelvar $100
                        y1984 $20
                        y1985 $20
                        y1986 $20
                        y1987 $20
                        y1988 $20
                        y1989 $20
                        y1990 $20
                        y1991 $20
                        y1992 $20
                        y1993 $20
                        y1994 $20
                        y1995 $20
                        y1996 $20
                        y1997 $20
                        y1998 $20
                        y1999 $20
                        y2000 $20
                        y2001 $20
                        y2002 $20
                        y2003 $20
                        y2004 $20
                        y2005 $20
                        y2006 $20
                        y2007 $20
                        y2008 $20
                        y2009 $20
                        y2010 $20
                        y2011 $20
                        y2012 $20
                        lengthvar $20
                        character $20
                        fileVarIn $20
            ;

                input
                        finalvar $
                        key $
                        labelvar $
                        y1984 $
                        y1985 $
                        y1986 $
                        y1987 $
                        y1988 $
                        y1989 $
                        y1990 $
                        y1991 $
                        y1992 $
                        y1993 $
                        y1994 $
                        y1995 $
                        y1996 $
                        y1997 $
                        y1998 $
                        y1999 $
                        y2000 $
                        y2001 $
                        y2002 $
                        y2003 $
                        y2004 $
                        y2005 $
                        y2006 $
                        y2007 $
                        y2008 $
                        y2009 $
                        y2010 $
                        y2011 $
                        y2012 $
                        lengthvar $
                        character $
                        fileVarIn $
                        generated $
            ;
            run;

proc print data=xwfile.opxw;run;
%mend;

* define libraries;
%macro readincarrierxw;
libname xwfile "&xwfile.";


**************************************************************************************;
******   CARRIER FILES;
**************************************************************************************;

** load files with macros that conform the files of various years into a common format;
data xwfile.carrierxw
                ;
                * MAKE SURE TO SAVE THE FILE IN TAB SEPERATED FORMAT WITH;
                infile "&xwfile./carrierxw.txt" delimiter='09'x MISSOVER DSD
        DSD lrecl=32767 firstobs=2 ;
            LENGTH
                        finalvar $20
                        key $20
                        labelvar $100
                        y1984 $20
                        y1985 $20
                        y1986 $20
                        y1987 $20
                        y1988 $20
                        y1989 $20
                        y1990 $20
                        y1991 $20
                        y1992 $20
                        y1993 $20
                        y1994 $20
                        y1995 $20
                        y1996 $20
                        y1997 $20
                        y1998 $20
                        y1999 $20
                        y2000 $20
                        y2001 $20
                        y2002 $20
                        y2003 $20
                        y2004 $20
                        y2005 $20
                        y2006 $20
                        y2007 $20
                        y2008 $20
                        y2009 $20
                        y2010 $20
                        y2011 $20
                        y2012 $20
                        lengthvar $20
                        character $20
                        fileVarIn $20
            ;

                input
                        finalvar $
                        key $
                        labelvar $
                        y1984 $
                        y1985 $
                        y1986 $
                        y1987 $
                        y1988 $
                        y1989 $
                        y1990 $
                        y1991 $
                        y1992 $
                        y1993 $
                        y1994 $
                        y1995 $
                        y1996 $
                        y1997 $
                        y1998 $
                        y1999 $
                        y2000 $
                        y2001 $
                        y2002 $
                        y2003 $
                        y2004 $
                        y2005 $
                        y2006 $
                        y2007 $
                        y2008 $
                        y2009 $
                        y2010 $
                        y2011 $
                        y2012 $
                        lengthvar $
                        character $
                        fileVarIn $
                        generated $
            ;
            run;

proc print data=xwfile.carrierxw;run;
%mend;


** Import CrossWalk Files for the different files.;
** Maurice Dalton, daltonm.at.nber.org ;
**;

%macro readinmedparxw;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
**%include ../dirInit.sas;

* define libraries;
libname xwfile "&xwfile.";


**************************************************************************************;
******   CARRIER FILES;
**************************************************************************************;

** load files with macros that conform the files of various years into a common format;
data xwfile.medparxw
                ;
                * MAKE SURE TO SAVE THE FILE IN TAB SEPERATED FORMAT WITH;
                infile "&xwfile./medparxw.txt" delimiter='09'x MISSOVER DSD
        DSD lrecl=32767 firstobs=2 ;
            LENGTH
                        finalvar $20
                        key $20
                        labelvar $100
                        y1984 $20
                        y1985 $20
                        y1986 $20
                        y1987 $20
                        y1988 $20
                        y1989 $20
                        y1990 $20
                        y1991 $20
                        y1992 $20
                        y1993 $20
                        y1994 $20
                        y1995 $20
                        y1996 $20
                        y1997 $20
                        y1998 $20
                        y1999 $20
                        y2000 $20
                        y2001 $20
                        y2002 $20
                        y2003 $20
                        y2004 $20
                        y2005 $20
                        y2006 $20
                        y2007 $20
                        y2008 $20
                        y2009 $20
                        y2010 $20
                        y2011 $20
                        y2012 $20
                        lengthvar $20
                        character $20
                        fileVarIn $20
                        generated $3
            ;

                input
                        finalvar $
                        key $
                        labelvar $
                        y1984 $
                        y1985 $
                        y1986 $
                        y1987 $
                        y1988 $
                        y1989 $
                        y1990 $
                        y1991 $
                        y1992 $
                        y1993 $
                        y1994 $
                        y1995 $
                        y1996 $
                        y1997 $
                        y1998 $
                        y1999 $
                        y2000 $
                        y2001 $
                        y2002 $
                        y2003 $
                        y2004 $
                        y2005 $
                        y2006 $
                        y2007 $
                        y2008 $
                        y2009 $
                        y2010 $
                        y2011 $
                        y2012 $
                        lengthvar $
                        character $
                        fileVarIn $
                        generated $
            ;
            run;

proc print data=xwfile.medparxw;run;
%mend;

%macro readinipxw;
libname xwfile "&xwfile.";


**************************************************************************************;
******   CARRIER FILES;
**************************************************************************************;

** load files with macros that conform the files of various years into a common format;
data xwfile.ipxw
                ;
                * MAKE SURE TO SAVE THE FILE IN TAB SEPERATED FORMAT WITH;
                infile "&xwfile./ipxw.txt" delimiter='09'x MISSOVER DSD
        DSD lrecl=32767 firstobs=2 ;
            LENGTH
                        finalvar $20
                        key $20
                        labelvar $100
                        y1984 $20
                        y1985 $20
                        y1986 $20
                        y1987 $20
                        y1988 $20
                        y1989 $20
                        y1990 $20
                        y1991 $20
                        y1992 $20
                        y1993 $20
                        y1994 $20
                        y1995 $20
                        y1996 $20
                        y1997 $20
                        y1998 $20
                        y1999 $20
                        y2000 $20
                        y2001 $20
                        y2002 $20
                        y2003 $20
                        y2004 $20
                        y2005 $20
                        y2006 $20
                        y2007 $20
                        y2008 $20
                        y2009 $20
                        y2010 $20
                        y2011 $20
                        y2012 $20
                        lengthvar $20
                        character $20
                        fileVarIn $20
            ;

                input
                        finalvar $
                        key $
                        labelvar $
                        y1984 $
                        y1985 $
                        y1986 $
                        y1987 $
                        y1988 $
                        y1989 $
                        y1990 $
                        y1991 $
                        y1992 $
                        y1993 $
                        y1994 $
                        y1995 $
                        y1996 $
                        y1997 $
                        y1998 $
                        y1999 $
                        y2000 $
                        y2001 $
                        y2002 $
                        y2003 $
                        y2004 $
                        y2005 $
                        y2006 $
                        y2007 $
                        y2008 $
                        y2009 $
                        y2010 $
                        y2011 $
                        y2012 $
                        lengthvar $
                        character $
                        fileVarIn $
                        generated $
            ;
            run;

proc print data=xwfile.ipxw;run;
%mend;

