
*NOTE: THE CODE HERE USE THE FIRST OCCURANCE OF THE EHIC AND SIMPLY IGNORES THE CASES WHERE THERE;
*ARE DUPLICATE BENE_IDS FOR AN EHIC -- THIS SHOULD NOT BE OCCURING--. OVERALL THIS IMPACTS A VERY SMALL ;
*PORTION OF THE ENTIRE SAMPLE. SEE EHICBENEX_TWO_TO_N FOR THE EXCLUDED LIST;
%macro applycrosswalk(year=1984,libin=,filein=medpar,libout=,fileout=medpar,keepall=no, id=, pct=);
    %put ******************Crosswalk MACRO Begin *************************************************;
   ************************************************************************************************;
   ** PREP INCOMING DATA FOR MATHCIN GWITH CROSSWALK;
   ************************************************************************************************;

    %if &year.>=2006 %then %do;
        %let rawid=bene_id;
        %end;
    %if &year.<=2005 %then %do;
        %let rawid=ehic;
        %end;

    proc sort data=&libin..&filein. ;
        by &rawid.;
    run;

    proc sort data=&libin..&filein. out=keycw&year. (keep=&rawid. dgn_date diag_id ) nodupkey;
        by &rawid.;
    run;


    %if "&keepall"="no" %then %do  ;
        %let var=;
        %end;
    %if "&keepall"="yes" %then %do  ;
        %let var=,S.*;
        %end;

    %if &year<=2005 %then %do  ;
        ************************************************************************************************;
        ** INITIAL MATCH WITH CROSSWALK;
        ************************************************************************************************;
        proc sql;
            create table idList as
                select S.ehic, S.dgn_date, S.diag_id ,M.bene_id, M.count
                from keycw&year.  S LEFT JOIN spxw.ehicbenex_unique&pct.  M
                ON  (S.ehic = M.ehic);
            quit;

            %if "&id."="bene_id" %then %do;
            ************************************************************************************************;
            ** PREP DATA FOR SECONDARY MATCH;
            ************************************************************************************************;
            ** In the case of being interested in bene_id, we need to first match the pre-2005 to ehics.;
            ** Once we have all of the bene_ids. We need to go back through and merge all of the bene_ids ;
            **********************************************************************************************;
            data idList_fill;
                LENGTH ehic $15;
                set idList;
                if bene_id="" then do;
                    bene_id=ehic;
                    flagEmpBene=1;
                    end;
                if ehic="" then do;
                    ehic=bene_id;
                    end;
            run;

            ** Take bene_ids;
            proc sort data=idList_fill out=idList_uniBene(keep=bene_id dgn_date diag_id) nodupkey;
                by bene_id;
            run;

            ** Grab all bene_ids associated with an ehic;
            proc sql;
                create table beneListehic as
                    select S.bene_id,S.dgn_date, S.diag_id , M.ehic, M.count,M.hic_mtch &var.
                    from idList_uniBene  S LEFT JOIN spxw.ehicbenex_unique_bene_indx&pct.  M
                    ON  (S.bene_id = M.bene_id);
                quit;

             ** Grab all bene_ids associated with an ehic;
             data &libout..&fileout.;
                LENGTH ehic $15;
                set beneListehic;
                ** count value of -1 corresponds to the cases where there are more than one bene_id associated;
                ** with a single bene_id very small amount of cases. See CW_create.sas macro for ;
                **  information on how it was constructed. ;
                WHERE count ne -1;
                flagEmpBene=0;
                flagEmpehic=0;
               if bene_id="" then do;
                    bene_id=ehic;
                    flagEmpBene=1;
                    end;
                if ehic="" then do;
                    ehic=bene_id;
                    flagEmpehic=1;
                    end;
                *The variable count is created by counting the number of bene_id which occur;
                *for each ehic. In cases where no bene_id is found in the cw a missing value;
                *is generated. For these cases we set the count variable to 1, since we assume ;
                *there is a one to one match because we will use the ehic;
                if count=. then count=1;

            run;

            proc datasets lib=work;
                delete idList_fill idList idList_uniBene;
            run;
            %end;
        %else %if "&id."="ehic" %then %do;
            data &libout..&fileout.;
                LENGTH ehic $15;
                set idList;
                flagEmpBene=0;
                flagEmpehic=0;
                if bene_id="" then do;
                    bene_id=ehic;
                    flagEmpBene=1;
                    end;
                if ehic="" then do;
                    ehic=bene_id;
                    flagEmpehic=1;
                    end;
                *The variable count is created by counting the number of bene_id which occur;
                *for each ehic. In cases where no bene_id is found in the cw a missing value;
                *is generated. For these cases we set the count variable to 1, since we assume ;
                *there is a one to one match because we will use the ehic;
                count=1;
            run;


            proc datasets lib=work;
                delete idList;
            run;

            %end;
        %end;
    %if &year>=2006 %then %do;
        proc sql;
            create table beneList as
                select S.bene_id,S.dgn_date, S.diag_id , M.ehic ,M.count, M.hic_mtch  &var.
                from &libin..&filein  S LEFT JOIN spxw.ehicbenex_unique_bene_indx&pct.  M
                ON (S.bene_id = M.bene_id);
            quit;

        data &libout..&fileout.;
            LENGTH ehic $15;
            set beneList;
            flagEmpBene=0;
            flagEmpehic=0;
            if bene_id="" then do;
                bene_id=ehic;
                flagEmpBene=1;
                end;
            if ehic="" then do;
                ehic=bene_id;
                flagEmpehic=1;
                end;
                *The variable count is created by counting the number of bene_id which occur;
                *for each ehic. In cases where no bene_id is found in the cw a missing value;
                *is generated. For these cases we set the count variable to 1, since we assume ;
                *there is a one to one match because we will use the ehic;
                if count=. then count=1;

        run;

        proc datasets lib=work ;
            delete beneList ;
        run;
        %end;

       *****************************************************************************************************;
    ***After the crosswalk has been applied. We need to create a unique index and then;
    ** merge it back into the raw diagnosis extract.;
    **
    ** Note these conditional statements define what we will create a unique index based on.;
    ** EHIC CASE: it does not change over time since an ehic merge will be one-to-one with the;
    ** crosswalk(cw).;
    **            However,post 2006 the program will create duplicate observations;
    **            for the ehics because post 2006 data only has bene_ids and and bene_ids are ;
    **            a 1 to many match with ehics ;
    **;
    ** BENE_ID CASE: Since bene_id are not unique in the crosswalk (several ehics can;
    **               collapse into a single bene_id) collapsing into bene_ids may cause a loss;
    **               of some information when several ehics match to a single bene_id. We need;
    **               to be sure to grab all of the ehics associated with bene_id, not just;
    **               the one tagged with an index event. Merge with ehics before 2006 bc that ;
    **               what in the raw data;
    **;
    **               Post 2006 we will be merging with bene_ids since these are in the raw data
    **               therefore if we keep the many bene_id observations than we will get a M-M;
    **               merge when it is merged back in with the first round extract. This will;
    **               create duplicate observations. Since we are only interested in cases which;
    **               have a index event, we first drop duplicate bene_id and then merge back in;
    **               with the raw extracts.;
    **;
    ** It is important to realize that this code only processes a file year by year. So post 2006;
    ** The raw data only has bene_ids and no information is lost by riding oneself of duplicate;
    ** bene_ids with several ehics (for crosswalk purposes only), assuming we are interested in;
    ** bene_ids. The case differs when we are interested in the EHIC case although this ends up;
    ** creating some duplicate observations in the post 2006 data.;
    *********************************************************************************************;

    %if "&id."="bene_id" %then %do;
        %if &year.>=2006 %then %do;
            %let codeid=bene_id;
            %end;
        %if &year.<=2005 %then %do;
            %let codeid=ehic;
            %end;
        %end;
    %else %if "&id."="ehic" %then %do;
        %if &year.>=2006 %then %do;
            %let codeid=ehic;
            %end;
        %if &year.<=2005 %then %do;
            %let codeid=ehic;
            %end;
        %end;

    proc sort data= &libout..&fileout. out=unique&year. (keep=ehic dgn_date diag_id bene_id count) nodupkey;
        by &codeid.;
    run;

    proc sort data=unique&year. (keep=ehic dgn_date diag_id  bene_id count) ;
        by &rawid.;
    run;

    %mend;

*Example;
*%crosswalk(year=1984,libin=samp,filein=medpar,libout=work,fileout=medcw,pct=05);


