***********************************************************************;
** MACRO TO ARCHIVE OLD LOG FILES ;
***********************************************************************;
***!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!;
*** PLACE THE FOLLOWING AT LIBNAME AT BEGINING PROGRAM YOU CALL MACRO IN;
/**** libname here "."; */
***!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!;
%macro archiveoldLogfiles(pct=,cohrt=,dgnPos=,yearin=,yearout=,los=,note=);
**************************************************************************;
*******   FOR REDIRECTING LOG FILES    **********************;
**************************************************************************;
** Getting complete path and program name ;
    %let fullpath=%sysfunc(getoption(sysin));
    %put &fullpath.;

** Getting the program name only ;
    %let program=%scan(&fullpath.,-1,\/);
    %put &program.;

    *** PLACE THE FOLLOWING AT LIBNAME AT BEGINING PROGRAM YOU CALL MACRO IN;
    *** libname here quote . quote;
    %let pgmdir=%scan(&fullpath.,-1,&program.);
    %let pgmdir=%sysfunc(pathname(here));
    %put &pgmdir.;

** Removing the .sas ;
    %let prog=%scan(&program.,1,\.);
    %put &prog.;

** Making output directory if it does not exist ;
** Returns 1 if exists, 0 if DNE ;
    %if (%sysfunc(fileexist(&pgmdir./&prog.))=0 ) %then %do;
        x mkdir &pgmdir./&prog.;
        %end;

    **Put sas to sleep so timer can write out time to log file before copyuing;
    data _null_;
        x=sleep(100);
    run;
        *******************************************************************;
        ** Copy log files to subdirectory;
        **************************************************************************;
    x "cd &pgmdir.";
     x "rm  &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..log -f ";
     x "rm &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..lst -f ";

     x "cp &prog..log
           &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..log";
     x "cp &prog..lst
           &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..lst";

     x "bzip2 --best &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..log
                    &prog./&prog._&cohrt.&los._&pct._&yearin._&yearout._&dgnPos._&note.&sysdate..lst -f ";

    %mend;

*%archiveoldLogfiles(pct=05,cohrt=ami,dgnPos=1,yearin=66,yearout=22);
