** Setup Distance formulas **;
%global radEarth;
%global degPerRad;

* Radius of earth in miles (obtained from Google search: radius of earth in miles);
%let radEarth = 3963.1676;

* Number of degrees per radian (obtained from Google search: 1 radian in degrees);
%let degPerRad = 57.2957795;

* This macro implements the distance function recommended by the DD memo I received from Amitabh Chandra;
%macro CalcDist_AC(lat1=,long1=,lat2=,long2=);
&radEarth.*arcos(sin(&lat1./&degPerRad.)*sin(&lat2./&degPerRad.) + cos(&lat1./&degPerRad.)*cos(&lat2./&degPerRad.) *cos((&long1.-&long2.)/&degPerRad.))
    %mend;

* This macro implements the distance function recommended as having fewer numerical precision problems;
* on Wikipedia: http://en.wikipedia.org/wiki/Great-circle_distance;
%macro CalcDist_WP(lat1=,long1=,lat2=,long2=);
&radEarth.*2*arsin(sqrt((sin((&lat1.-&lat2.)/(2*&degPerRad.)))**2 + cos(&lat1./&degPerRad.)*cos(&lat2./&degPerRad.)*(sin((&long1.-&long2.)/(2*&degPerRad.)))**2))
    %mend;


