***********************************************************************;
** MACRO TO DECOMPRESS MEDPAR  FILES ;
***********************************************************************;
** NOTE THIS PROGRAM REQUIRES YOU READ IN THE FOLLOWING PROGRAMS;
**         1) UtilityMacros.sas;
** The programs uses the macro found within each file to run this program. ;
** all datasets are renamed to have the medpar&pct._&yr._all.sas7bdat name;
** Aggregates all parts into a single file.;
***********************************************************************;
** Maurice Dalton daltonm@nber.org, 11/30/2012
***********************************************************************;

%macro decompressMedPar(yr=,pct=,libout=,dirout=,dflag=,dataroot=);
    *********************************************************;
    ** DEFINE SOME NAME CHANGES;
    *********************************************************;
    %let root=&dataroot.;
    %let mtyp=med;
    *********************************************************;
    ** CHECK IF THE FILE EXIST: BEGIN PROCESSING IF IT DOESNT;
    *********************************************************;
    %if not %sysfunc(fileexist("&dirout./medpar&pct._&yr._all.sas7bdat*")) %then %do;
        x "rm &dirout./medpar&pct._&yr.* -f ";
        x "rm &dirout./med&pct._&yr._* -f ";
        %if &yr. <=2005  %then %do ;
            ** Medpar files only have one part in this time period;
            %decompress_i(spaceDir=&dirout.,dataRoot=&dataroot.,ftype=&mtyp.,pct=&pct.,year=&yr.,indx=1);
            *******************************************************;
            ** Accounts for name change during these years;
            *******************************************************;
            x "mv &dirout./med&pct._&yr._1.sas7bdat  &dirout./medpar&pct._&yr._1.sas7bdat  -f ";
            x "mv &dirout./medpar&pct._&yr._1.sas7bdat  &dirout./medpar&pct._&yr._all.sas7bdat  -f ";*/
            %end;
        %if &yr. >=2006 and &yr. <=2009  %then %do;
            %if &pct.= 0001 %then %do;
                %let numfile=1;
                %end;
            %else %do;
                %let numfile=100;
                %end;

            ********************************************************************************;
            ** Beginning in 2006, the medpar files are chunked into a 100 single files.;
            ********************************************************************************;
            %do z=1 %to &numfile.;
                %decompress_i(spaceDir=&dirout.,dataRoot=&dataroot.,ftype=&mtyp.,pct=&pct.,year=&yr.,indx=&z.);
                ********************************************************************************;
                ** Append part to base after decompressing --(keep=&rawvarlist.);
                ********************************************************************************;
                proc append base=&libout..medpar&pct._&yr.  data=&libout..&mtyp.&pct._&yr._&z.  force;
                run;
                ********************************************************************************;
                ** REMOVE PARTS NO LONGER USED;
                ********************************************************************************;
                x "rm &dirout./med&pct._&yr._&z..sas7bdat -f";

                %end;
                x "rm &dirout./med&pct._&yr._* -f";
                x "mv &dirout./medpar&pct._&yr..sas7bdat  &dirout./medpar&pct._&yr._all.sas7bdat  -f ";
                %end ;
            ********************************************************************************;
            ** Rename file and drop unused data;
            ********************************************************************************;
            x "rm &dirout./medpar&pct._&yr._1.sas7bdat.bz2 -f"
            x "rm &dirout./med&pct._&yr._* -f"
            %end;
        %if &yr. >=2010 %then %do;
            %if not %sysfunc(fileexist("&dirout./medpar&pct._&yr._all.sas7bdat")) %then %do;
                x "rm &dirout./medpar&pct._&yr..* -f ";
                x "cp &dataroot./&pct.pct/med/&yr/med&yr..sas7bdat &dirout./med&yr..sas7bdat -f ";
                x "mv &dirout./med&yr..sas7bdat &dirout./medpar&pct._&yr._all.sas7bdat -f ";
                x "rm &dirout./med&yr..* -f ";
                %end;
            %end;
    %mend;
