%macro generateEnrollRest(indxDateVar=,end=,start=,FFSmonthpost=,HMOmonthpost=,FFSmonthpre=,HMOmonthpre=);
     ** Look for continuous traditional Medicare (A & B, ) enrollment before and after diag **;
    ***************************************************************************;
    ** A four in the denominator files means that the individual was enrolled;
    ** in a CHRONIC CARE DISEASE MANAGEMENT ORGANIZATIONS-FFS PLAN CCDMO still;
    ** files claims under the FFS. Based on email correspondence with ResDAC;
    ** these organizations claims will still occur in the claims files;
    ** CCDMO was part of a pilot program CMS used to identify subgroups of;
    ** patients which could benefit from the program. Ran for 3 years.;
    **************************************************************************;

    ** set up arrays to work with enrollment variables;
    ** The first month in the start data is designated month 1, and the;
    ** last month in end year is designated N. ;
    array aentitl&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.{%eval(12*(&end.-&start.+1))} %GenYM(buyin,&start.,&end.);
    array ahmo&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.{%eval(12*(&end.-&start.+1))} %GenYM(hmoind,&start.,&end.);
        ** diagmonth is the month number of the indx event. Its the origin around which;
        ** enrollment will be defined. As defined by the above arrays ;
        ** its a frunction of your start and end date;
    diagmonth = (year(&indxDateVar.) - &start.)*12 + month(&indxDateVar.);
        if (year(&indxDateVar.) < &start.) then do;
            eHMO_pre&HMOmonthpre. = 0;
            eFFS_pre&FFSmonthpre. = 0;
            end;
        else do;
            eHMO_pre&HMOmonthpre. = 1;
            eFFS_pre&FFSmonthpre. = 1;
***********************************************;
*** PRE-CHECK;
***********************************************;
    *************************************;
    *** Entitlement;
    *************************************;
    **CHECK ENDPOINTS OF WINDOW ARE INSIDE THE WINDOW BEING STUDIED;
    if diagmonth-&FFSmonthpre.>0 then do;
        do m=diagmonth-&FFSmonthpre. to diagmonth;
            eFFS_pre&FFSmonthpre. = eFFS_pre&FFSmonthpre. and
                (aentitl&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "3" or aentitl&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "C" );
            end;
        end;
    ** If elment cannont be checked in the window being studied;
    ** then assumed no cont enrollemnt;
    if diagmonth-&FFSmonthpre.<=0 then do;
        eFFS_pre&FFSmonthpre. = 0 ;
        end;

    *************************************;
    *** HMO BEFORE:: DEFINE HMO MONTHS ;
    *************************************;
    if diagmonth-&HMOmonthpre. >0 then do;
        do m=diagmonth-&HMOmonthpre. to diagmonth;
            eHMO_pre&HMOmonthpre. = eHMO_pre&HMOmonthpre. and
                (ahmo&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "0" or ahmo&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "4" ) ;
            end;
        end;
    ** If elment cannont be checked in the window being studied;
    ** then assumed no cont enrollemnt;
    if diagmonth-&HMOmonthpre. <= 0 then do;
        eHMO_pre&HMOmonthpre. = 0;
        end;
    end;

***********************************************;
*** AFTER CHECK;
***********************************************;
    if (year(&indxDateVar.) > &end.) or (year(&indxDateVar.) < &start.)
        then do;
        eHMO_post&FFSmonthpost. = 0;
        eFFS_post&HMOmonthpost. = 0;
        end;
    else do;
        eHMO_post&FFSmonthpost. = 1;
        eFFS_post&HMOmonthpost. = 1;

    *************************************;
    *** ENTITLEMENT AFTER :: DEFINE ENTITLEMENT;
    *************************************;
    * Calculate the number of months over which to Examine enrollment;
    * In particular, do not search after death;
    if (sdod ne .) then deathmonth = (year(sdod) - &start.)*12 + month(sdod);
    **SPECIAL CASE 1:: INDIVIDUALS WHO DIED THE YEAR THEY HAD INDX EVENT;
    if (sdod ne .) and
        (( deathmonth >= diagmonth ) and (deathmonth - diagmonth < &FFSmonthpost.)) then do;
        monthsAheadFFS = deathmonth - diagmonth;
        end;
    else do;
        monthsAheadFFS = &FFSmonthpost.;
        end;
    eFFS_post&FFSmonthpost. = 1;
    **SPECIAL CASE 2:: POSSIBLE TO CHECK ENROLMENT GIVEN WINDOW AND START END YEAR ;
    if diagmonth + monthsAheadFFS <= (&end.-&start.+1)*12 then do;
        do m=diagmonth to (diagmonth + monthsAheadFFS);
            eFFS_post&FFSmonthpost. = eFFS_post&FFSmonthpost.
                and
                (aentitl&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "3" or aentitl&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "C");
            end;
        end;
   **SPECIAL CASE 3:: NOT POSSIBLE TO CHECK WINDOW - ASSUME NO ENROLLMENT;
    ** Includes individuals falling outside study window, for example because of ;
    ** errant coding ;
    ** Also ignore individuals who died within  X months of the end point of the study;
    ** because its impossible for them to have X months of post enrollment - because the
    ** study period ends;
    if (diagmonth + monthsAheadFFS > (&end.  - &start. + 1 ) * 12 ) or
       (diagmonth + &FFSmonthpost. > (&end. - &start. + 1 ) * 12 ) then do;
        eFFS_post&FFSmonthpost.=0;
        end;

    *************************************;
    *** HMO AFTER:: DEFINE HMO MONTHS ;
    *************************************;
    **SPECIAL CASE 1:: INDIVIDUALS WHO DIED THE YEAR THEY HAD INDX EVENT;
    if (sdod ne .) and
        (( deathmonth >= diagmonth ) and (deathmonth - diagmonth < &HMOmonthpost.)) then do;
        monthsAheadHMO = deathmonth - diagmonth;
        end;
    else do;
        monthsAheadHMO = &HMOmonthpost.;
        end;

    eHMO_post&HMOmonthpost. = 1;
    **SPECIAL CASE 2:: POSSIBLE TO CHECK ENROLMENT GIVEN WINDOW AND START END YEAR ;
    if diagmonth + monthsAheadHMO <= (&end.-&start.+1)*12 then do;
        do m=diagmonth to (diagmonth + monthsAheadHMO);
            eHMO_post&HMOmonthpost. = eHMO_post&HMOmonthpost.
                and
                (ahmo&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "0" or ahmo&FFSmonthpost.&FFSmonthpre.&HMOmonthpost.&HMOmonthpre.(m) = "4" );
            end;
        end;
    **SPECIAL CASE 3:: NOT POSSIBLE TO CHECK WINDOW - ASSUME NO ENROLLMENT;
    ** Includes individuals falling outside study window, for example because of ;
    ** errant coding ;
    ** Also ignore individuals whose indx event are within  X months of the end point of the study;
    ** because its impossible for them to have X months of post enrollment ;
    if (diagmonth + monthsAheadHMO > (&end. - &start. + 1 ) * 12 ) or
       (diagmonth + &HMOmonthpost. > (&end. - &start. + 1 ) * 12 ) then do;
        eHMO_post&HMOmonthpost.=0;
        end;
    end;
    %mend;

