%macro splitindxfiles(cohrt=,begin=, end=,pct=,outlib=,indxlib=,winyear=);
    *ALL DATA HAS BEEN TRANSFORMED INTO BENE_ID -- NO NEED TO PROCESS DATA;
    proc freq data=&indxlib..&cohrt.&pct._indx ;
        WHERE bene_id="";
        by diag_year;
    run;

    proc sort data=&indxlib..&cohrt.&pct._indx ;
        by diag_id;
    run;

    *When splitting the index files, we need to make sure to have all ehics which are mapped to a singel bene_id abailable.;
    data %RepeatN(&outlib..Samp&cohrt.,&begin.,&end.) (drop=fileyear);
        set &indxlib..&cohrt.&pct._indx (keep=bene_id  dgn_date diag_id fileyear);
        by diag_id;
        %do splityear=&begin. %to &end.;
            if ((year(dgn_date) >= %sysevalf(&splityear. - &winyear.)) and
               (year(dgn_date) <= %sysevalf(&splityear. + &winyear.))) or
                       ( abs(year(dgn_date)-fileyear) >=2 )   then do;
                if last.diag_id then output &outlib..Samp&cohrt.&splityear.;
                end;
            %end;
run;

    %mend;
