*This a macro to draw a random sample of the data to work with the data ;
%macro takerandomsample(fromdata =, idvar=, dataout=, srate=);
    proc sql;
        create table _ids as
            select distinct &idvar
            from &fromdata;
        quit;

* Select sample;
    proc surveyselect data = _ids method= SRS rep= 1 samprate= &srate
        seed = 12345 out = _sampled;
    run;

* Get data;
    proc sql;
        create table &dataout as
            select *
            from &fromdata
            where &idvar in (select &idvar from _sampled);
        quit;
    %mend takerandomsample;

