//******************************************************************;
//**!!!!!!!!!!!! START - USER INPUT - START  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;
// Define the root directory to which all extracts will be output too;
// The following program will define directories for you;
global rootoutputDir agebulk3
// Define the root directory to which the code can be found. ;
// For example the directory this file is sitting in.;
global programRoot /disk/agedisk1/medicare.work/wise-DUA16702/daltonm/Medicode

// used to generate space directories. For example mine would be;
global DUAfolder wise-DUA16702
//
global projectName medicode
//**!!!!!!!!!!!! END - USER INPUT - END  !!!!!!!!!!!!!!!!!!!!!!!!!!!**;
//*******************************************************************;

/// Master Stata directory log.
//// READ IN SERVER
! rm ~/readgit.txt -f
! uname -n > ~/readgit.txt

file open servername using "~/readgit.txt", read
file read servername line
while r(eof)==0 {
   global sname `line'
   file read servername line
   }

forvalues i=1/50 {
    if "$sname" =="age`i'"{
        global spacedrv agescratch`i'
    }
}
file close servername
! rm ~/readgit.txt -f

//// READ IN USER
! rm ~/readgit.txt -f
! whoami > ~/readgit.txt

file open whoami using "~/readgit.txt", read
file read whoami line
while r(eof)==0 {
   global username `line'
   file read whoami line
    }
file close whoami
! rm ~/readgit.txt -f


di "USERNAME::$username"
di "SERVER::$sname -SPACE :: $spacedrv"

global spaceroot "/disk/$rootoutputDir/medicare.work/$DUAfolder/$username/$projectName/scratch"
di  "$spaceroot"
global tmproot "/tmp/$username/medicare.work/$DUAfolder/$projectName"
di  "$tmproot"
global rootout "/disk/$rootoutputDir/medicare.work/$DUAfolder/$username/$projectName"
di  "$spaceroot"

/// Raw Extract -- DATA IN
global indexExt "$rootout/1PrimaryExtract/indx"
global medExt "$rootout/1PrimaryExtract/medpar"
global carExt "$rootout/1PrimaryExtract/car"
global opExt "$rootout/1PrimaryExtract/op"

global costs "$rootout/2SecondManiOut/costs/"
global comorbid "$rootout/2SecondManiOut/comorbid/"
global proc "$rootout/2SecondManiOut/proc/"

global exhcris "$rootout/0preProcess/hcris"
global expos "$rootout/0preProcess/pos"
global inpos "/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/pos"
global inHRRzipxw "$rootout/0preProcess/HRRxw"
! mkdir -p $inpos
! mkdir -p $inHRRzipxw
global HRRexcelxw "/disk/aging/medicare/code/AuxData/HRRxw"


/// Cost utilization directories--MAKE SURE IT MATCHE COSTUTIL IN SAS FILE
  global carRVU  "$rootout/2SecondManiOut/costutil/car"
  global costutil  "$rootout/2SecondManiOut/costutil"
! mkdir -p $carRVU
/// State crosswalk file for
global statexw "$programRoot/Auxiliary"


///SPACE DRIVE
global spstat "$spaceroot/3stats"
! mkdir -p $spstat


global texroot "$programRoot/tex_stats"

***************************************************************************************;
**COST UTILIZATION PROGRAMS-INPUT FILES INCLUDED WITH THE SAS PACK;
***************************************************************************************;
* define libraries that allow access to the various directories specified above;
* THESE FILES ARE FOUND ON THE NBER SERVERS;
global APCdir "/disk/aging/medicare/code/AuxData/costUtilizationWeights/OPPS_APCweights"
global DRGdir "/disk/aging/medicare/code/AuxData/costUtilizationWeights/AIPPS_drgweights"
global PFSdir "/disk/aging/medicare/code/AuxData/costUtilizationWeights/PFS_rvuweights/fromMatFiedler_NivSubramanian"



! mkdir -p $carCost
! mkdir -p $medparCost
! mkdir -p $OPCost
! mkdir -p $outCost
! mkdir -p $sumStatout
! mkdir -p $HRRout

