**********************************************************************;
****!!!!!!!!!!!! START - USER INPUT - START  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;
** Define the bulk drive you want to write out too;
%global rootoutputDrive;
%let rootoutputDrive=agedisk2;\

** Define DUA PI, last name  and NUMBER, used for reference to folder on the filesystem;
%let DUAfolder=chandra-DUA21441;
** Define a unique name for these results, whatever you want, e.g., amitrend;
%let projectName=doctors1998to2011;
** Define the root directory to which the code can be found. ;
** For example the directory this file is sitting in.;
%global programRoot;
%let programRoot=/disk/agebulk11/medicare.work/chandra-DUA21441/oostromt/oostromt-team/trunk/raw/Medicare Claims 1998-2011 (20 pct)/code;
****!!!!!!!!!!!! END - USER INPUT - END  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;


***************************************************************************************;
******** GET THE LATEST CODE TAG TO SAVE FILES, CHECK WHICH SERVER AND LOOK WHO IS RUNNING CODE****;
**************************************************************************************;
** used below to build directories.;
* directory where extracts are written ;
filename whoami pipe "whoami";
  data getusername;
      infile whoami lrecl=162  missover pad;
      length username $10;
      ** Inputting whole STDOUT line *;
      input username;
      call symputx('username',username);
  run;

  %put RUNNING USERNAME: &username.;

* directory where extracts are written ;
filename brnch pipe "git name-rev HEAD | sed --quiet 's/HEAD \(.*\)/\1/p'";

  data branch;
      infile brnch lrecl=162  missover pad;
      length branch $25;
      ** Inputting whole STDOUT line *;
      input branch;
      call symputx('branch',branch);
  run;

  %put RUNNING BRANCH: &branch.;


* directory where extracts are written ;
filename psetenv pipe "git tag";

  data versionid;
      infile psetenv lrecl=162  missover pad;
      length versionid $6;
      ** Inputting whole STDOUT line *;
      input versionid;
      call symputx('vid',versionid);
  run;

  %put RUNNING CODE VERSION: &vid.;

  * find wich server your running on;
filename sname pipe "uname -n";
* NO LONGER USED BECAUSE OF THE UPGRADE TO THE SYSTEMS;
data sname;
      infile sname lrecl=162  missover pad;
      length sname $10;
      ** Inputting whole STDOUT line *;
      input sname;
      if sname="agesas1" then spacedrv="agesasscratch1";
      if sname="agesas2" then spacedrv="agesasscratch2";
      if sname="agesas3" then spacedrv="agesasscratch3";
      call symputx('spacedrv',spacedrv);
  run;

  %put RUNNING CODE ON SERVER: &spacedrv.;


****!!!!!!!!!!!!!BUiLD ROOT DIRECTORIES!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;
%let spaceloc=/disk/&rootoutputDrive/medicare.work/&DUAfolder./&username./&projectName./scratch;
** Temp files will be placed on the local tmp drive. ;
** should have alot of space, will be deleted at the end. Will however store;
** intermediate files here before merging;
%let tmprootDir=/tmp/&username./medicare.work/&DUAfolder./&projectName.;
** Build from the user defined quantities above and user characteristics;
%let rootoutputDir=/disk/&rootoutputDrive/medicare.work/&DUAfolder./finkels-team/MedicareExtract/&projectName.;
***************************************************************************************;
***OUTPUT DIRECTORIES -- DIRECTORIES WILL BE GENERATE BY THE PROGRAM;
***************************************************************************************;
  %global  reports;
** MAIN EXTRACTS;
%let medparExt=&rootoutputDir./1PrimaryExtract/medpar;
%let carExt=&rootoutputDir.//1PrimaryExtract/car;
%let opExt=&rootoutputDir./1PrimaryExtract/op;
%let ipExt=&rootoutputDir./1PrimaryExtract/ip;
%let deninExt=&rootoutputDir./1PrimaryExtract/denominator;
%let indxExt=&rootoutputDir./1PrimaryExtract/indx;


** MANIPULATION EXTRACTS ---ran on Main Extracts;
%let proc=&rootoutputDir./2SecondManiOut/proc;
%let costs=&rootoutputDir./2SecondManiOut/costs;
%let comorb=&rootoutputDir./2SecondManiOut/comorbid;
%let costutil=&rootoutputDir./2SecondManiOut/costutil;
%let carRVU=&rootoutputDir./2SecondManiOut/costutil/car;
* directory where reports can be written;
%let reports =&rootoutputDir./3reports/;

***DEFINE TEMP DIRECTORIERS --THESE WILL BE PUSHED TO THE PUBLIC SITE;
* directory with the harmonized denom files already generated:: PREPROCESSED ;
*%let denext =&rootoutputDir./0preProcess/masterDenomFiles;
%let denext =&spaceloc./0preProcess/masterDenomFiles;
* directory with the harmonized xw files already generated ::PREPROCESSED ;
%let xwext =&rootoutputDir./0preProcess/benexw;
* directory with the HRR/HSA Dartmouth XW files already generated ::PREPROCESSED ;
%let HRRext =&rootoutputDir./0preProcess/HRRxw;
* directory with the FORMATED POS FILES  already generated ::PREPROCESSED ;
%let POSext =&rootoutputDir./0preProcess/pos;
%let geoex=&rootoutputDir./0preProcess/geoex;
%let exhcris=&rootoutputDir./0preProcess/hcris;

x "mkdir &carRVU. -p";
x "mkdir &exhcris. -p";
x "mkdir &geoex. -p";
x "mkdir &POSext. -p";
x "mkdir &HRRext. -p";
x "mkdir &xwext. -p";
x "mkdir &deninExt. -p";
x "mkdir &denext. -p";
x "mkdir &indxExt. -p";

** Create version ID file;
x "mkdir &medparExt. -p";
x "mkdir &carExt. -p";
x "mkdir &opExt. -p";
x "mkdir &ipExt. -p";
x "mkdir &proc. -p";
x "mkdir &costs. -p";
x "mkdir &comorb. -p";
x "mkdir &reports. -p";
x "mkdir &costutil. -p";

***************************************************************************************;
***SPACE / LOCAL DIRECTORIES DIRECTORIES --NEW USERS NO NEED TO CHANGE THESE UNLESS YOU WANT TO CHANGE DIRECTORY;
***************************************************************************************;
* directory to which data should be decompressed;
%global  sphcris;
%global  spop;
%global  spden;
%global  spmed;
%global  spcar;
%global  spxw;
%global  spcost;
%global  spip;


* directory to which data should be decompressed;
***DEFINE AGESAS1 TEMP;
%let  sphcris=&spaceloc./pos;
%let  sppos=&spaceloc./pos;
%let  spmed=&spaceloc./medpar;
%let  spip=&spaceloc./ip;
%let  spop=&spaceloc./op;
%let  spden=&spaceloc./denom;
%let  spcar=&spaceloc./car;
%let  spxw=&spaceloc./spacexw;
%let  spcost=&spaceloc./costutil;

** Create directories in space drive;

    x "mkdir &sphcris. -p";
    x "mkdir &sppos. -p";
    x "mkdir &spip. -p";
    x "mkdir &spmed. -p";
    x "mkdir &spop. -p";
    x "mkdir &spcar. -p";
    x "mkdir &spden. -p";
    x "mkdir &spxw. -p";
    x "mkdir &spcost. -p";

%global indxerz;
%global mederz;
%global carerz;
%global operz;
%global denerz;
%global iperz;

%let indxerz=&spaceloc./indx/TempErase;
%let mederz=&spaceloc./medpar/TempErase;
%let carerz=&spaceloc./car/TempErase;
%let operz=&spaceloc./op/TempErase;
%let iperz=&spaceloc./ip/TempErase;
%let denerz=&spaceloc./denom/TempErase;


** Create directories in space drive;
x "mkdir &indxerz. -p";
x "mkdir &mederz. -p";
x "mkdir &carerz. -p";
x "mkdir &operz. -p";
x "mkdir &iperz. -p";
x "mkdir &denerz. -p";


***************************************************************************************;
***TEMPFILES -- DIRECTORIES WILL BE GENERATE BY PROGRAM;
***************************************************************************************;
* directory where temporary files can be written;
%let cartmp=&tmprootDir./tempextracts/car;
%let optmp=&tmprootDir./tempextracts/op;
%let medtmp=&tmprootDir./tempextracts/med;
%let iptmp=&tmprootDir./tempextracts/ip;

**Creates directory if it does not exist;
    x "mkdir &optmp. -p";
    x "mkdir &iptmp. -p";
    x "mkdir &cartmp. -p";
    x "mkdir &medtmp. -p";

***************************************************************************************;
****USED GLOBABLY/INPUT DIRECTORIES;
***************************************************************************************;
***************************************************************************************;
****FILES GENERATED INHOUSE AT THE NBER TO SPEED PROCESSING;
**************************************************************************************;
* directory with the harmonized denom files already generated:: PREPROCESSED ;
%let inden =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/masterDenomFiles;
*%let inden =&denext.;
x "mkdir &inden. -p";
* directory with the harmonized xw files already generated ::PREPROCESSED ;
%let inbenexw =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/benexw;
x "mkdir &inbenexw. -p";
* directory with the HRR/HSA Dartmouth XW files already generated ::PREPROCESSED ;
%let inHRRzipxw =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/HRRxw;
x "mkdir &inbenexw. -p";

* directory with the FORMATED POS FILES  already generated ::PREPROCESSED ;
%let inPOS =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/pos;
x "mkdir &inPOS. -p";
%let ingeoLoc =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/provGeo;
x "mkdir &ingeoLoc. -p";

* directory with the SAS macros -- downloaded with SAS pack ;
%let SASmac =&programRoot./SASmacros;

* data root directory of the directory hierarchy containing the NBER claims data collection;
* let dataRoot = /disk/agedisk1/medicare/data.NOBACKUP/u/c;
%let dataRoot = /disk/aging/medicare/data;

* raw bene_id Crosswalk found here on the servers;
%let beniroot= &dataRoot./100pct/xw;

* directory with CC/ICD9-CM mappings;
* Included in the downloaded sas pak.;
%let CC =&programRoot./2SecondaryManipPrgms/comorbid/CC;

* Raw provder files live here;
%let providerDir= /homes/data/pos;

%let xwfile=&programRoot./claim_xw;

***************************************************************************************;
**COST UTILIZATION PROGRAMS-INPUT FILES INCLUDED WITH THE SAS PACK;
***************************************************************************************;
*define libraries that allow access to the various directories specified above;
* THESE FILES ARE FOUND ON THE NBER SERVERS;
%let APCdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/OPPS_APCweights;
%let DRGdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/AIPPS_drgweights;
%let PFSdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/PFS_rvuweights/fromMatFiedler_NivSubramanian;

***************************************************************************************;
**** DIRECTORIES SPECIFIC TO THE PROVIDER GEOCODING SUBPROJECT;
**************************************************************************************;
%let ingnis=/disk/aging/medicare/code/AuxData/providerGeoCodingPrj/GNIS;

***************************************************************************************;
**** DIRECTORIES SPECIFIC TO VIEWS;
**************************************************************************************;
*** These SAS views are basically compiled sas code which harmonizes the raw sas files.;
*** The are generated with the 0PreProcess/rawviews sas code and are stored on the NBER ;
*** for ease of use  ;


%let medvw=/disk/aging/medicare/code/ExtData/views/v4.70/ALL/medpar;
%let opvw=/disk/aging/medicare/code/ExtData/views/v4.70/ALL/op;
%let carvw=/disk/aging/medicare/code/ExtData/views/v4.70/ALL/car;
%let ipvw=/disk/aging/medicare/code/ExtData/views/v4.70/ALL/ip;

%let medvw4e=/disk/aging/medicare/code/ExtData/view4extract/v4.70/ALL/medpar;
%let opvw4e=/disk/aging/medicare/code/ExtData/view4extract/v4.70/ALL/op;
%let carvw4e=/disk/aging/medicare/code/ExtData/view4extract/v4.70/ALL/car;
