********************************************************************************;
**     MACRO:  Decompresses the &pct.denom files for the years where they exist.;
**  NO LONGER USING;
********************************************************************************;

%macro notusingDecompressDenom(yr=,pct=);

    %if &yr.<=2005 %then %do;
        %let dtyp=den;
        %end;

    %else %if &yr.>=2009 %then %do;
        %let dtyp=bsf;
        %end;
    %else %if &yr.>=2006 and &yr.<=2008 %then %do;
        %let dtyp=den;
        %end;
    %if &yr. >= 1992 %then %do;
		** Determines the number of parts each file has for Denom files;
		%DetermineMax(datadir=&dataroot.,pct=&pct,ftype=&dtyp.,year=&yr.,subtype=,pctsuffix=);
		%do z=1 %to &num_file.;
			%decompress_i(spaceDir=&spden.,dataRoot=&dataRoot.,ftype=&dtyp.,pct=&pct.,year=&yr.,indx=&z.);
			proc append base=outDen.denom&pct._&yr.
						data=spDenom.&dtyp.&pct._&yr._&z. force;
			run;
			x "rm &spden./&dtyp.&pct._&yr._&z.* -f ";
		%end;
	%end;
%mend;

***************************************************************************;
**     MACRO:  Generate Sample for Given Year;
***************************************************************************;
%macro genSample(data=, year=,count=);
    data nomove_&year.;
	set outDen.moverIndex;
        if year=&year.;
        if mover=0;
    run;

    proc surveyselect data=nomove_&year. method=srs n=&count. seed=7190 out=outDen.nomove_&year.;
    run;

    proc sort data=outDen.nomove_&year.;
        by bene_id;
    run;

    proc sort data=outDen.denom20_nomove;
        by bene_id;
    run;

    data outDen.nomove_&year;
        merge outDen.nomove_&year. (in=samp) outDen.denom20_nomove;
        by bene_id;
        if samp;
    run;
%mend;


