**********************************************************************;
****!!!!!!!!!!!! START - USER INPUT - START  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;
**Define the root directory to which tmp  extracts will be output too;
** should have alot of space, will be deleted at the end. Will however store;
** intermediate files here before merging;
%let tmprootDir=/disk/agebulk11/medicare.work/finkels-DUA22559/oostromt/;
** Define the root directory to which all extracts will be output too;
** The following program will define directories for you;
%global rootoutputDir;
%let rootoutputDir=/disk/agedisk2/medicare.work/finkels-DUA22559/finkels-team/MedicareExtract/;
** Define the root directory to which the code can be found. ;
** For example the directory this file is sitting in.;
%global programRoot;
%let programRoot=/disk/agebulk11/medicare.work/finkels-DUA22559/oostromt/oostromt-team/trunk/raw/Provider of Service/code/;

** used to generate space directories. For example mine would be;
** PUT YOUR DUA FOLDER HERE. USSUALLY THE PI LAST NAME + DUA-NUMBER;
%let DUAfolder=finkels-DUA22559;

%let projectName=movers;
****!!!!!!!!!!!! END - USER INPUT - END  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;

***************************************************************************************;
******** GET THE LATEST CODE TAG TO SAVE FILES ************;
**************************************************************************************;
* directory where extracts are written ;
filename whoami pipe "whoami";
  data getusername;
      infile whoami lrecl=162  missover pad;
      length username $10;
      ** Inputting whole STDOUT line *;
      input username;
      call symputx('username',username);
  run;

  %put RUNNING USERNAME: &username.;

  *%let vid=;

****!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****************;
%let spaceloc=/disk/agebulk11/medicare.work/&DUAfolder./&username/movers;

***************************************************************************************;
***OUTPUT DIRECTORIES -- DIRECTORIES WILL BE GENERATE BY THE PROGRAM;
***************************************************************************************;
  %global  reports;
** MAIN EXTRACTS;
%let medparExt=&rootoutputDir./&projectName./1PrimaryExtract/medpar;
%let carExt=&rootoutputDir./&projectName./1PrimaryExtract/car;
%let opExt=&rootoutputDir./&projectName./1PrimaryExtract/op;
%let ipExt=&rootoutputDir./&projectName./1PrimaryExtract/ip;
%let denExt=&rootoutputDir./&projectName./1PrimaryExtract/denominator;
%let indxExt=&rootoutputDir./&projectName./1PrimaryExtract/indx;


** MANIPULATION EXTRACTS ---ran on Main Extracts;
%let proc=&rootoutputDir./&projectName./2SecondManiOut/proc;
%let costs=&rootoutputDir./&projectName./2SecondManiOut/costs;
%let comorb=&rootoutputDir./&projectName./2SecondManiOut/comorbid;
%let costutil=&rootoutputDir./&projectName./2SecondManiOut/costutil;
%let carRVU=&rootoutputDir./&projectName./2SecondManiOut/costutil/car;
* directory where reports are written;
%let reports =&rootoutputDir./&projectName./3reports/;

***DEFINE TEMP DIRECTORIERS --THESE WILL BE PUSHED TO THE PUBLIC SITE;
* directory with the HRR/HSA Dartmouth XW files already generated ::PREPROCESSED ;
%let HRRext =&rootoutputDir./&projectName./0preProcess/HRRxw;
* directory with the FORMATED POS FILES  already generated ::PREPROCESSED ;
%let POSext =&rootoutputDir./&projectName./0preProcess/pos;
%let geoex=&rootoutputDir./&projectName./0preProcess/geoex;
%let exhcris=&rootoutputDir./&projectName./0preProcess/hcris;

x "mkdir &carRVU. -p";
x "mkdir &exhcris. -p";
x "mkdir &geoex. -p";
x "mkdir &POSext. -p";
x "mkdir &HRRext. -p";
x "mkdir &denext. -p";
x "mkdir &indxExt. -p";

** Create version ID file;
x "mkdir &medparExt. -p";
x "mkdir &carExt. -p";
x "mkdir &opExt. -p";
x "mkdir &ipExt. -p";
x "mkdir &proc. -p";
x "mkdir &costs. -p";
x "mkdir &comorb. -p";
x "mkdir &reports. -p";
x "mkdir &costutil. -p";

***************************************************************************************;
***SPACE / LOCAL DIRECTORIES DIRECTORIES --NEW USERS NO NEED TO CHANGE THESE UNLESS YOU WANT TO CHANGE DIRECTORY;
***************************************************************************************;
* directory to which data should be decompressed;
%global  sphcris;
%global  spop;
%global  spden;
%global  spmed;
%global  spcar;
%global  spxw;
%global  spcost;
%global  spip;


* directory to which data should be decompressed;
***DEFINE AGESAS1 TEMP;
%let  sphcris=&spaceloc./pos;
%let  sppos=&spaceloc./pos;
%let  spmed=&spaceloc./medpar;
%let  spip=&spaceloc./ip;
%let  spop=&spaceloc./op;
%let  spden=&spaceloc./denom;
%let  spcar=&spaceloc./car;
%let  spxw=&spaceloc./spacexw;
%let  spcost=&spaceloc./costutil;

** Create directories in space drive;

    x "mkdir &sphcris. -p";
    x "mkdir &sppos. -p";
    x "mkdir &spip. -p";
    x "mkdir &spmed. -p";
    x "mkdir &spop. -p";
    x "mkdir &spcar. -p";
    x "mkdir &spden. -p";
    x "mkdir &spxw. -p";
    x "mkdir &spcost. -p";


%global mederz;
%global carerz;
%global operz;
%global denerz;
%global iperz;

%let mederz=&spaceloc./medpar/TempErase;
%let carerz=&spaceloc./car/TempErase;
%let operz=&spaceloc./op/TempErase;
%let iperz=&spaceloc./ip/TempErase;
%let denerz=&spaceloc./denom/TempErase;


** Create directories in space drive;
x "mkdir &mederz. -p";
x "mkdir &carerz. -p";
x "mkdir &operz. -p";
x "mkdir &iperz. -p";
x "mkdir &denerz. -p";


***************************************************************************************;
***TEMPFILES -- DIRECTORIES WILL BE GENERATE BY PROGRAM;
***************************************************************************************;
* directory where temporary files can be written;
%let iptmp=&tmprootDir./&projectName./tempextracts/ip;
%let optmp=&tmprootDir./&projectName./tempextracts/op;

**Creates directory if it does not exist;
    x "mkdir &iptmp. -p";
    x "mkdir &optmp. -p";

***************************************************************************************;
****USED GLOBABLY/INPUT DIRECTORIES;
***************************************************************************************;
***************************************************************************************;
****FILES GENERATED INHOUSE AT THE NBER TO SPEED PROCESSING;
**************************************************************************************;
* directory with the harmonized denom files already generated:: PREPROCESSED ;
%let inden =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/masterDenomFiles;
*let inden =&rootoutputDir./&projectName./0preProcess/masterDenomFiles;
x "mkdir &inden. -p";
* directory with the HRR/HSA Dartmouth XW files already generated ::PREPROCESSED ;
%let inHRRzipxw =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/HRRxw;
* directory with the FORMATED POS FILES  already generated ::PREPROCESSED ;
%let inPOS =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/pos;
x "mkdir &inPOS. -p";
%let ingeoLoc =/disk/agebulk1/medicare.work/wise-DUA16702/daltonm/preprocessed/provGeo;
x "mkdir &ingeoLoc. -p";

* directory with the SAS macros -- downloaded with SAS pack ;
%let SASmac =&programRoot./SASmacros;

* data root directory of the directory hierarchy containing the NBER claims data collection;
%let dataRoot = /disk/aging/medicare/data/;

* raw bene_id Crosswalk found here on the servers;
%let bene_id_xw_root= &dataRoot./100pct/xw;

* directory with CC/ICD9-CM mappings;
* Included in the downloaded sas pak.;
%let CC =&programRoot./2SecondaryManipPrgms/comorbid/CC;

* Raw provder files live here;
%let providerDir= /homes/data/pos;

%let xwfile=&programRoot./ClaimsNavigators;

***************************************************************************************;
**COST UTILIZATION PROGRAMS-INPUT FILES INCLUDED WITH THE SAS PACK;
***************************************************************************************;
*define libraries that allow access to the various directories specified above;
* THESE FILES ARE FOUND ON THE NBER SERVERS;
%let APCdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/OPPS_APCweights;
%let DRGdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/AIPPS_drgweights;
%let PFSdir=/disk/aging/medicare/code/AuxData/costUtilizationWeights/PFS_rvuweights/fromMatFiedler_NivSubramanian;

***************************************************************************************;
**** DIRECTORIES SPECIFIC TO THE PROVIDER GEOCODING SUBPROJECT;
**************************************************************************************;
%let ingnis=/disk/aging/medicare/code/AuxData/providerGeoCodingPrj/GNIS;


