options pagesize=200;
options nocenter;
*options symbolgen mlogic mprint mfile ;
options notes stimer fullstimer mprint msglevel=i;
options formdlim=" ";
options mergenoby=error;
options spool;
*options errorabend;

**** PRELIMINARIES ****;
** ALL DIRECTORIES LIVE HERE -- READS IN DIRECTORIES;
%include "./dirInit.sas";
%include "&SASmac./UtilityMacros.sas";
%let providerDir= /homes/data/pos;

*define libraries that allow access to the various directories specified above;
libname provDir "&providerDir.";
libname provOut "&posext.";

*Make sure we are starting with a clean slate- no old files;
x "rm &posext./* --force";


filename dd1 "&providerDir./1998/POS98OTHER.TXT";
data provOut.pos1998;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $219-220
        termCode $208-209
        FMSsurveyDate $58-65
        parentProvider $1577-1586
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 228-230
        category $3-4
        ownChDate $7-12
        partDate $118-125
        termDate $210-217
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-197
        zipcode $221-225
        ssastate $155-156
    statusofrecord $149-149
        bedtotal 273-276
        bedtotal_certified 277-280;

        citystate="";
run;

x "rm &posext./POS99OTHER.txt -f";
x "unzip -o -d &posext. &providerDir./1999/POS99OTHER.txt.zip ";
filename dd1 "&posext./POS99OTHER.txt";


data provOut.pos1999;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
        termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $ 58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;

        citystate="";
run;


x "rm &posext./POS00OTHER.txt -f";
x "unzip -o -d &posext.  &providerDir./2000/POS00OTHER.txt.zip";
filename dd1 "&posext./POS00OTHER.txt";

data provOut.pos2000;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;

    citystate="";
run;


x "rm &posext./DEC01other -f";
x "unzip -o -d &posext. &providerDir./2001/DEC01other.zip ";
filename dd1 "&posext./DEC01other";

data provOut.pos2001;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;
        citystate="";
run;
x "rm &posext./DEC01other -f";


x "unzip -o -d &posext. &providerDir./2002/posotherdec02.txt.zip";
filename dd1 "&posext./posotherdec02.txt";

data provOut.pos2002;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $231-232
        termCode $220-221
        FMSsurveyDate $58-65
        parentProvider $1594-1603
        priorownChDate $126-133
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 240-242
        category $3-4
        ownChDate $7-12
        termDate $222-229
        partDate $118-125
        provider $139-148
        oldprov $48-57
        name $75-112
        city  $15-42
        state $153-154
        address $160-209
        zipcode $233-237
        ssastate $155-156
        statusofrecord $149-149
        bedtotal 285-288
        bedtotal_certified 289-292;


        citystate="";
run;

x "rm &posext./posotherdec02.txt -f";



filename dd1 "&providerDir./2003/DEC03other";
data provOut.pos2003;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1606-1615
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 312-315
        bedtotal_certified 316-319;

        citystate="";
run;




x "rm &posext./DEC04other -f";
x "unzip -o -d &posext.  &providerDir./2004/DEC04other.zip ";
filename dd1 "&posext./DEC04other";


data provOut.pos2004;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1606-1615
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176
        bedtotal 312-315
        bedtotal_certified 316-319;

        citystate="";
run;
x "rm &posext./DEC04other -f ";


x "rm &posext./DEC05other -f";
x "unzip -o -d &posext.  &providerDir./2005/DEC05other.zip ";
filename dd1 "&posext./DEC05other";
data provOut.pos2005;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1631-1640
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        prv_ssacounty 45-47
        prv_fipscounty 267-269
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

        citystate="";
run;
x "rm &posext./DEC05other -fr";




x "rm &posext./DEC06other -f";
x "unzip -o -d &posext. &providerDir./2006/DEC06other.zip ";
filename dd1 "&posext./DEC06other";


data provOut.pos2006;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;
    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        category $3-4
        ownChDate $7-12
        termDate  $249-256
        partDate $145-152
        provider $ 166-175
        oldprov $ 48-57
        name $ 75-124
        city  $15-42
        state $180-181
        address $ 187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

        citystate="";
run;
x "rm &posext./DEC06other -fr";





x "unzip -o -d &posext. &providerDir./2007/other.dec07.zip";
filename dd1 "&posext./M1M1/@BFV2550/POSOTHER/DEC07";


data provOut.pos2007;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        category $3-4
        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;


    citystate="";

run;
x "rm &posext./M1M1 -fr"


x "rm &posext./OtherDec08 -f";
x "unzip -o -d &posext. &providerDir./2008/OtherDec08.zip  ";
filename dd1 "&posext./W148.@AAASOO1.POSOTHER.DEC08";


data provOut.pos2008;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        owncount 5-6
        category $3-4
        ownChDate $7-14
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176
        bedtotal 291-294
        bedtotal_certified 295-298;

       citystate="";
run;
x "rm &posext./W148.@AAASOO1.POSOTHER.DEC08 -f";



x "unzip -o -d &posext. &providerDir./2009/POS.OTHER.Annual09.zip";
filename dd1 "&posext./EXTRACT.POSY.OTHER.YR09";

data provOut.pos2009;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-14
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
        statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

       citystate="";
run;
x "rm &posext./EXTRACT.POSY.OTHER.YR09 -fr";
x "rm &posext./POS.OTHER.Annual09.zip -fr";



x "cp &providerDir./2010/EXTRACT.POSY.OTHER.YR10  &posext./ -f";
filename dd1 "&posext./EXTRACT.POSY.OTHER.YR10";


data provOut.pos2010;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $258-259
        termCode $247-248
        FMSsurveyDate $58-65
        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        ownChDate $7-12
        termDate $249-256
        partDate $145-152
        provider $166-175
        oldprov $48-57
        name  $75-124
        city  $15-42
        state $180-181
        address $187-236
        zipcode $260-264
        ssastate $182-183
            statusofrecord $176-176
        bedtotal 291-294
        bedtotal_certified 295-298;

    citystate="";
run;
x "rm &posext./EXTRACT.POSY.OTHER.YR10 -f";


x "cp &providerDir./2011/POSQ.OTHER.DATA.DEC11.txt  &posext./ -f";
filename dd1 "&posext./POSQ.OTHER.DATA.DEC11.txt";


data provOut.pos2011;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $250-251
        termCode $239-240
        prv_ssacounty 45-47
        prv_fipscounty 267-269

        parentProvider $1629-1638
        priorownChDate $153-160
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $241-248
        partDate $137-144
        provider $158-167
        oldprov $1510-1519
        name  $67-116
        city  $15-42
        state $180-181
        address $179-228
        zipcode $252-256
        ssastate $174-175
        statusofrecord $168-168
        bedtotal 390-393
        bedtotal_certified 386-389;

    citystate="";
    FMSsurveyDate="";
run;
x "rm &posext./POSQ.OTHER.DATA.DEC11.txt -f";


x "cp &providerDir./2012/POS_OTHER_DATA_DEC12.txt  &posext./ -f";
filename dd1 "&posext./POS_OTHER_DATA_DEC12.txt";


data provOut.pos2012;
    infile dd1 lrecl=700 missover pad;
    length termCode $2 FMSsurveyDate $8 partDate $8 bedtotal_certified 4 bedtotal 4
           termDate $8  address $50  priorownChDate $8 ;

    input
        faciltySubType $1-2
        ownerType $250-251
        termCode $239-240
        prv_ssacounty 45-47
        prv_fipscounty 259-261

        parentProvider $1161-1170
        priorownChDate $145-152
        owncount 5-6
        category $3-4
        ownChDate $7-12
        termDate $241-248
        partDate $137-144
        provider $158-167
        oldprov $1510-1519
        name  $67-116
        city  $15-42
        state $172-173
        address $179-228
        zipcode $252-256
        ssastate $174-175
        statusofrecord $168-168
        bedtotal 390-393
        bedtotal_certified 386-389;

    citystate="";
    FMSsurveyDate="";
run;
x "rm &posext./POS_OTHER_DATA_DEC12.txt -f";

x "rm &posext./*.txt -f";

%macro AssignYear;
    %do year=1998 %to 2012;

        proc print data=provOut.pos&year.(obs=10);
        run;

        data posyr_&year.;
            length provider $10 oldprov $10 parentProvider $10 name $50 bedtotal_certified 5 bedtotal 5
                   city $50 FMSsurveyDate  $8 termCode $2  partDate $8
                termDate $8  address $50  priorownChDate $8 citystate $50 state $2;
            set provOut.pos&year. ;
            year=&year.;
                        **10 digit providers exist in some years, break them up;
            if length(provider)>6 then do;
                provider4=substr(provider,1,4);
                provider6=substr(provider,5,6);
                end;
            else do;
                provider6=substr(provider,1,6);
                end;


    *The imputed date values change over time and convert them to numeric;
            %if &year<=1995 %then %do;
                if partDate ne "" then partYr="19" || substr(partDate,1,2);
                if ownChDate ne "" then ownCYr="19" || substr(ownChDate,1,2);
                if termDate ne "" then termYr="19" || substr(termDate,1,2);
                if FMSsurveyDate ne "" then FMSsurveyYr="19" || substr(FMSsurveyDate,1,2);
                if priorownChDate ne "" then priorownChYr="19" || substr(priorownChDate,1,2);
                %end;
            %if &year>=1996 %then %do;
                termYr=substr(termDate,1,4);
                partYr=substr(partDate,1,4);
                ownCYr=substr(ownChDate,1,4);
                FMSsurveyYr=substr(FMSsurveyDate,1,4);
                priorownChYr=substr(priorownChDate,1,4);
    *The inputed date values change over time;
                %end;
            *drop partDate ownChDate termDate;
             %if &year< 1992 %then %do;
                 if provider="" then delete;
                 number=countw(citystate);
                 state="";
                 city=scan(citystate,1," ");
                 %do i=2 %to 30;
                     if &i.< number then do;
                         temp=scan(citystate,&i.," ");
                         city=catx(" ",city,temp);
                         end;
                     %end;
                 state=reverse(scan(reverse(citystate),1," "));
                 city=compress(city,',');
                 drop temp ;
                 %end;
        run;
        x "rm &posext./pos&year..sas7bdat -f ";
        %end;

data provOut.posmaster;
    set %do y=1998 %to 2012; posyr_&y. %end;;
run;

x "st &posext./posmaster.sas7bdat  &posext./posmaster.dta -Y";
%mend ;

**Run Macro defined above;
%AssignYear;


proc export data=provOut.posmaster
    outfile='/disk/agedisk2/medicare.work/chandra-DUA21441/finkels-team/MedicareExtract/movers/0preProcess/pos/posmaster.csv'
    dbms=csv
    replace;
run;
